<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Frame_admin
 * 
 * Публикация/скрытие элемента
 */
class Frame_admin
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var string таблица в базе данных
	 */
	public $table;

	/**
	 * @var array поля таблицы с типами
	 */
	public $variable_table = array();

	/**
	 * @var array переводимые поля
	 */
	public $language_names = array();

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;	
	}

	/**
	 * Публикует/скрывает элемент
	 * 
	 * @return boolean
	 */
	public function act_module()
	{
		//проверка прав пользователя на активацию/блокирование
		if($this->diafan->admin_roles('act'))
		{
			$this->diafan->goto_diafan(URL);
			return FALSE;
		}
		
		//учитывается языковая версия, если это необходимо
		$lang = in_array("act", $this->language_names) ? _LANG : '';
		$ids  = array();
		if($this->diafan->unblock || $this->diafan->block)
		{
			$id = $this->diafan->unblock ? $this->diafan->unblock : $this->diafan->block;
			$action = $this->diafan->unblock ? "unblock" : "block";
			$ids = $this->diafan->get_children($id, $this->table, array(), FALSE);
		}
		else
		{
			$action = $_GET["action"];
			if(! empty($_GET["ids"]))
			{
				foreach($_GET["ids"] as $id)
				{
					$id = intval($id);
					if(! in_array($id, $ids))
					{
						$array = $this->diafan->get_children($id, $this->table, array(), FALSE);
						$ids   = array_merge($ids, $array);
					}
				}
			}
		}
		if($ids)
		{
			DB::query("UPDATE {".$this->table."} SET act".$lang."='"
			          .($action == "block" ? "1".(! empty($this->variable_table["timeedit"]) ? "', timeedit='".time() : '') : '')
					  ."' WHERE id IN (".implode(',', $ids).")"
			);
		}
		if($this->config_module['category'])
		{
			DB::query("UPDATE {".str_replace('_category', '', $this->table)."} SET act".$lang."='"
			          .($action == "block" ? "1".(! empty($this->variable_table["timeedit"]) ? "', timeedit='".time() : '') : '')
					  ."' WHERE cat_id IN (".implode(',', $ids).")"
			);
		}
		$this->diafan->_cache->delete("", $this->diafan->rewrite);

		$this->diafan->goto_diafan(URL);

		return TRUE;
	}
}
