<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Frame_admin
 * 
 * Обработка Ajax-запросов
 */
class Frame_admin extends Theme_admin
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var array результаты, передаваемы Ajaxом
	 */
	private $result;

	/**
	 * @var string SQL-условия для списка
	 */
	protected $where;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;	
	}

	/**
	 * Загружает изображение
	 * 
	 * @return void
	 */
	public function upload_photo_module()
	{		
		include_once(ABSOLUTE_PATH.'includes/image.php');

		if($this->diafan->admin_roles('save'))
		{
			$this->result["errors"]["photo"] = _ADMIN_NO_RULES_FOR_SAVE;
			$this->send_json();
		}

		if(! isset($_FILES["photo"]) || ! is_array($_FILES["photo"]) || $_FILES["photo"]['name'] == '')
		{
			$this->diafan->result["errors"]["photo"] = _ADMIN_NO_FILE_FOR_UPLOAD;
			$this->send_json();
		}

		$this->diafan->uploadphoto = $this->get_id_element();

		$this->result["id"] = $this->diafan->uploadphoto;

		$altname = $this->diafan->translit($_POST["name"]);

		$altname = str_replace('/', '', substr($altname, 0, 15));

		if(empty($altname))
		{
			$altname = rand(100, 99999999);
		}
		
		$config_cat = ($this->config_module['category'] ? "_cat" : "");

		if(! $this->diafan->configmodules("big_width".$config_cat) || ! $this->diafan->configmodules("big_height".$config_cat))
		{
			$this->diafan->result["errors"]["photo"] = _ADMIN_NO_CONFIG_BIG_SIZE;
			$this->send_json();
		}

		if(! $this->diafan->configmodules("medium_width".$config_cat) || ! $this->diafan->configmodules("medium_height".$config_cat))
		{
			$this->diafan->result["errors"]["photo"] = _ADMIN_NO_CONFIG_MEDIUM_SIZE;
			$this->send_json();
		}

		list($width, $height) = getimagesize( $_FILES["photo"]['tmp_name']);
		if ($width > $this->diafan->configmodules("big_width".$config_cat) || $height > $this->diafan->configmodules("big_height".$config_cat))
		{
			if(! Image::resize($_FILES["photo"]['tmp_name'],
				       $this->diafan->configmodules("big_width".$config_cat),
				       $this->diafan->configmodules("big_height".$config_cat),
				       $this->diafan->configmodules("big_quality".$config_cat)
			))
			{
				$this->diafan->result["errors"]["photo"] = _ADMIN_INCORRECT_FORMAT_FILE;
				$this->send_json();
			}
		}

		$size = filesize($_FILES["photo"]['tmp_name']);

		DB::query("INSERT INTO {images} (name,module_name,element_id,size) VALUES ('%s','%s','%d','%d')",
			  $altname,
			  $this->diafan->rewrite.($this->config_module['category'] ? "cat" : ""),
			  $this->diafan->uploadphoto,
			  $size
		);

		$id = DB::next_id("images");

		if (! copy($_FILES["photo"]['tmp_name'], ABSOLUTE_PATH.USERFILES."/".$this->diafan->rewrite."/".$altname.'_'.$id.".jpg"))
		{
			$this->diafan->result["errors"]["photo"] = _ADMIN_NO_UPLOAD_FILE;
			$this->send_json();
		}

		list($width, $height) = getimagesize($_FILES["photo"]['tmp_name']);

		if ($width > $this->diafan->configmodules("medium_width".$config_cat) || $height > $this->diafan->configmodules("medium_height".$config_cat))
		{
			if(! Image::resize($_FILES["photo"]['tmp_name'],
					$this->diafan->configmodules("medium_width".$config_cat),
					$this->diafan->configmodules("medium_height".$config_cat),
					$this->diafan->configmodules("medium_quality".$config_cat)
			))
			{
				$this->diafan->result["errors"]["photo"] = _ADMIN_INCORRECT_FORMAT_FILE;
				$this->send_json();
			}
		}

		if (! copy($_FILES["photo"]['tmp_name'], ABSOLUTE_PATH.USERFILES."/".$this->diafan->rewrite."/medium/".$altname.'_'.$id.".jpg"))
		{
			$this->diafan->result["errors"]["photo"] = _ADMIN_NO_UPLOAD_FILE;
			$this->send_json();
		}

		list($width, $height) = getimagesize( $_FILES["photo"]['tmp_name']);

		if ($width > 50|| $height > 50)
		{		
			if(! Image::resize($_FILES["photo"]['tmp_name'], 50, 50, 70))
			{
				$this->diafan->result["errors"]["photo"] = _ADMIN_INCORRECT_FORMAT_FILE;
				$this->send_json();
			}
		}
		if (! move_uploaded_file($_FILES["photo"]['tmp_name'], ABSOLUTE_PATH.USERFILES."/".$this->diafan->rewrite."/small/".$altname.'_'.$id.".jpg"))
		{
			$this->diafan->result["errors"]["photo"] = _ADMIN_NO_UPLOAD_FILE;
			$this->send_json();
		}

		chmod(ABSOLUTE_PATH.USERFILES."/".$this->diafan->rewrite."/".$altname.'_'.$id.".jpg", 0755);
		chmod(ABSOLUTE_PATH.USERFILES."/".$this->diafan->rewrite."/medium/".$altname.'_'.$id.".jpg", 0755);
		chmod(ABSOLUTE_PATH.USERFILES."/".$this->diafan->rewrite."/small/".$altname.'_'.$id.".jpg", 0755);

		$this->diafan->_cache->delete("", $this->diafan->rewrite);

		DB::query("UPDATE {images} SET sort=id WHERE sort=0");

		$this->result["data"]   = $this->show_edit_photo_module($this->diafan->uploadphoto);
		$this->result["target"] = ".div_photo";

		$this->send_json();
	}

	/**
	 * Удаляет изображение
	 * 
	 * @return void
	 */
	public function del_photo_module()
	{
		if($this->diafan->admin_roles('del'))
		{
			$this->result["errors"]["photo"] = _ADMIN_NO_RULES_FOR_DELETE;
			$this->send_json();
		}
		if(! empty($_GET["id"]))
		{
			$this->diafan->delphoto = intval($_GET["id"]);
		}
		else
		{
			$this->result["errors"]["photo"] = _ADMIN_NO_RULES_FOR_DELETE;
			$this->send_json();
		}

		$_GET['photodel'] = intval($_GET['photodel']);
		if(! empty($_GET['photodel']))
		{
			$row = DB::fetch_array(DB::query("SELECT id, name FROM {images} WHERE id=%d and module_name='%s'", $_GET['photodel'], $this->diafan->rewrite.($this->config_module['category'] ? "cat" : "")));
			if($row)
			{
				unlink(ABSOLUTE_PATH.USERFILES."/".$this->diafan->rewrite.'/'.$row["name"].'_'.$row["id"].'.jpg');
				unlink(ABSOLUTE_PATH.USERFILES."/".$this->diafan->rewrite.'/medium/'.$row["name"].'_'.$row["id"].'.jpg');
				unlink(ABSOLUTE_PATH.USERFILES."/".$this->diafan->rewrite.'/small/'.$row["name"].'_'.$row["id"].'.jpg');
				DB::query("DELETE FROM {images} WHERE id=%d", $_GET['photodel']);

				$this->diafan->_cache->delete("", $this->diafan->rewrite);
			}
		}
		$this->diafan->_cache->delete("", $this->diafan->rewrite);

		$this->result["data"]   = $this->show_edit_photo_module($this->diafan->delphoto);
		$this->result["target"] = ".div_photo";

		$this->send_json();
	}

	/**
	 * Редактирует изображение
	 * 
	 * @return void
	 */
	public function edit_photo_module()
	{
		if(! empty($_GET["id"]))
		{
			$id = intval($_GET["id"]);
		}
		else
		{
			$this->result["errors"]["photo"] = 'ERROR';
			$this->send_json();
		}

		$img_id = intval($_GET['img_id']);
		$row = DB::fetch_array(DB::query("SELECT id, [alt], [title], name FROM {images} WHERE id=%d", $img_id));
		if(! $row)
		{
			$this->result["errors"]["photo"] = 'ERROR';
			$this->send_json();
		}
		
		$this->diafan->_cache->delete("", $this->diafan->rewrite);
		$this->result["data"]   = $this->edit_img($row);

		$this->send_json();
	}

	/**
	 * Редактирует изображение
	 * 
	 * @return void
	 */
	public function save_photo_module()
	{
		if(! empty($_POST["id"]))
		{
			$id = intval($_POST["id"]);
		}
		else
		{
			$this->result["errors"]["photo"] = 'ERROR';
			$this->send_json();
		}

		DB::query("UPDATE {images} SET [alt]='%h', [title]='%h' WHERE id=%d", $_POST["alt"], $_POST["title"], $id);
		$element_id = DB::query_result("SELECT element_id FROM {images} WHERE id=%d", $id);

		$this->diafan->_cache->delete("", $this->diafan->rewrite);

		$this->result["data"]   = $this->show_edit_photo_module($element_id);
		$this->result["target"] = ".div_photo";

		$this->send_json();
	}

	/**
	 * Сортирует изображения
	 * 
	 * @return void
	 */
	public function sort_photo_module()
	{
		if(! empty($_GET["id"]))
		{
			$id = intval($_GET["id"]);
		}
		else
		{
			$this->result["errors"]["photo"] = 'ERROR';
			$this->send_json();
		}

		$img_id = intval($_GET['img_id']);
		if(! empty($img_id))
		{
			$oldsort = DB::query_result("SELECT sort FROM {images} WHERE id=%d", $img_id);
			$row = DB::fetch_array(DB::query("SELECT id, sort FROM {images} WHERE element_id=%d AND module_name='%s' AND id<>%d AND"
				  .($_GET["type"] == "up" ? " sort<=%d ORDER BY sort DESC" : " sort>=%d ORDER BY sort ASC")." LIMIT 1",
				  $id, $this->diafan->rewrite.($this->config_module['category'] ? "cat" : ""), $img_id, $oldsort));
			if($row)
			{
				DB::query("UPDATE {images} SET sort=%d WHERE id=%d", $oldsort, $row["id"]);
				DB::query("UPDATE {images} SET sort=%d WHERE id=%d", $row["sort"], $img_id);
			}
		}
		$this->diafan->_cache->delete("", $this->diafan->rewrite);
		$this->result["data"]   = $this->show_edit_photo_module($id);
		$this->result["target"] = ".div_photo";

		$this->send_json();
	}

	/**
	 * Добавляет тэг
	 * 
	 * @return void
	 */
	public function upload_tag_module()
	{
		if($this->diafan->admin_roles('save'))
		{
			$this->result["errors"]["tags"] = _ADMIN_NO_RULES_FOR_SAVE;
			$this->send_json();
		}

		if(! $_POST["tag"])
		{
			$this->result["errors"]["tags"] = _ADMIN_TAGS_FIELD_NULL;
			$this->send_json();
		}
		if(! $tags_name_id = DB::query_result("SELECT id FROM {tags_name} WHERE name='%h'", trim($_POST["tag"])))
		{
			DB::query("INSERT INTO {tags_name} ([name]) VALUES ('%h')", trim($_POST["tag"]));
			$tags_name_id = DB::next_id("tags_name");
		}

		$this->diafan->uploadtag = $this->get_id_element();
		$this->result["id"] = $this->diafan->uploadtag;

		if(DB::query_result("SELECT COUNT(id) FROM {tags} WHERE module_name='%h' AND element_id='%d' AND tags_name_id='%d'",
				    $this->diafan->rewrite,
				    $this->diafan->uploadtag,
				    $tags_name_id
		))
		{
			$this->result["errors"]["tags"] = _ADMIN_TAGS_TAG_EXISTS;
			$this->send_json();
		}

		DB::query("INSERT INTO {tags} (module_name, element_id, tags_name_id) VALUES ('%h', %d, '%d')",
			  $this->diafan->rewrite,
			  $this->diafan->uploadtag,
			  $tags_name_id
		);

		$this->diafan->_cache->delete("", "tags");
		$this->result["data"]   = $this->show_edit_tags_module($this->diafan->uploadtag);
		$this->result["target"] = ".div_tag";

		$this->send_json();
	}

	/**
	 * Удаляет тэг
	 * 
	 * @return void
	 */
	public function del_tag_module()
	{
		if($this->diafan->admin_roles('del'))
		{
			$this->result["errors"]["tags"] = _ADMIN_NO_RULES_FOR_DELETE;
			$this->send_json();
		}
		$row = DB::fetch_array(DB::query("SELECT element_id, tags_name_id FROM {tags} WHERE module_name='%h' AND id='%d'", $this->diafan->rewrite, $this->diafan->deltag));
		if(! $row)
		{
			return;
		}

		DB::query("DELETE FROM {tags} WHERE module_name='%h' AND id='%d'", $this->diafan->rewrite, $this->diafan->deltag);
		if(! DB::query_result("SELECT COUNT(*) FROM {tags} WHERE tags_name_id=%d", $row["tags_name_id"]))
		{
			DB::query("DELETE FROM {tags_name} WHERE id='%d'", $row["tags_name_id"]);
		}

		$this->diafan->_cache->delete("", "tags");

		$this->result["data"]   = $this->show_edit_tags_module($row["element_id"]);
		$this->result["target"] = ".div_tag";
		$this->send_json();
	}

	/**
	 * Выдает список загруженных тэгов
	 * 
	 * @return void
	 */
	public function search_tag_module()
	{
		$mes = '';
	
		//максимальный и минимальный размеры текста в em
		$max = 3;
		$min = 0.9;
	
		$maxr = 0;
		$minr = 10;
		$rows = array();
	
		$res = DB::query("SELECT id, [name] FROM {tags_name} WHERE trash='0'"
				 .(empty($_GET["new"]) ? " AND id NOT IN"
				 ." (SELECT tags_name_id FROM {tags} WHERE module_name='%h' AND element_id='%d')"
				 : "")
				 ." ORDER BY [name] ASC",
				 $this->diafan->rewrite, $this->diafan->searchtag);
		while($row = DB::fetch_array($res))
		{
			$row["size"] = DB::query_result("SELECT COUNT(*) FROM {tags} WHERE tags_name_id='%d' and trash='0'", $row["id"]);
			if(! $row["size"])
			{
				continue;
			}
			$maxr = $maxr < $row["size"] ? $row["size"] : $maxr;
			$minr = $minr > $row["size"] ? $row["size"] : $minr;
			$rows[] = $row;
		}
	
		foreach($rows as $row)
		{
			$size = ($maxr - $minr < 1 ? $min
						       : ($max - $min) * ($row["size"] - $minr) / ($maxr - $minr) + $min);
			$mes .= '<nobr><a href="javascript:void(0)" onClick="add_tag(this)" style="font-size: '.$size.'em;">'
			        .$row["name"].'</a></nobr> ';
		}
		$mes = ($mes ? '<div style="float:right;padding: 0px 0px 5px 5px"><a href="javascript:void(0)" onclick="$(\'#search_tags\').hide()">x</a></div>' : '')
		       .$mes;
		$this->result["data"] = $mes;
		$this->send_json();
	}

	/**
	 * Подгружает список для сортировки элементов
	 * 
	 * @return void
	 */
	public function sort_module()
	{
		//список элементов, которые при сортировке стоят перед редактируемым элементом
		$text = $this->select_option(
			"sort",
			$this->table,
			"id",
			"name",
			'',
				($this->config_module["parent"] ? "parent_id='".$_POST["parent_id"]."' AND " : '')
				.($this->config_module["element"] ? 'cat_id="'.$_POST["cat_id"].'" AND ' : '')
				.($this->config_module["element_site"] ? 'site_id="'.$_POST["site_id"].'" AND ' : '')
				."sort<='".$_POST["sort"]."'"
				.(! empty($this->variable_table["act"]) ? " AND act='1'" : '')
				.($this->config_module['menu'] ? " AND actm='1'" : '')
				." AND id<>'".$_POST["id"]."'"
				.$this->where
				.($this->config_module["trash"] ? " AND trash='0'" : ''),
			'',
			'',
			'',
			(! empty($this->variable_table["act"]) ? 'act DESC,' : '').($this->config_module['menu'] ? "actm DESC," : '').'sort ASC, id ASC'
		)

		.'<option value="'.$_POST["id"].'" selected>----'.$_POST["name"].'---</option>'

		//список элементов, которые при сортировке стоят после редактируемого элемента
		.$this->select_option(
			"sort",
			$this->table,
			"id",
			"name",
			'',
				($this->config_module["parent"] ? "parent_id='".$_POST["parent_id"]."' AND " : '')
				.($this->config_module["element"] ? 'cat_id="'.$_POST["cat_id"].'" AND ' : '')
				.($this->config_module["element_site"] ? 'site_id="'.$_POST["site_id"].'" AND ' : '')
				."sort>'".$_POST["sort"]."'"
				.(! empty($this->variable_table["act"]) ? " AND act='1'" : '')
				.($this->config_module['menu'] ? " AND actm='1'" : '')
				." AND id<>'".$_POST["id"]."'"
				.$this->where
				.($this->config_module["trash"] ? " AND trash='0'" : ''),
			'',
			'',
			'',
			(! empty($this->variable_table["act"]) ? 'act DESC,' : '').($this->config_module['menu'] ? "actm DESC," : '').'sort ASC, id ASC'
		)
		.'<option value="down">----'._ADMIN_ORDERING_DOWN.'---</option>';

		$this->result["data"]   = $text;
		$this->send_json();
	}

	/**
	 * Подгружает список родителей
	 * 
	 * @return void
	 */
	public function parent_id_module()
	{
		$result = DB::query("SELECT id, name, parent_id FROM {".$this->table."} WHERE trash='0' AND id<>'%d'"
				    .($this->diafan->module == 'site' ? " AND id<>1" : '')." ORDER BY id ASC", $_POST["id"]);
		while ($row = DB::fetch_array($result))
		{
			$cats[$row["parent_id"]][] = $row;
		}

		$this->result["data"]   = '<option value="">'.($this->diafan->module == 'site' ? _LANG_HOME : '').'</option>'
					  .$this->get_options($cats, $cats[0], array($_POST["parent_id"]));
		$this->send_json();
	}

	/**
	 * Отдает ответ Ajax
	 * 
	 * @return void
	 */
	private function send_json()
	{
		if($this->result)
		{
			include_once(ABSOLUTE_PATH.'plugins/json.php');
			echo to_json($this->result);
			exit;
		}
	}

	/**
	 * Возвращает номер элемента, к которому подключается фотография или тэг
	 * 
	 * @return integer
	 */
	private function get_id_element()
	{
		if(! empty($_POST["id"]))
		{
			return intval($_POST["id"]);
		}
		else
		{
			$names  = array();
			$values = array();
			if($this->config_module["parent"])
			{
				$names[]  = "parent_id";
				$values[] = "'".$this->diafan->enterid."'";
			}
			if($this->config_module["element"])
			{
				$names[]  = "cat_id";
				$values[] = "'".$this->diafan->cat."'";
			}
			if($this->config_module["element_site"])
			{
				$names[]  = "site_id";
				$values[] = "'".$this->diafan->site."'";
			}

			DB::query("INSERT INTO {".$this->table."} (".implode(', ', $names).") VALUES (".implode(', ', $values).")");

			return DB::next_id($this->table);
		}
	}
}