<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Frame_admin
 * 
 * Редактирование элемента
 */
class Frame_admin extends Theme_admin
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var string таблица в базе данных
	 */
	public $table;

	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file;

	/**
	 * @var string таблица, которая делит элементы на категории (если отлична от $table.'_category')
	 */
	public $category_table;

	/**
	 * @var array зависимости между полями
	 */
	public $show_tr_click_checkbox;

	/**
	 * @var array настройки отображения
	 */
	public $config_module = array();

	/**
	 * @var array поля таблицы с типами
	 */
	public $variable_table = array();

	/**
	 * @var array дополнительные поля
	 */
	public $variable_other = array();

	/**
	 * @var boolean кнопка "Дополнительно" выведена
	 */
	private $variable_other_white = FALSE;

	/**
	 * @var array варианты значений переменной с типом список, которые берутся из таблицы
	 */
	public $select = array();

	/**
	 * @var array варианты значений переменной с типом список
	 */
	public $select_arr = array();

	/**
	 * @var array переводимые поля
	 */
	public $language_names = array();

	/**
	 * @var array значения полей
	 */
	public $values = array();

	/**
	 * @var integer счетчик
	 */
	public $k = 0;

	/**
	 * @var string название текущего поля
	 */
	public $key;

	/**
	 * @var mixed значение текущего поля
	 */
	public $value;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;	
	}

	/**
	 * Генерирует форму редактирования/добавления элемента
	 * 
	 * @return boolean
	 */
	public function edit_module()
	{
		//проверка прав на редиктирование
		if($this->diafan->admin_roles('edit') && $this->diafan->edit)
		{
			$this->diafan->goto_js(URL);
			return FALSE;
		}
		
		//проверка прав на добавление
		if($this->diafan->admin_roles('addnew') && $this->diafan->addnew)
		{
			$this->diafan->goto_js(URL);
			return FALSE;
		}

		$this->prepare_values();
		
		echo '
		<form METHOD="POST" action="'.URL.(! $this->diafan->addnew ? 'save'.$this->diafan->edit : 'savenew1').'/" enctype="multipart/form-data" id="save">
			<input type="hidden" name="noOut" id="noOut" value="0">
			<input type="hidden" name="save_post" value="1">
			<input type="hidden" name="id" value="'.(! $this->diafan->addnew ? $this->diafan->edit : '').'">';
		
		if($this->config_module['tab_card'])
		{
			foreach($this->variable_table as $title => $variable_table)
			{
				echo '<div class="tab_card_title"><a href="javascript:void(0)" rel="'.$title.'">'.$this->variable_names($title).'</a></div>';
			}

			foreach($this->variable_table as $title => $variable_table)
			{
				if(empty($js))
				{
					$js = '<script language="javascript" type="text/javascript">tab_active("'.$title.'");</script>';
				}
				$this->show_table($variable_table, $title);
			}
			echo $js;
			
		}
		else
		{
			$this->show_table($this->variable_table);
		}
		
		echo '
		<table class="table-edit">
			<tr>
				<td class="first-td">
					'.($this->diafan->admin_roles('save') ? '' : '
					<input type="submit" value="'._LANG_SAVE.'" class="button"'
					.(! $this->diafan->config ? ' onClick="$(\'#noOut\').val(\'1\')"' : '').'>
					').'
				</td>
				<td>
					'.(!$this->diafan->config && ! $this->config_module["no_out"] && ! $this->diafan->admin_roles('save') ? '
					<input type="submit" value="'._ADMIN_SAVE_AND_OUT_TO_LIST.'" class="button">
					':'').'
					'.(!$this->diafan->config && ! $this->config_module["no_out"] ? '
					<input type="button" onClick="document.location=\''.URL.'\'" class="button" value="'._ADMIN_OUT_TO_LIST.'">
					':'').'
				</td>
			</tr>
		</table>
	</form>';
		return TRUE;
	}

	/**
	 * Подготавливает значения для формы
	 * 
	 * @return boolean
	 */
	private function prepare_values()
	{
		$this->values = $this->get_values();
		
		if($this->diafan->config)
		{
			if($this->config_module['tab_card'])
			{
				foreach($this->variable_table as $title => $variable_table)
				{	
					foreach($variable_table as $k => $v)
					{
						if(empty($this->values[$k]))
						{
							$this->values[$k] = $this->diafan->configmodules($k);
						}
					}
				}
			}
			else
			{
				foreach($this->variable_table as $k => $v)
				{
					if(empty($this->values[$k]))
					{
						$this->values[$k] = $this->diafan->configmodules($k);
					}
				} 	
			}  	
		}		
		elseif(! $this->diafan->addnew && ! $this->values)
		{
			$this->values = DB::fetch_array(DB::query("SELECT * FROM {".$this->table."} WHERE id = %d"
								  .($this->table == "param" ? " AND module_name='".str_replace('param', '', $this->file)."'" : '')
								  .($this->config_module["trash"] ? " AND trash='0'" : ''),
								  $this->diafan->edit
								  )
							);
			if(empty($this->values))
			{
				$this->diafan->goto_js(URL);
				return FALSE;
			}
		}
		return TRUE;
	}

	/**
	 * Формирует таблицу с формой
	 * 
	 * @return boolean true
	 */
	private function show_table($variable_table, $title = '')
	{
		
		echo
		($title ? '
		<div id="'.$title.'" class="tab-card">' : '').'
		<table class="table-edit">
			<tr>
				<td class="first-td"><b>'._ADMIN_PROPERTY.'</b></td>
				<td><b>'._ADMIN_VALUE.'</b></td>
			</tr>';

		foreach ($variable_table as $this->key => $type)
		{
			$this->k++;
			$key = $this->key.(! $this->diafan->config && in_array($this->key, $this->language_names) ? _LANG : '');
			
			$this->value = (! empty($this->values[$key]) ? $this->values[$key] : '');
		  	$func = 'edit_'.$this->key.'_module'.($this->diafan->config ? '_config' : '');
			if(method_exists($this, $func))
			{
				$this->$func();
			}

			elseif($type == 'title')
			{
				echo '
				<tr'.$this->get_other().'>
				    <td class="first-td"><b>'.$this->variable_names().'</b> '.$this->show_help_row().'</td>
					<td></td>
				</tr>';
			}

			elseif($type == 'password')
			{
				echo '
				<tr'.$this->get_other().'>
					<td class="first-td">'.$this->variable_names().'</td>
					<td>
						<input type="password" name="'.$this->key.'" size="40" value="">
						'.$this->show_help_row().'
					</td>
				</tr>';
			}

			elseif($type == 'text')
			{
				echo '
				<tr'.$this->get_other().'>
					<td class="first-td">'.$this->variable_names().'</td>
					<td>
						<input type="text" name="'. $this->key.'" size="40" value="'
						.(! $this->diafan->addnew ? str_replace('"', '&quot;', $this->value) : '')
						.'">
						'.$this->show_help_row().'
					</td>
				</tr>';
			}

			elseif($type == 'disabled')
			{
				echo '
				<tr'.$this->get_other().'>
					<td class="first-td">'.$this->variable_names().'</td>
					<td>
						<input type="text" name="'. $this->key.'" size="40" value="'
						.(! $this->diafan->addnew ? str_replace('"', '&quot;', $this->value) : '')
						.'" disabled>
						'.$this->show_help_row().'
					</td>
				</tr>';
			}

			elseif($type == 'date')
			{
				echo '
				<tr'.$this->get_other().'>
					<td class="first-td">'.$this->variable_names().'</td>
					<td>
						<input type="text" name="'.$this->key.'" size="40" value="'
						.(! $this->diafan->addnew ? date("d.m.Y", $this->value) : date("d.m.Y"))
						.'">
						'.$this->show_help_row().'
					</td>
				</tr>';
			}

			elseif($type == 'datetime')
			{
				echo '
				<tr'.$this->get_other().'>
					<td class="first-td">'.$this->variable_names().'</td>
					<td>
						<input type="text" name="'.$this->key.'" size="40" value="'
						.($this->value ? date("d.m.Y H:i", $this->value) : date("d.m.Y H:i"))
						.'">
						'.$this->show_help_row().'
					</td>
				</tr>';
			}

			elseif($type == 'numtext')
			{
				echo '
				<tr'.$this->get_other().'>
					<td class="first-td">'.$this->variable_names().'</td>
					<td>
						<input type="text" name="'.$this->key.'" size="20" value="'
						.(! $this->diafan->addnew ? $this->value : '')
						.'" class="inpnum">'.$this->show_help_row().'
					</td>
				</tr>';
			}

			elseif($type == 'floattext')
			{
				echo '
				<tr'.$this->get_other().'>
					<td class="first-td">'.$this->variable_names().'</td>
					<td>
						<input type="text" name="'.$this->key.'" size="20" value="'
						.(! $this->diafan->addnew ? number_format($this->value, 2, ',', '') : '')
						.'" class="inpnum">
						'.$this->show_help_row().'
					</td>
				</tr>';
			}

			elseif($type == 'textarea')
			{
				echo '
				<tr'.$this->get_other().'>
					<td class="first-td">'.$this->variable_names().'</td>
					<td>
						<textarea name="'.$this->key.'" cols="60" rows="5">'
						.(! $this->diafan->addnew ? str_replace(array('<', '>', '"'), array('&lt;', '&gt;', '&quot;'), $this->value) : '')
						.'</textarea>'
						.$this->show_help_row().'
					</td>
				</tr>';
			}

			elseif($type == 'checkbox')
			{
				echo '
				<tr'.$this->get_other().'>
					<td class="first-td">'.$this->variable_names().'</td>
					<td>
						<input type="checkbox" name="'.$this->key.'" value="1"'
						.(! $this->diafan->addnew && $this->value == 1 ? " checked" : '')
						.$this->show_tr_click_checkbox()
						.'>
						'.$this->show_help_row().'
					</td>
				</tr>';
			}

			elseif($type == 'select')
			{
				if(! empty($this->select[$this->key]) || ! empty($this->select_arr[$this->key]))
				{
					echo '
					<tr'.$this->get_other().'>
						<td class="first-td">'.$this->variable_names().'</td>
						<td>
							<select name="'.$this->key.'">'
							.(!empty($this->select[$this->key][4])?
							'<option value="">'.$this->select[$this->key][4].'</option>':'')
							.$this->select_option(
								$this->key,
								(! empty($this->select[$this->key][0]) ? $this->select[$this->key][0] : ''),
								(! empty($this->select[$this->key][1]) ? $this->select[$this->key][1] : ''),
								(! empty($this->select[$this->key][2]) ? $this->select[$this->key][2] : ''),
								(empty($this->diafan->addnew)
								? $this->value
								: (! empty($this->select[$this->key][3]) ? $this->select[$this->key][3] : '')
								),
								(! empty($this->select[$this->key][5]) ? $this->select[$this->key][5] : ''),
								(! empty($this->select[$this->key][6]) ? $this->select[$this->key][6] : '')
							)
							.'</select>
							'.$this->show_help_row().'
						</td>
					</tr>';
				}
			}

			elseif($type == 'editor')
			{
				echo '
				<tr'.$this->get_other().'>
					<td colspan="2">'
						.($this->variable_names() ? $this->variable_names().$this->show_help_row().'<br>' : '')
						.'<textarea name="'.$this->key.'" style="width:100%; height:'
						.(! empty($this->editor_height[$this->key]) ? $this->editor_height[$this->key] : '400').'px"'
						.(HTMLEDITOR ? ' class="htmleditor"' : '').'>'
						.(! $this->diafan->addnew ? str_replace(array('<', '>', '"'), array('&lt;', '&gt;', '&quot;'), str_replace('&', '&amp;', $this->value)) : '')
						.'</textarea>
					</td>
				</tr>';
			}

			elseif($type == 'hr')
			{
				echo '
				<tr'.$this->get_other().'>
					<td colspan="2">
						<hr>
					</td>
				</tr>';
			}
		  
			elseif($type == 'none')
			{
			}
			echo "\n";
		}
		echo
		'</table>'.($title ? '</div>' : '');
		return TRUE;
	}

	/**
	 * Получает значения полей для формы (альтернативный метод)
	 * 
	 * @return array
	 */
	protected function get_values()
	{
		return array();
	}

	/**
	 * Определяет название поля, отображаемое для пользователя
	 * 
	 * @return string
	 */
	protected function variable_names($key = '')
	{
		$key = ($key
		       ? ($this->diafan->config ? str_replace('-', '_', $key) : $key)
		       : ($this->diafan->config ? str_replace('-', '_', $this->key) : $this->key)
		       );
		
		$const  = strtoupper('_ADMIN_'.$this->file.'_'.$key);
		$const2 = strtoupper('_ADMIN_'.$key.($this->diafan->config ? '_CONFIG' : ''));

		if(defined($const))
		{
			return constant($const);
		}
		elseif(defined($const2))
		{
			return constant($const2);
		}
	}

	/**
	 * Определяет подсказки для полей
	 * 
	 * @return string
	 */
	protected function show_help_row()
	{
		$const  = strtoupper('_ADMIN_'.$this->file.'_'.$this->key.'_HELP');
		$const2 = strtoupper('_ADMIN_'.$this->key.($this->diafan->config ? '_CONFIG' : '').'_HELP');
		if(! defined($const) && ! defined($const2))
		{
			return '';
		}
		
		return ' <a href="#" onClick="javascript:show_div(\'help'.$this->key.'\'); return false;"><img src="'.BASE_PATH.'img/quest.gif"></a>'
		.'<div id="help'.$this->key.'" class="help-row">'.(defined($const) ? constant($const) : constant($const2)).'</div>';
	}

	/**
	 * Определяет поле как дополнительное
	 * 
	 * @return string
	 */
	protected function get_other()
	{
		$text = '';
		if(! empty($this->variable_other[$this->key]))
		{
			if($this->variable_other && ! $this->variable_other_white)
			{
				$text .= ' id="other_button">
					<td></td>
					<td align="left">
						<a href="javascript:void(0)" class="href show_other_block">'._ADMIN_OTHER_FIELDS.'</a>
					</td>
				</tr><tr';
				$this->variable_other_white = TRUE;
			}
			$text .= ' class="other"';
		}
		$text .= ' id="'.$this->key.'"';
		return $text;
	}

	/**
	 * Определяет связанные поля
	 * 
	 * @return string
	 */
	protected function show_tr_click_checkbox()
	{
		return 
			(! empty($this->show_tr_click_checkbox[$this->key])
			 ? ' class="show_tr_click_checkbox" rel="#'
			   .(is_array($this->show_tr_click_checkbox[$this->key])
			     ? implode(",#", $this->show_tr_click_checkbox[$this->key])
			     : $this->show_tr_click_checkbox[$this->key]
			    )
			    .'"'
			 : ''
			);
	}
	
	
	//----------------------------------------------------------------------//
	//функции редактирования полей

	/**
	 * Редактирование поля "Категория"
	 * 
	 * @return boolean
	 */
	protected function edit_cat_id_module()
	{
		if(! $this->diafan->configmodules("cat"))
		{
			return FALSE;
		}
		if(! $this->value)
		{
			$this->value = $this->diafan->cat;
		}

		echo '
		<tr'.$this->get_other().' valign="top">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<select name="'.$this->key.'">';

		$marker = "&nbsp;&nbsp;";
		$result = DB::query("SELECT id, name, parent_id FROM {".$this->table."_category} WHERE trash='0' ORDER BY id ASC");
		while ($row = DB::fetch_array($result))
		{
			$cats[$row["parent_id"]][] = $row;
		}
		echo $this->get_options($cats, $cats[0], array($this->value))
		.'
				</select>
				'.$this->show_help_row();

		$values = array();
		$result = DB::query("SELECT cat_id FROM {category} WHERE module_name='%s' AND element_id='%d'", $this->diafan->module, $this->diafan->edit);
		while ($row = DB::fetch_array($result))
		{
			if($row["cat_id"] != $this->value)
			{
				$values[] = $row["cat_id"];
			}
		}
		echo '
				<br>
				<input type="checkbox" value="1" class="show_tr_click_checkbox" rel="#cat_ids"'.($values ? ' checked' : '').'>
				'._ADMIN_CAT_IDS.'
				<div id="cat_ids">
				<select name="cat_ids[]" multiple="multiple">'
				.$this->get_options($cats, $cats[0], $values).'
				</select>
				</div>
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Принадлежит"
	 * 
	 * @return boolean
	 */
	protected function edit_parent_id_module()
	{
		if($this->diafan->addnew)
		{
			$this->value = $this->diafan->enterid;
		}

		echo '
		<tr'.$this->get_other().' valign="top">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<select name="'.$this->key.'" onclick="ajax_parent_id(this, \''.BASE_PATH_HREF.$this->diafan->rewrite.'/\')"'
				.' edit_id="'.(! $this->diafan->addnew ? $this->diafan->edit : '').'">
				<option value="'.$this->value.'">'
				.(! $this->value ? "-" : DB::query_result("SELECT [name] FROM {".$this->table."} WHERE id=%d", $this->value))
				.'</option>
				</select>
				</div>
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Страницы"
	 * 
	 * @return boolean
	 */
	protected function edit_site_id_module()
	{
		if($this->config_module["element"])
		{
			return FALSE;
		}
		if(! $this->value)
		{
			$this->value = $this->diafan->site;
		}

		echo '
		<tr'.$this->get_other().' valign="top">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<select name="'.$this->key.'">';
		$result = DB::query("SELECT id, name FROM {site} WHERE trash='0' AND addmodule='%s' ORDER BY id ASC", $this->diafan->module);
		while ($row = DB::fetch_array($result))
		{
			$cats[0][] = $row;
		}
		echo $this->get_options($cats, $cats[0], array($this->value)).'
				</select>
				'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Изображения"
	 * 
	 * @return boolean
	 */
	private function edit_photo_module()
	{
		if($this->config_module['category'] && ! $this->diafan->configmodules("image_cat")
		   || ! $this->config_module['category'] && ! $this->diafan->configmodules("image"))
		{
			return FALSE;
		}

		if(! extension_loaded('gd'))
		{
			$this->diafan->error = _ADMIN_PHOTO_NOT_GD;
		}
		echo '
		<tr valign="top">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<input type="file" name="photo" size="40" id="uploadphoto">
				<input type="button" value="'._ADMIN_UPLOAD_PHOTOS.'" class="ajax" url="'.BASE_PATH_HREF.$this->diafan->rewrite
				.($this->diafan->site ? '/site'.$this->diafan->site : '')
				.($this->diafan->enterid ? '/enterid'.$this->diafan->enterid : '')
				.($this->diafan->cat ? '/cat'.$this->diafan->cat : '')
				.'/uploadphoto1/" rel="uploadphoto"> '.$this->show_help_row().'
				<div class="div_photo">'.$this->show_edit_photo_module($this->diafan->edit).'</div>';
		
		echo '
				<div class="errors error-photo"></div>
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Комментарии"
	 * 
	 * @return boolean
	 */
	private function edit_comments_module()
	{
		if(! $this->diafan->configmodules("comments") && ! $this->config_module['category']
		   || ! $this->diafan->configmodules("comments_cat") && $this->config_module['category']
		   || ! $this->diafan->edit
		)
		{
			return FALSE;
		}
	
	
		echo '
		<tr'.$this->get_other().'>
			<td align="right"></td>
			<td>
				'
		.(DB::query_result("SELECT COUNT(id) FROM {comments} WHERE module_name='%h' AND element_id='%d' AND trash='0'", $this->table, $this->diafan->edit)?
			'<a href="'.BASE_PATH_HREF.'comments/?rew='.$this->table.$this->diafan->edit.'">'._LANG_COMMENTS.'</a>'
		:
			_ADMIN_COMMENTS_NOT_MESSAGE
		)
		.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Тэги"
	 * 
	 * @return boolean
	 */
	private function edit_tags_module()
	{
		if(!$this->diafan->configmodules("tags") || $this->config_module['category'])
		{
			return FALSE;
		}

		echo '
		<tr'.$this->get_other().' valign="top">
			<td align="right">'._LANG_TAGS.'</td>
			<td>
				<div id="search_tags"></div>
				<input type="text" name="tag" size="40" id="uploadtag" autocomplete="off">
				<input type="button" value="'._ADMIN_TAGS_ADD_TAG.'" class="ajax" url="'
				.BASE_PATH_HREF.$this->diafan->rewrite
				.($this->diafan->site ? '/site'.$this->diafan->site : '')
				.($this->diafan->enterid ? '/enterid'.$this->diafan->enterid : '')
				.($this->diafan->cat ? '/cat'.$this->diafan->cat : '')
				.'/uploadtag1/" rel="uploadtag">
				<a href="'.path_module($this->diafan).'searchtag'.($this->diafan->addnew ? '1/?new=1' : $this->diafan->edit.'/').'" id="cloud_tags">'._ADMIN_CLOUD_TAGS.'</a>
				<div class="div_tag">'.$this->show_edit_tags_module($this->diafan->edit).'</div>';

		echo $this->show_help_row().'
				<div class="errors error-tags"></div>
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Рейтинг"
	 * 
	 * @return boolean
	 */
	private function edit_rate_module()
	{
		if(! $this->diafan->configmodules("rating") || ! $this->diafan->edit)
		{
			return FALSE;
		}
		
		$row = DB::fetch_array(DB::query("SELECT id, rating, count_votes FROM {rating} WHERE element_id='%d' AND module_name='".$this->table."' AND trash='0'", $this->diafan->edit));
		echo '<tr>
			<td align="right"></td>
			<td>'
			.($row
			 ? '
				<a href="'.BASE_PATH_HREF.'rating/edit'.$row["id"].'/">'._LANG_RATING.': '.$row["rating"]
				.' '._ADMIN_RATING_VOTES.': '.$row["count_votes"].'</a>'
			 : _LANG_RATING.': '._ADMIN_RATING_NOT_VOTES)
			.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Сортировка"
	 * 
	 * @return boolean
	 */
	private function edit_sort_module()
	{
		if($this->diafan->addnew || ! empty($this->variable_table["act"]) && empty($this->values["act"]) || $this->config_module['menu'] && empty($this->values["actm"]))
		{
			return FALSE;
		}

		echo '
		<tr'.$this->get_other().'>
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<select name="'.$this->key.'" onclick="ajax_sort(this, \''.path_module($this->diafan).'/\')"'
				.' sort="'.$this->value.'" sname="'.$this->values["name"].'"'
				.' edit_id="'.(! $this->diafan->addnew ? $this->diafan->edit : '').'"'
				.($this->config_module["element"] ? ' cat_id="'.(! empty($this->values["cat_id"]) ? $this->values["cat_id"] : $this->diafan->cat).'"' : '')
				.($this->config_module["parent"] ? ' parent_id="'.(! empty($this->values["parent_id"]) ? $this->values["parent_id"] : $this->diafan->enterid).'"' : '')
				.($this->config_module["element_site"] ? ' site_id="'.(! empty($this->values["site_id"]) ? $this->values["site_id"] : $this->diafan->site).'"' : '')
				.'>
				<option value="'.$this->values["id"].'">----'.$this->values["name"].'---</option>
				</select>
				'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Псевдоссылка"
	 * 
	 * @return boolean true
	 */
	protected function edit_rewrite_module()
	{
		$rewrite =  '';
		if(! $this->diafan->addnew)
		{
			if($this->config_module["category"])
			{
				$rewrite = DB::query_result("SELECT rewrite FROM {rewrite} WHERE module_name='%s' AND cat_id=%d",
							    $this->diafan->module, $this->diafan->edit);
			}
			elseif($this->diafan->module == "site")
			{
				$rewrite = DB::query_result("SELECT rewrite FROM {rewrite} WHERE module_name='%s' AND site_id=%d",
							    $this->diafan->module, $this->diafan->edit);
			}
			else
			{
				$rewrite = DB::query_result("SELECT rewrite FROM {rewrite} WHERE module_name='%s' AND element_id=%d",
							    $this->diafan->module, $this->diafan->edit);
			}
		}
		$rewrite_site = '';
		if(! $rewrite && $this->diafan->module != "site")
		{
			if($this->diafan->addnew)
			{
				$this->values["parent_id"] = $this->diafan->enterid;
				$this->values["cat_id"]    = $this->diafan->cat;
				$this->values["site_id"]   = $this->config_module["element"]
				                              ? DB::query_result("SELECT site_id FROM {".$this->table."_category} WHERE id=%d", $this->diafan->cat)
							      : $this->diafan->site;
			}
			if($this->config_module["element"])
			{
				if(! $rewrite_site = DB::query_result("SELECT rewrite FROM {rewrite} WHERE module_name='%s' AND cat_id=%d",
							        $this->diafan->module, $this->values["cat_id"]))
				{
					$rewrite_site = DB::query_result("SELECT rewrite FROM {rewrite} WHERE module_name='site' AND site_id=%d",
									 $this->values["site_id"]);
				}
				
			}
			elseif($this->config_module["category"])
			{
				if(! $this->values["parent_id"]
				   || ! $rewrite_site = DB::query_result("SELECT rewrite FROM {rewrite} WHERE module_name='%s' AND cat_id=%d",
									 $this->diafan->module, $this->values["parent_id"]))
				{
					$rewrite_site = DB::query_result("SELECT rewrite FROM {rewrite} WHERE module_name='site' AND site_id=%d",
									 $this->values["site_id"]);
				}
			}
			else
			{
				$rewrite_site = DB::query_result("SELECT rewrite FROM {rewrite} WHERE module_name='site' AND site_id=%d",
								 $this->values["site_id"]);
			}
		}
		echo '
		<tr'.$this->get_other().'>
			<td align="right">'.$this->variable_names().'</td>
			<td>
				http://'.BASE_URL.'/'.($rewrite_site ? $rewrite_site.'/' : '').'<input type="text" name="rewrite" size="40" value="'.$rewrite.'">/'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Время редактирования"
	 * 
	 * @return boolean true
	 */
	private function edit_timeedit_module()
	{
		$timeedit = ($this->value ? $this->value : time());
		
		echo '
		<tr'.$this->get_other().'>
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td>
				'.date("D, d M Y H:i:s", $timeedit)
				.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Номер страницы"
	 * @return boolean true
	 */
	protected function edit_number_module()
	{
		echo '<tr'.$this->get_other().'>
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td style="color:#999999;font-weight:bold">
				id='.$this->diafan->edit.' '.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}
	
	//----------------------------------------------------------------------//
	//функции редактирования конфигурации

	/**
	 * Редактирование поля "Электронный адрес" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	private function edit_emailconf_module_config()
	{
		
		$this->select_arr["emailconf"] = array(
			0 => EMAIL_CONFIG,
			1 => _LANG_OTHER
		);
		
		echo '
		<tr'.$this->get_other().'>
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<select name="'.$this->key.'" class="show_select_div" rel="emailtext" id="text_em">'
					.$this->select_option($this->key,'','','',$this->value)
				.'</select>
				<div id="emailtext">
					<br>
					<input type="text" name="email" size="20" value="'.$this->values["email"].'">
					'.$this->variable_names("email").'
				</div>'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Электронный адрес администратора" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	private function edit_emailconfadmin_module_config()
	{
		
		$this->select_arr["emailconfadmin"] = array(
			0 => EMAIL_CONFIG,
			1 => _LANG_OTHER
		);
		
		echo '
		<tr'.$this->get_other().'>
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<select name="'.$this->key.'" class="show_select_div" rel="emailadmintext">
					'.$this->select_option($this->key, '', '', '', $this->value).'
				</select>
				<div id="emailadmintext">
					<br>
					<input type="text" name="email-admin" size="20" value="'.$this->values["email-admin"].'"> 
					'.$this->variable_names("email-admin").'
				</div>
				'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Размер большого изображения" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	private function edit_big_width_module_config()
	{
		echo '
		<tr id="big">
			<td align="right">'.$this->variable_names().'</td>
			<td><input type="text" name="'.$this->key.'" size="3" value="'.$this->value.'" class="inpnum"> x
				<input type="text" name="big_height" size="3" value="'.$this->values["big_height"].'" class="inpnum">,
				'._LANG_QUALITY.'
				<input type="text" name="big_quality" size="2" value="'.$this->values["big_quality"].'"
				class="fr" onkeydown="return number_only(event);">'

				.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Размер большого изображения для категории" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	private function edit_big_width_cat_module_config()
	{
		echo '
		<tr id="big_cat">
			<td align="right">'.$this->variable_names().'</td>
			<td><input type="text" name="'.$this->key.'" size="3" value="'.$this->value.'" class="inpnum"> x
				<input type="text" name="big_height_cat" size="3" value="'.$this->values["big_height_cat"].'" class="inpnum">,
				'._LANG_QUALITY.'
				<input type="text" name="big_quality_cat" size="2" value="'.$this->values["big_quality_cat"].'" class="inpnum">'

				.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Размер маленького изображения" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	private function edit_medium_width_module_config()
	{
		echo '
		<tr id="medium">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<input type="text" name="'.$this->key.'" size="3" value="'.$this->value.'" class="inpnum"> x
				<input type="text" name="medium_height" size="3" value="'.$this->values["medium_height"].'" class="inpnum">,
				'._LANG_QUALITY.'
				<input type="text" name="medium_quality" size="2" value="'.$this->values["medium_quality"].'" class="inpnum">'
				.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Размер маленького изображения для категории" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	private function edit_medium_width_cat_module_config()
	{
		echo '
		<tr id="medium_cat">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<input type="text" name="'.$this->key.'" size="3" value="'.$this->value.'" class="inpnum"> x
				<input type="text" name="medium_height_cat" size="3" value="'.$this->values["medium_height_cat"].'" class="inpnum">,
				'._LANG_QUALITY.'
				<input type="text" name="medium_quality_cat" size="2" value="'.$this->values["medium_quality_cat"].'" class="inpnum">'
				.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Подключить изображения" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	private function edit_image_module_config()
	{
		echo '
		<tr id="'.$this->key.'">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<input type="checkbox" name="'.$this->key.'"'
				.(! extension_loaded('gd')
				 ? ' onclick="javascript:alert(\''._ADMIN_NO_GD_CONFIG_IMAGE.'\');" value="0"'
				 : $this->show_tr_click_checkbox().'" value="1" '
				   .($this->value == 1 ? " checked" : '')
				 )
				.' id="image_">
				'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Использовать изображения для категорий" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	private function edit_image_cat_module_config()
	{
		$this->edit_image_module_config();
	}

	/**
	 * Редактирование поля "Подключить комментарии" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	private function edit_comments_module_config()
	{
		$com = DB::query_result("SELECT COUNT(id) FROM {adminsite} WHERE act='1' AND rewrite='comments'");
		echo '
		<tr'.$this->get_other().'>
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<input type="checkbox" name="'.$this->key.'"'
				.($com ? ' value="1"':' value="0" onclick="javascript:alert(\''._ADMIN_NO_COMMENTS_CONFIG.'\');return false;"')
				.($this->value == 1 && $com ? " checked" : '')
				.'>'
				.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Подключить комментарии к категориям" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	private function edit_comments_cat_module_config()
	{
		$com = DB::query_result("SELECT COUNT(id) FROM {adminsite} WHERE act='1' AND rewrite='comments'");

		echo '
		<tr'.$this->get_other().'>
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<input type="checkbox" name="'.$this->key.'"'
				.($com ? ' value="1"' : ' value="0" onclick="javascript:alert(\''._ADMIN_NO_COMMENTS_CONFIG.'\');return false;"')
				.($this->value == 1 && $com ? " checked" : '')
				.'>'
				.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Подключить рейтинг" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	private function edit_rating_module_config()
	{
		$com = DB::query_result("SELECT COUNT(id) FROM {adminsite} WHERE act='1' AND rewrite='rating'");

		echo '
		<tr'.$this->get_other().'>
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<input type="checkbox" name="'.$this->key.'"'
				.($com ? ' value="1"' : ' value="0" onclick="javascript:alert(\''._ADMIN_NO_RATING_CONFIG.'\');return false;"')
				.($this->value == 1 && $com ? " checked" : '')
				.'>'
				.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Подключить тэги" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	private function edit_tags_module_config()
	{
		$com = DB::query_result("SELECT COUNT(id) FROM {adminsite} WHERE act='1' AND rewrite='tags'");

		echo '
		<tr'.$this->get_other().'>
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<input type="checkbox" name="'.$this->key.'"'
				.($com ? ' value="1"' : ' value="0" onclick="javascript:alert(\''._ADMIN_NO_TAGS_CONFIG.'\');return false;"')
				.($this->value == 1 && $com ? " checked" : '')
				.'>'
				.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Максимальный размер загружаемых файлов" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	private function edit_upload_max_filesize_module_config()
	{
		echo '
		<tr'.$this->get_other().'>
			<td align="right">'.$this->variable_names().'</td>
			<td>
				'.ini_get('upload_max_filesize')
				.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Использовать описание элемента"
	 * 
	 * @return boolean true
	 */
	private function edit_text_element_module_config()
	{
		echo '
		<tr'.$this->get_other().'>
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<select name="'.$this->key.'" onchange="javascript:show_shorttext(\'_element\');" id="'.$this->key.'_">'
					.$this->select_option($this->key, '', '', '',$this->value)
				.'</select>
				<div id="shorttext_element">
				<br>
				<input type="text" name="shorttext_element" size="10" value="'.$this->values["shorttext_element"]
				.'" onkeydown="return number_only(event);"> '
				.$this->variable_names("shorttext_element")
				.'</div>';
		echo $this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Использовать описание группы"
	 * 
	 * @return boolean true
	 */
	private function edit_text_module_config()
	{
		echo '
		<tr'.$this->get_other().'>
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<select name="'.$this->key.'" onchange="javascript:show_shorttext(\'\');" id="'.$this->key.'_">'
					.$this->select_option($this->key, '', '', '', $this->value)
				.'</select>
				<div id="shorttext">
				<br>
				<input type="text" name="shorttext" size="10" value="'.$this->values["shorttext"]
				.'" onkeydown="return number_only(event);"> '
				.$this->variable_names("shorttext")
				.'</div>';
		?>
		<script language="javascript" type="text/javascript">
		show_shorttext('');
		show_shorttext('_element');
		function show_shorttext(prefix)
		{
			var d = document.getElementById("text" + prefix + "_").value;
			if(d == 2)
			{
				document.getElementById("shorttext" + prefix).style.display = "block";
			}
			else
			{
				document.getElementById("shorttext" + prefix).style.display = "none";
			}
		}
		</script>
		<?php
		echo $this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}
}