<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

class Initadmin extends Core
{

	/**
	 * @var integer переменная, передаваемая в URL: номер удаляемого элемента
	 */
	public $del;

	/**
	 * @var integer переменная, передаваемая в URL: номер редактируемого элемента
	 */
	public $edit;

	/**
	 * @var integer переменная, передаваемая в URL: номер сохраняемого элемента
	 */
	public $save;

	/**
	 * @var integer переменная, передаваемая в URL: сохранить новый элемент (1)
	 */
	public $savenew;

	/**
	 * @var integer переменная, передаваемая в URL: номер элемента раскрытия каталога вложенности
	 */
	public $enterid;

	/**
	 * @var integer переменная, передаваемая в URL: номер системного сообщения
	 */
	public $error;

	/**
	 * @var integer переменная, передаваемая в URL: номер скрываемого элемента
	 */
	public $block;

	/**
	 * @var integer переменная, передаваемая в URL: номер публикуемого элемента
	 */
	public $unblock;

	/**
	 * @var integer переменная, передаваемая в URL: номер элемента, сортируемого вверх
	 */
	public $up;

	/**
	 * @var integer переменная, передаваемая в URL: номер элемента, сортируемого вниз
	 */
	public $down;

	/**
	 * @var integer переменная, передаваемая в URL: добавление элемента (1)
	 */
	public $addnew;

	/**
	 * @var integer переменная, передаваемая в URL: конфигурация модуля (1)
	 */
	public $config;

	/**
	 * @var integer переменная, передаваемая в URL: номер категории
	 */
	public $cat;

	/**
	 * @var integer переменная, передаваемая в URL: номер страницы
	 */
	public $site;

	/**
	 * @var integer переменная, передаваемая в URL: загрузка изображения (1)
	 */
	public $uploadphoto;

	/**
	 * @var integer переменная, передаваемая в URL: удаление изображения (1)
	 */
	public $delphoto;

	/**
	 * @var integer переменная, передаваемая в URL: номер элемента, удаляемого в корзину
	 */
	public $trash;

	/**
	 * @var integer переменная, передаваемая в URL: номер элемента, восстанавливаемого из корзины
	 */
	public $restore;

	/**
	 * @var integer переменная, передаваемая в URL: номер удаляемого тэга
	 */
	public $deltag;

	/**
	 * @var integer переменная, передаваемая в URL: добавление тэга (1)
	 */
	public $uploadtag;

	/**
	 * @var integer переменная, передаваемая в URL: показать список тэгов (1)
	 */
	public $searchtag;

	/**
	 * @var integer номер страницы
	 */
	public $page;

	/**
	 * @var string псевдоссылка текущей страницы
	 */
	public $rewrite;

	/**
	 * @var string модуль текущей страницы
	 */
	public $module;

	/**
	 * @var string название подключаемой функции
	 */
	public $action;

	/**
	 * @var integer номер ошибки
	 */
	public $err;

	/**
	 * @var array переменные, передаваемые в URL
	 */
	public $rewrite_variable_names = array(
		'page',
		'del',
		'trash',
		'restore',
		'edit',
		'savenew',
		'save',
		'enterid',
		'error',
		'unblock',
		'block',
		'up',
		'down',
		'addnew',
		'config',
		'site',
		'cat',
		'uploadphoto',
		'delphoto',
		'uploadtag',
		'searchtag',
		'deltag'
	);

	/**
	 * @var integer номер текущей страницы
	 */
	public $cid;

	/**
	 * @var string заголовок текущей страницы
	 */
	public $name;

	/**
	 * @var string контент текущей страницы
	 */
	public $text;

	/**
	 * @var integer номер страницы-родителя
	 */
	public $parent_id;
	
	/**
	 * @var object работа с пользователями
	 */
	public $_user;

	/**
	 * @var object кэширование
	 */
	public $_cache;

	/**
	 * Конструктор класса. Определяет свойства класса
	 * 
	 * @return void
	 */
	public function __construct()
	{
		$this->_user = new User_admin();
	}

	/**
	 * Инициализирует генерирование страницы
	 * 
	 * @return boolean true
	 */
	public function init()
	{
		Dev::set_profiling();

		$this->include_other_file();

		Session_admin::init();

		include_once (ABSOLUTE_PATH.'includes/cache.php');
		$this->_cache = new Cache;
		$this->magic_quote_off();

		define('BASE_PATH', "http://".$_SERVER["HTTP_HOST"]."/".(REVATIVE_PATH ? REVATIVE_PATH.'/' : '').'adm/');
		define('BASE_URL', $_SERVER["HTTP_HOST"].(REVATIVE_PATH ? '/'.REVATIVE_PATH : ''));

		$this->get_language_array();
		$this->get_user();

		$this->reminding();
		$this->prepare_rewrite();
		$this->prepare_variables();

		$this->get_page_in_site();

		Gzip::init_gzip();
		$this->get_headers();
		$this->get_module();

		Dev::get_profiling();
		Gzip::do_gzip();
		return TRUE;
	}

	/**
	 * Подключает файлы для решения нестандартых задач (вывод каптчи...)
	 * 
	 * @return boolean true
	 */
	private function include_other_file()
	{
		if(preg_match('/code\/(.*)$/', $_GET["rewrite"], $ob))
		{
		    $_GET["rewrite"] = $ob[1];
		    include_once(ABSOLUTE_PATH.'includes/captcha/captcha.php.php');
		}
		return TRUE;
	}

	/**
	 * Записывает данные о языках сата
	 * 
	 * @return boolean true
	 */
	private function get_language_array()
	{
		unset($_lang);
		$this->language_all();
		include_once(ABSOLUTE_PATH.'language/'.LANGUAGE_BASE.'.php');
					
		if($_GET["rewrite"])
		{
			$rew = explode('/', $_GET["rewrite"], 2);
			foreach($this->language_all as $l => $langarr)
			{
				if(in_array($rew[0], $langarr))
				{
					$_GET["rewrite"] = preg_replace('/^'.$rew[0].'(\/)*/', '', $_GET["rewrite"]);
					define('_LANG', $langarr[0]);
					define('_SHORTNAME', '/'.$langarr[1]);
					define('TITLE', (defined('TIT'.$langarr[0]) ? constant('TIT'.$langarr[0]) : ''));
					define('BASE_PATH_HREF', "http://".$_SERVER["HTTP_HOST"]."/".(REVATIVE_PATH ? REVATIVE_PATH.'/' : '').ADMIN_FOLDER.'/'.$langarr[1].'/');
					break;
				}
			}
		}
		if(! defined('_LANG'))
		{	
			define('_LANG', '');
			define('TITLE', TIT);
			define('_SHORTNAME', '');
			define('BASE_PATH_HREF', "http://".$_SERVER["HTTP_HOST"]."/".(REVATIVE_PATH ? REVATIVE_PATH.'/':'').ADMIN_FOLDER.'/');
		}
		return TRUE;
	}

	/**
	 * Инициирует авторизацию или выход пользователя из системы
	 * 
	 * @return boolean true
	 */
	private function get_user()
	{
		if(! empty($_POST['action']) && $_POST['action'] == 'auth')
		{
			$this->_user->auth($_POST);
		}
		elseif(strstr($_GET["rewrite"], "logout"))
		{
			$this->_user->logout();
		}
		return TRUE;
	}

	/**
	 * Выводит форму восстановления пароля
	 * 
	 * @return boolean true
	 */
	private function reminding()
	{
		if(empty($this->_user->id) && ! empty($_GET["rewrite"]) && ($_GET["rewrite"] == "reminding" || $_GET["rewrite"] == "reminding/diafan"))
		{
			$this->rewrite = $_GET["rewrite"];
			$this->module = "reminding";
			include_once(ABSOLUTE_PATH.'adm/includes/theme.php');
			include_once(ABSOLUTE_PATH.'includes/model.php');
			include_once(ABSOLUTE_PATH.'adm/includes/reminding.php');
			include_once(ABSOLUTE_PATH.'modules/reminding/reminding.ajax.php');
			include_once(ABSOLUTE_PATH.'modules/reminding/reminding.view.php');
			$reminding = new Reminding_admin($this);
			$reminding->form();
			$theme     = new Theme_admin($this);
			include_once(ABSOLUTE_PATH.'adm/themes/adminreminding.php');
			exit;
		}
		return TRUE;
	}

	/**
	 * Подготавливает запрос для идентифицикации страницы в таблице {site} по rewrite или по id,
	 * удаляет из строки запроса $_GET[rewrite] переданные переменные
	 * 
	 * @return boolean true
	 */
	private function prepare_rewrite()
	{
		if($_GET["rewrite"])
		{		
			$rewrite_array = explode("/", $_GET["rewrite"]);
			
			foreach($rewrite_array as $key => $ra)
			{
		
				foreach($this->rewrite_variable_names as $name)
				{		
					if(preg_match('/'.$name.'([0-9]+)/', $ra, $result))
					{
						$this->$name = $result[1];
						unset($rewrite_array[$key]);
					}
				}
			}
			$this->rewrite = implode("/", $rewrite_array);
		}
		if(! $this->rewrite)
		{
			if(! $this->admin_roles('init', 'site') || ! $this->_user->id)
			{
				$this->rewrite = 'site';
			}
			else
			{
				$result = DB::query("SELECT id, rewrite FROM {adminsite} WHERE act='1' and parent_id>0 ORDER BY id asc"); 
				while ($row = DB::fetch_array($result))
				{
					if(! $this->admin_roles('init', $row["rewrite"]))
					{
						$this->rewrite = $row["rewrite"];
						break;
					}
				}
			}
		}
		return TRUE;
	}

	/**
	 * Подключает файл, выполняющий запрашиваемое действие на элементом
	 * 
	 * @return boolean true
	 */
	private function prepare_variables()
	{
		define('URL', path_module($this));
		
		if($this->del || $this->trash || ! empty($_GET["action"]) && ($_GET["action"] == 'trash' || $_GET["action"] == 'del'))
		{
			include(ABSOLUTE_PATH."adm/includes/del.php");
			$this->action = 'del_module';
			return TRUE;
		}
		
		if($this->restore || ! empty($_GET["action"]) && $_GET["action"] == 'restore')
		{
			$this->action = 'restore_module';
			include(ABSOLUTE_PATH."adm/includes/del.php");
			return TRUE;
		}
			
		if($this->up || $this->down)
		{
			include(ABSOLUTE_PATH."adm/includes/order.php");
			$this->action = 'order_module';
			return TRUE;
		}
			
		if($this->unblock || $this->block || ! empty($_GET["action"]) && ($_GET["action"] == 'block' || $_GET["action"] == 'unblock'))
		{
			include(ABSOLUTE_PATH."adm/includes/act.php");
			$this->action = 'act_module';
			return TRUE;
		}

		if($this->save)
		{
			include(ABSOLUTE_PATH."adm/includes/save.php");
			$this->action = 'save_module';
			return TRUE;
		}

		if($this->savenew && ! empty($_POST["id"]))
		{
			$this->save = intval($_POST["id"]);
			include(ABSOLUTE_PATH."adm/includes/save.php");
			$this->action = 'save_module';
			return TRUE;
		}
		
		if($this->savenew)
		{
			include(ABSOLUTE_PATH."adm/includes/save.php");
			$this->action = 'new_module';
			return TRUE;
		}
		
		include(ABSOLUTE_PATH."adm/includes/theme.php");
		
		if($this->uploadphoto)
		{
			include(ABSOLUTE_PATH."adm/includes/ajax.php");
			$this->action = 'upload_photo_module';
			return TRUE;
		}
		
		if($this->delphoto)
		{
			include(ABSOLUTE_PATH."adm/includes/ajax.php");
			$this->action = 'del_photo_module';
			return TRUE;
		}
		
		if(! empty($_GET["action"]) && $_GET["action"] == "sort-photo")
		{
			include(ABSOLUTE_PATH."adm/includes/ajax.php");
			$this->action = 'sort_photo_module';
			return TRUE;
		}
		
		if(! empty($_GET["action"]) && $_GET["action"] == "edit-photo")
		{
			include(ABSOLUTE_PATH."adm/includes/ajax.php");
			$this->action = 'edit_photo_module';
			return TRUE;
		}
		
		if(! empty($_POST["action"]) && $_POST["action"] == "save-photo")
		{
			include(ABSOLUTE_PATH."adm/includes/ajax.php");
			$this->action = 'save_photo_module';
			return TRUE;
		}

		if($this->uploadtag)
		{
			include(ABSOLUTE_PATH."adm/includes/ajax.php");
			$this->action = 'upload_tag_module';
			return TRUE;
		}

		if($this->deltag)
		{
			include(ABSOLUTE_PATH."adm/includes/ajax.php");
			$this->action = 'del_tag_module';
			return TRUE;
		}

		if($this->searchtag)
		{
			include(ABSOLUTE_PATH."adm/includes/ajax.php");
			$this->action = 'search_tag_module';
			return TRUE;
		}
		
		if(! empty($_POST["action"]) && $_POST["action"] == "sort-module")
		{
			include(ABSOLUTE_PATH."adm/includes/ajax.php");
			$this->action = 'sort_module';
			return TRUE;
		}
		
		if(! empty($_POST["action"]) && $_POST["action"] == "parent-module")
		{
			include(ABSOLUTE_PATH."adm/includes/ajax.php");
			$this->action = 'parent_id_module';
			return TRUE;
		}

		if($this->config)
		{
			$this->edit = 1;
		}

		if($this->edit || $this->addnew || $this->rewrite=="config")
		{
			include(ABSOLUTE_PATH."adm/includes/edit.php");
		}

		else
		{
			include_once(ABSOLUTE_PATH."adm/includes/show.php");
		}

		$this->action = 'show_theme';
		return TRUE;
	}

	/**
	 * Идентифицирует страницу, задает параметры страницы
	 * 
	 * @return boolean true
	 */
	private function get_page_in_site()
	{
		if($this->rewrite)
		{
			$row = DB::fetch_array(DB::query("SELECT id,name,text,parent_id FROM {adminsite} WHERE rewrite = '%h'", $this->rewrite));
		}

		if(empty($row))
		{
			include(ABSOLUTE_PATH.'includes/404.php');
		}

		$this->cid		= $row["id"];
		$this->name		= $row['name'];
		$this->text		= $row['text'];
		$this->parent_id	= $row['parent_id'];

		return TRUE;
	}

	/**
	 * Отдает браузеру заголовки страницы
	 * 
	 * @return boolean true
	 */
	private function get_headers()
	{
		header("Expires: " . date("r"));
		header("Cache-Control: no-store, no-cache, must-revalidate");
		header("Pragma: no-cache");
		header("Cache-Control: post-check=0, pre-check=0", FALSE);
		header('Content-Type: text/html; charset=utf-8');

		return TRUE;
	}

	/**
	 * Подключает модуль
	 * 
	 * @return boolean true
	 */
	private function get_module()
	{
		if($this->admin_roles('init') && $this->_user->id)
		{
			include(ABSOLUTE_PATH.'includes/404.php');
		}
		if(strstr($this->rewrite, '/'))
		{
			$module = preg_replace('/[^A-Za-z0-9-\.]+/', '', str_replace('/', '.admin.', $this->rewrite));
			$rew = explode('/', $this->rewrite);
			$rewrite = preg_replace('/[^A-Za-z0-9-]+/', '', $rew[0]);
		}
		else
		{
			$rewrite = preg_replace('/[^A-Za-z0-9-]+/', '',$this->rewrite);
			$module = $rewrite.'.admin';
		}

		if(file_exists(ABSOLUTE_PATH.'modules/'.$rewrite.'/'.$module.'.php') && $this->_user->id)
		{
			if(! empty($_GET["enterid"]))
			{
				$this->enterid = preg_replace('/[^0-9]+/', '', $_GET["enterid"]);
			}

			if($this->config)
			{
				if(! $this->admin_roles('config') && file_exists(ABSOLUTE_PATH.'modules/'.$rewrite.'/'.$module.'.config.php'))
				{
					include_once(ABSOLUTE_PATH.'modules/'.$rewrite.'/'.$module.'.config.php');
				}
				else
				{
					include(ABSOLUTE_PATH.'includes/404.php');
				}
			}
			else
			{
				include_once(ABSOLUTE_PATH.'modules/'.$rewrite.'/'.$module.'.php');
				$this->config = 0;
			}				
		}
		$this->module = $rewrite;
		$name_class_module = str_replace('.', '_', ucfirst($module)).($this->config ? '_config' : '');
		$name_func_module = 'inc_file_'.$rewrite;

		if(function_exists($name_func_module))
		{
			$name_class_module = $name_func_module($this);
		}

		if(in_array($name_class_module, get_declared_classes()))
		{
			$frame = new $name_class_module($this);
			$this->get_config_module($frame);
		}

		else
		{
			$frame = new Frame_admin($this);
		}

		if($this->enterid && ! empty($frame->config_module["parent"]) && ! DB::query_result("SELECT id FROM {".$frame->table."} WHERE id=%d", $this->enterid))
		{
			$this->goto_diafan(path_module($this, 0, 1));
			exit;
		}

		if($this->enterid && ! empty($frame->config_module["element"]) && ! DB::query_result("SELECT id FROM {".$frame->table."_category} WHERE id=%d", $this->enterid))
		{
			$this->goto_diafan(path_module($this, 0, 1));
			exit;
		}

		if($this->site && ! empty($frame->config_module["element_site"]) && ! DB::query_result("SELECT id FROM {site} WHERE id=%d", $this->site))
		{
			$this->goto_diafan(BASE_PATH_HREF.$thi->rewrite.'/');
			exit;
		}

		$action = $this->action;
		$frame->$action();

		return TRUE;
	}

	/**
	 * Определяет права доступа
	 * 
	 * @param string $module_name модуль
	 * @param string $action действие
	 * @param array $roles права пользователя
	 * @return boolean
	 */
	public function admin_roles($action, $module_name = '', $roles = '')
	{
		if(! $module_name)
		{
			$module_name = $this->rewrite;
		}
		if(! $roles)
		{
			$roles = $this->_user->roles;
		}

		return (! array_search('admin all', $roles) && ! array_search('admin '.$module_name.' all', $roles) && ! array_search('admin '.$module_name.' '.$action, $roles));
	}

	/**
	 * Задает настройку модуля по умолчанию
	 * 
	 * @return boolean true
	 */
	public function get_config_module(&$th)
	{
		$config_module = array('act', 'del', 'nopage', 'element', 'element_site', 'category', 'date', 'datetime', 'photo', 'prior',
				       'parent', 'menu', 'view', 'order', 'trash', 'no_out', 'tab_card', 'search_name');

		foreach($config_module as $param)
		{
			if(empty($th->config_module[$param]))
			{
				$th->config_module[$param] = '';
			}
		}

		return TRUE;
	}

	/**
	 * Борьба с магическими кавычками
	 * 
	 * @return boolean true
	 */
	private function magic_quote_off()
	{
		if(get_magic_quotes_gpc())
		{
			$_GET = $this->stripslashes_array($_GET);
			$_POST = $this->stripslashes_array($_POST);
		}
		return TRUE;
	}

	/**
	 * Вырезает магические кавычки из массива
	 * 
	 * @return array
	 */
	private function stripslashes_array($array)
	{
		if(is_array($array))
		{
			foreach($array as $key => $value)
			{
				$array[$key] = $this->stripslashes_array($value);
			}
			return $array;
		}
		else
		{
			return stripslashes($array);
		}
	}
}