<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Frame_admin
 * 
 * Сортировка
 */
class Frame_admin
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var string таблица в базе данных
	 */
	public $table;

	/**
	 * @var array настройки отображения
	 */
	public $config_module = array();

	/**
	 * @var array поля таблицы с типами
	 */
	public $variable_table = array();

	/**
	 * @var array переводимые поля
	 */
	public $language_names = array();

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;	
	}

	/**
	 * Сортирует элементы
	 * 
	 * @return boolean
	 */
	public function order_module()
	{
		
		//проверка прав на сортировку
		if($this->diafan->admin_roles('order'))
		{
			$this->diafan->goto_diafan(URL);
			return FALSE;
		}

		//учитывается языковая версия, если это необходимо
		$lang = (in_array("act", $this->language_names) ? _LANG : '');
		
		$edit = (! empty($this->diafan->up) ? $this->diafan->up : $this->diafan->down);
		
		$sort = DB::query_result("SELECT sort FROM {".$this->table."} WHERE id='%d'", $edit);

		//для корректной сортировки в таблицы не должно быть несколько элементов с одинаковым значением sort
		if(DB::query_result("SELECT COUNT(id) FROM {".$this->table."} WHERE sort='%d'", $sort) > 1)
		{
			DB::query("UPDATE {".$this->table."} SET sort=sort+1 WHERE sort>='%d' AND id<>'%d'", $sort, $edit);
		}

		//при сотировки нужно учитывать параметр parent_id
		if($this->config_module["parent"])
		{
			$parent_id = DB::query_result("SELECT parent_id FROM {".$this->table."} where id='%d'", $edit);
		}

		//при сотировки нужно учитывать параметр cat_id
		elseif($this->config_module["element"])
		{
			$cat_id = DB::query_result("SELECT cat_id FROM {".$this->table."} where id='%d'", $edit);
		}

		//приоритет при сортировке отдается параметрам cat_id, act, actm, а затем только sort
		$order=
		($this->config_module["act"] ? 'act'.$lang.' '.($this->diafan->up ? "ASC" : "DESC").',' : '')
		.($this->config_module["menu"] ? 'actm '.($this->diafan->up ? "ASC" : "DESC").',' : '')
		.'sort '.($this->diafan->up ? "DESC" : "ASC")
		.',id '.($this->diafan->up ? "DESC" : "ASC")
		;

		//заблокированные элементы и страницы сайта, не показываемы в меню, не сортируются
		$where=
		($this->config_module["act"] ? " AND act".$lang."='1'" : '')
		.($this->config_module["menu"] ? " AND actm='1'" : '')
		.($this->config_module["trash"] ? " AND trash='0'" : '')
		.$this->where;

		//выбираем элемент, с которым поменяемся значениями sort		
		$row = DB::fetch_array(DB::query("SELECT id, sort FROM {".$this->table."} WHERE "
			." sort".($this->diafan->up ? '<' : '>')."%d"
			.($this->config_module["parent"]
			 ? " AND parent_id=%d"
			 :($this->config_module["element"] ? " AND cat_id=%d" : '')
			 )
			.$where." ORDER BY ".$order." LIMIT 1",
			$sort,
			($this->config_module["parent"] ? $parent_id : ($this->config_module["element"] ? $cat_id : ''))
		));

		DB::query("UPDATE {".$this->table."} SET sort='".$row["sort"]."' WHERE id=%d", $edit);

		DB::query("UPDATE {".$this->table."} SET sort='".$sort."' WHERE id=%d", $row["id"]);

		$this->diafan->_cache->delete("", $this->diafan->rewrite);

		$this->diafan->goto_diafan(URL);

		return TRUE;
	}
}
