<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Frame_admin
 * 
 * Список элементов
 */
class Frame_admin extends Theme_admin
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var string таблица в базе данных
	 */
	public $table;

	/**
	 * @var string таблица, которая делит элементы на категории (если отлична от $table.'_category')
	 */
	public $category_table;

	/**
	 * @var array настройки отображения
	 */
	public $config_module = array();

	/**
	 * @var array поля таблицы с типами
	 */
	public $variable_table = array();

	/**
	 * @var array варианты значений переменной с типом список, которые берутся из таблицы
	 */
	public $select = array();

	/**
	 * @var array варианты значений переменной с типом список
	 */
	public $select_arr = array();

	/**
	 * @var array переводимые поля
	 */
	public $language_names = array();

	/**
	 * @var array список дополнительных полей, выводимых в списке
	 */
	public $config_other_row;
	
	/**
	 * @var integer|string язык поля, обозначающего активность
	 */
	public $lang_act;

	/**
	 * @var integer количество элементов на странице, участвующих в сортировке
	 */
	public $count_order;

	/**
	 * @var integer счетчик
	 */
	public $k;

	/**
	 * @var array предки текущего раскрытого элемента
	 */
	public $enterid_parents;

	/**
	 * @var integer количество вложенных элементов
	 */
	public $count_children;

	/**
	 * @var array предки текущего элемента в списке
	 */
	public $elements_parents;

	/**
	 * @var string название поля таблицы, используемое для ссылки на страницу редактирования
	 */
	protected $name = 'name';

	/**
	 * @var string SQL-условия для списка
	 */
	protected $where;

	/**
	 * @var string GET переменные, участвующие в навигации для постраничного вывода
	 */
	protected $get_nav;

	/**
	 * @var integer количество элементов, показанных на странице
	 */
	protected $nastr = 30;

	/**
	 * @var integer количество ссылок постраничной навигации, показанных на одной страние
	 */
	protected $navnastr = 10;

	/**
	 * @var string ссылка на текущую страницу, используемая в постраничной навигации
	 */
	private $navlink;

	/**
	 * @var string ссылка на текущую страницу, используемая при раскрытии/закрытии дерева
	 */
	private $enterlink;

	/**
	 * @var integer порядковый номер элемента, с которого начинается вывод элементов
	 */
	private $polog = 0;

	/**
	 * @var integer количество элементов в списке
	 */
	private $nen;

	/**
	 * @var boolean отображать групповые операции
	 */
	protected $group_actions = FALSE;

	/**
	 * @var integer общее количество елементов
	 */
	protected $count;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;	
	}

	/**
	 * Формирует список элементов
	 *
	 * @param integer $id родитель
	 * @param integer $r подрядковый номер
	 * @return boolean true
	 */
	public function list_row($id = 0, $r = '')
	{
		$this->get_folders();
		if(! $id || !$this->config_module["parent"])
		{
			$this->group_actions_show();
		}
		$this->prepare_variables($id);
		
		$links  = $this->prepare_paginator($id);
		$nen = $this->nen;

		$result = $this->sql_query($id);

		while ($row = DB::fetch_array($result))
		{ 
			$this->prepare_variables_id($row);

	        $link = $this->get_base_link($row);

			echo '
			<tr altcolor="#eeeeee" class="tr">'

				//выводит название раздела
				.$this->get_parent_name($row)
				
				//выводит дату
				.($this->config_module["date"]
				 ? '
				 <td>'.date("d.m.Y", $row["created"]).'</td>'
				 : '')
				
				//выводит дату и время
				.($this->config_module["datetime"]
				 ? '
				 <td>'.date("d.m.Y H:i", $row["created"]).'</td>'
				 : '')

				.$this->get_photo_link($row["id"], $link).'

				<td class="tdedit'.$r.'" style="padding-left: '.($r * 10 + 5).'px; width:'.(70 - count($this->config_other_row)*20).'%;">'
				.'<font>'
				
				//выводит + в виде ссылке на вложенные элементы
				.$this->get_plus($row)
				
				//выводит ссылку на редактирование
				.($link ? $link.($this->diafan->short_text($row["name"]) ? $this->diafan->short_text($row["name"]) : $row["id"]).'</a>' : '')
				.'</font>'
				
				//выводит индикатор Показан в меню
				.($this->config_module["menu"]
				 ? ($row["actm"] ? ' (м)' : '')
				 : '');
				
				//выводит прочие поля таблицы
				$this->get_other_rows($row);
				
				echo '</td><td>'
				
				//выводит кнопки удаление, добавление, сортировка
				.$this->get_action($row, $r, $nen);
			if($this->group_actions)
			{
				echo '
				</td><td class="checkbox">';
			
				if($this->config_module["del"]
				   && ! $this->diafan->admin_roles('del')
				   && ($this->table != "trash" || ! $row["parent_id"])
				   && ($this->table != "language" || $row["id"] != 1)
				   && ($this->table != "users" || $this->diafan->_user->id != $row["id"])
				   ||
				   $this->config_module["act"]
				   && ! $this->diafan->admin_roles('act')
				   && ($this->table != "users" || $this->diafan->_user->id != $row["id"])
				   && ($this->table != "trash" || ! $row["parent_id"])
				   && ($this->table != "language" || $row["id"] != 1))
				{
					echo '<input type="checkbox" name="ids[]" value="'.$row["id"].'">';
				}
			}
			echo '
			</td></tr>'."\n";
			
			//выводит вложенные элементы
			if(! empty($this->config_module["parent"])
				&& in_array($row["id"], $this->enterid_parents)
				&& $this->config_module["parent"] != $r + 2
			)
			{
				$k = $this->k;
				$this->list_row($row["id"], $r + 1);
				$this->k = $k;
			}
	
		}
		$this->group_actions($links, $id);
		return TRUE;
	}

	/**
	 * Выводит вложенные категории
	 *
	 * @return boolean
	 */
	private function get_folders()
	{
		if(! $this->config_module["element"])
		{
			return FALSE;
		}

		$cats = '';
		$result = @DB::query("SELECT id, [name], [act] FROM {".$this->table."_category} WHERE trash='0' AND parent_id=%d", $this->diafan->cat);
		while ($row = DB::fetch_array($result))
		{
			$cats .= '
			<a href="'.BASE_PATH_HREF.$this->diafan->rewrite.'/cat'.$row["id"].'/"'.(! $row["act"] ? ' class="noplus"' : '').'>'.$row["name"].'</a>';
		}
		if($cats)
		{
			echo '<p>'._ADMIN_CHILD_CATEGORY.': '.$cats.'</p>';
		}
		return TRUE;
	}

	private function group_actions_show()
	{
		$this->count = DB::query_result("SELECT COUNT(*) FROM {".$this->table."} WHERE 1=1"
							.($this->config_module["element"]  ? " AND cat_id='".$this->diafan->cat."'" : '')
							.($this->config_module["element_site"] && $this->diafan->site ? " AND site_id='".$this->diafan->site."'" : '')
							.($this->where                     ? " ".$this->where : '')
							.($this->table == 'site'           ? " AND id<>1" : '')
							.($this->config_module["trash"] ? " AND trash='0'" : ''));
		$this->group_actions = $this->count > 3;
	}

	/**
	 * Определяет свойства класса
	 *
	 * @param integer $id родитель
	 * @return boolean true
	 */
	private function prepare_variables($id)
	{	
		$this->name .= (in_array($this->name, $this->language_names) ? _LANG : '');
		
		$this->k = 1;
		$this->lang_act = in_array("act", $this->language_names) ? _LANG : '';
		
		if($this->config_other_row)
		{
			foreach($this->config_other_row as $key => $value)
			{
				$this->config_other_row[$key] .= (in_array($value,$this->language_names) ? _LANG : '');
			}
		}
		
		//для корректной сортировки не должно быть элементов в нулевым значением поля sort
		if($this->config_module["order"])
		{
			DB::query("UPDATE {".$this->table."} SET sort=id WHERE sort=0");
			$this->count_order = $this->count_order($id);
		}
		
		if($this->config_module["parent"])
		{
			$this->enterid_parents = $this->diafan->get_parents($this->diafan->enterid, $this->table);
		}
		return TRUE;
	}

	/**
	 * Подсчитывает сколько элементов на данной странице нужно сортировать, если в конфигурации разрешена соритовка
	 *
	 * @param integer $id родитель
	 * @return integer
	 */
	private function count_order($id)
	{
		return 
		($this->config_module["order"]
		?
			DB::query_result("SELECT COUNT(id) FROM {".$this->table."} WHERE 1=1"
			.($this->config_module["parent"]  ?" AND parent_id='".$id."'" : '')
			.($this->config_module["element"] ?" AND cat_id='".$id."'" : '')
			.($this->config_module["element_site"] && $this->diafan->site ? " AND site_id='".$this->diafan->site."'" : '')
			.($this->where                    ? " ".$this->where : '')
			.($this->config_module["act"]     ? " AND act".$this->lang_act."='1'" : '')
			.($this->config_module["menu"]    ? " AND actm='1'" : '')
			.($this->table == 'site'          ? " AND id<>1" : '')
			.($this->config_module["trash"]   ? " AND trash='0'" : '')
			.' LIMIT '.$this->polog.', '.$this->nastr
			)
		: 0);
	}

	/**
	 * Формирует постраничную навигацию
	 *
	 * @return array
	 */
	private function prepare_paginator($id)
	{
		include_once(ABSOLUTE_PATH.'includes/paginator/paginator.inc.php');
		$paginator = new Paginator_inc();
		if($this->nastr)
		{
			$paginator->nastr = $this->nastr;
		}
		if(! $id || ! $this->config_module["parent"])
		{
			$paginator->page    = $this->diafan->page;
			$paginator->navlink = ($this->diafan->rewrite ? $this->diafan->rewrite.'/' : '')
			                     .($this->diafan->site    ? 'site'.$this->diafan->site.'/' : '')
			                     .($this->diafan->cat     ? 'cat'.$this->diafan->cat.'/' : '');
			$this->enterlink     = $paginator->navlink.'enterid%d/'
			                      .($paginator->page ? 'page'.$paginator->page.'/' : '').'?';
			$paginator->get_nav = $this->get_nav;
			$this->navlink     .= $paginator->navlink.'enterid%d/'
			                     .($paginator->page ? 'page'.$paginator->page.'/' : '')
					     .($this->get_nav ? $this->get_nav.'&' : '?');
		}
		elseif($this->config_module["parent"])
		{
			$paginator->page    = ! empty($_GET["page".$id]) ? intval($_GET["page".$id]) : 0;
			$paginator->urlpage = 'page'.$id.'=%d';
			$this->enterlink    = $this->enterlink.($paginator->page ? 'page'.$id.'='.$paginator->page : '').'&';
			$paginator->navlink = sprintf($this->navlink, $id);
			$paginator->get_nav = '';
			$this->navlink     .= $paginator->page ? 'page'.$id.'='.$paginator->page.'&' : '';
		}

		$this->nen = DB::query_result("SELECT COUNT(id) FROM {".$this->table."} WHERE 1=1"
		.($this->config_module["parent"]  ? " AND parent_id='".$id."'" : '')
		.($this->config_module["element"] ? " AND cat_id='".$id."'" : '')
		.($this->config_module["element_site"] && $this->diafan->site ? " and site_id='".$this->diafan->site."'" : '')
		.($this->where                    ? " ".$this->where:'')
		.($this->table == 'site'          ? " AND id<>1" : '')
		.($this->config_module["trash"]   ? " AND trash='0'" : '')
		);
		$paginator->nen = $this->nen;

		$links = $paginator->get();
		$this->polog = $paginator->polog;
		$this->nastr = $paginator->nastr;

		return $links;
	}

	/**
	 * Формирует SQL-запрос для списка элементов
	 *
	 * @param integer $id родитель
	 * @return resource
	 */
	private function sql_query($id)
	{
		return DB::query("SELECT id, ".$this->name." AS name"
			.($this->config_module["act"]      ? ', act'.$this->lang_act.' AS act' : '')
			.($this->config_module["menu"]     ? ', actm' : '')
			.($this->config_module["parent"]   ? ', parent_id' : '')
			.($this->config_other_row          ? ', '.implode(', ',$this->config_other_row) : '')
			.($this->config_module["date"] || $this->config_module["datetime"] ? ', created' : '')
			.($this->config_module["view"]     ? ', othurl, addmodule' : '')
			.($this->config_module["element_site"] ? ', site_id' : '')
			.($this->config_module['element'] || $this->category_table ? ', cat_id' : '')
			." FROM {".$this->table."} WHERE 1=1"
			.($this->config_module["parent"]   ? " AND parent_id='".$id."'" : '')
			.($this->config_module["element"]  ? " AND cat_id='".$id."'" : '')
			.($this->config_module["element_site"] && $this->diafan->site ? " AND site_id='".$this->diafan->site."'" : '')
			.($this->where                     ? " ".$this->where : '')
			.($this->table == 'site'           ? " AND id<>1" : '')
			.($this->config_module["trash"]    ? " AND trash='0'" : '')
			." ORDER BY "
			.($this->category_table            ? 'cat_id ASC, ' : '')
			.($this->config_module["prior"]    ? 'prior DESC, ' : '')
			.($this->config_module["date"] || $this->config_module["datetime"] ? 'created DESC, ' : '')
			.($this->config_module["act"]      ? 'act'.$this->lang_act.' DESC, ' : '')
			.($this->config_module["menu"]     ? 'actm DESC, ' : '')
			.($this->config_module["order"]    ? 'sort ASC, id ASC' : 'id DESC')
			.' LIMIT '.$this->polog.', '.$this->nastr
		);
	}

	/**
	 * Подготовка текущего элмента списка
	 *
	 * @param array $row информация о текущем элменте списка
	 * @return boolean true
	 */
	private function prepare_variables_id($row)
	{
		if($this->config_module["parent"])
		{
			$this->elements_parents = $this->diafan->get_parents($row["id"], $this->table);
		}

		//количество вложенных элементов
		$this->count_children = ($this->config_module["parent"]
					? DB::query_result("SELECT count(id) FROM {".$this->table."} WHERE parent_id='".$row["id"]."'"
					.($this->config_module["trash"] ? " and trash='0'" : ''))
					: 0
					);
		$this->k++;
		return TRUE;
	}

	/**
	 * Выводит название раздела/категории в списке
	 *
	 * @param array $row информация о текущем элменте списка
	 * @return string
	 */
	private function get_parent_name($row)
	{
		return ($this->category_table && ! $this->diafan->cat ? '<td class="parent_name">'.($row["cat_id"] ? DB::title($this->category_table, $row["cat_id"], "name") : $this->select["cat_id"][7]).'</td>' : '')
		.($this->config_module["element_site"] ? '<td class="parent_name">'.DB::title("site", $row["site_id"], "name").'</td>' : '');
	}

	/**
	 * Выводит ссылку на вложенные элементы
	 *
	 * @param array $row информация о текущем элменте списка
	 * @return string
	 */
	private function get_plus($row)
	{
		return ($this->config_module["parent"]
			? ($this->count_children
			   ? '<a href="'.BASE_PATH_HREF.sprintf($this->enterlink, (in_array($row["id"], $this->enterid_parents) ? $row["parent_id"] : $row["id"])).'" class="plus"'
			    .' title="'.(in_array($row["id"], $this->enterid_parents) ? _ADMIN_CURTAIL : _ADMIN_UNWRAP).'">'
			    .(in_array($row["id"], $this->enterid_parents) ? '&#151;' : '+').'</a>'
			    : '&nbsp;&nbsp;'
			  )
			: ''
			);
	}

	/**
	 * Формирует основную ссылку для элемента в списке
	 *
	 * @param array $row информация о текущем элменте списка
	 * @return string
	 */
	private function get_base_link($row)
	{
		if($this->diafan->module == "trash")
			return '';
		
		$link = ' <a href="'
			.($this->config_module["view"] && $row["addmodule"] && $row["addmodule"] != "reminding" && file_exists(ABSOLUTE_PATH.'modules/'.$row["addmodule"].'/'.$row["addmodule"].'.admin.php')
			 ? BASE_PATH_HREF.$row["addmodule"].'/site'.$row["id"].'/"'
			 : ($this->config_module["category"]
			   ? path_module($this->diafan, 1, 1).'cat'.$row["id"]
			   : (! $this->diafan->admin_roles('edit')
			     ? path_module($this->diafan, 0, ($this->diafan->enterid && in_array($this->diafan->enterid, $this->elements_parents)? 0 : 1)).'edit'.$row["id"]
			     : '#'
			     )
			   )
			   .'/" title="'._LANG_EDIT.' ('.$row["id"].')"'
			)
			.($this->config_module["act"] ? (! $row["act"] ? ' class="noplus"' : '') : '').'>';
		return $link;
	}

	/**
	 * Выводит изображение элемента в списке
	 *
	 * @param integer $id номер элемета
	 * @param string $link основная ссылка
	 * @return string
	 */
	private function get_photo_link($id, $link)
	{
		if(! $this->config_module["photo"])
		{
			return FALSE;
		}
		$photo_row = DB::fetch_array(DB::query("SELECT id, name FROM {images} WHERE element_id=%d AND module_name='%s' AND trash='0' ORDER BY sort ASC LIMIT 1" ,$id, $this->table));
		if($photo_row && file_exists(ABSOLUTE_PATH.USERFILES."/".$this->table."/small/".$photo_row["name"]."_".$photo_row["id"].".jpg"))
		{
			$photo = '<img src="http://'.BASE_URL.'/'.USERFILES.'/'.$this->table."/small/".$photo_row["name"]."_".$photo_row["id"].'.jpg" border="0">';
		}
		
		
		return '<td>'.(! empty($photo) ? $link.$photo.'</a>' : '').'</td>';
	}

	/**
	 * Выводит дополнительную информацию для элемента в списке
	 *
	 * @param array $row информация о текущем элменте списка
	 * @return boolean true
	 */
	private function get_other_rows($row)
	{
		if($this->config_other_row)
		{
			foreach($this->config_other_row as $value)
			{
				$func = 'other_row_'.preg_replace('/[^a-z_]+/', '', $value);
				echo 
				(method_exists($this,$func)
				? $this->$func($row)
				: '</td><td class="Comments">
					<div>
						<span></span>
						<table><tbody><tr><td>
							'.$this->diafan->short_text($row[$value]).'
						</td></tr></tbody></table>
					</div>
				'
				);
			}
		}
		return TRUE;
	}

	/**
	 * Выводит ссылки на добавление, удаление, активацию, сортировку
	 *
	 * @param array $row информация о текущем элменте списка
	 * @param integer $r порядковый номер
	 * @param integer $nen количество элеметнов в списке
	 * @return string
	 */
	private function get_action($row, $r, $nen)
	{
		if($this->config_module["view"] && $row["act"])
		{
			$row["rewrite"] = DB::query_result("SELECT rewrite FROM {rewrite} WHERE site_id=%d AND module_name='site'", $row["id"]);
		}
		return '<div class="actions"><span><nobr> '
			.($this->config_module["parent"] 
			&& ! $this->diafan->admin_roles('addnew')
			&& $this->table != "trash"
			? '<a href="'.path_module($this->diafan, 0, 1).'enterid'.$row["id"].'/'.'addnew'.$row["id"].'/"'
			 .'title="'._ADMIN_ADD_SUBPAGE.'"><img src="'.BASE_PATH.'img/b1.gif"></a> '
			: '')

			.($this->config_module["act"] && ! $this->diafan->admin_roles('act')
			  && ($this->table != "users" || $row["id"] != $this->diafan->_user->id)
			 ?
				'<a href="'.URL.($row["act"] ? 'un' : '').'block'.$row["id"].'/" title="'
				.($row["act"] ? _ADMIN_BLOCK : _ADMIN_UNBLOCK).'">'
				.'<img src="'.BASE_PATH.'img/b'.($row["act"] ? '2' : '3').'.gif"></a> '
			 : '')

			.($this->config_module["del"]
			&& ($this->table != "trash" || ! $row["parent_id"])
			&& ! $this->diafan->admin_roles('del') 
			&& ($this->table != "language" || $row["id"] != 1)
			&& ($this->table != "users" || $this->diafan->_user->id != $row["id"])
			?
				'<a href="'.URL.($this->config_module["trash"] ? 'trash' : 'del').$row["id"].'/" title="'._LANG_DELETE.'"'
				.' onClick="if(! confirm(\''.($this->config_module["trash"]
				     ?
				     ($this->count_children ? _ADMIN_CONFIRM_TRASH_PARENT : _ADMIN_CONFIRM_TRASH)
				     :
				     ($this->count_children ? _ADMIN_CONFIRM_DELETE_PARENT : _ADMIN_CONFIRM_DELETE)
				    ).'\')){ return false; }">'
				.'<img src="'.BASE_PATH.'img/b4.gif"></a>'
			: '')
			.($this->config_module["order"] && ! $this->diafan->admin_roles('order')
			  && (! $this->config_module["act"] || $row["act"])
			  && (! $this->config_module["menu"] || $row["actm"]
			)
			 ?
				($this->k != 2 || $this->diafan->page > 1
				?
					'<a href="'.URL.'up'.$row["id"].'/" title="'._ADMIN_UP.'">'
					.'<img src="'.BASE_PATH.'img/b5.gif"></a> '
				: '')
				.($this->k < ($this->count_order + 1 - (($this->diafan->page ? $this->diafan->page : 1) - 1) * $this->nastr)
				?
					'<a href="'.URL.'down'.$row["id"].'/" title="'._ADMIN_DOWN.'">'
					.'<img src="'.BASE_PATH.'img/b6.gif"></a> '
				: '')
			 : '')
			.($this->config_module["view"] && $row["act"]
			 ?
				'<a href="http://'.BASE_URL._SHORTNAME.'/'.($row["rewrite"] ? $row["rewrite"] : $row["id"]).'/"'
				.' title="'._ADMIN_SHOW_PAGE_SITE.'" target="_blank">'
				.'<img src="'.BASE_PATH.'img/b7.gif"></a> '
			 : '')
			.'</nobr></span></div>';
	}

	/**
	 * Выводит кнопки для групповых операций и постраничную навигацию
	 *
	 * @param array $links ссылки для постраничной навигации
	 * @param integer $nen количество  элементов в списке
	 * @param integer $id родитель текущего уровня
	 * @return boolean true
	 */
	private function group_actions($links, $id)
	{
		if(! $this->group_actions)
		{
			return FALSE;
		}
		if(! $id || ! $this->config_module["parent"])
		{
			$count = 1;
			if($this->config_module["date"])
			{
				$count++;
			}
			if($this->config_module["datetime"])
			{
				$count++;
			}
			if($this->config_module["element_site"])
			{
				$count++;
			}
			if($this->config_module["photo"])
			{
				$count++;
			}
			$count += count($this->config_other_row);
			$count_group = 2;
			if($count > 5)
			{
				$count_group = $count - 5 + 2;
				$count = 5;
			}
			echo '<tr>
				<td align="center" colspan="'.$count.'">
					'.Paginator_view::get_admin($links).'
				</td>
				<td colspan="'.$count_group.'" align="right">'.(! $id || ! $this->config_module["parent"] ? ' '._ADMIN_CHECK_ALL.': <input type="checkbox" name="check_all" value="1">' : '').'</td>
			</tr>
			<tr>
				<td align="right" colspan="'.($count+$count_group).'" class="group-actions">
					'._ADMIN_GROUP_ACTION.': '
					.($this->config_module["act"] && ! $this->diafan->admin_roles('act') && $this->table != "users"
					?
					       '<a href="'.URL.'" title="'._ADMIN_UNBLOCK.'" action="block">'
					       .'<img src="'.BASE_PATH.'img/b2.gif"></a> '
					       .'<a href="'.URL.'" title="'._ADMIN_BLOCK.'" action="unblock">'
					       .'<img src="'.BASE_PATH.'img/b3.gif"></a> '
					: '')
	       
				       .($this->config_module["del"] && ! $this->diafan->admin_roles('del') 
				       ?
					       '<a href="'.URL.'" title="'._LANG_DELETE.'" action="'.($this->config_module["trash"] ? 'trash' : 'del').'"
						onClick="if(! confirm(\''.($this->config_module["trash"] ?  _ADMIN_CONFIRM_TRASH : _ADMIN_CONFIRM_DELETE)
						.'\')){ return false; }">'
					       .'<img src="'.BASE_PATH.'img/b4.gif"></a>'
				       : '')
	       
				       .($this->table == "trash" 
				       ?
					       '<a href="'.URL.'" title="'._LANG_RESTORE.'" action="restore">'._LANG_RESTORE.'</a>'
				       : '')
				.'</td>
			</tr>
		';
		}
		else
		{
			echo '<tr>
				<td align="center" colspan="7">
					'.Paginator_view::get_admin($links).'
				</td>
			</tr>';
		}
		return TRUE;
	}

	/**
	 * Выводит ссылку на добавление элемента
	 *
	 * @param string $text текст ссылки "Добавить элемент"
	 * @return boolean true
	 */
	protected function addnew_init($text)
	{
		echo '
		<div class="add">
			<a href="'.URL.'addnew1/" title="'.$text.'">'.$text.'</a>
		</div>';
		return TRUE;
	}
}