<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Theme_admin
 * 
 * Представление в административной части
 */
class Theme_admin
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var string таблица в базе данных
	 */
	public $table;

	/**
	 * @var string таблица, которая делит элементы на категории (если отлична от $table.'_category')
	 */
	public $category_table;

	/**
	 * @var array настройки отображения
	 */
	public $config_module = array();

	/**
	 * @var array варианты значений переменной с типом список, которые берутся из таблицы
	 */
	public $select = array();

	/**
	 * @var array варианты значений переменной с типом список
	 */
	public $select_arr = array();

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;	
	}

	/**
	 * Выводит контент модуля
	 * @return boolean true
	 */
	public function show_module()
	{
		return TRUE;
	}

	/**
	 * Подключает шаблон
	 * 
	 * @return boolean true
	 */
	public function show_theme()
	{
		if($this->diafan->_user->id)
		{
			$site_theme = file_get_contents(ABSOLUTE_PATH.'adm/themes/admin.php');
		}
		else
		{
			$site_theme = file_get_contents(ABSOLUTE_PATH.'adm/themes/adminauth.php');
		}
		$this->get_function_in_theme($site_theme);
		
		echo '<!-- версия '.VERSION_CMS.' '.date("d.m.Y",DATE_UPDATE).'-->';
		return TRUE;
	}

	/**
	 * Парсит шаблон
	 * 
	 * @return boolean true
	 */
	private function get_function_in_theme($text)
	{
		$text = str_replace('<?php if(!defined("DIAFAN")){include("../../includes/404.php");}?>', '', $text);
		$regexp = '/(<insert ([^>]*)>)/im';
		$tokens = preg_split($regexp, $text, -1, PREG_SPLIT_DELIM_CAPTURE);
		$cnt = count($tokens);
		echo $tokens[0];
		$i = 1;
		while ($i < $cnt)
		{
			$i++;
			$att_string 	= $tokens[$i++];
			$data 		= $tokens[$i++];
			$attributes 	= $this->parse_attributes($att_string);
			$this->start_element($attributes);
			echo $data;
		}
		return TRUE;
	}

	/**
	 * Парсит атрибуты шаблонного тэга
	 * 
	 * @return array
	 */
	private function parse_attributes($string)
	{
		static $entities = array(
			'&lt;' 		=> '<',
			'&gt;' 		=> '>',
			'&amp;' 	=> '&',
			'&quot;' 	=> '"',
			'[' 		=> '<',
			']' 		=> '>',
			'`' 		=> '"'
		);
		
		$attributes = array();
		$match = array();
		preg_match_all('/([a-zA-Z_0-9]+)="((?:\\\.|[^"\\\])*)"/U', $string, $match);
		for($i = 0; $i < count($match[1]); $i++)
		{
			$attributes[strtolower($match[1][$i])] = strtr((string) $match[2][$i], $entities);
		}
		return $attributes;
	}

	/**
	 * Выполняет действие, заданное в шаблонном тэге: выводит информацию или подключает шаблонную функцию
	 *
	 * @param array атрибуты шаблонного тэга
	 * @return boolean true
	 */
	private function start_element($attributes)
	{
		if(empty($attributes['name']))
		{
			if(! empty($attributes['value']) && defined($attributes['value']))
			{
				echo constant($attributes['value']);			
			}
			return;
		}
		
		switch($attributes['name'])
		{
			case "path":
				echo BASE_PATH;
			break;

			case "path_url":
				echo BASE_PATH_HREF;
			break;

			case "base_url":
				echo BASE_URL;
			break;

			case "userid":
				echo $this->diafan->_user->id;
			break;

			case "userfio":
				echo $this->diafan->_user->fio;
			break;

			case "errauth":
				switch($this->diafan->_user->errauth)
				{
					case 'wrong_login_or_pass':
						echo '<font color="#FF0000"><b>'._LANG_WRONG_LOGIN_OR_PASS.'</b></font><br>';
					break;

					case 'blocked_30_min':
						echo '<font color="#FF0000"><b>'._LANG_BLOCKED_30_MIN.'</b></font><br>';
					break;

					case 'blocked':
						echo '<font color="#FF0000"><b>'._LANG_LOGIN_BLOCKED.'</b></font><br>';
					break;
				}
			break;

			default:
				if(method_exists($this, $attributes['name']))
				{
					$this->$attributes['name']($attributes);
				}
		}
		return TRUE;
	}

	/**
	 * Выводит заголовок. Используется между тегами <title></title> в шапке сайта
	 * 
	 * @return boolean true
	 */
	private function show_title()
	{
		echo ($this->diafan->name ? $this->diafan->name.' - ' : '')."CMS ".BASE_URL;
		return TRUE;
	}

	/**
	 * Выводит меню
	 * 
	 * @return boolean true
	 */
	private function show_menu_admin()
	{
		echo '<table width="100%" cellpadding="0" cellspacing="0">';
			foreach($this->diafan->_user->roles as $r)
			{
				if(strstr($r, 'admin all') || preg_match('/admin (.*) all/', $r) || preg_match('/admin (.*) config/', $r))
				{
					$configmodules = 1;
				}
			}
			
			$result = DB::query("SELECT id, name FROM {adminsite} WHERE act='1' and parent_id='0' ORDER BY id asc"); 
			while ($row = DB::fetch_array($result))
			{
				$menu = '
					<tr><td colspan="3" class="fist-tr-menu">'.$row["name"].'</td></tr>';

				$k = 0;
				$ic = '';
				$result2 = DB::query("SELECT id, name, rewrite FROM {adminsite} WHERE act='1' and parent_id=%d ORDER BY sort ASC", $row["id"]); 
				while ($row2 = DB::fetch_array($result2))
				{
				if(! $this->diafan->admin_roles('init', $row2["rewrite"]) && ($row2["rewrite"] != "configmodules" || ! empty($configmodules)))
				{ 
					echo $menu.'
					<tr>
						<td'.($k ? ' class="td-menu"' : '').'>
							';
					if($this->diafan->rewrite != $row2["rewrite"] || ! empty($this->diafan->config))
					{
						echo '<a href="'.BASE_PATH_HREF.$row2["rewrite"].'/">';
					}
					echo $row2["name"];
					if($this->diafan->rewrite != $row2["rewrite"] || ! empty($this->diafan->config))
					{
						echo '</a>';
					}
					echo '
						</td>
						<td>'
						.(file_exists('adm/img/'.$row2["rewrite"].'.gif') ? '<img src="'.BASE_PATH.'img/'.$row2["rewrite"].'.gif">' : '')
						.'</td>
						<td class="act-menu">'.($this->diafan->rewrite == $row2["rewrite"] ? '<div></div>' : '').'</td>
					</tr>';
					if(strstr($this->diafan->rewrite, $row2["rewrite"]))
					{
						$m = 0;
						$result3 = DB::query("SELECT id, name, rewrite FROM {adminsite} WHERE act='1' AND parent_id='".$row2["id"]."' ORDER BY id ASC"); 
						while ($row3 = DB::fetch_array($result3))
						{
							if(! $this->diafan->admin_roles('init', $row3["rewrite"]))
							{ 
								echo '
								<tr>
								<td class="td-menu-level">'

								.($this->diafan->rewrite != $row3["rewrite"]
								 ? '<a href="'.BASE_PATH_HREF.$row3["rewrite"].'/">'
								 : '')

								.$row3["name"]

								.($this->diafan->rewrite != $row3["rewrite"]
								 ? '</a>'
								 : '')

								.'</td>
								<td></td>
								<td class="act-menu">'

								.($this->diafan->rewrite == $row3["rewrite"]
								 ? '<div><img src="'.BASE_PATH.'img/menu-act.gif" width="22px" height="41" alt=""></div>'
								 : '')
								
								.'</td>
								</tr>';
							}
							$m = 1;
						}
						echo $m ? '<tr><td colspan="3"><br></td></tr>' : '';
					}
					$menu = '';
					$k++;
				}
			}
		}
		echo '</table>';
		return TRUE;
	}

	/**
	 * Выводит навигации по сайту «Хлебные крошки»
	 * 
	 * @return boolean
	 */
	public function show_path_admin()
	{
		
		if($this->diafan->rewrite != "site" || ! empty($this->diafan->enterid) || ! empty($this->diafan->edit) || ! empty($this->diafan->config))
		{
			echo '<a href="'.BASE_PATH_HREF.'">'._ADMIN_SITE.'</a> ';
		}

		if($this->diafan->rewrite && $this->diafan->rewrite != "site")
		{
			if($this->diafan->parent_id != 1 && $this->diafan->parent_id != 16 && $this->diafan->parent_id != 15)
			{
				echo '&gt; <a href="'.BASE_PATH_HREF.DB::title("adminsite", $this->diafan->parent_id, "rewrite").'/">'
				.DB::title("adminsite", $this->diafan->parent_id, "name").'</a> ';
			}
			echo '&gt; <a href="'.BASE_PATH_HREF.$this->diafan->rewrite.'/">'.$this->diafan->name.'</a>';
		}

		if($this->diafan->enterid && $this->table != "trash" || $this->diafan->cat && $this->table != "votes")
		{
			if($this->config_module["element"] && $this->diafan->cat)
			{
				$this->diafan->parents = array_reverse($this->diafan->get_parents($this->diafan->cat, $this->table.'_category'));
			}
			elseif($this->config_module["parent"] && $this->diafan->enterid)
			{
				$this->diafan->parents = array_reverse($this->diafan->get_parents($this->diafan->enterid, $this->table));
			}
			if(! empty($this->diafan->parents))
			{
				foreach($this->diafan->parents as $p)
				{
					echo ' > <a href="';
					if(! empty($this->config_module["element"]))
					{
						echo path_module($this->diafan, 0, 0, 1, 1).'cat';
					}
					else
					{
						echo path_module($this->diafan,0,1,1,0).'enterid';
					}
					echo $p.'/">';
	
					$table = $this->table.($this->config_module["element"] ? '_category' : '');
					echo DB::title($table, $p, "name");
					echo '</a>';
				}
			}
		}
		echo $this->diafan->config ? ' > <a href="'.URL.'">'._ADMIN_CONFIG_MODULE.'</a>' : '';
		return TRUE;
		
	}

	/**
	 * Выводит ссылки на альтернативные языковые версии сайта
	 * 
	 * @return boolean
	 */
	private function show_language()
	{
		if(count($this->diafan->language_all) < 2)
			return;
		
		foreach($this->diafan->language_all as $key => $language)
		{
			echo ($language[0] != _LANG ? '<a href="http://'.BASE_URL.'/'.ADMIN_FOLDER.'/'.($language[1] ? $language[1].'/' : '')
			.($_GET["rewrite"] ? $_GET["rewrite"].'/'.($this->diafan->config ? 'config1/' : '') : '').'">' : '')
			.$language[2].($language[0] != _LANG ? '</a>' : '').' ';
		}
		return TRUE;
	}

	/**
	 * Выводит основной контент страницы
	 * 
	 * @return boolean true
	 */
	private function show_body_admin()
	{	
		$this->show_title_body();	
		$this->show_module_body();
		return TRUE;
	}

	/**
	 * Выводит помощь по странице
	 * 
	 * @return boolean true
	 */
	private function show_help_text()
	{
		echo str_replace('base_path/', BASE_PATH_HREF, $this->diafan->text);
		return TRUE;
	}

	/**
	 * Выводит заголовок страницы H1
	 * 
	 * @return boolean true
	 */
	private function show_title_body()
	{
		if(!$this->diafan->config && ($this->diafan->edit && $this->diafan->rewrite != "config" || $this->diafan->addnew))
		{
			$this->error_message();
			return;
		}
		
		if(! empty($this->config_module['element']) && ! empty($this->diafan->cat) && empty($this->category_table))
		{			
			$this->diafan->name = DB::title($this->table."_category", $this->diafan->cat, "name"._LANG);
			$c = '<font class="edit"> ('
			.'<a href="'.path_module($this->diafan, 0, 0, 0, 1).'enterid'.$this->diafan->cat.'/edit'.$this->diafan->cat.'/">'
			._ADMIN_EDIT
			.'</a>)</font>';	
		}
		elseif(! $this->diafan->config && ! empty($this->config_module['element_site']) && $this->diafan->site)
		{
			if($this->diafan->site)
			{
				$this->diafan->name = DB::title("site", $this->diafan->site, "name"._LANG);
				$c = $this->diafan->site;
			}
			$c = '<font class="edit"> (<a href="'.BASE_PATH_HREF.'site/edit'.$c.'/">'._ADMIN_EDIT.'</a>)</font>';
		}
		elseif($id = DB::where("site", "addmodule='".$this->diafan->rewrite."'", "id"))
		{
			$this->diafan->name = DB::title("site", $id, "name"._LANG);
			$c = '<font class="edit"> (<a href="'.BASE_PATH_HREF.'site/edit'.$id.'/">изменить</a>)</font>';
		}
		
		echo '<h1>'
			.(file_exists('adm/img/'.$this->diafan->rewrite.'.gif') ? '<img src="'.BASE_PATH.'img/'.$this->diafan->rewrite.'.gif">' : '').' '
			.($this->diafan->config ? $this->diafan->name.". "._ADMIN_CONFIG_MODULE : $this->diafan->name)
			.(! empty($c) ? $c : '')
		.'</h1>';

		if(! empty($this->config_module['element_site']))
		{
			$this->select_category('catid');
		}
		$this->error_message();
		return TRUE;
	}

	/**
	 * Выводит системное сообщение
	 * 
	 * @return boolean true
	 */
	private function error_message()
	{
		$error_mess = '_ADMIN_ERROR_'.$this->diafan->error;
		if(!empty($this->diafan->error) && defined($error_mess))
		{
			echo '<font color="red" size="3">'.constant($error_mess).'</font><br /><br />';
		}
		return TRUE;
	}

	/**
	 * Инициирует функцию-действие модуля
	 * 
	 * @return boolean
	 */
	private function show_module_body()
	{
		if($this->diafan->edit && ! $this->diafan->admin_roles('edit')
		   || $this->diafan->addnew && ! $this->diafan->admin_roles('addnew'))
		{
			$this->edit_module();
			return TRUE;
		}
		if($this->diafan->config && $this->diafan->admin_roles('config'))
		{
			return FALSE;
		}
		if(! $this->diafan->admin_roles('init'))
		{
			if(! empty($this->config_module['search_name']))
			{
				if(! empty($_GET["name"]))
				{
					$name = $this->diafan->get_param($_GET, "name", '', 1);
					$this->where   = " AND name like '%%".$name."%%'";
					$this->get_nav = ($this->get_nav ? '&amp;' : '?').'name='.$name;
				}
			}
			$this->show_module();
			if(! empty($this->config_module['search_name']) &&  (! empty($this->group_actions) || ! empty($_GET["name"])))
			{
				echo '
				<form action="'.BASE_PATH_HREF.$this->diafan->rewrite.'/'.($this->diafan->cat ? 'cat'.$this->diafan->cat.'/' : '').'" method="GET">
					<p>'._ADMIN_NAME.' <input type="text" name="name" value="'.(! empty($name) ? $name : '').'" size="20">
					<input type="submit" value="'._LANG_SEARCH.'"></p>
				</form>';
			}
			return TRUE;
		}
		return FALSE;
	}

	/**
	 * Выводит информацию о CMS
	 * 
	 * @return boolean true
	 */
	public function show_brand($a)
	{
		$number = preg_replace('/[^0-9]+/', '', $a["id"]);
		global $brandtext;
		include_once(ABSOLUTE_PATH.'adm/brand.php');
		echo $brandtext[$number];
		return TRUE;
	}

	/**
	 * Подключает необходимые JS-библиотеки
	 * 
	 * @return boolean true
	 */
	public function show_js()
	{
		echo '
		<script type="text/javascript" src="http://'.BASE_URL.'/adm/htmleditor/tiny_mce/tiny_mce.js"></script>
		<script type="text/javascript" src="http://'.BASE_URL.'/adm/htmleditor/tiny_mce/plugins/images/images_init.php"></script>
		<script type="text/javascript" src="http://'.BASE_URL.'/adm/htmleditor/tiny_mce/config.js"></script>';
		if(! empty($this->config_module['multiupload']))
		{
			echo '
			<script type="text/javascript" src="http://'.BASE_URL.'/js/fileuploader.js"></script>
			<script type="text/javascript" src="http://'.BASE_URL.'/js/multiupload-func.js"></script>
			<link href="'.BASE_PATH.'fileuploader.css" rel="stylesheet" type="text/css">';
		}

		return TRUE;
	}

	/**
	 * Формирует HTML-список
	 * 
	 * @return string
	 */
	protected function select_option($key, $table = '', $id = '', $name = '', $value = '', $where = "", $parent_id = "", $parent_value = 0, $marker = '', $order = 'id asc')
	{
		$list = '';
		if($parent_id && ! $marker)
		{
			$marker = "&nbsp;&nbsp;";
		}
		
		if(! empty($this->select_arr[$key]))
		{
			foreach($this->select_arr[$key] as $k => $val)
			{
				$list .= '<option value="'.$k.'"'.($value == $k ? ' selected' : '').'>'.$val.'</option>';
			}
			return $list;
		}
		$result = DB::query("SELECT ".$id.','.$name." FROM {".$table."} ".(! empty($where) ? "WHERE ".$where : '')
		.($parent_id ? ($where ? " AND " : 'WHERE ').$parent_id."='".$parent_value."'" : "")." ORDER BY ".$order);
		
		while ($row = DB::fetch_array($result))
		{
			$list.=
			'<option value="'.$row[$id].'"'.($value == $row[$id] ? ' selected':'').'>'
				.$this->diafan->short_text($marker.$row[$name],40)
			.'</option>'
			
			.($parent_id
			 ? $this->select_option($key, $table, $id, $name, $value, $where, $parent_id, $row[$id], $marker."&nbsp;&nbsp;")
			 : '');
		}
		return $list;
	}

	/**
	 * Формирует теги <option> при редактировании списка
	 *
	 * @param array $cats все возможные значения
	 * @param array $rows возможные значения для текущего уровня
	 * @param array $values значения
	 * @param string $marker отступ для текущего уровня
	 * @return boolean
	 */
	protected function get_options($cats, $rows, $values, $marker = '')
	{
		$text = '';
		foreach($rows as $row)
		{
			$text .=
			'<option value="'.$row["id"].'"'.(in_array($row["id"], $values) ? ' selected' : '').'>'
				.$marker.$this->diafan->short_text($row["name"], 40)
			.'</option>';
			if(! empty($cats[$row["id"]]))
			{
				$text .= $this->get_options($cats, $cats[$row["id"]], $values, $marker.'&nbsp;&nbsp;');
			}
		}
		return $text;
	}

	/**
	 * Выводит форму выбора страницы
	 * 
	 * @return boolean true
	 */
	protected function select_category($name)
	{
		echo '<p>'._ADMIN_SITE_ID.': <select rel="'.path_module($this->diafan, 0, 0, 0, 0, 1).'" class="redirect" name="site">'
		.'<option value="">'._LANG_ALL.'</option>';
		$result = DB::query("SELECT id, name FROM {site} WHERE trash='0' AND addmodule='%s' ORDER BY id ASC", $this->diafan->module);
		while ($row = DB::fetch_array($result))
		{
			$cats[0][] = $row;
		}
		echo $this->get_options($cats, $cats[0], array($this->diafan->site))
		.'</select></p>';
		return TRUE;
	}

	/**
	 * Выводит фотографии, прикрепленные к элементу
	 *
	 * @param integer $edit номер элемента
	 * @return string
	 */
	protected function show_edit_photo_module($edit)
	{
		$text = ' ';
		$k = 1;
		$result = DB::query("SELECT id, name, [alt], [title] FROM {images} WHERE module_name='%s' AND element_id='%d' ORDER BY sort ASC", $this->diafan->rewrite.($this->config_module['category'] ? "cat" : ""), $edit);
		$count = DB::num_rows($result);
		while ($row = DB::fetch_array($result))
		{
			if(! file_exists(ABSOLUTE_PATH.USERFILES."/".$this->diafan->rewrite.'/'.$row["name"].'_'.$row["id"].'.jpg'))
				continue;

			$text .= '<div class="images-actions'.($k == 1 ? ' first' :'').'" altcolor="#eeeeee" onMouseOver="show_action(this)" onMouseOut="show_action(this)">
				<a href="http://'.BASE_URL."/".USERFILES."/".$this->diafan->rewrite.'/'.$row["name"].'_'.$row["id"].'.jpg" class="image" target="_blank">'
			       .'<img src="http://'.BASE_URL."/".USERFILES."/".$this->diafan->rewrite."/small/".$row["name"].'_'.$row["id"].'.jpg?'.rand(0, 9999).'"'
			       .($k == 1 ? ' alt="'._ADMIN_MAIN_PHOTO.'" title="'._ADMIN_MAIN_PHOTO.'"' : '').'>'
			        .'</a>'

			.'<div>'
				.($row["alt"] ? 'alt: '.$row["alt"].' ' : '')
				.($row["title"] ? ($row["alt"] ? '<br>' : '').'title: '.$row["title"] : '&nbsp;')
			.'</div><div class="span">
			<a href="'.BASE_PATH_HREF.$this->diafan->rewrite.($this->diafan->cat ? '/cat'.$this->diafan->cat : '').'/delphoto'.$edit.'/?photodel='.$row["id"].'&amp;id=" title="'._ADMIN_PHOTOS_CONFIRM_DELETE.'" onClick="return ajax_action(this)"><img src="'.BASE_PATH.'img/b4.gif" width="15" height="15" alt="'._LANG_DELETE.'"></a>
			<a href="'.BASE_PATH_HREF.$this->diafan->rewrite.($this->diafan->cat ? '/cat'.$this->diafan->cat : '').'/?action=edit-photo&amp;img_id='.$row["id"].'&amp;id=" onClick="return ajax_action(this)"><img src="'.BASE_PATH.'img/edit.gif" width="12" height="14" alt="'._LANG_EDIT.'"></a>
			'.($k != 1 ? '<a href="'.BASE_PATH_HREF.$this->diafan->rewrite.($this->diafan->cat ? '/cat'.$this->diafan->cat : '').'/?action=sort-photo&amp;type=up&amp;img_id='.$row["id"].'&amp;id=" onClick="return ajax_action(this)"><img src="'.BASE_PATH.'img/b5.gif" width="14" height="16" alt="'._ADMIN_UP.'"></a>' : '').'
			'.($k != $count ? '<a href="'.BASE_PATH_HREF.$this->diafan->rewrite.($this->diafan->cat ? '/cat'.$this->diafan->cat : '').'/?action=sort-photo&amp;type=down&amp;img_id='.$row["id"].'&amp;id=" onClick="return ajax_action(this)"><img src="'.BASE_PATH.'img/b6.gif" width="14" height="16" alt="'._ADMIN_DOWN.'"></a> ' : '').'
			</div>
			<div class="clear"></div>
			</div>';
			$k++;
		}
		return $text;
	}

	/**
	 * Форма редактирования атрибутов alt и title для изображения
	 *
	 * @param array $row данные о изображении
	 * @return string
	 */
	protected function edit_img($row)
	{
		$text = '<a href="http://'.BASE_URL."/".USERFILES."/".$this->diafan->rewrite.'/'.$row["name"].'_'.$row["id"].'.jpg" class="image" target="_blank">'
		.'<img src="http://'.BASE_URL."/".USERFILES."/".$this->diafan->rewrite."/small/".$row["name"].'_'.$row["id"].'.jpg?'.rand(0, 9999).'">'
		.'</a>'

		.'<div>
		<p>alt:   <input name="alt"  type="text" value="'.$row["alt"].'"></p>
		<p>title: <input name="title" type="text" value="'.$row["title"].'"></p>
		<input type="button" value="'._LANG_SAVE.'" class="button ajax_save_photo" img_id="'.$row["id"].'">
		</div>
		<div class="clear"></div>';
		return $text;
	}

	/**
	 * Выводит тэги, прикрепленные к элементу
	 *
	 * @param integer $edit номер элемента
	 * @return string
	 */
	protected function show_edit_tags_module($edit)
	{

		$text = '';
		$result = DB::query("SELECT t.id, n.[name] FROM {tags} AS t "
				    ." INNER JOIN {tags_name} AS n ON n.id=t.tags_name_id"
				    ." WHERE t.module_name='%h' AND t.element_id='%d' AND t.trash='0' ORDER BY t.id DESC",
				    $this->diafan->rewrite, $edit);
		while($row = DB::fetch_array($result))
		{
			$text .= '<a href="'.BASE_PATH_HREF.'tags/edit'.$row["id"].'/">'.($row["name"] ? $row["name"] : $row["id"]).'</a>
			<a href="'.BASE_PATH_HREF.$this->diafan->rewrite.'/deltag'.$row["id"].'/?id=" title="'._ADMIN_TAGS_CONFIRM_DELETE.'" onClick="return ajax_action(this)">x</a>&nbsp;&nbsp; ';
		}
		return $text;
	}
}