<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Captcha_inc
 * 
 * Работа с каптчей
 */

class Captcha_inc
{
	/**
	 * Выводит каптчу
	 * 
	 * @param string $modules метка каптчи
	 * @param string $url адрес, на который будет отправлен запрос на обновление каптчи
	 * @param boolean $update обновление каптчи
	 * @return string
	 */
	public function get($modules = "modules", $error = "", $update = FALSE)
	{
		return Captcha_view::get($modules, $error, $update);
	}

	/**
	 * Проверяет правильность ввода каптчи
	 * 
	 * @param string $modules метка каптчи
	 * @return string|boolean false
	 */
	public function is_right($modules = "modules")
	{
		//Защитный код не введен
		if(empty($_POST['code']) || empty($_POST['codeint']))
			return _LANG_ENTER_CAPTCHA;

		//В сессии не записан код с данным идентификатором codeint
		if(! isset($_SESSION['captcha'][$modules][$_POST['codeint']])
		||
		//код из сессии не соответствует введенному. регистр не учитывается
		strtoupper($_SESSION['captcha'][$modules][$_POST['codeint']]) != strtoupper($_POST['code']))
			return _LANG_WRONG_CAPTCHA;

		//очищаем из сессии запись с данным идентификатором
		unset($_SESSION['captcha'][$modules][$_POST['codeint']]);
		return FALSE;
	}
}

require_once (ABSOLUTE_PATH.'includes/captcha/captcha.view.php');