<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	echo 'diafan.CMS version 4.3.7.6';
	exit;
}

/**
 * Init
 *
 * Основной класс системы
 */
class Init extends Core
{
	/**
	 * @var string ЧПУ текущей страницы сайта
	 */
	public $rewrite;

	/**
	 * @var string ЧПУ текущей страницы, сгенерированной модулем
	 */
	public $rewrite_module;

	/**
	 * @var string ЧПУ всех страниц
	 */
	public $rewrites;

	/**
	 * @var integer номер текущей страницы
	 */
	public $cid;

	/**
	 * @var string название текущей страницы
	 */
	public $name;

	/**
	 * @var string заголовок текущей страницы для тега title
	 */
	public $title_meta;

	/**
	 * @var string заголовок страницы, сформированный прикрепленным модулем
	 */
	public $titlemodule;

	/**
	 * @var string заголовок текущей страницы для тега title, сформированный прикрепленным модулем
	 */
	public $titlemodule_meta;

	/**
	 * @var string ключевые слова текущей страницы
	 */
	public $keywords;

	/**
	 * @var string описание текущей страницы
	 */
	public $descr;

	/**
	 * @var string прикрепленный к текущей страницы шаблон
	 */
	public $theme;

	/**
	 * @var string контент текущей страницы
	 */
	public $text;

	/**
	 * @var integer номер страницы-родителя
	 */
	public $parent_id;

	/**
	 * @var integer показывать текущую страницу в меню
	 */
	public $actm;

	/**
	 * @var boolean не показывать заголовок h1 текущей страницы
	 */
	public $title_no_show;

	/**
	 * @var integer время редактирования текущей страницы
	 */
	public $timeedit;

	/**
	 * @var string модуль, прикрепленный к текущей странице
	 */
	public $module;

	/**
	 * @var array часть навигация "Хлебные крошки", сформированная прикрепленным модулем
	 */
	public $path;

	/**
	 * @var array переменные, передаваемые в URL
	 */
	public $rewrite_variable_names_all = array('page', 'show', 'comments', 'cat', 'year', 'month', 'step', 'sort',
						   'add', 'edit', 'save', 'savenew', 'del');

	/**
	 * @var array переменные, прикрепленные к псевдоссылке текущей страницы
	 */
	public $rewrite_variable_in_page = array();

	/**
	 * @var array переменные, передаваемые в URL для текущего модуля
	 */
	public $rewrite_variable_names = array();

	/**
	 * @var integer номер страницы
	 */
	public $page;

	/**
	 * @var integer количество элементов, показанных на странице
	 */
	public $nastr = 10;

	/**
	 * @var string ссылка на текущую страницу, используемая в постраничной навигации
	 */
	public $navlink;

	/**
	 * @var integer порядковый номер элемента, с которого начинается вывод элементов
	 */
	public $polog;

	/**
	 * @var integer переменная, передаваемая в URL: номер элемента
	 */
	public $show;

	/**
	 * @var integer переменная, передаваемая в URL: номер страницы с комментариями 
	 */
	public $comments;

	/**
	 * @var integer переменная, передаваемая в URL: номер категории
	 */
	public $cat;

	/**
	 * @var integer переменная, передаваемая в URL: год
	 */
	public $year;

	/**
	 * @var integer переменная, передаваемая в URL: месяц
	 */
	public $month;

	/**
	 * @var integer переменная, передаваемая в URL: номер шага
	 */
	public $step;

	/**
	 * @var integer переменная, передаваемая в URL: направление сортировки
	 */
	public $sort;

	/**
	 * @var integer переменная, передаваемая в URL: добавить элемент (1)
	 */
	public $add;

	/**
	 * @var integer переменная, передаваемая в URL: номер редактируемого элемента
	 */
	public $edit;

	/**
	 * @var integer переменная, передаваемая в URL: номер сохраняемого элемента
	 */
	public $save;

	/**
	 * @var integer переменная, передаваемая в URL: сохранить новый элемент (1)
	 */
	public $savenew;

	/**
	 * @var integer переменная, передаваемая в URL: номер удаляемого элемента
	 */
	public $del;
	
	/**
	 * @var object работа с пользователями
	 */
	public $_user;
	
	/**
	 * @var object голосование
	 */
	public $_votes;
	
	/**
	 * @var object кэширование
	 */
	public $_cache;
	
	/**
	 * @var object комментарии
	 */
	public $_comments;

	/**
	 * Конструктор класса. Определяет свойства класса
	 * 
	 * @return void
	 */
	public function __construct()
	{
		$this->_user = new User();

		include_once(ABSOLUTE_PATH.'includes/cache.php');
		$this->_cache = new Cache;
	}

	/**
	 * Инициализирует генерирование страницы
	 * 
	 * @return boolean true
	 */
	public function init()
	{
		Dev::set_profiling();

		$this->include_other_file();

		Session::init();

		$this->language_all();
		$this->magic_quote_off();
		$this->get_user();
		$this->get_language_site();

		include_once(ABSOLUTE_PATH.'modules/votes/votes.inc.php');
		$this->_votes = new Votes_inc($this);

		if($_GET["rewrite"] == "newsrss")
		{
			include_once (ABSOLUTE_PATH.'modules/news/news.rss.php');
		}

		$this->prepare_rewrite();
		$this->get_page_in_site();
		$this->include_comments();

		$module = $this->get_module();

		$view = new View($this, $module);

		Gzip::init_gzip();

		$this->get_headers();
		$view->show_theme();

		Dev::get_profiling();

		Gzip::do_gzip($this->rewrite);
		return TRUE;
	}

	/**
	 * Подключает файлы для решения нестандартых задач (вывод каптчи, вывод прикрепленных файлов...)
	 * 
	 * @return boolean true
	 */
	private function include_other_file()
	{
		if(preg_match('/file\/(.*)$/', $_GET["rewrite"], $ob))
		{
		    $_GET["rewrite"] = $ob[1];
		    include_once(ABSOLUTE_PATH.'includes/files.php.php');
		}

		if(strstr($_GET["rewrite"], '404.php') !== FALSE)
		{
		    include_once(ABSOLUTE_PATH.'includes/404.php');
		}

		if(preg_match('/code\/(.*)$/', $_GET["rewrite"], $ob))
		{
		    $_GET["rewrite"] = $ob[1];
		    include_once(ABSOLUTE_PATH.'includes/captcha/captcha.php.php');
		}

		if(preg_match('/payment\/(.*)$/', $_GET["rewrite"], $ob))
		{
		    $_GET["rewrite"] = $ob[1];
		    include_once(ABSOLUTE_PATH.'modules/order/order.payment.php');
		}

		if(strstr($_GET["rewrite"], 'sitemap.xml') !== FALSE)
		{
		    include_once(ABSOLUTE_PATH.'includes/sitemap.xml.php');
		}
		return TRUE;
	}

	/**
	 * Подготавливает запрос для идентифицикации страницы в таблице {site} по rewrite или по id,
	 * удаляет из строки запроса $_GET[rewrite] переданные переменные
	 * 
	 * @return boolean true
	 */
	private function prepare_rewrite()
	{
		if($this->get_rewrite($_GET["rewrite"]))
		{
			return TRUE;
		}
		if($_GET["rewrite"])
		{
			$rewrite_array = explode("/",$_GET["rewrite"]);
			foreach($this->rewrite_variable_names_all as $name)
			{
				$this->$name = 0;
			}

			foreach($rewrite_array as $key => $ra)
			{
				foreach($this->rewrite_variable_names_all as $name)
				{
					if(preg_match('/'.$name.'([0-9]+)/', $ra, $result))
					{
						$this->$name = $result[1];
						unset($rewrite_array[$key]);
					}
				}
			}

			$_GET["rewrite"] = implode("/", $rewrite_array);
			if(! $this->get_rewrite($_GET["rewrite"]))
			{
				include(ABSOLUTE_PATH.'includes/404.php');
			}
		}

		if(! $this->rewrite)
		{
			$this->cid = empty($_GET["url"]) ? 1 : intval($_GET["url"]);
		}
		return TRUE;
	}

	/**
	 * Получаем страницу по псевдоссыле
	 *
	 * @param string $rewrite текущая псевдоссылка
	 * @return boolean
	 */
	public function get_rewrite($rewrite)
	{
		if(! $rews = $this->_cache->get("rewrite", "rewrite"))
		{
			$result = DB::query("SELECT rewrite, element_id, module_name, site_id, cat_id FROM {rewrite} WHERE trash='0'");
			while($row = DB::fetch_array($result))
			{
				$rews[$row["rewrite"]] = $row;
				if($row["module_name"] == 'site')
				{
					$this->rewrites[$row["site_id"]] = $row;
				}
				else
				{
					if($row["cat_id"])
					{
						$this->rewrites[$row["module_name"]]["cat".$row["cat_id"]] = $row;
					}
					else
					{
						$this->rewrites[$row["module_name"]]["element".$row["element_id"]] = $row;
					}
				}
			}
			$this->_cache->save($this->rewrites, "ids", "rewrite");
			$this->_cache->save($rews, "rewrite", "rewrite");
		}
		else
		{
			$this->rewrites = $this->_cache->get("ids", "rewrite");
		}
		if(! empty($rews[$rewrite]))
		{
			if(! $this->show && ! $this->cat)
			{
				$this->rewrite_module = $rewrite;
			}
			if($rews[$rewrite]["element_id"])
			{
				if($this->show)
				{
					include(ABSOLUTE_PATH.'includes/404.php');
				}
				$this->show =  $rews[$rewrite]["element_id"];
				$this->rewrite_variable_in_page[] = 'show';
			}
			if($rews[$rewrite]["cat_id"])
			{
				if($this->cat)
				{
					include(ABSOLUTE_PATH.'includes/404.php');
				}
				$this->cat =  $rews[$rewrite]["cat_id"];
				$this->rewrite_variable_in_page[] = 'cat';
			}
			$this->cid            = $rews[$rewrite]["site_id"];
			$this->module         = $rews[$rewrite]["module_name"] ? $rews[$rewrite]["module_name"] : $this->module;
			$this->rewrite        = $rewrite;
			return TRUE;
		}
		return FALSE;
	}

	/**
	 * Идентифицирует страницу сайта, задает параметры страницы
	 * 
	 * @return boolean true
	 */
	private function get_page_in_site()
	{
		$site_pages = $this->get_site_pages();

		if($this->cid && ! empty($site_pages[$this->cid." "]))
		{
			$current_page = $site_pages[$this->cid." "];
		}

		if(empty($current_page))
		{
			include(ABSOLUTE_PATH.'includes/404.php');
		}

		$this->cid           = $current_page["id"];
		$this->name          = $current_page['name'];
		$this->keywords      = $current_page['keywords'];
		$this->descr         = $current_page['descr'];
		$this->text          = DB::query_result("SELECT [text] FROM {site} WHERE id=%d", $this->cid);
		$this->parent_id     = $current_page['parent_id'];
		$this->title_no_show = $current_page['title_no_show'];
		$this->title_meta    = $current_page['title_meta'];
		$this->timeedit      = $current_page['timeedit'];
		$this->theme         = $current_page['theme'];
		$this->module        = $current_page["addmodule"];
		$this->actm          = $current_page["actm"];
		$this->rewrite       = $current_page["rewrite"];
		return TRUE;
	}

	/**
	 * Получаем все страницы сайта из кеша или из базы данных
	 * 
	 * @return array
	 */
	public function get_site_pages()
	{
		if(! $this->_user->id)
		{	
			if(! $site_pages = $this->_cache->get("site_pages"._LANG))
			{
				$result = DB::query(
						"SELECT s.id, s.parent_id, s.[name], s.[title_meta], s.[name], s.[keywords], s.[descr], s.title_no_show,"
						." s.timeedit, s.theme, s.addmodule, s.actm, s.sort, s.othurl, r.rewrite FROM {site} AS s"
						." LEFT JOIN {rewrite} as r ON r.module_name='site' AND r.site_id=s.id"
						." WHERE s.[act]='1' AND s.access='0' AND s.trash='0' ORDER BY s.sort ASC, s.id ASC"
					);
				while($row = DB::fetch_array($result))
				{
					if(! $row["theme"])
					{
						$row["theme"] = $this->search_theme($row["id"]);
					}
					$site_pages[$row["id"]." "] = $row;
				}
				$this->_cache->save($site_pages, "site_pages"._LANG);
			}
		}
		else
		{
			if(! $site_pages = $this->_cache->get("site_pages_only_user"._LANG))
			{
				$site_pages = array();
				$result = DB::query(
					"SELECT s.id, s.parent_id, s.[name], s.[title_meta], s.[name], s.[keywords], s.[descr], s.title_no_show,"
					." s.timeedit, s.theme, s.addmodule, s.actm, s.sort, s.othurl, r.rewrite FROM {site} as s"
					." LEFT JOIN {rewrite} as r ON r.module_name='site' AND  r.site_id=s.id"
					." WHERE s.[act]='1' AND s.trash='0' ORDER BY s.sort ASC, s.id ASC"
					);
				while($row = DB::fetch_array($result))
				{
					if(! $row["theme"])
					{
						$row["theme"] = $this->search_theme($row["id"]);
					}
					$site_pages[$row["id"]." "] = $row;
				}
				$this->_cache->save($site_pages, "site_pages_only_user"._LANG);
			}
		}
		return $site_pages;
	}

	/**
	 * Отдает браузеру заголовки страницы
	 * 
	 * @return boolean true
	 */
	private function get_headers()
	{
		header("Expires: ".date("r"));
		header("Last-Modified: ".(! $this->timeedit ? gmdate("D, d M Y H:i:s") : gmdate("D, d M Y H:i:s", $this->timeedit)) . " GMT");
		header("Cache-Control: no-store, no-cache, must-revalidate");
		header("Pragma: no-cache");
		header("Cache-Control: post-check=0, pre-check=0", FALSE);
		header('Content-Type: text/html; charset=utf-8');
		return TRUE;
	}

	/**
	 * Подключает модуль, прикрепленный к странице
	 * 
	 * @return object
	 */
	private function get_module()
	{
		if($this->module && file_exists(ABSOLUTE_PATH.'modules/'.$this->module.'/'.$this->module.'.php'))
		{
			include_once(ABSOLUTE_PATH.'modules/'.$this->module.'/'.$this->module.'.php');
			if(file_exists(ABSOLUTE_PATH.'modules/'.$this->module.'/'.$this->module.'.view.php'))
			{
				include_once(ABSOLUTE_PATH.'modules/'.$this->module.'/'.$this->module.'.view.php');
			}
			if(file_exists(ABSOLUTE_PATH.'modules/'.$this->module.'/'.$this->module.'.model.php'))
			{
				include_once(ABSOLUTE_PATH.'modules/'.$this->module.'/'.$this->module.'.model.php');
			}
			$name_class_module = ucfirst($this->module);
			$mod = new $name_class_module($this);

			foreach($this->rewrite_variable_names_all as $name)
			{
				if($this->$name && ! in_array($name, $mod->rewrite_variable_names))
				{
					$this->goto_diafan($this->path_module_variable());
				}
			}
			return $mod;
		}
		else
		{
			foreach($this->rewrite_variable_names_all as $name)
			{
				if($this->$name && ($name != "comments" || ! $this->configmodules("comments", "site")))
				{
					include(ABSOLUTE_PATH.'includes/404.php');
				}
			}
			$mod = new Frame($this);
			return $mod;
		}
	}

	/**
	 * Записывает данные о языках сайта
	 * 
	 * @return boolean true
	 */
	private function get_language_site()
	{
		//при авторизации язык сайта изменяем в соответствии с настройками пользователя
		if(! empty($_GET["rewrite"]) && preg_match("/^lang/", $_GET["rewrite"]))
		{
			$_GET["rewrite"] = preg_replace("/^lang\//", '', $_GET["rewrite"]);
			$_GET["rewrite"] = preg_replace("/^lang/", '', $_GET["rewrite"]);
			define('_LANG', $this->_user->language);
		}

		if($_GET["rewrite"] || defined('_LANG') && _LANG)
		{
			$rew = explode('/', $_GET["rewrite"], 2);
			foreach($this->language_all as $l => $langarr)
			{
				if(! defined('_LANG') && in_array($rew[0], $langarr) || defined('_LANG') && $langarr[0] == _LANG)
				{
					$_GET["rewrite"] = preg_replace('/^'.$rew[0].'(\/)*/', '', $_GET["rewrite"]);
					if(! defined('_LANG'))
					{
						define('_LANG', $langarr[0]);
					}
					define('BASE_PATH_HREF', BASE_PATH.$langarr[1].'/');
					define('BASE_URL', $_SERVER["HTTP_HOST"].(REVATIVE_PATH ? '/'.REVATIVE_PATH : '').'/'.$langarr[1]);
					if(defined('TIT'.$langarr[0]))
					{
						define('TITLE', constant('TIT'.$langarr[0]));
					}
					else
					{
						define('TITLE', TIT);
					}
					include_once(ABSOLUTE_PATH.'language/'.$langarr[1].'.php');
					break;
				}
			}
		}

		if(! defined('_LANG'))
		{
			define('_LANG', '');
			define('TITLE', TIT);
			define('BASE_PATH_HREF', BASE_PATH);
			define('BASE_URL', $_SERVER["HTTP_HOST"].(REVATIVE_PATH ? '/'.REVATIVE_PATH : ''));
			include_once(ABSOLUTE_PATH.'language/'.LANGUAGE_BASE.'.php');
		}
		return TRUE;
	}

	/**
	 * Борьба с магическими кавычками
	 * 
	 * @return boolean true
	 */
	private function magic_quote_off()
	{
		if(get_magic_quotes_gpc())
		{
			$_GET = $this->stripslashes_array($_GET);
			$_POST = $this->stripslashes_array($_POST);
		}
		return TRUE;
	}

	/**
	 * Вырезает магические кавычки из массива
	 * 
	 * @return array
	 */
	private function stripslashes_array($array)
	{
		if(is_array($array))
		{
			foreach($array as $key => $value)
			{
				$array[$key] = $this->stripslashes_array($value);
			}
			return $array;
		}
		else
		{
			return stripslashes($array);
		}
	}

	/**
	 * Инициирует авторизацию или выход пользователя из системы
	 * 
	 * @return boolean true
	 */
	private function get_user()
	{
		if(! empty($_POST['action']) && $_POST['action'] == 'auth')
		{
			$this->_user->auth($_POST);
		}
		elseif(strstr($_GET["rewrite"], "logout"))
		{
			$this->_user->logout();
		}
		return TRUE;
	}

	/**
	 * Подключает комментарии
	 * 
	 * @return boolean
	 */
	private function include_comments()
	{
		if($this->configmodules("comments") && $this->show || $this->configmodules("comments_cat") && $this->cat
		   || $this->configmodules("comments", "site"))
		{
			include_once(ABSOLUTE_PATH.'modules/comments/comments.inc.php');
			$this->_comments = new Comments_inc($this);
			return TRUE;
		}
		return FALSE;
	}
}