<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(__FILE__)).'/includes/404.php');
}

/**
 * Menu
 * 
 * Формирование иерархического меню
 */
class Menu
{
	/**
	 * @var object основной объект системы
	 */
	private $diafan;

	/**
	 * @var string $table название таблицы
	 */
	public $table;

	/**
	 * @var integer $cid текущий пункт меню
	 */
	public $cid;

	/**
	 * @var array $a атрибуты шаблонного тэга
	 */
	private $a;

	/**
	 * Конструктор класса. Определяет свойства класса
	 * 
	 * @return void
	 */
	public function __construct($diafan, $attributes)
	{
		$this->diafan = $diafan;
		$this->a      = $attributes;
	}

	/**
	 * Шаблон вывода одного уровня меню
	 * 
	 * @param array $menu_data массив, хранящий информацию об иерархии меню
	 * @param integer $parent_id родитель для текущего уровня
	 * @param integer $level текущий уровень меню
	 * @return boolean
	 */
	public function draw_menu($menu_data, $parent_id = 0, $level = 1)
	{
		if(! $parent_id)
		{
			$parent_id = $this->a["koren"];
		}
		$module = str_replace('_category', '', $this->table);
		$this->a["tag_level_start_".$level]  = isset($this->a["tag_level_start_".$level])  ? $this->a["tag_level_start_".$level]  : $this->a["tag_level_start_".($level-1)];
		$this->a["tag_level_end_".$level]    = isset($this->a["tag_level_end_".$level])    ? $this->a["tag_level_end_".$level]    : $this->a["tag_level_end_".($level-1)];
		
		$this->a["tag_active_child_start_".$level]  = isset($this->a["tag_active_child_start_".$level])  ? $this->a["tag_active_child_start_".$level]  : $this->a["tag_active_child_start_".($level-1)];
		$this->a["tag_active_child_end_".$level]    = isset($this->a["tag_active_child_end_".$level])    ? $this->a["tag_active_child_end_".$level]    : $this->a["tag_active_child_end_".($level-1)];
		
		$this->a["tag_start_".$level]        = isset($this->a["tag_start_".$level])        ? $this->a["tag_start_".$level]        : $this->a["tag_start_".($level-1)];
		$this->a["tag_end_".$level]          = isset($this->a["tag_end_".$level])          ? $this->a["tag_end_".$level]          : $this->a["tag_end_".($level-1)];
		
		$this->a["tag_active_start_".$level] = isset($this->a["tag_active_start_".$level]) ? $this->a["tag_active_start_".$level] : $this->a["tag_active_start_".($level-1)];
		$this->a["tag_active_end_".$level]   = isset($this->a["tag_active_end_".$level])   ? $this->a["tag_active_end_".$level]   : $this->a["tag_active_end_".($level-1)];
		
		$this->a["separator_".$level]        = isset($this->a["separator_".$level])        ? $this->a["separator_".$level]        : $this->a["separator_".($level-1)];
		$this->a["site_id"]                  = isset($this->a["site_id"]) ? $this->a["site_id"] : 0;

		$k = 0;
		if(! empty($menu_data[$parent_id]))
		{
			echo $this->a["tag_level_start_".$level];
			foreach($menu_data[$parent_id] as $row)
			{
				echo ($k ? $this->a["separator_".$level] : '');
				if($row["active"] && $this->a["tag_active_start_".$level])
				{
					echo str_replace(array('Increment', 'Level'), array($k, $level), $this->a["tag_active_start_".$level]);
				}
				elseif($row["active_child"] && $this->a["tag_active_child_start_".$level])
				{
					echo str_replace(array('Increment', 'Level'), array($k, $level), $this->a["tag_active_child_start_".$level]);
				}
				else
				{
					echo str_replace(array('Increment', 'Level'), array($k, $level), $this->a["tag_start_".$level]);
				}
				if(! $row["active"] && (! $this->a["hide_parent_link"] || empty($menu_data[$row["id"]])))
				{
					echo '<a href="';
					if($this->table == 'site')
					{
						echo
						(! empty($row['othurl']) ? $row["othurl"].'" target="_blank':
						BASE_PATH_HREF.($row["id"] == 1
							        ? ""
							        : ! empty($this->diafan->rewrites[$row["id"]]["rewrite"])
							          ? $this->diafan->rewrites[$row["id"]]["rewrite"].'/'
								  : ''
							        )
						);
					}
					else
					{
						echo BASE_PATH_HREF
						.(! empty($this->diafan->rewrites[$module]["cat".$row["id"]]["rewrite"])
						  ? $this->diafan->rewrites[$module]["cat".$row["id"]]["rewrite"].'/'
						  : (! empty($this->diafan->rewrites[$this->a["site_id"]]["rewrite"])
						     ? $this->diafan->rewrites[$this->a["site_id"]]["rewrite"].'/cat'.$row["id"].'/'
						     : '')
						  );
					}
					echo '">';
				}
				echo $row["name"]
				.(! $row["active"] && (! $this->a["hide_parent_link"] || empty($menu_data[$row["id"]])) ? '</a>' : '');
				if($row["active"] && $this->a["tag_active_end_".$level])
				{
					echo str_replace(array('Increment', 'Level'), array($k, $level), $this->a["tag_active_end_".$level]);
				}
				elseif($row["active_child"] && $this->a["tag_active_child_end_".$level])
				{
					echo str_replace(array('Increment', 'Level'), array($k, $level), $this->a["tag_active_child_end_".$level]);
				}
				else
				{
					echo str_replace(array('Increment', 'Level'), array($k, $level), $this->a["tag_end_".$level]);
				}
	
				$this->draw_menu($menu_data, $row["id"], $level+1, $this->a);
				$k++;
			}
			echo $this->a["tag_level_end_".$level];
		}
		return TRUE;
	}

	/**
	 * Вызывает все функции, формирующие иерархическое меню
	 * 
	 * @return array
	 */
	public function get_menu()
	{	
		$parents_links = $this->menu_parents_link();
		$active_chain = $this->menu_active_chain($parents_links);
		$parent_id = intval($this->a["koren"]);
		$level = 0;
		$list = $this->buid_menu($parent_id, $level, $active_chain, $parents_links, $this->a["show_all_level"], $this->a["count_level"]);
		$menudata = $this->menu_data($list, $active_chain);
		return $menudata;
	}

	/**
	 * Получает все пункты меню из базы данных
	 * 
	 * @return array
	 */
	private function menu_parents_link()
	{
		$parents_links = array();
		$result = DB::query("SELECT id, parent_id FROM {".$this->table."} WHERE"
				    ." [act]='1'  AND trash='0'"
				    .($this->table == 'site'
				      ? " AND actm='1'"
					.(! $this->diafan->_user->id ? " AND access='0'" : '')
				      : " AND site_id='".$this->a["site_id"]."'"
				      )
				); 
		while ($row = DB::fetch_array($result))
		{
			$parents_links[$row["id"]] = $row["parent_id"];
		}
		return $parents_links;
	}

	/**
	 * Получает массив пунктов меню активной цепи (текущая страница и ее родители)
	 *
	 * @param array $parents_links массив со всеми пунктами меню
	 * @return array
	 */
	private function menu_active_chain($parents_links)
	{
		$chain = array();
		if(! isset($parents_links[$this->cid]))
		{
			return $chain;
		}
		$current = $this->cid;
		do
		{
			$chain[] = $current;
			$current = $parents_links[$current];
		}
		while($current);

		return $chain;
	}

	/**
	 * Устраняет из массива меню лишние пункты, исходя из информации о раскрытии меню и количесте уровней
	 *
	 * @param integer $parent_id номер родителя для текущего уровня
	 * @param integer $level текущий уровень меню
	 * @param array $active_chain пункты меню активной цепи
	 * @param array $parents_links массив со всеми пунктами меню
	 * @param boolean $show_all_level раскрывать все пункты меню
	 * @param integer $count_level количество уровней меню
	 * @return array
	 */
	private function buid_menu($parent_id, $level, $active_chain, $parents_links, $show_all_level, $count_level)
	{
		$list = array();
		$brothers = array_keys($parents_links, $parent_id);
		foreach($brothers as $value)
		{
			$list[$value] = $level;
			if($show_all_level || in_array($value, $active_chain))
			{
				if($count_level > $level)
				{
					$chindren = $this->buid_menu($value, $level+1, $active_chain, $parents_links, $show_all_level, $count_level);
					$list = $list + $chindren;
				}
			}
		}
		return $list;
	}

	/**
	 * Получает все необходимые данные для используемых пунктов меню из базы данных
	 *
	 * @param array $list пункты, формирующие меню
	 * @param array $active_chain пункты меню активной цепи
	 * @return array
	 */
	private function menu_data($list, $active_chain)
	{
		if(empty($list))
			return;

		$ids = array_keys($list);
		$in = implode(',', $ids);
		$result = DB::query("SELECT id, [name], ".($this->table == 'site' ? "othurl, ": "")
		                    ."parent_id FROM {".$this->table."} WHERE id IN (".$in.") ORDER BY sort ASC");
		$data = array();
		while($row = DB::fetch_array($result))
		{        
			$id = $row['id'];
			$active = $id == $this->cid && ($this->table != 'site' && ! $this->diafan->show || ! $this->diafan->cat && ! $this->diafan->show) ? TRUE : FALSE;
			$active_child = in_array($id, $active_chain);
			$a = $row + compact('active', 'active_child');
			$data[$row['parent_id']][] = $a;
		}
		return $data;
	}
}