<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Paginator_inc
 * 
 * Постраничная навигация
 */
class Paginator_inc
{
	/**
	 * @var integer количество элементов, показанных на странице
	 */
	public $nastr = 10;

	/**
	 * @var integer количество ссылок постраничной навигации, показанных на одной страние
	 */
	public $navnastr = 10;

	/**
	 * @var string ссылка на текущую страницу, используемая в постраничной навигации
	 */
	public $navlink;

	/**
	 * @var integer номер страницы
	 */
	public $page;

	/**
	 * @var string GET переменные, участвующие в навигации для постраничного вывода
	 */
	public $get_nav;

	/**
	 * @var string шаблон вывода переменной постраничной навигации в GET-запросе
	 */
	public $urlpage = 'page%d/';

	/**
	 * @var integer порядковый номер элемента, с которого начинается вывод элементов
	 */
	public $polog = 0;

	/**
	 * @var integer количество элементов в списке
	 */
	public $nen;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct()
	{
		include_once(ABSOLUTE_PATH.'includes/paginator/paginator.view.php');
	}
	/**
	 * Формирует строку навигации
	 * 
	 * @return array
	 */
	public function get()
	{
		$this->config();
		$links     = array();
		$navlink   = $this->navlink;
		$string    = '';
		if ($this->nen > $this->nastr)
		{
			$nen = ceil($this->nen/$this->nastr);
			$apage = 1;
			$bpage = $this->navnastr;
			while($this->page > $bpage && $apage < $nen)
			{
				$apage += $this->navnastr;
				$bpage += $this->navnastr;
			}
			if ($bpage > $nen)
			{
				$bpage = $nen;
			}
			if ($nen > $this->navnastr && $apage != 1)
			{
				$url = sprintf($this->urlpage, $apage - 1);
				$links[] = array(
						 "type" => "previous",
						 "link" => ($apage < 3 ? $this->navlink : $navlink.$url).$this->get_nav
						);
			}
			for($i = $apage; $i <= $bpage; $i++)
			{
				if($this->page == $i)
				{
					$links[] = array(
							 "type" => "current",
							 "name" => $i
							);
				}
				else
				{
					$links[] = array(
							 "type" => "default",
							 "name" => $i,
							 "link" => ($i == 1 ? $this->navlink : $navlink.sprintf($this->urlpage, $i)).$this->get_nav
							);
				}
			}
			if ($nen > $this->navnastr && $bpage != $nen)
			{
				$links[] = array(
						 "type" => "next",
						 "nen"  => $nen,
						 "link" => $navlink.sprintf($this->urlpage, $apage + $this->navnastr).$this->get_nav
						);
			}
		}
		return $links;
	}

	/**
	 * Рассчитывает параметры постраничной навигации
	 * 
	 * @return boolean true
	 */
	private function config()
	{
		global $diafan;
		if(! IS_ADMIN && $diafan->configmodules("nastr") && $this->urlpage == 'page%d/')
		{
			$this->nastr = $diafan->configmodules("nastr");
		}

		if($this->page)
		{
			$this->polog = ($this->page - 1) * $this->nastr;
			if (($this->page - 1) * $this->nastr > $this->nen)
			{
				include(ABSOLUTE_PATH.'includes/404.php');
				exit;
			}
		}
		else
		{
			$this->page  = 1;
			$this->polog = 0;
		}
		return TRUE;
	}
}