<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(__FILE__)).'/includes/404.php');
}

/**
 * View
 * 
 * Представление в пользовательской части
 */
class View
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var object подключенный к текущей страницы модуль
	 */
	public $module;

	/**
	 * @var object объект с общими шаблонными функциями
	 */
	private $functions;

	/**
	 * Конструктор класса. Определяет свойства класса
	 * 
	 * @return void
	 */
	public function __construct($diafan, $module)
	{
		$this->diafan = $diafan;
		$this->module = $module;
		$this->functions = new Theme_functions($this);
	}

	/**
	 * Подключает шаблон
	 * 
	 * @return boolean true
	 */
	public function show_theme()
	{
		if(! file_exists(ABSOLUTE_PATH.'themes/'.$this->diafan->theme))
		{
			$this->diafan->theme = 'site.php';
		}
		$site_theme = file_get_contents(ABSOLUTE_PATH.'themes/'.$this->diafan->theme);
		$this->get_function_in_theme($site_theme);
		return TRUE;
	}

	/**
	 * Парсит шаблон
	 * 
	 * @return boolean true
	 */
	public function get_function_in_theme($text)
	{
		$text = preg_replace(
			array(
				'/<\?php if\(!defined\("DIAFAN"\)\)\{@*include\("..\/includes\/404.php"\);exit\(\);\} \'<\?xml version="1.0" encoding="UTF-8"\?>\'; \?>/',
				'/<p>([^<]+)<insert/',
				'/<\/insert>([^<]*)<\/p>/',
				'/<\/insert>/'
			),
			array(
				'<?xml version="1.0" encoding="UTF-8"?>',
				'<insert',
				'</insert>',
				''
			),
			$text
		);
		
		$regexp = '/(<insert ([^>]*)>)/im';
		$tokens = preg_split($regexp, $text, -1, PREG_SPLIT_DELIM_CAPTURE);
		$cnt = count($tokens);
		echo $tokens[0];
		$i = 1;
		while ($i < $cnt)
		{
			$i++;
			$att_string 	= $tokens[$i++];
			$data 		= $tokens[$i++];
			$attributes 	= $this->parse_attributes($att_string);
			$this->start_element($attributes);
			echo $data;
		}
		return TRUE;
	}

	/**
	 * Парсит атрибуты шаблонного тэга
	 * 
	 * @return array
	 */
	private function parse_attributes($string)
	{
		static $entities = array(
			'&lt;' 		=> '<',
			'&gt;' 		=> '>',
			'[' 		=> '<',
			']' 		=> '>',
			'&amp;' 	=> '&',
			'&quot;' 	=> '"',
			'`' 		=> '"'
		);
		
		$attributes = array();
		$match = array();
		preg_match_all('/([a-zA-Z_0-9]+)="((?:\\\.|[^"\\\])*)"/U', $string, $match);
		for($i = 0; $i < count($match[1]); $i++)
		{
			$attributes[strtolower($match[1][$i])] = strtr((string)$match[2][$i], $entities);
		}
		return $attributes;
	}

	/**
	 * Выполняет действие, заданное в шаблонном тэге: выводит информацию или подключает шаблонную функцию
	 *
	 * @param array атрибуты шаблонного тэга
	 * @return boolean true
	 */
	private function start_element($attributes)
	{
		if (empty($attributes['name']))
		{
			if(! empty($attributes['value'._LANG]))
			{
				echo $attributes['value'._LANG];
			}
			elseif(! empty($attributes['value']))
			{
				echo $attributes['value'];
			}
		}
		else
		{
			$attributes['name'] = preg_replace('/[^a-zA-Z0-9_]/', '', $attributes['name']);
		
			switch($attributes['name'])
			{
				case "path":
					echo BASE_PATH;
				break;
			
				case "path_url":
					echo BASE_PATH_HREF;
				break;
			
				case "language":
					echo _LANG;
				break;
			
				case "title":
					echo TITLE;
				break;
			
				case "module":
					echo $this->diafan->module;
				break;
		
				default:
					if(! empty($attributes['module']))
					{
						$attributes['module'] = preg_replace('/[^a-zA-Z0-9_]/', '', $attributes['module']);
						$mod = ucfirst($attributes['module']);
						
						if(file_exists(ABSOLUTE_PATH.'modules/'.$attributes['module'].'/'.$attributes['module'].'.php'))
						{
							include_once(ABSOLUTE_PATH.'modules/'.$attributes['module'].'/'.$attributes['module'].'.php');

							if(is_callable(array($mod, $attributes['name'])))
							{
								eval($mod.'::'.$attributes['name'].'($this,$attributes);');
							}
						}
					}
					else
					{
						if(is_callable(array($this->functions, $attributes['name'])))
						{
							$this->functions->$attributes['name']($attributes);
						}
					}
			}
		}
		return TRUE;
	}

	/**
	 * Задает неопределенным атрибутам шаблонного тэга значение по умолчанию
	 * 
	 * @param array $attributes массив определенных атрибутов
	 * @return array
	 */
	public function get_attributes($attributes)
	{
		$a = func_get_args();
		for($i = 1; $i < count($a); $i++)
		{
			if(is_array($a[$i]))
			{
				$name = $a[$i][0];
				$value = $a[$i][1];
			}
			else
			{
				$name = $a[$i];
				$value = '';
			}
			if(empty($attributes[$name]))
			{
				$attributes[$name] = $value;
			}
		}
		return $attributes;
	}
}

/**
 * Frame
 * 
 * Каркас для модулей
 */
class Frame
{
	/**
	 * @var array переменные, передаваемы в URL страницы
	 */
	public $rewrite_variable_names = array();

	/**
	 * @var array сгенерированные в моделе данные, передаваемые в шаблон
	 */
	protected $result;

	/**
	 * @var object основной объект системы
	 */
	protected $diafan;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct(&$diafan)
	{
		
	}

	/**
	 * Выводит шаблон модуля
	 * 
	 * @return void
	 */
	public function show_module()
	{
		
	}

	/**
	 * Определяет свойства страницы, если они заданы в модуле
	 * 
	 * @return boolean true
	 */
	protected function get_global_variables()
	{
		$this->diafan->timeedit = ! empty($this->result["timeedit"]) && $this->diafan->timeedit > $this->result["timeedit"]
					  ? $this->result["timeedit"]
					  : $this->diafan->timeedit;
		if(! empty($this->result["path"]))
		{
			$this->diafan->path = $this->result["path"];
		}

		if(! empty($this->result["title_meta"]))
		{
			$this->diafan->titlemodule_meta = $this->result["title_meta"];
		}
		if(! empty($this->result["titlemodule"]))
		{
			$this->diafan->titlemodule = $this->result["titlemodule"];
		}

		if(! empty($this->result["keywords"]))
		{
			$this->diafan->keywords = $this->result["keywords"];
		}
		if(! empty($this->result["descr"]))
		{
			$this->diafan->descr = $this->result["descr"];
		}
		return TRUE;
	}

	/**
	 * Задает неопределенным атрибутам шаблонного тэга значение по умолчанию
	 * 
	 * @param array $attributes массив определенных атрибутов
	 * @return array
	 */
	protected function get_attributes($attributes)
	{
		$a = func_get_args();
		for($i = 1; $i < count($a); $i++)
		{
			if(is_array($a[$i]))
			{
				$name = $a[$i][0];
				$value = $a[$i][1];
			}
			else
			{
				$name = $a[$i];
				$value = '';
			}
			if(empty($attributes[$name]))
			{
				$attributes[$name] = $value;
			}
		}
		return $attributes;
	}
}