$(document).ready(function(){
	$('.ajax').click(function(){
		var button = $(this);
		$(this).parents('form').ajaxSubmit({
			dataType: 'json',
			url: button.attr("url"),

			beforeSubmit: function(a,form,o) {
				$('.errors').hide();
			},

			success: function(response, statusText, xhr, form)
			{
				if(response.errors)
				{
					$.each(response.errors, function(k, val)
					{
						val = prepare(val);
						$(form).find(".error"+(k != 0 ? "-"+k : '')).html(val).show();
					});
				}
				if(response.id)
				{
					$(form).find("input[name=id]").val(response.id);
				}
				if(response.data && response.target)
				{
					$(response.target).html(prepare(response.data));
					$('#'+button.attr("rel")).val('');
				}
				$("#search_tags").hide();
				return false;
			}
		});
		return false;
	});

	$('.inpnum').keydown(function(evt) {
		evt = (evt) ? evt : ((window.event) ? event : null);

		if(evt)
		{
			var elem = (evt.target)
			? evt.target
			:(
			  evt.srcElement
			  ? evt.srcElement
			  :null
			);
		 
			if(elem)
			{
				var charCode = evt.charCode
				?evt.charCode
				:(evt.which
				  ?evt.which
				  :evt.keyCode
				  );
		 
				if ((charCode < 32 ) ||
					(charCode > 44 && charCode < 47) || 
					(charCode > 95 && charCode < 106) || 
					(charCode > 47 && charCode < 58) || charCode == 188 || charCode == 191 || charCode == 190  || charCode == 110)
				{
					return true;
				}
				else
				{
					return false;
				}
			}
		}
	});

	$('#cloud_tags').click(function() {
		$.ajax({
			url : $(this).attr("href"),
			dataType : 'json',
			success : (function(response)
			{
				if(response.data)
				{
					$("#search_tags").html(prepare(response.data));
					$("#search_tags").show();
				}
				else
				{
					$("#search_tags").hide();
				}
			})
		});
		return false;
	});

	$('.show_other_block').click(function() {
		$('.other').toggle();
	});
	$('.tab_card_title a').click(function() {
		$('.tab_card_title').removeClass("tab_card_title_active");
		$('.tab-card').hide();
		$('#'+$(this).attr("rel")).show("show");
		$(this).parents('.tab_card_title').addClass("tab_card_title_active");
	});
	$('.show_tr_click_checkbox').click(function() {
		show_tr_click_checkbox($(this));
	});
	$('.show_tr_click_checkbox').each(function() {
		show_tr_click_checkbox($(this));
	});
	$('.show_select_div').change(function() {
		show_select_div($(this));
	});
	$('.show_select_div').each(function() {
		show_select_div($(this));
	});
	$('select.redirect').change(function() {
		var path = $(this).attr("rel");
		if($(this).val())
		{
			path = path+$(this).attr("name")+$(this).val()+'/';
		}
		window.location.href = path;
	});
	$('.show_tab_mini').click(function() {
		$('.'+$(this).attr("rel")).toggle("slow");
		$('.tab_mini').hide();
	});
	$('.plus').click(function() {
		$('.rowparam:last').clone(true).appendTo('#param table');
		$('.rowparam:last input').val('');
	});
	$('.check_price input[type=checkbox]').click(function() {
		if($(this).attr("checked"))
		{
			$('.check_price').hide();
			$('.price_param').hide();
			$('.select_param').show();
			$('.check_price').attr("checked", "");

			$(this).attr("checked", 'checked');
			$(this).parents('.check_price').show();
			$('#price_param_'+$(this).attr('rel')).show();
			$('#select_param_'+$(this).attr('rel')).hide();
			$('#price').hide();
		}
		else
		{
			$('.check_price').show();
			$('#price_param_'+$(this).attr('rel')).hide();
			$('#select_param_'+$(this).attr('rel')).show();
			$('#price').show();
		}
	});
	$('input[name=file_type]').change(function() {
		$('.file_type1').hide();
		$('.file_type2').hide();
		$('.file_type3').hide();
		$('.file_type'+$(this).val()).show();
	});

	$(".tr").mouseover(function() {
		$(this).css('backgroundColor', $(this).attr("altcolor"));
		$(this).find(".actions span").show();
	});

	$(".tr").mouseout(function() {
		$(this).css('backgroundColor', '');
		$(this).find(".actions span").hide();
	});

	$(".group-actions a").click(function() {
		
		var path = $(this).attr("href") + '?action='+$(this).attr("action");
		$(".checkbox input[type=checkbox]:checked").each(function(){
			path = path + '&ids[]=' + $(this).val();
		});
		window.location.href = path;
		return false;
	});

	$("input[name=check_all]").click(function(){
		$(".checkbox input[type=checkbox]").attr("checked", $(this).attr("checked"));
	});

	$('.user-center font a, .help-close a').click(function(){
		$('.help-top, .help').toggle();
	});

	$(".ajax_save_photo").live('click', function(){
		var self = $(this);
		$.ajax({
			url : window.location.href,
			type : 'POST',
			dataType : 'json',
			data : { action: 'save-photo', id : self.attr("img_id"), alt : self.parents("div").find("input[name=alt]").val(), title : self.parents("div").find("input[name=title]").val()},
			success : (function(response)
			{
				if(response.data && response.target)
				{
					$(response.target).html(prepare(response.data));
				}
			})
		});
	});
});

function prepare(string)
{
	string = str_replace('&lt;', '<', string);
	string = str_replace('&gt;', '>', string);
	string = str_replace('&amp;', '&', string);
	return string;
}

function str_replace(search, replace, subject, count)
{
	f = [].concat(search),
	r = [].concat(replace),
	s = subject,
	ra = r instanceof Array, sa = s instanceof Array;
	s = [].concat(s);
	if (count)
	{
		this.window[count] = 0;
	}
	for (i=0, sl=s.length; i < sl; i++)
	{
		if (s[i] === '')
		{
			continue;
		}
		for (j=0, fl=f.length; j < fl; j++)
		{
			temp = s[i]+'';
			repl = ra ? (r[j] !== undefined ? r[j] : '') : r[0];
			s[i] = (temp).split(f[j]).join(repl);
			if (count && s[i] !== temp)
			{
				this.window[count] += (temp.length-s[i].length)/f[j].length;
			}
		}
	}
	return sa ? s : s[0];
}

function tab_active(title)
{
	$('.tab_card_title a[rel='+title+']').parents('.tab_card_title').addClass("tab_card_title_active");
	$('#'+title).show();
}

function show_tr_click_checkbox(check)
{
	var str_arr = check.attr("rel").split(',');
	$.each(str_arr, function(key, str){
		if(check.attr("checked"))
		{
			$(str).show();
		}
		else
		{
			$(str).hide();
		}
	});
}

function show_select_div(select)
{
	if(select.val() == 1)
	{
		$('#'+select.attr("rel")).show();
	}
	else
	{
		$('#'+select.attr("rel")).hide();
	}
}

function show_div(div)
{
	$('#'+div).toggle();
}

function ajax_sort(th, url)
{
	if($(th).attr("upload"))
	{
		return false;
	}
	var val = $(th).val();
	$.ajax({
		url : url,
		type : 'POST',
		dataType : 'json',
		data : { action: 'sort-module', id : $(th).attr("edit_id"), sort : $(th).attr("sort"), name : $(th).attr("sname"),
		         cat_id : $(th).attr("cat_id"), site_id : $(th).attr("site_id"), parent_id : $(th).attr("parent_id")},
		success : (function(response)
		{
			$(th).html(prepare(response.data));
			$(th).val(val);
			$(th).attr("upload", "1");
		})
	});
}

function ajax_parent_id(th, url)
{
	if($(th).attr("upload"))
	{
		return false;
	}
	var val = $(th).val();
	$.ajax({
		url : url,
		type : 'POST',
		dataType : 'json',
		data : { action: 'parent-module', id : $(th).attr("edit_id"), parent_id : $(th).val()},
		success : (function(response)
		{
			$(th).html(prepare(response.data));
			$(th).val(val);
			$(th).attr("upload", "1");
		})
	});
	return false;
}

function show_action(th)
{
	if(! $(th).attr("stable"))
	{
		$(th).find(".span").toggle();
		if($(th).css('backgroundColor') == "transparent")
		{
			$(th).css('backgroundColor', $(th).attr("altcolor"));
		}
		else
		{
			$(th).css('backgroundColor', '');
		}
	}
}

function ajax_action(th)
{
	if(! $(th).attr("href"))
	{
		return false;
	}
	if($(th).attr("title") && ! confirm($(th).attr("title")))
	{
		return false;
	}
	$.ajax({
		url : $(th).attr("href")+$(th).parents("form").find("input[name=id]").val(),
		dataType : 'json',
		success : (function(response)
		{
			if(response.target)
			{
				$(response.target).html(prepare(response.data));
			}
			else
			{
				$(th).parents(".images-actions").attr('stable', "1");
				$(th).parents(".images-actions").html(prepare(response.data));
			}
		})
	});
	return false;
}

function add_tag(th)
{
	$("#uploadtag").val($(th).text());
	$(th).parents('#tags').find(".ajax").click();
}