<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Adminsite_admin
 *
 * Редактирование страниц административной части сайта
 */
class Adminsite_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'adminsite';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'adminsite';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		//поля в базе данных для редактирования	
		$this->variable_table=array(
			'name'		=> 'text',
			'rewrite'	=> 'text',
			'act'		=> 'checkbox',
			'parent_id'	=> 'select',
			'text'		=> 'editor'
		);
		
		$this->config_module=array(
			'parent' => 1,	//содержит вложенности
			'act'    => 1,	//показать/скрыть
			'del'    => 1,	//удалить
			'order'	 => 1
		);
		
		//поле Принаделжит генерируется из таблицы
		$this->select["parent_id"]=array(
			$this->table,	//название таблицы в бд
			"id",		//поле таблицы, которое берется в виде занчения
			"name"._LANG,	//поле таблицы, которое отображется пользователю
			$this->diafan->enterid, // значение по умолчанию
			_LANG_HOME,	//поле с пустым значением
					//страница не может принадлежать Главной и самой себе
			"id<>1".(!empty($this->diafan->edit) ? ' and id<>'.$this->diafan->edit : ''),
			"parent_id" 	//список содержит вложенности по полю parent_id
		);
	}

	/**
	 * Выводит контент модуля
	 * @return boolean true
	 */
	public function show_module()
	{
		echo '<table border="0" cellpadding="1" cellspacing="3" class="list">';
		$this->list_row();	
		echo '</table>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Псевдоссылка"
	 * 
	 * @return boolean
	 */
	protected function edit_rewrite_module()
	{
		echo '
		<tr'.$this->get_other().' valign="top">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<input type="text" name="'. $this->key.'" size="40" value="'
				.(! $this->diafan->addnew ? str_replace('"', '&quot;', $this->value) : '')
				.'">
				'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}
}