<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Basket_ajax
 *
 * Обработка запроса при пересчете суммы покупки в корзине товаров
 */
class Basket_ajax extends Model
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * Обрабатывает полученные данные из формы
	 * 
	 * @return boolean
	 */
	public function ajax_request()
	{
		if(! empty($_POST['editform']) && (! $this->diafan->configmodules('security_user', 'shop') || $this->diafan->_user->id))
		{
			$summ  = 0;
			$count = 0;
			foreach($_SESSION["basket"] as $shop_id => $array)
			{
				foreach($array as $param => $c)
				{
					if(! empty($_POST['del'.$shop_id.'_'.$param]) || empty($_POST['editshop'.$shop_id.'_'.$param]))
					{
						unset($_SESSION["basket"][$shop_id][$param]);
					}
					else
					{
						$edit_count = intval($_POST['editshop'.$shop_id.'_'.$param]);
						$edit_count = $edit_count > 0 ? $edit_count : 0;

						$_SESSION["basket"][$shop_id][$param]["count"] = $edit_count;
						if(! empty($c["param"]["depend"]))
						{
							$summ += DB::query_result("SELECT price FROM {shop_price} WHERE shop_id=%d AND param_value=%d", $shop_id, $c["param"]["depend"]) * $edit_count;
						}
						else
						{
							$summ += DB::query_result("SELECT price FROM {shop_price} WHERE shop_id=%d", $shop_id) * $edit_count;
						}
						$count += $edit_count;
					}
				}
			}
			$_SESSION["basket-summ"]  = $summ;
			$_SESSION["basket-count"] = $count;
			
			if(! empty($_POST['ajax']))
			{
				$model  = new Basket_model($this->diafan);
				$result = $model->form();
				$json["table"] = Basket_view::table_basket($result);
				if(! $count)
				{
					$json["empty"] = 1;
				}

				include_once(ABSOLUTE_PATH.'plugins/json.php');
				echo to_json($json);
			}
			else
			{
				$this->diafan->goto_diafan($this->diafan->path_module_variable().'?error=basket&mess='._LANG_CHANGES_SAVED);
			}
			return TRUE;
		}
		return FALSE;
	}
}