<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Basket_model
 *
 * Модель модуля "Корзина товаров"
 */
class Basket_model extends Model
{
	/**
	 * @var array сгенерированные в моделе данные, передаваемые в шаблон
	 */
	protected $result;

	/**
	 * @var object основной объект системы
	 */
	protected $diafan;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * Генерирует данные для формы редактирования товаров
	 * 
	 * @return array
	 */
	public function form()
	{
		global $param_select;
		$rewrite = $this->get_rewrite_from_module("order").'/';

		if(! empty($_SESSION["basket-count"]))
		{
			$result["to-order"] = BASE_PATH_HREF.$rewrite;
		}
		$result["error"] = $this->get_error("basket");
		
		$result["currency"] = $this->diafan->configmodules("currency","shop");
		$result["summ"]  = 0;
		$result["count"] = 0;
		$k = 0;
		
		$rewrite = $this->get_rewrite_from_module("shop");
		$rewrite = $rewrite ? $rewrite.'/' : '';
		
		if(! empty($_SESSION["basket"]) && is_array($_SESSION["basket"]))
		{
			foreach($_SESSION["basket"] as $shop_id => $array)
			{
				if(! $row = DB::fetch_array(DB::query("SELECT id, [name], cat_id, site_id FROM {shop} WHERE [act]='1' and id = %d and trash='0'", $shop_id)))
				{
					continue;
				}
				if(! empty($this->diafan->rewrites["shop"]["element".$row["id"]]))
				{
					$link = $this->diafan->rewrites["shop"]["element".$row["id"]]["rewrite"].'/';
				}
				elseif($row["cat_id"] && ! empty($this->diafan->rewrites["shop"]["cat".$row["cat_id"]]))
				{
					$link = $this->diafan->rewrites["shop"]["cat".$row["cat_id"]]["rewrite"].'/show'.$row["id"].'/';
				}
				else
				{
					$link = (! empty($this->diafan->rewrites[$row["site_id"]]) ? $this->diafan->rewrites[$row["site_id"]]["rewrite"].'/' : '')
							   .($row["cat_id"] ? 'cat'.$row["cat_id"].'/' : '')
							   .'show'.$row["id"].'/';
				}
				foreach($array as $param => $c)
				{
					$price = 0;
					$result["rows"][$k]["name"]  = $row["name"];
					$result["rows"][$k]["link"]  = $link;
					$query = array();
					foreach($c["param"] as $id => $value)
					{
						if($id == 'depend')
						{
							$depend = DB::fetch_array(DB::query("SELECT param_id, price FROM {shop_price} WHERE shop_id=%d AND param_value=%d", $shop_id, $value));
							if(! $depend)
							{
								continue;
							}
							$price = $depend["price"];
							$id = $depend["param_id"];
						}
						if(empty($param_names[$id]))
						{
							$param_names[$id] = DB::query_result("SELECT [name] FROM {param} WHERE id=%d", $id);
						}
						if(empty($select_names[$id][$value]))
						{
							$select_names[$id][$value] = DB::query_result("SELECT [name] FROM {param_select} WHERE param_id=%d AND"
							                                              ." value=%d", $id, $value);
						}

						$query[] = 'p'.$id.'='.$value;
						$result["rows"][$k]["name"] .= ', '.$param_names[$id].': '.$select_names[$id][$value];
					}
					if(! $price)
					{
						$price = DB::query_result("SELECT price FROM {shop_price} WHERE shop_id=%d", $shop_id);
					}
					$result["rows"][$k]["link"] .= ! empty($query) ? '?'.implode('&', $query) : '';
					$result["rows"][$k]["count"] = $c["count"];
					$result["rows"][$k]["id"]    = $row["id"]."_".$param;
					$result["rows"][$k]["price"] = $this->diafan->format_price($price);
					$result["rows"][$k]["summ"]  = $this->diafan->format_price($price * $c["count"]);
					
					$result["summ"]  += $price * $c["count"];
					$result["count"] += $c["count"];
					$k++;
				}
			}
		}
		$result["summ"] = $this->diafan->format_price($result["summ"]);
		return $result;
	}

	/**
	 * Генерирует данные для шаблонной функции: выводит информацию о заказанных товарах
	 * 
	 * @return array
	 */
	function show_basket()
	{
		$result["summ"]  = 0;
		$result["count"] = 0;

		if(isset($_SESSION["basket-summ"]) && isset($_SESSION["basket-count"]))
		{
			$result["summ"]  = $_SESSION["basket-summ"]  ? $_SESSION["basket-summ"]  : 0;
			$result["count"] = $_SESSION["basket-count"] ? $_SESSION["basket-count"] : 0;
		}
		
		$rewrite = $this->get_rewrite_from_module("basket");
		$result["link"] = BASE_PATH_HREF.($rewrite ? $rewrite.'/' : '');
		$result["summ"] = $this->diafan->format_price($result["summ"]);
		$result["currency"] = $this->diafan->configmodules("currency", "shop");
		return $result;
	}
}