<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Basket
 *
 * Контроллер модуля "Корзина товаров"
 */
class Basket extends Frame
{
	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct(&$diafan)
	{
		$this->diafan = &$diafan;
		
		include_once(ABSOLUTE_PATH.'modules/basket/basket.ajax.php');
		$ajax = new Basket_ajax($diafan);
		if($ajax->ajax_request())
		{
			exit;
		}

		$model = new Basket_model($diafan);
		$this->result = $model->form();
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	public function show_module()
	{
		Basket_view::form($this->result);
		return TRUE;
	}

	/**
	 * Шаблонная функция: количество товаров в корзине
	 * 
	 * @return boolean
	 */
	public function show_basket($th, $attributes)
	{
		if($th->diafan->module == "basket" || $th->diafan->configmodules('security_user', 'shop') && ! $th->diafan->_user->id)
			return FALSE;

		$attributes = $this->get_attributes($attributes, 'template');

		include_once(ABSOLUTE_PATH.'modules/basket/basket.model.php');
		$model = new Basket_model($th->diafan);
		$result = $model->show_basket();

		include_once(ABSOLUTE_PATH.'modules/basket/basket.view.php');
		$func = 'show_basket';
		if($attributes["template"])
		{
			$func .= '_'.preg_replace('/[^a-z_]+/','', $attributes["template"]);
			
		}
		Basket_view::$func($result);
		return TRUE;
	}
}