<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Basket_view
 *
 * Шаблон модуля "Корзина товаров"
 */
class Basket_view
{
	/**
	 * Шаблон вывода формы редактирования корзины товаров
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function form($result)
	{
		echo '
		<script type="text/javascript" src="'.BASE_PATH.'modules/basket/basket-func.js"></script>

		<form action="" method="POST" enctype="multipart/form-data" class="basket-form">
		<input type="hidden" name="editform" value="1">
		<input type="hidden" name="ajax" value="">
		<div class="errors error"'.($result["error"] ? '>'.$result["error"] : ' style="display:none">').'</div>
		<div class="basket-table">'.self::table_basket($result).'</div>
		'.(! empty($result["to-order"])
		  ? '
		<input type="submit" class="button" value="'._LANG_RECALCULATE.'">
		<div class="to-order"><a href="'.$result["to-order"].'">'._LANG_ORDER.'</a></div>'
		  : '').'
		</form>';

		return TRUE;
	}

	/**
	 * Шаблон вывода таблицы с товарами в корзине
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function table_basket($result)
	{
		$text = '
		<table class="basket">
			<tr>
				<th class="basket-th-first">'._LANG_NAME_GOOD.'</th>
				<th>'._LANG_COUNT.'</th>
				<th>'._LANG_PRICE.', '.$result["currency"].'</th>
				<th>'._LANG_SUM.', '.$result["currency"].'</th>
				<th class="basket-th-last">'._LANG_DELETE.'</th>
			</tr>';		
		if(! empty($result["rows"]))
		{
		
			foreach($result["rows"] as $row)
			{
				$text .= '
				<tr>
					<td class="basket-name"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a></td>
					<td class="basket-count"><input type="text" value="'.$row["count"].'" name="editshop'.$row["id"].'" class="inpnum" size="2"></td>
					<td class="basket-price">'.$row["price"].'</td>
					<td class="basket-summ">'.$row["summ"].'</td>
					<td class="basket-delete"><input type="checkbox" name="del'.$row["id"].'" value="1"></td>
				</tr>';
			}
		}
		$text .= '
			<tr class="basket-last-tr">
				<td class="basket-total">'._LANG_GOODS_TOTAL.'</td>
				<td class="basket-count">'.$result["count"].'</td>
				<td>&nbsp;</td>
				<td class="basket-summ">'.$result["summ"].'</td>
				<td id="basket-td-last">&nbsp;</td>
			</tr>
		</table>';
		return $text;
	}

	/**
	 * Шаблонная функция: выводит информацию о заказанных товарах
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function show_basket($result)
	{
		echo '
		<div class="basket-block">
			<a href="'.$result["link"].'">'._LANG_BASKET.'</a>:
			'.sprintf(_LANG_OF_GOODS_FOR_SUM,
				  ' <span id="basket_count" class="basket-count">'.$result["count"].'</span> ',
				  ' <span id="basket_summ" class="basket-summ">'.$result["summ"].'</span>'.'&nbsp;'.$result["currency"]
				  ).'
		</div>';

		return TRUE;
	}
}