<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Clauses_admin_config
 *
 * Конфигурирование модуля "Статьи"
 */
class Clauses_admin_config extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'clauses_config';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		$this->variable_table = array(
			'cat'			=> 'checkbox',
			'nastr'			=> 'numtext',
			'count_list'		=> 'numtext',
			'allclauses'		=> 'text',
			'childrens_elements'	=> 'checkbox',

			'hr1'			=> 'hr',

			'image'			=> 'function',
			'big_width'		=> 'function',
			'big_height'		=> 'none',
			'big_quality'		=> 'none',
			'medium_width'		=> 'function',
			'medium_height'		=> 'none',
			'medium_quality'	=> 'none',
			'list_img'		=> 'select',

			'image_cat'		=> 'function',
			'big_width_cat'		=> 'function',
			'big_height_cat'	=> 'none',
			'big_quality_cat'	=> 'none',
			'medium_width_cat'	=> 'function',
			'medium_height_cat'	=> 'none',
			'medium_quality_cat'	=> 'none',
			'list_img_cat'		=> 'select',

			'use_animation'		=> 'checkbox',
			'upload_max_filesize'	=> 'function',

			'hr2'			=> 'hr',
			'format_date'		=> 'select',
			'back-to-list'		=> 'text',

			'hr3'			=> 'hr',
			'comments_cat'		=> 'function',
			'comments'		=> 'function',
			'tags'			=> 'function',
			'rating'		=> 'function'
		);

		$this->language_names = array(
			'back-to-list',
			'allclauses'
		);

		$this->config_module = array(
			'element_site'	=> 1	//делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
		);

		$this->select_arr["list_img"] = array(
			0 => _ADMIN_CONFIG_LIST_IMG_0,
			1 => _ADMIN_CONFIG_LIST_IMG_1,
			2 => _ADMIN_CONFIG_LIST_IMG_2
		);

		$this->select_arr["list_img_cat"] = array(
			0 => _ADMIN_CONFIG_LIST_IMG_0,
			1 => _ADMIN_CONFIG_LIST_IMG_1,
			2 => _ADMIN_CONFIG_LIST_IMG_2
		);

		$this->select_arr["format_date"] = array(
			0 => _ADMIN_FORMAT_DATE_0,
			1 => _ADMIN_FORMAT_DATE_1,
			2 => _ADMIN_FORMAT_DATE_2,
			3 => _ADMIN_FORMAT_DATE_3,
			4 => _ADMIN_FORMAT_DATE_4
		);

		$this->show_tr_click_checkbox = array(
			'cat' => array(
				'count_list',
				'allclauses',
				'comments_cat',
				'childrens_elements',
				'image_cat'
			),
			'image' => array(
				'list_img',
				'big',
				'medium'
			),
			'image_cat' => array(
				'big_cat',
				'medium_cat',
				'list_img_cat'
			)
		);
	}
}