<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Clauses_admin_element
 *
 * Редактирование статей
 */
class Clauses_admin_element extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'clauses';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'clauses'; 

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'		=> 'text',
			'created'	=> 'datetime',
			'photo'		=> 'function',
			'act'		=> 'checkbox',
			'tags'		=> 'function',
			'comments'	=> 'function',
			'rate'		=> 'function',
			'hr1'           => 'hr',
			'number'	=> 'function',
			'timeedit'	=> 'function',
			'title_meta'	=> 'text',
			'keywords'	=> 'text',
			'descr'		=> 'textarea',
			'rewrite'	=> 'function',
			'site_id'	=> 'function',
			'cat_id'	=> 'function',
			'prior'		=> 'checkbox',
			'hr2'           => 'hr',
			'anons'         => 'editor',
			'text'		=> 'editor'
		);

		//поля, которые прячутся в Дополнительно
		$this->variable_other = array(
			'keywords'   => 1,
			'title_meta' => 1,
			'descr'      => 1,
			'prior'      => 1,
			'cat_id'     => 1,
			'site_id'    => 1,
			'rewrite'    => 1,
			'timeedit'   => 1,
			'number'     => 1,
			'hr1'        => 1
		);

		//переводимые поля
		$this->language_names = array(
			'name',
			'title_meta',
			'anons',
			'act',
			'keywords',
			'descr',
			'text'
		);
		
		$this->config_module = array(
			'act'			=> 1,	//показать/скрыть
			'del'			=> 1,	//удалить
			'date'			=> 1,	//показывать дату в списке, сортировать по дате 
			'prior'			=> 1,	//сортировать по полю приоритет
			'element_site'		=> $this->diafan->configmodules("cat") ? 0 : 1,	//модуль может быть прикреплен к нескольким страницам
			'element'               => $this->diafan->configmodules("cat") ? 1 : 0,	//используются группы
			'search_name'  		=> 1,	//искать по названию
			'trash'			=> 1	//использовать корзину
		);
		
		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'anons',
			'text'
		);

		//высота поля для Визуального редактора
		$this->editor_height = array(
			'anons'   => 200,
			'text'    => 400
		);
	}

	/**
	 * Выводит список статей
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_CLAUSES_ADD);
		echo '<table border="0" cellpadding="1" cellspacing="3" class="list">';
			$this->list_row($this->diafan->cat);
		echo '</table>';

		return TRUE;
	}
}