<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Clauses
 *
 * Контроллер модуля "Статьи"
 */
class Clauses extends Frame
{
	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct(&$diafan)
	{
		$this->diafan = &$diafan;

		$this->rewrite_variable_names = array('page', 'show', 'cat');
		if($this->diafan->configmodules("comments") || $this->diafan->configmodules("comments_cat") && ! $this->diafan->show && $this->diafan->cat)
		{
			$this->rewrite_variable_names[] = 'comments';
		}
		$this->diafan->rewrite_variable_names = $this->rewrite_variable_names;
		
		$model = new Clauses_model($diafan);
		
		if($this->diafan->show)
		{
			$this->result = $model->id();
		}
		elseif(! $this->diafan->configmodules("cat"))
		{
			$this->result = $model->list_();
		}
		elseif(! $this->diafan->cat)
		{
			$this->result = $model->first_page();
		}
		else
		{
			$this->result = $model->list_category();
		}
		$this->get_global_variables();
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	public function show_module()
	{
		if($this->diafan->show)
		{
			Clauses_view::id($this->result);
		}
		elseif($this->diafan->configmodules("cat") && ! $this->diafan->cat && !$this->diafan->year && !$this->diafan->month)
		{
			Clauses_view::first_page($this->result);
		}
		else
		{
			if(! empty($this->result["level"]) && is_callable(array('Clauses_view', 'list_level_'.$this->result["level"])))
			{
				$func = 'list_level_'.$this->result["level"];
				Clauses_view::$func($this->result);
			}
			else
			{
				Clauses_view::list_($this->result);
			}
		}
		return TRUE;
	}

	/**
	 * Шаблонная функция: блок статей
	 * 
	 * @param object $th основной объект
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return boolean
	 */
	public function show_block($th, $attributes)
	{
		$attributes = $this->get_attributes($attributes, 'count', 'cat_id', 'photo', 'sort', 'site_id', 'template');
		
		$count   = $attributes["count"] ? intval($attributes["count"]) : 3;
		$cat_id  = intval($attributes["cat_id"]);
		$site_id = intval($attributes["site_id"]);
		$sort    = $attributes["sort"] == "date" || $attributes["sort"] == "rand" ? $attributes["sort"] : "date";
		$photo   = intval($attributes["photo"]);

		if(($th->diafan->cid == $site_id || ! $site_id && $th->diafan->module == "clauses") && ! $th->diafan->show && $th->diafan->page < 2)
			return FALSE;

		include_once(ABSOLUTE_PATH.'modules/clauses/clauses.model.php');
		$model = new Clauses_model($th->diafan);
		$result = $model->show_block($count, $cat_id, $photo, $sort, $site_id);
		
		include_once(ABSOLUTE_PATH.'modules/clauses/clauses.view.php');
		$func = 'show_block';
		if($attributes["template"])
		{
			$func .= '_'.preg_replace('/[^a-z_]+/','', $attributes["template"]);
			
		}
		Clauses_view::$func($result);
		return TRUE;
	}
}