<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Comments_admin
 *
 * Редактирование комментариев
 */
class Comments_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'comments';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'comments';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'text'		=> 'textarea',
			'created'	=> 'datetime',
			'act'		=> 'checkbox',
			'element_id'	=> 'function',
			'user_id'	=> 'function'
		);

		$this->config_module = array(
			'act'		=> 1,	//показать/скрыть
			'del'		=> 1,	//удалить
			'datetime'	=> 1,	//показывать дату и время в списке
			'trash'		=> 1	//использовать корзину
		);

		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'element_id',
			'module_name'
		);
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	function show_module()
	{
		$this->name  = 'text';
		$this->where = (! empty($_GET["rew"])
			       ? " AND module_name='".preg_replace('/[^A-Za-z_]+/', '', $_GET["rew"])
			         ."' AND element_id='".preg_replace('/[^0-9]+/', '', $_GET["rew"])."'"
			       : '');

		echo '<table border="0" cellpadding="1" cellspacing="3" class="list">';
		$this->list_row();	
		echo '</table>';
		if(! $this->count)
		{
			echo _ADMIN_COMMENTS_NONE;
		}

		return TRUE;
	}

	/**
	 * Выводит объект, к которому прикреплен комментарий, в списке
	 * 
	 * @return string
	 */
	protected function other_row_element_id($row)
	{
		global $elements;
		if(empty($elements[$row["module_name"]][$row["element_id"]]))
		{
			$name = DB::query_result("SELECT ".($row["module_name"] != 'faq' ? 'name' : 'anons')." FROM {".$row["module_name"]."} where id='%d'", $row["element_id"]);
			$name = $this->diafan->short_text($name);
			$elements[$row["module_name"]][$row["element_id"]] = ($name ? $name : $row["element_id"]);
		}
		return '</td><td>'.$elements[$row["module_name"]][$row["element_id"]];
	}

	/**
	 * Выводит название модуля в списке
	 * 
	 * @return string
	 */
	protected function other_row_module_name($row)
	{					
		$const = strtoupper('_LANG_'.$row["module_name"]);
		return '</td><td>'.(defined($const) ? constant($const) : $row["module_name"]);
	}

	/**
	 * Редактирование поля "Объект"
	 * 
	 * @return boolean true
	 */
	protected function edit_element_id_module()
	{
		$module_name = str_replace('_category', '', $this->values["module_name"]);
		
		$link = BASE_PATH_HREF.$module_name
		.($this->diafan->configmodules('cat', $this->values["module_name"]) && $module_name == $this->values["module_name"]
		 ? '/cat'.DB::title($this->values["module_name"], $this->value, "cat_id")
		 : '')
		.'/edit'.$this->value.'/';

		echo '
		<tr valign="top">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<a href="'.$link.'" target="_blank">'.$link.'</a>
				<br>
				<a href="'.path_module($this->diafan, 1).'?rew='.$this->values["module_name"].$this->value.'">'._ADMIN_COMMENTS_ALL_COMMENTS.'</a>'
				.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Пользователь"
	 * 
	 * @return boolean true
	 */
	protected function edit_user_id_module()
	{
		echo '
		<tr>
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td>
			'.($this->value
			  ? '<a href="'.BASE_PATH_HREF.'usersite/edit'.$this->value.'/">'
			    .DB::title("users_site", $this->value, "fio").'</a>'
			  : _ADMIN_COMMENTS_ANONYMOUSY)
			.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Сохранение поля "Объект"
	 * 
	 * @return boolean true
	 */
	protected function save_element_id_module()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Пользователь"
	 * 
	 * @return boolean true
	 */
	protected function save_user_id_module()
	{
		return TRUE;
	}
}