<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Сomments_inc
 *
 * Подключение модуля "Комментарии"
 */
class Comments_inc extends Model
{
	/**
	 * @var array сгенерированные в моделе данные, передаваемые в шаблон
	 */
	private $result;

	/**
	 * @var object основной объект системы
	 */
	protected $diafan;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		require_once (ABSOLUTE_PATH.'modules/comments/comments.view.php');
		
		include_once(ABSOLUTE_PATH.'modules/comments/comments.ajax.php');
		$ajax = new Comments_ajax($diafan);
		if($ajax->ajax_request())
		{
			exit;
		}
	}

	/**
	 * Показывает комментарии, прикрепленные к элементу, и форму добавления комментария
	 *
	 * @param integer $element_id номер элемента
	 * @param string $module_name модуль
	 * @return string|boolean false
	 */
	public function get()
	{
		$id = 	($this->diafan->module
			? ($this->diafan->show
			  ? $this->diafan->show
			  : $this->diafan->cat
			  )
			: $this->diafan->cid
			);

		$module_name = ($this->diafan->module
			       ? $this->diafan->module.(! $this->diafan->show ? "_category" : '')
			       : 'site'
			       );

		////navigation//
		include_once(ABSOLUTE_PATH.'includes/paginator/paginator.inc.php');
		$paginator = new Paginator_inc();
		$paginator->page    = $this->diafan->comments;
		if(! $paginator->nastr = $this->diafan->configmodules("nastr", 'comments'))
		{
			$paginator->nastr = 10;
		}
		$paginator->urlpage = 'comments%d/';
		$paginator->navlink = $this->diafan->path_module_variable('comments');
		$paginator->nen = DB::query_result("SELECT COUNT(id) FROM {comments} WHERE module_name='%h'"
						  ." AND element_id='%d' and act='1' AND trash='0'", $module_name, $id);
		$links = $paginator->get();
		////navigation///	
		
		$result = DB::query_range("SELECT created,user_id,text FROM {comments} WHERE module_name='%h' AND element_id='%d'"
					  ." AND act='1' AND trash='0' ORDER BY created ASC",
					  $module_name, $id, $paginator->polog, $paginator->nastr);
		global $users_site;
		$rows = array();
		while($row = DB::fetch_array($result))
		{
			$row['date'] = $this->format_date($row['created'], "comments");
			unset($row['created']);
			if($this->diafan->configmodules('user_name', 'comments') && empty($users_site[$row["user_id"]]))
			{
				$users_site[$row["user_id"]] = DB::title("users_site", $row["user_id"], "fio");
			}
			$row["text"] = nl2br($row["text"]);
			$row["name"] = $this->diafan->configmodules('user_name', 'comments') ? $users_site[$row["user_id"]] : '';
			$rows[] = $row;
		}

		$paginator = $links;
		
		if(! empty($_SERVER["HTTP_X_REQUESTED_WITH"]))
		{
			include_once(ABSOLUTE_PATH.'plugins/json.php');
			$json["content"] = Comments_view::get($rows, $paginator, TRUE);
			echo to_json($json);
			exit;
		}
		else
		{
			$text = Comments_view::get($rows, $paginator);
			if(! $this->diafan->configmodules('security_user', 'comments') || $this->diafan->_user->id)
			{
				$this->result["first"] = count($rows) ? FALSE : TRUE;
				$this->result["captcha"] = '';
				if($this->diafan->configmodules('security_code', 'comments') == 1)
				{
					require_once (ABSOLUTE_PATH.'includes/captcha/captcha.inc.php');
					$this->result["captcha"] = Captcha_inc::get("comments", $this->get_error("comments", "code"));
				}
				$this->result["error"]  = $this->get_error("comments");
				$text .= Comments_view::form($this->result);
			}
			return $text;
		}
	}
}