<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Comments_install
 *
 * Установка модуля "Комментарии"
 */

$title = "Комментарии";

$sql = array(
	"CREATE TABLE {comments} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		user_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		text text NOT NULL,
		act ENUM('0', '1') NOT NULL DEFAULT '0',
		created INT(12) UNSIGNED NOT NULL DEFAULT '0',
		module_name VARCHAR(17) NOT NULL DEFAULT '',
		element_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY element_id (element_id),
		KEY module_name (module_name(2))
	)",

	"ALTER DATABASE {comments} DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;",

	"INSERT INTO {adminsite} (id, parent_id, name, rewrite, text, act, numrow, sort) VALUES (
		42,
		15,
		'Комментарии',
		'comments',
		'<p>Комментарии оставляются пользователями на сайте и прикрепляются к продуктам магазина, к новостям, статьям, фотогалереям и пр. Все комментарии с сайта собираются в этом модуле в неактивном (<img src=\"".BASE_PATH."adm/img/b3.gif\" alt=\"\" />) виде. Чтобы комментарий начал отображаться на сайте, его необходимо активировать.<br />\r\n<a href=\"base_path/comments/config1/\">Настройки модуля &quot;Комментарии&quot;</a>.</p>\r\n<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>',
		'1',
		255772,
		'9'
	);",

	"INSERT INTO {config} (id, module_name, config, cat_id) VALUES (
		8,
		'comments',
		'security_user=0"
		."\n"
		."security_code=1"
		."\n"
		."security_moderation=0"
		."\n"
		."user_name=0"
		."\n"
		."nnastr=10"
		."\n"
		."format_date="
		.multilang(
			"\n"
			."error-insert-message=Ваше сообщение уже имеется в базе"
			."\n"
			."add-message=Спасибо! Ваш комментарий будет проверен в ближайшее время и появиться на сайте."
			."\n"
			."error-add-message=Ваш комментарий не может быть добавлен"
			,
			"\n"
			."error-insert-message2=Your message is already in data base."
			."\n"
			."add-message2=Thank you! Your comment will check in near time and will publish on this page."
			."\n"
			."error-add-message2=Impossible to add your comment.&lt;br&gt;Сheсk if input data is correct."
		)
		."',
		0
	);"
);
	
$example = array();


if(! empty($_POST["photo"]))
{
	$example[] = "INSERT INTO {comments} VALUES (
		3,
		0,
		'Лошадь просто супер. Сынишка в восторге. Спасибо!',
		'1',
		'".(time()-86400*5)."',
		'photo',
		'2',
		'0'
	)";
	$example[] = "INSERT INTO {comments} VALUES (
		8,
		0,
		'Вау, какая изворотливая!',
		'1',
		'".time()."',
		'photo',
		'9',
		'0'
	);";
}

if(! empty($_POST["shop"]))
{
	$example[] = "INSERT INTO {comments} VALUES (
		1,
		0,
		'Хороший коршун, я купил себе три на дачу.',
		'1',
		'".(time()-86400*6)."',
		'shop',
		'1',
		'0'
	)";
	$example[] = "INSERT INTO {comments} VALUES (
		4,
		0,
		'Отличный пеликан. Купил и не нарадуюсь.',
		'1',
		'".(time()-86400*4)."',
		'shop',
		'3',
		'0'
	)";
	$example[] = "INSERT INTO {comments} VALUES (
		5,
		0,
		'Очень хочется познакомиться с вашим создателем.',
		'1',
		'".(time()-86400*3)."',
		'shop',
		'30',
		'0'
	)";
	$example[] = "INSERT INTO {comments} VALUES (
		6,
		0,
		'Красавец',
		'1',
		'".(time()-86400*2)."',
		'shop',
		'19',
		'0'
	)";
}

if(! empty($_POST["clauses"]))
{
	$example[] = "INSERT INTO {comments} VALUES (
		7,
		0,
		'Отличная статья. Я в восторге. Автор.',
		'1',
		'".(time()-86400)."',
		'clauses',
		'1',
		'0'
	)";
}

/**
 * Деинсталлирует модуль
 * 
 * @return void
 */
function module_basic_uninstall_comments()
{
	$module = 'comments';
	DB::query("DROP TABLE {".$module."};");
	DB::query("DELETE FROM {adminsite} WHERE rewrite='".$module."';");
	DB::query("DELETE FROM {config} WHERE module_name='".$module."';");
}