<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Comments_view
 *
 * Шаблон модуля "Комментарии"
 */
class Comments_view
{
	/**
	 * Шаблон формы добавления комментария
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return string
	 */
	public function form($result)
	{
		return '
		<h2>'._LANG_ADD_COMMENTS.'</h2>
		<form method="POST" action="" id="comments" name="comments" class="ajax comments-form">
		<input type="hidden" name="ajax_comments" value="1">
		<input type="hidden" name="ajax" value="0" class="ajax">

		'.($result["first"] ? '<input type="hidden" name="first" value="1">' : '').'

		<div class="errors error"'.($result["error"] ? '>'.$result["error"] : ' style="display:none">').'</div>
		<textarea name="comment" class="inptext"></textarea><br>'

		//Защитный код
		.$result["captcha"]

		//Кнопка Отправить
		.'<input type="submit" value="'._LANG_SEND.'" class="button">'
		.'
		</form>';
	}

	/**
	 * Шаблон вывода комментариев
	 * 
	 * @param array $rows массив с комментариями
	 * @param string $navigation навигация
	 * @param boolean $new добавленный комментарий
	 * @return string
	 */
	public function get($rows, $paginator, $new = FALSE)
	{
		$text = $rows && ! $new? '<h2>'._LANG_COMMENTS.'</h2>' : '';

		if($rows)
		{
			$text .= ! $new? '<div class="comments">' : '';
			foreach($rows as $row)
			{
				$text .=
				($row['date'] ? '
				<div class="comments-date">'.$row['date'].'</div>' : '')

				.($row["name"] ? '
				<div class="comments-name">'.$row["name"].":</div>" : '').'

				<div class="comments-text">'.$row['text']."</div>"
				;
			}

			$text .= Paginator_view::get($paginator);

			$text .= ! $new? '</div>
			<script type="text/javascript" src="'.BASE_PATH.'modules/comments/comments-func.js"></script>' : '';
		}
		return $text;
	}
}