<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Config_admin
 *
 * Настройка параметров сайта
 */
class Config_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'config';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'base' => array(
				'db_host'       => 'text',
				'db_name'       => 'text',
				'db_user'       => 'text',
				'db_pass'       => 'text',
				'db_prefix'     => 'text',
				'db_charset'    => 'disabled',

				'hr2'           => 'hr',
				'email'         => 'text',
				'htmleditor'    => 'checkbox',
				'userfiles'     => 'text',
				'language'      => 'disabled',
				'admin_folder'  => 'text',

				'hr3'           => 'hr',
				'ftp_host'      => 'text',
				'ftp_login'     => 'text',
				'ftp_password'  => 'text',
				'ftp_dir'       => 'text',

				'hr4'           => 'hr',
				'smtp_mail'     => 'checkbox',
				'smtp_host'     => 'text',
				'smtp_login'    => 'text',
				'smtp_password' => 'text',
				'smtp_port'     => 'text',

				'hr5'           => 'hr'
			),
			'mod_developer' => array(
				'mod_developer'              => 'checkbox',
				'mod_developer_cache'        => 'checkbox',
				'mod_developer_delete_cache' => 'checkbox',
				'mod_developer_profiling'    => 'checkbox'
			)
		);

		$this->config_module = array(
			'no_out'   => 1, //не отображать кнопки Сохранить и выйти, Выйти без сохранения
			'tab_card' => 1
		);

		$this->show_tr_click_checkbox = array(
			'smtp_mail' => array(
						'smtp_host',
						'smtp_login',
						'smtp_password',
						'smtp_port'
			)
		);

		foreach($this->diafan->language_all as $l => $langarr)
		{
			define('_ADMIN_CONFIG_TITLE_'.$langarr[0], _ADMIN_CONFIG_TITLE.($langarr[1] ? ' ('.$langarr[1].')' : ''));
			$this->variable_table['base']['title_'.$langarr[0]] = 'text';
		}
		
		$this->diafan->edit = 1;
	}

	/**
	 * Выводит форму редактирования параметров сайта
	 * @return boolean true
	 */
	public function edit_module()
	{
		if(file_exists(ABSOLUTE_PATH.'bdcfg.php') &&  ! is_writable(ABSOLUTE_PATH.'bdcfg.php'))
		{
			echo '<p><font color="red" size="3">'._ADMIN_CONFIGFILE_NO_PERMISSION.'</font></p>';
		}
		parent::edit_module();

		return TRUE;
	}

	/**
	 * Задает значения полей для формы
	 * 
	 * @return array
	 */
	protected function get_values()
	{
		$url = parse_url(DB_URL);

		$array = array(
			'db_host'                    => urldecode($url['host']),
			'db_user'                    => urldecode($url['user']),
			'db_pass'                    => isset($url['pass']) ? urldecode($url['pass']) : '',
			'db_name'                    => substr(urldecode($url['path']), 1),
			'db_prefix'                  => DB_PREFIX,
			'email'                      => EMAIL_CONFIG,
			'db_charset'                 => DB_CHARSET,
			'htmleditor'                 => HTMLEDITOR,
			'userfiles'                  => USERFILES,
			'language'                   => LANGUAGE_BASE,
			'admin_folder'               => ADMIN_FOLDER,
			'mod_developer'              => MOD_DEVELOPER,
			'mod_developer_profiling'    => MOD_DEVELOPER_PROFILING,
			'mod_developer_cache'        => MOD_DEVELOPER_CACHE,
			'mod_developer_delete_cache' => FALSE,
			'ftp_host'                   => FTP_HOST,
			'ftp_login'                  => FTP_LOGIN,
			'ftp_password'               => FTP_PASSWORD,
			'ftp_dir'                    => FTP_DIR,
			
			'smtp_mail'                  => defined('SMTP_MAIL') ? SMTP_MAIL : FALSE,
			'smtp_host'                  => defined('SMTP_HOST') ? SMTP_HOST : '',
			'smtp_login'                 => defined('SMTP_LOGIN') ? SMTP_LOGIN : '',
			'smtp_password'              => defined('SMTP_PASSWORD') ? SMTP_PASSWORD : '',
			'smtp_port'                  => defined('SMTP_PORT') ? SMTP_PORT : ''
		);

		foreach($this->diafan->language_all as $l => $langarr)
		{
			$array['title_'.$langarr[0]] = (defined('TIT'.$langarr[0]) ? constant('TIT'.$langarr[0]) : '');
		}

		return $array;
		
	}

	/**
	 * Сохраняет файл конфигурации
	 * 
	 * @return boolean
	 */
	public function save_module()
	{
		//проверка прав на сохранение
		if($this->diafan->admin_roles('save'))
		{
			$this->diafan->goto_diafan(URL);
			return FALSE;
		}

		$url = parse_url(DB_URL);
		$diafan_user = urldecode($url['user']);
		if(isset($url['pass']))
		{
			$diafan_pass = urldecode($url['pass']);
		}
		else
		{
			$diafan_pass = '';
		}
		$diafan_host = urldecode($url['host']);
		$diafan_dbname = substr(urldecode($url['path']), 1);

		$dir_url_path = '';

		if($_SERVER['REQUEST_URI'] != "/".ADMIN_FOLDER."/config/save1/")
		{
			$dir_url_path = str_replace("/".ADMIN_FOLDER."/config/save1/", "", $_SERVER['REQUEST_URI']);
		}

		$admin_folder = substr($this->diafan->get_param($_POST, "admin_folder", ADMIN_FOLDER, 1), 0, 20);

		include_once(ABSOLUTE_PATH.'includes/validate.php');
		$text = '<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined(\'DIAFAN\'))
{
	include(dirname(__FILE__).\'/includes/404.php\');
}
define("REVATIVE_PATH", "'.REVATIVE_PATH.'");';
		foreach($this->diafan->language_all as $l => $langarr)
		{
			$text .= '
define("TIT'.$langarr[0].'", "'.str_replace('"', '', htmlspecialchars(stripslashes($this->diafan->get_param($_POST, "title_".$langarr[0], '', 1)))).'");';
		}
		$text.='

define("DB_URL", "mysql://'.str_replace('"', '&quot;', $this->diafan->get_param($_POST, "db_user", $diafan_user, 1))
	.($_POST["db_pass"] ? ":".str_replace('"', '&quot;', $this->diafan->get_param($_POST, "db_pass_update", $diafan_pass, 1)) : '')
	."@".str_replace('"', '&quot;', $this->diafan->get_param($_POST, "db_host", $diafan_host, 1))
	."/".str_replace('"', '&quot;', $this->diafan->get_param($_POST, "db_name", $diafan_dbname, 1)).'");
define("DB_PREFIX", "'.str_replace('"','&quot;', $this->diafan->get_param($_POST, "db_prefix", DB_PREFIX, 1)).'");
define("DB_CHARSET", "utf8");

define("EMAIL_CONFIG", "'.(! Validate::mail($_POST["email"]) ? str_replace('"','&quot;', $this->diafan->get_param($_POST, "email", EMAIL_CONFIG, 1)) : '').'");
define("HTMLEDITOR", '.(! empty($_POST["htmleditor"]) ? 'TRUE' : 'FALSE').');
define("USERFILES", "'.$this->diafan->get_param($_POST, "userfiles", USERFILES, 1).'");
define("LANGUAGE_BASE", "'.LANGUAGE_BASE.'");
define("VERSION_CMS", "'.VERSION_CMS.'");
define("DATE_UPDATE", "'.DATE_UPDATE.'");
define("DIAFAN_CODE", "'.DIAFAN_CODE.'");
define("ADMIN_FOLDER", "'.$admin_folder.'");
define("MOD_DEVELOPER", '.(! empty($_POST["mod_developer"]) ? 'TRUE' : 'FALSE').');
define("MOD_DEVELOPER_CACHE", '.(! empty($_POST["mod_developer_cache"]) ? 'TRUE' : 'FALSE').');
define("MOD_DEVELOPER_PROFILING", '.(! empty($_POST["mod_developer_profiling"]) ? 'TRUE' : 'FALSE').');

define("FTP_HOST", "'.$this->diafan->get_param($_POST, "ftp_host", FTP_HOST, 1).'");
define("FTP_DIR", "'.$this->diafan->get_param($_POST, "ftp_dir", FTP_DIR, 1).'");
define("FTP_LOGIN", "'.$this->diafan->get_param($_POST, "ftp_login", FTP_LOGIN, 1).'");
define("FTP_PASSWORD", "'.$this->diafan->get_param($_POST, "ftp_password", FTP_PASSWORD, 1).'");

define("SMTP_MAIL", '.(! empty($_POST["smtp_mail"]) ? 'TRUE' : 'FALSE').');
define("SMTP_HOST", "'.$this->diafan->get_param($_POST, "smtp_host", "", 1).'");
define("SMTP_LOGIN", "'.$this->diafan->get_param($_POST, "smtp_login", "", 1).'");
define("SMTP_PASSWORD", "'.$this->diafan->get_param($_POST, "smtp_password", "", 1).'");
define("SMTP_PORT", "'.$this->diafan->get_param($_POST, "smtp_port", "", 1).'");
'
.(defined("ROBOX_LOGIN")?'
define("ROBOX_LOGIN", "'.ROBOX_LOGIN.'");
' : '').(defined("ROBOX_PASS_1") ? '
define("ROBOX_PASS_1", "'.ROBOX_PASS_1.'");
' : '').(defined("ROBOX_PASS_2") ? '
define("ROBOX_PASS_2", "'.ROBOX_PASS_2.'");
' : '').(defined("WM_SECRET")?'

define("WM_SECRET", "'.WM_SECRET.'");
' : '').(defined("WM_TARGET") ? '
define("WM_TARGET", "'.WM_TARGET.'");' : '');

		$fp = fopen(ABSOLUTE_PATH."bdcfg.php", "w");
		fwrite($fp, $text);
		fclose($fp);

		if(! empty($_POST["mod_developer_delete_cache"]))
		{
			$this->diafan->_cache->delete("", array());
		}
		if($admin_folder == ADMIN_FOLDER)
		{
			$this->diafan->goto_diafan(URL.'error1/');
		}
		else
		{
			$this->diafan->goto_diafan('http://'.BASE_URL.'/'.$admin_folder.'/config/error1/');
		}
		return TRUE;
	}
}
