<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Faq_admin_config
 *
 * Конфигурирование модуля "Вопрос-Ответ"
 */
class Faq_admin_config extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'faq_config';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		$this->variable_table = array(
			'nastr'			=> 'numtext',
			'cat'			=> 'checkbox',
			'count_list'		=> 'numtext',
			'allfaq'		=> 'text',
			'childrens_elements'	=> 'checkbox',

			'hr1'			=> 'hr',
			'show-form'		=>'select',
			'security'		=>'select',
			'format_date'		=>'select',
			'back-to-list'		=>'text',
			'add-message'		=>'textarea',
			'error-insert-message'	=>'text',

			'hr2'			=> 'hr',
			'files'			=> 'checkbox',
			'max-count-files'	=> 'numtext',
			'attachment-extensions' => 'text',

			'hr3'			=> 'hr',
			'subject'		=> 'text',
			'message'		=> 'textarea',
			'emailconf'		=> 'select',
			'email'			=> 'none',
			'sendmailadmin'		=> 'checkbox',
			'emailconfadmin'	=> 'function',
			'email-admin'		=> 'none',
			'subject-admin'		=> 'text',
			'message-admin'		=> 'textarea',

			'hr4'			=> 'hr',
			'comments'		=> 'function',
			'comments_cat'		=> 'function',
			'tags'			=> 'function',
			'rating'		=> 'function'
		);

		$this->language_names = array(
			'back-to-list',
			'subject',
			'message',
			'add-message',
			'allfaq',
			'error-insert-message',
			'error-empty-fields'
		);

		$this->config_module = array(
			'element_site'	=> 1	//делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
		);

		$this->select_arr["security"] = array(
			0 => _ADMIN_FORMAT_SECURITY_0,
			1 => _ADMIN_FORMAT_SECURITY_1,
			2 => _ADMIN_FORMAT_SECURITY_2
		);

		$this->select_arr["format_date"] = array(
			0 => _ADMIN_FORMAT_DATE_0,
			1 => _ADMIN_FORMAT_DATE_1,
			2 => _ADMIN_FORMAT_DATE_2,
			3 => _ADMIN_FORMAT_DATE_3,
			4 => _ADMIN_FORMAT_DATE_4
		);

		$this->select_arr['show-form'] = array(
			0 => _ADMIN_FAQ_SHOW_FORM_0,
			1 => _ADMIN_FAQ_SHOW_FORM_1,
			2 => _ADMIN_FAQ_SHOW_FORM_2,
			3 => _ADMIN_FAQ_SHOW_FORM_3
		);

		$this->show_tr_click_checkbox = array(
			'sendmailadmin' => array(
						'emailconfadmin',
						'subject-admin',
						'message-admin'
			),
			'files' => array(
					'max-count-files',
					'attachment-extensions'
			),
			'cat' => array(
					'count_list',
					'allfaq',
					'comments_cat',
					'childrens_elements'
			)
		);
		
	}
}