<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Faq_admin_element
 *
 * Редактирование вопросов
 */
class Faq_admin_element extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'faq';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'faq'; 

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'		=> 'text',
			'created'	=> 'datetime',
			'act'		=> 'checkbox',
			'often'		=> 'checkbox',
			'sendmail'	=> 'function',
			'mail'		=> 'text',
			'files'		=> 'function',
			'tags'		=> 'function',
			'comments'	=> 'function',
			'rate'		=> 'function',
			'hr1'           => 'hr',
			'number'	=> 'function',
			'timeedit'	=> 'function',
			'title_meta'	=> 'text',
			'keywords'	=> 'text',
			'descr'		=> 'textarea',
			'rewrite'	=> 'function',
			'site_id'	=> 'function',
			'cat_id'	=> 'function',
			'hr2'           => 'hr',
			'anons'         => 'textarea',
			'text'		=> 'editor'
		);
		
		//поля, которые прячутся в Дополнительно
		$this->variable_other = array(
			'hr1'           => 1,
			'number'        => 1,
			'title_meta'	=> 1,
			'timeedit'	=> 1,
			'keywords'	=> 1,
			'descr'		=> 1,
			'rewrite'	=> 1,
			'cat_id'	=> 1,
			'site_id'	=> 1
		);

		//переводимые поля
		$this->language_names = array(
			'name',
			'title_meta',
			'anons',
			'act',
			'keywords',
			'descr',
			'text'
		);

		$this->config_module = array(
			'act'			=> 1,	//показать/скрыть
			'del'			=> 1,	//удалить
			'date'			=> 1,	//показывать дату в списке, сортировать по дате
			'element_site'		=> $this->diafan->configmodules("cat") ? 0 : 1,	//модуль может быть прикреплен к нескольким страницам
			'element'               => $this->diafan->configmodules("cat") ? 1 : 0,	//используются группы
			'trash'			=> 1	//использовать корзину
		);

		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'anons',
			'text'
		);

		//высота поля для Визуального редактора
		$this->editor_height = array(
			'anons'   => 200,
			'text'    => 400
		);
	}

	/**
	 * Выводит список вопросов
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_FAQ_ADD);
		echo '<table border="0" cellpadding="1" cellspacing="3" class="list">';
			$this->list_row($this->diafan->cat);
		echo '</table>';

		return TRUE;
	}

	/**
	 * Выводит статус вопроса (отвеченный/неотвеченный), в списке
	 * 
	 * @return string
	 */
	protected function other_row_anons($row)
	{
		return (! $row["text"] ? ' <a href="'.path_module($this->diafan).'edit'.$row["id"].'/">(неотвеченный вопрос)</a>' : '').'</td><td class="Comments">
			<div>
				<span></span>
				<table><tbody><tr><td>
					'.$this->diafan->short_text($row["anons"]).'
				</td></tr></tbody></table>
			</div>';
	}

	/**
	 * Редактирование поля "Отправить ответ"
	 * @return boolean true
	 */
	protected function edit_sendmail_module()
	{
		echo '
		<tr>
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<input name="sendmail" value="1" type="checkbox">'.$this->show_help_row().'
			</td>
		</tr>';
	}

	/**
	 * Редактирование поля "Файлы"
	 * @return boolean true
	 */
	protected function edit_files_module()
	{
		$result = DB::query("SELECT id, name FROM {attachment} WHERE module_name='".$this->table."' AND element_id='%d'", $this->diafan->edit);
		while ($row = DB::fetch_array($result))
		{
			echo (empty($yes) ? '
			<tr>
				<td align="right">'.$this->variable_names().'</td>
				<td>' : '').'
				<input type="checkbox" name="filedel[]" value="'.$row["id"].'" /><a href="http://'.BASE_URL.'/file/'.$row["id"]."/".$row["name"].'">'.$row["name"].'</a><br>';
			$yes = 1;
		}
		echo (! empty($yes) ? $this->show_help_row().'
			</td>
		</tr>' : '');
	}

	/**
	 * Сохранение поля "Отправить ответ"
	 * @return boolean true
	 */
	protected function save_sendmail_module()
	{		
		if(! empty($_POST["sendmail"]) && ! empty($_POST["mail"]) && ! empty($_POST["text"]) && ! empty($_POST["anons"]))
		{			
			$subject = str_replace(
				array('%title', '%url'),
				array(TITLE, BASE_URL),
				$this->diafan->configmodules('subject', 'faq', _LANG, $_POST["site_id"])
			);
		
			$message =	str_replace(
				array(
					', %name',
					'%name',
					'%title',
					'%url',
					'%question',
					'%answer'
				),
				array(
					strip_tags($_POST["name"]) ? ', '.strip_tags($_POST["name"]) : '',
					strip_tags($_POST["name"]),
					TITLE,
					BASE_URL,
					htmlspecialchars($_POST["anons"]),
					$_POST["text"]
				),
				$this->diafan->configmodules('message', 'faq', _LANG, $_POST["site_id"])
			);

			include_once(ABSOLUTE_PATH.'includes/mail.php');
			send_mail(
				 trim(strip_tags($_POST["mail"])),
				 $subject,
				 $message,
				 $this->diafan->configmodules("emailconf", 'faq', _LANG, $_POST["site_id"]) && $this->diafan->configmodules("email", 'faq', _LANG, $_POST["site_id"])
				 ? $this->diafan->configmodules("email",'faq',_LANG,$_POST["site_id"])
				 : ''
			);
			$this->diafan->err = 5;
		}
		elseif(! empty($_POST["sendmail"]))
		{
			$this->diafan->err = 6;		
		}
		return TRUE;
	}

	/**
	 * Сохранение поля "Файлы"
	 * @return boolean true
	 */
	protected function save_files_module()
	{
		$result = DB::query("SELECT id FROM {attachment} WHERE module_name='%s' AND element_id='%d'", $this->table, $this->diafan->save);
		while ($row = DB::fetch_array($result))
		{
			if(!empty($_POST["filedel"]) && in_array($row["id"], $_POST["filedel"]))
			{
				DB::query("DELETE FROM {attachment} WHERE id='%d'", $row["id"]);
				unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/files/'.$row["id"]);
			}
		}
		return TRUE;
	}
}