<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Faq
 *
 * Контроллер модуля "Вопрос-Ответ"
 */
class Faq extends Frame
{
	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct(&$diafan)
	{
		$this->diafan = &$diafan;

		$this->rewrite_variable_names = array('page', 'show', 'cat');
		if($this->diafan->configmodules("comments") || $this->diafan->configmodules("comments_cat") && ! $this->diafan->show && $this->diafan->cat)
		{
			$this->rewrite_variable_names[] = 'comments';
		}
		$this->diafan->rewrite_variable_names = $this->rewrite_variable_names;

		include_once(ABSOLUTE_PATH.'modules/faq/faq.ajax.php');
		$ajax = new Faq_ajax($diafan);
		if($ajax->ajax_request())
		{
			exit;
		}

		$model = new Faq_model($diafan);
		
		if($this->diafan->show)
		{
			$this->result = $model->id();
		}
		elseif(! $this->diafan->configmodules("cat"))
		{
			$this->result = $model->list_();
		}
		elseif(! $this->diafan->cat)
		{
			$this->result = $model->first_page();
		}
		else
		{
			$this->result = $model->list_category();
		}
		$this->get_global_variables();
		$this->result = $model->form();
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	public function show_module()
	{
		if($this->diafan->show)
		{
			Faq_view::id($this->result);
		}
		elseif($this->diafan->configmodules("cat") && ! $this->diafan->cat && !$this->diafan->year && !$this->diafan->month)
		{
			Faq_view::first_page($this->result);
		}
		else
		{
			if(! empty($this->result["level"]) && is_callable(array('Faq_view', 'list_level_'.$this->result["level"])))
			{
				$func = 'list_level_'.$this->result["level"];
				Faq_view::$func($this->result);
			}
			else
			{
				Faq_view::list_($this->result);
			}
		}

		if(! empty($this->result["form"]["ok"]))
		{
			Faq_view::form($this->result["form"]);
		}

		return TRUE;
	}

	/**
	 * Шаблонная функция: блок вопросов и ответов
	 *
	 * @param object $th основной объект
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return boolean
	 */
	public function show_block($th, $attributes)
	{
		$attributes = $this->get_attributes($attributes, 'count', 'cat_id', 'sort', 'site_id', 'often', 'template');
		
		$count   = $attributes["count"] ? intval($attributes["count"]) : 3;
		$cat_id  = intval($attributes["cat_id"]);
		$site_id = intval($attributes["site_id"]);
		$sort    = $attributes["sort"] == "date" || $attributes["sort"] == "rand" ? $attributes["sort"] : "date";
		$often   = $attributes["often"] ? TRUE : FALSE;

		if(($th->diafan->cid == $site_id || ! $site_id && $th->diafan->module == "faq") && ! $th->diafan->show && $th->diafan->page < 2)
			return FALSE;

		include_once(ABSOLUTE_PATH.'modules/faq/faq.model.php');
		$model = new Faq_model($th->diafan);
		$result = $model->show_block($count, $cat_id, $often, $sort, $site_id);
		
		include_once(ABSOLUTE_PATH.'modules/faq/faq.view.php');
		$func = 'show_block';
		if($attributes["template"])
		{
			$func .= '_'.preg_replace('/[^a-z_]+/','', $attributes["template"]);
			
		}
		Faq_view::$func($result);
		return TRUE;
	}

	/**
	 * Шаблонная функция: форма добавления вопроса
	 *
	 * @param object $th основной объект
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return boolean
	 */
	public function show_form($th, $attributes)
	{
		$attributes = $this->get_attributes($attributes, 'cat_id', 'site_id', 'template');

		$cat_id  = intval($attributes["cat_id"]);
		$site_id = intval($attributes["site_id"]);

		include_once(ABSOLUTE_PATH.'modules/faq/faq.model.php');
		$model = new Faq_model($th->diafan);
		$result = $model->form($site_id, $cat_id, TRUE);
		if($result)
		{
			include_once(ABSOLUTE_PATH.'modules/faq/faq.view.php');
			$func = 'form';
			if($attributes["template"])
			{
				$func .= '_'.preg_replace('/[^a-z_]+/','', $attributes["template"]);
				
			}
			Faq_view::$func($result["form"]);
		}
		return TRUE;
	}
}