<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Faq_view
 *
 * Шаблон модуля "Вопрос-Ответ"
 */
class Faq_view
{
	/**
	 * Шаблон формы добавления вопроса
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function form($result)
	{
		echo '<h2>'._LANG_ASK_YOUR_QUESTION.'</h2>

		<form method="POST" action="'.BASE_PATH_HREF.$result["action"].'" enctype="multipart/form-data" class="ajax faq-form">
		<input type="hidden" name="ajax_faq" value="1">
		<input type="hidden" name="ajax" value="0">'

		//Имя
		.'<div class="infofield">'._LANG_YOUR_NAME.'<font color="red">*</font>:</div>
		<input type = "text" maxLength="70" name="name" size="40" class="inptext" value=""><br>
		<div class="errors error-name"'.($result["error-name"] ? '>'.$result["error-name"] : ' style="display:none">').'</div>'

		//Вопрос
		.'<div class="infofield">'._LANG_YOUR_QUESTION.'<font color="red">*</font>:</div>
		<textarea rows="10" name="question" cols="30" class="inptext"></textarea><br>
		<div class="errors error-question"'.($result["error-question"] ? '>'.$result["error-question"] : ' style="display:none">').'</div>'

		//E-mail
		.'<div class="infofield">'._LANG_YOUR_EMAIL.':</div>
		<input type = "text" maxLength="70" name="email" size="40" class="inptext" value=""><br>
		<div class="errors error-email"'.($result["error-email"] ? '>'.$result["error-email"] : ' style="display:none">').'</div>';

		//Прикрепляемые файлы
		if($result["files"])
		{
			echo '
			<div class="infofield">'._LANG_ATTACHMENT.':</div>
			<input type="file" name="attachment[]" class="inptext" max="'.$result["files"].'">
			<div class="errors error-attachments"'.($result["error-attachments"] ? '>'.$result["error-attachments"] : ' style="display:none">').'</div>';
		}

		//Защитный код
		echo $result["captcha"]

		//Кнопка Отправить
		.'<input type="submit" value="'._LANG_SEND.'" class="button" name="button">
		<div class="errors error"'.($result["error"] ? '>'.$result["error"] : ' style="display:none">').'</div>

		</form>';

		return TRUE;
	}

	/**
	 * Шаблон списка вопросов и ответов
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean
	 */
	public function list_($result)
	{
		//название и описание раздела
		echo '
		<div class="faq-list">';

		echo (! empty($result["text"]) ? '
			<div class="faq-cat-text">'.$result["text"].'</div>' : '');

		//ссылки на подразделы
		if(! empty($result["children"]))
		{
			foreach($result["children"] as $child)
			{
				echo '
				<div class="faq-cat-links"><a href="'.BASE_PATH_HREF.$child["link"].'">'.$child["name"].'</a></div>
				'.($child["anons"] ? '<div class="faq-cat-text">'.$child["anons"].'</div>' : '');
			}
		}

		//вопросы
		if(! empty($result["rows"]))
		{
			foreach($result["rows"] as $row)
			{
				echo '
				<div class="faq">'
					.(! empty($row['date']) ? '
					<div class="faq-date">'.$row["date"]."</div>" : '')
					
					//Вопрос
					.'<div class="faq-question"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["anons"]."</a></div>\n"

					//Ответ
					.'<div class="faq-answer">'.$row["text"]."</div>\n"
					
					.(! empty($row["show-rating"]) ? $row["show-rating"] : '').'
					'.(! empty($row["tags"]) ? $row["tags"] : '').'
				</div>';
			}
			echo '<div class="clear"></div>';
		}

		echo Paginator_view::get($result["paginator"])

		.(! empty($result["previous"]) ? '
		<div class="previous-link"><a href="'.BASE_PATH_HREF.$result["previous"]["link"].'">&larr; '.$result["previous"]["text"].'</a></div>' : '')

		.(! empty($result["next"]) ? '
		<div class="next-link"><a href="'.BASE_PATH_HREF.$result["next"]["link"].'">'.$result["next"]["text"].' &rarr;</a></div>' : '')

		.'<div class="clear"></div>'

		.(! empty($result["comments"]) ? $result["comments"] : '')
		.'
		</div>';

		return TRUE;
	}

	/**
	 * Шаблон первой страницы модуля "Впорос-Ответ"
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function first_page($result)
	{
		if(empty($result["categories"]))
			return;
		foreach($result["categories"] as $cat_id => $cat)
		{
			//название и описание категории
			echo '
			<div class="faq-list">
				<h2>'.$cat["name"].'</h2>'
				
				.(! empty($cat["anons"]) ? '
				<div class="faq-cat-text">'.$cat["anons"].'</div>' : '');
			
			//ссылки на подкатегории
			if(! empty($cat["children"]))
			{
				foreach($cat["children"] as $child)
				{
					echo '
					<div class="faq-cat-links"><a href="'.BASE_PATH_HREF.$child["link"].'">'.$child["name"].'</a></div>
					'.(! empty($child["anons"]) ? '<div class="faq-cat-text">'.$child["anons"].'</div>' : '');
				}
			}
			
			//вопросы в категории
			if($cat["rows"])
			{
				foreach($cat["rows"] as $row)
				{
					echo '
					<div class="faq">'
						.(! empty($row['date']) ? '
						<div class="faq-date">'.$row["date"]."</div>" : '')
						
						//Вопрос
						.'<div class="faq-question"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["anons"]."</a></div>\n"
	
						//Ответ
						.'<div class="faq-answer">'.$row["text"]."</div>\n"
						
						.(! empty($row["show-rating"]) ? $row["show-rating"] : '').'
						'.(! empty($row["tags"]) ? $row["tags"] : '').'
					</div>';
				}
			}
			//ссылка на все вопросы в категории
			echo ($cat["allfaq"]?'
			      <div class="show-all"><a href="'.BASE_PATH_HREF.$cat["allfaq"]["link"].'">'.$cat["allfaq"]["text"].'</a></div>' : '')
			.'
			</div>';
		}

		return TRUE;
	}

	/**
	 * Шаблон страницы вопроса
	 * 
	 * @param array $row данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function id($row)
	{
		echo '<div class="faq-id">'
			.(! empty($row["show-rating"]) ? $row["show-rating"] : '')
		
			//Дата вопроса. Формат задается в Конфигурации модуля
			.($row['date'] ? '
			<div class="faq-date">'.$row['date']."</div>" : '')

			//Вопрос
			.'
			<div class="faq-question">'.$row["anons"]."</div>"

			//Ответ
			.'
			<div class="faq-answer">'.$row["text"]."</div>"

			//Теги
			.(! empty($row["tags"]) ? $row["tags"] : '')

			.(! empty($row["add-rating"]) ? $row["add-rating"] :'')

			.(! empty($row["previous"]) ? '
		        <div class="previous-link"><a href="'.BASE_PATH_HREF.$row["previous"]["link"].'">&larr; '.$row["previous"]["text"].'</a></div>' : '')

			.(! empty($row["next"]) ? '
		        <div class="next-link"><a href="'.BASE_PATH_HREF.$row["next"]["link"].'">'.$row["next"]["text"].' &rarr;</a></div>' : '')

			//Вернуться к списку. Ссылка
			.(! empty($row["allfaq"]) ? '
		        <div class="show-all"><a href="'.BASE_PATH_HREF.$row["allfaq"]["link"].'">'.$row["allfaq"]["text"].'</a></div>' : '')

		."</div>\n"

		//Комментарии
		.(! empty($row["comments"]) ? $row["comments"] : '');

		return TRUE;		
	}

	/**
	 * Шаблонная функция: блок вопросов и ответов
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean
	 */
	public function show_block($result)
	{
		if(empty($result["rows"]))
		{
			return FALSE;
		}
		echo '
		<div class="faq-block">'
		.(! empty($result["name"]) ? '<h2>'.$result["name"].'</h2>' : '');
		foreach($result["rows"] as $row)
		{
			echo '
			<div class="faq">'
				.(! empty($row['date']) ? '
				<div class="faq-date">'.$row["date"]."</div>" : '')

				//Вопрос
				.'<div class="faq-question"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["anons"]."</a></div>\n"
	
				//Ответ
				.'<div class="faq-answer">'.$row["text"]."</div>\n"
				.'
			</div>';
		}

		//ссылка на все вопросы
		echo (! empty($result["allfaq"]) ? '
		      <div class="show-all"><a href="'.BASE_PATH_HREF.$result["allfaq"]["link"].'">'.$result["allfaq"]["text"].'</a></div>' : '').'
		</div>';

		return TRUE;
	}
}