<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Feedback_admin_config
 *
 * Конфигурирование модуля "Обратная связь"
 */
class Feedback_admin_config extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'feedback_config';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		$this->variable_table = array(
			'security'              => 'select',
			'add-message'           => 'textarea',
			'error-add-message'     => 'textarea',
			'error-empty-fields'    => 'text',
			'files'                 => 'checkbox',
			'max-count-files'       => 'numtext',
			'attachment-extensions' => 'text',
			'subject'               => 'text',
			'message'               => 'textarea',
			'emailconf'             => 'select',
			'email'                 => 'none',
			'sendmailadmin'         => 'checkbox',
			'emailconfadmin'        => 'function',
			'email-admin'           => 'none',
			'subject-admin'         => 'text',
			'message-admin'         => 'textarea'
		);
		
		$this->language_names = array(
			'subject',
			'message',
			'add-message',
			'error-add-message',
			'error-insert-message',
			'error-empty-fields'
		);

		$this->config_module = array(
			'element_site' => 1 //делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
		);

		$this->select_arr["security"] = array(
			0 => _ADMIN_FORMAT_SECURITY_0,
			1 => _ADMIN_FORMAT_SECURITY_1,
			2 => _ADMIN_FORMAT_SECURITY_2
		);

		$this->show_tr_click_checkbox = array(
			"sendmailadmin" => array(
				'emailconfadmin',
				'subject-admin',
				'message-admin'
			),
			'files' => array(
				'max-count-files',
				'attachment-extensions'
			)
		);
	}
}