<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Feedback_admin_param
 *
 * Конструктор обратной связи
 */
class Feedback_admin_param extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'feedbackparam';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'param'; 

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'     => 'text',
			'type'     => 'select',
			'site_id'  => 'select',
			'required' => 'checkbox',
			'param'    => 'function',
			'sort'     => 'function'
		);

		//поля, которые прячутся в Дополнительно
		$this->variable_other = array(
			'sort' => 1
		);

		//переводимые поля
		$this->language_names = array(
			'name'
		);

		$this->config_module = array(
			'del'          => 1,	//удалить
			'order'        => 1,	//сортируется
			'element_site' => 1,	//делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
			'trash'        => 1 	//использовать корзину
		);

		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'type'
		);

		$this->select_arr["type"] = array(
			"text"     => _ADMIN_PARAM_TEXT_FIELD,
			"numtext"  => _ADMIN_PARAM_NUMTEXT_FIELD,
			"date"     => _ADMIN_PARAM_DATE_FIELD,
			"textarea" => _ADMIN_PARAM_TEXTAREA_FIELD,
			"checkbox" => _ADMIN_PARAM_CHECKBOX_FIELD,
			"select"   => _ADMIN_PARAM_SELECT_FIELD,
			"multiple" => _ADMIN_PARAM_MULTIPLE_FIELD,
			"email"    => _ADMIN_PARAM_EMAIL_FIELD
		);

		$this->where = " AND module_name='feedback'"
		               .($this->diafan->site ? ' AND site_id='.($this->diafan->site == 999999 ? 0 : $this->diafan->site) : '');
	}

	/**
	 * Выводит список полей формы
	 * @return boolean true
	 */
	public function show_module()
	{
		if($this->diafan->configmodules("cat", "feedback"))
		{
			$this->select_category('cat');
		}

		$this->addnew_init(_ADMIN_FEEDBACK_ADD_PARAM);

		echo '<table class="list">';
		$this->list_row();
		echo '</table>';

		return TRUE;
	}

	/**
	 * Вывод типа поля в списке полей
	 * @return string
	 */
	protected function other_row_type($row)
	{
		return '</td><td>'.$this->select_arr["type"][$row["type"]];
	}

	/**
	 * Редактирование поля "Страницаы"
	 * 
	 * @return boolean
	 */
	protected function edit_site_id_module()
	{
		if(! $this->value)
		{
			$this->value = $this->diafan->site;
		}

		echo '
		<tr'.$this->get_other().' valign="top">
			<td class="first-td">'.$this->variable_names().'</td>
			<td>
				<select name="'.$this->key.'"><option value="">'._LANG_ALL.'</option>';
		$result = DB::query("SELECT id, name FROM {site} WHERE trash='0' AND addmodule='%s' ORDER BY id ASC", $this->diafan->module);
		while ($row = DB::fetch_array($result))
		{
			$cats[0][] = $row;
		}
		echo $this->get_options($cats, $cats[0], array($this->value)).'
				</select>
				'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Параметры"
	 * @return boolean true
	 */
	protected function edit_param_module()
	{
		$value = array();
		if(! $this->diafan->addnew && in_array($this->values["type"], array('select', 'multiple', 'checkbox')))
		{
			$result_select = DB::query("SELECT [name], value FROM {param_select} WHERE param_id=%d ORDER BY value ASC", $this->diafan->edit);
			while ($row_select = DB::fetch_array($result_select))
			{
				$value[$row_select["value"]] = $row_select["name"];
			}
		}


		echo '
		<script language="javascript" type="text/javascript">
			$(document).ready(function(){
				show_param($("#type select"));
				$("#type select").change(function(){
					show_param($(this));
				});
			});
			function show_param(obj)
			{
				if(obj.val() == "select" || obj.val() == "multiple")
				{
					$("#param").show();
				}
				else
				{
					$("#param").hide();
				}
				if(obj.val() == "checkbox")
				{
					$("#param_check").show();
				}
				else
				{
					$("#param_check").hide();
				}
			}
		</script>
		<tr id="param">
			<td colspan="2"><b>'.$this->variable_names().'</b><br>
			<table>';

		$fileds = false;
		foreach($value as $k => $v)
		{
			echo '
			<tr class="rowparam">
				<td>
					<input type="text" name="paramv[]" size="40" value="'.str_replace('"', '&quot;', $v).'">
				</td>
			</tr>';
			$fileds = true;
		}
		if(! $fileds)
		{
			echo '
			<tr class="rowparam">
				<td>
					<input type="text" name="paramv[]" size="40" value="">
				</td>
			</tr>';
		}
		echo '</table>
				<a href="javascript:void(0)" class="plus" title="'._LANG_ADD.'">+</a>
			</td>
		</tr>
		<tr id="param_check">
			<td colspan="2">
				<b>'.$this->variable_names().'</b><br>
				<table>';
		echo '<tr>
			<td>
				'._LANG_YES.' <input type="text" name="paramk_check1" size="20" value="'
				.(! empty($value[1]) ? str_replace('"', '&quot;', $value[1]) : '')
				.'">
			</td>
			<td>
				'._LANG_NO.' <input type="text" name="paramv_check0" size="20" value="'
				.(! empty($value[0]) ? str_replace('"', '&quot;', $value[0]) : '').'"></td></tr>';
				echo '</table>
		</td></tr>';

		return TRUE;
	}

	/**
	 * Сохранение поля "Параметры"
	 * @return boolean true
	 */
	protected function save_param_module()
	{
		if(($_POST["type"] == "select" || $_POST["type"] == "multiple") && ! empty($_POST["paramv"]))
		{
			foreach($_POST["paramv"] as $key => $value)
			{
				if(! $value)
				{
					break;
				}
				$result = DB::query("SELECT id FROM {param_select} WHERE param_id=%d AND value=%d", $this->diafan->save, $key + 1);
				if($row = DB::fetch_array($result))
				{
					DB::query("UPDATE {param_select} SET [name]='%h' WHERE id=%d", $value, $row["id"]);
				}
				else
				{
					DB::query("INSERT INTO {param_select} (param_id, value, [name]) VALUES (%d, %d, '%h')", $this->diafan->save, $key + 1, $value);
				}
				$max = $key + 1;
			}
			DB::query("DELETE FROM {param_select} WHERE param_id=%d AND (value>%d OR value=0)", $this->diafan->save, $max);
		}
		elseif($_POST["type"] = "checkbox")
		{
			if($this->oldrow["type"] == "checkbox")
			{
				$result = DB::query("SELECT id, value FROM {param_value} WHERE param_id=%d", $this->diafan->save);
				while ($row = DB::fetch_array($result))
				{
					if($row["value"] == 1)
					{
						DB::query("UPDATE {param_select} SET [name]='%h' WHERE id=%d", $_POST["paramk_check1"], $row["id"]);
						$check1 = TRUE;
					}
					elseif($row["value"] == 0)
					{
						DB::query("UPDATE {param_select} SET [name]='%h' WHERE id=%d", $_POST["paramk_check0"], $row["id"]);
						$check0 = TRUE;
					}
				}
				DB::query("DELETE FROM {param_select} WHERE param_id=%d AND value NOT IN (0,1)", $this->diafan->save);
			}
			else
			{
				DB::query("DELETE FROM {param_select} WHERE param_id=%d", $this->diafan->save);
			}
			if(empty($check0))
			{
				DB::query("INSERT INTO {param_select} (param_id, value, [name]) VALUES (%d, 0, '%h')", $this->diafan->save, $_POST["paramk_check0"]);
			}
			elseif(empty($check1))
			{
				DB::query("INSERT INTO {param_select} (param_id, value, [name]) VALUES (%d, 1, '%h')", $this->diafan->save, $_POST["paramk_check1"]);
			}
		}
		else
		{
			DB::query("DELETE FROM {param_select} WHERE param_id=%d", $this->diafan->save);
		}
		return TRUE;
	}
}