<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Feedback_admin
 *
 * Редактирование сообщений из формы обратной связи
 */
class Feedback_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'feedback';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'feedback';

	/**
	 * @var string номера дополнительных полей, выводимых в списке; если пустой, генерируется автоматически
	 */
	private $other_rows_param = array();

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'created'  => 'date',
			'site_id'  => 'select',
			'language' => 'select',
			'files'    => 'function',
			'hr1'      => 'hr',
			'param'    => 'function',
			'hr2'      => 'hr',
			'text'     => 'editor'
		);

		$this->config_module = array(
			'del'          => 1,	//удалить
			'date'         => 1,	//показывать дату в списке, сортировать по дате 
			'element_site' => 1,	//делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
			'trash'        => 1 	//использовать корзину
		);
		
		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'id'
		);

		foreach($this->diafan->language_all as $key => $language)
		{
			$this->select_arr["language"][$language[0]] = $language[2];
		}
	}

	/**
	 * Выводит список обращений в обратную связь
	 * @return boolean true
	 */
	public function show_module()
	{
		if(! $this->other_rows_param)
		{
			$result = DB::query_range("SELECT id from {param} WHERE site_id IN (0, %d) AND trash='0'"
			                          ." AND module_name='feedback' AND (type='textarea' OR type='text')",
			                          $this->diafan->site, 0, 3);

			while($row = DB::fetch_array($result))
			{
				$this->other_rows_param[] = $row["id"];
			}
		}
		echo '<p><a href="'.BASE_PATH_HREF.'feedback/param/'.($this->diafan->site ? 'site'.$this->diafan->site.'/' : '').'">'._ADMIN_FEEDBACK_PARAM.'</a></p>';
		echo '<table class="list">';
		$this->name = "'"._LANG_EDIT."'";
		$this->list_row();
		echo '</table>';

		return TRUE;
	}

	/**
	 * Выводит дополнительные поля в списке
	 * 
	 * @return string
	 */
	protected function other_row_id($row)
	{
		$text = '';
		foreach($this->other_rows_param as $id)
		{
			$text .= '</td><td class="Comments"><div><span></span><table><tbody><tr><td>'
			         .DB::query_result("SELECT [value] FROM {param_element} WHERE module_name='feedback'"
			                           ." AND element_id=%d AND param_id=%d", $row["id"], $id)
			         .'</td></tr></tbody></table></div>';
		}
		return $text;
	}

	/**
	 * Редактирование поля "Прикрепленные файлы"
	 * @return boolean true
	 */
	protected function edit_files_module()
	{
		if(! $this->diafan->configmodules("files", "feedback", "", $this->values["site_id"]))
		{
			return FALSE;
		}
		$result = DB::query("SELECT id, name FROM {attachment} WHERE module_name='".$this->table."' AND element_id='%d'", $this->diafan->edit);
		while ($row = DB::fetch_array($result))
		{
			echo
			(empty($yes) ? '
			<tr>
				<td align="right">
					'.$this->variable_names().'
				</td>
				<td>' : ''
			)
			.'<input type="checkbox" name="filedel[]" value="'.$row["id"].'" />'
			.'<a href="http://'.BASE_URL.'/file/'.$row["id"]."/".$row["name"].'">'.$row["name"].'</a><br>';
			$yes = 1;
		}
		echo
		(! empty($yes) ? $this->show_help_row().'
				</td>
			</tr>' : ''
		);

		return TRUE;
	}

	/**
	 * Редактирование поля "Дополнительные параметры"
	 * 
	 * @return boolean true
	 */
	protected function edit_param_module()
	{
		$values = array();
		$rvalues = array();
		$result_el = DB::query("SELECT value as rv, [value], param_id FROM {param_element} WHERE element_id=%d AND module_name='feedback'",
		                       $this->diafan->edit);
		while ($row_el = DB::fetch_array($result_el))
		{
			$values[$row_el["param_id"]][]  = $row_el["value"];
			$rvalues[$row_el["param_id"]][] = $row_el["rv"];
		}

		echo '
		<tr>
			<td></td>
			<td>
				<a href="'.BASE_PATH_HREF.$this->diafan->rewrite.'/param/addnew1/'.($this->diafan->site ? 'site'.$this->diafan->site.'/' : '').'" target="_blank">'. _ADMIN_FEEDBACK_ADD_PARAM.'</a>
				'.$this->show_help_row().'
			</td>
		</tr>';

		$result = DB::query("SELECT p.id, p.name, p.type FROM {param} as p "
		                    ." WHERE p.trash='0' AND p.module_name='feedback' AND p.site_id IN (0,%d)"
		                    ." ORDER BY p.sort ASC", $this->values["site_id"]
		                   );

		while($row = DB::fetch_array($result))
		{
			$option = array();
			if(! $this->diafan->addnew && in_array($row["type"], array('select', 'multiple')))
			{
				$result_select = DB::query("SELECT [name], value FROM {param_select} WHERE param_id=%d ORDER BY value ASC", $row["id"]);
				while ($row_select = DB::fetch_array($result_select))
				{
					$option[$row_select["value"]] = $row_select["name"];
				}
			}
			if($row["type"] == 'text')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="40" value="'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'">
					</td>
				</tr>';
			}
			elseif($row["type"] == 'email')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="40" value="'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'">
						<br>
						<input type="checkbox" value="1" name="param'.$row["id"].'send"> '._ADMIN_SEND_ANSWER.'
					</td>
				</tr>';
			}
			elseif($row["type"] == 'date')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="40" value="'
						.(! empty($values[$row["id"]]) ? date("d.m.Y", $values[$row["id"]][0]) : '')
						.'">
					</td>
				</tr>';
			}
			elseif($row["type"] == 'numtext')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="20" value="'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'" class="inpnum">
					</td>
				</tr>';
			}
			elseif($row["type"] == 'textarea')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<textarea name="param'.$row["id"].'" cols="60" rows="5">'
						.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '')
						.'</textarea>
					</td>
				</tr>';
			}
			elseif($row["type"] == 'checkbox')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="checkbox" name="param'.$row["id"].'" value="1"'
						.(! $this->diafan->addnew && ! empty($values[$row["id"]]) ? " checked":'').'>
					</td>
				</tr>';
			}
			elseif($row["type"] == 'select')
			{
				$value = (! empty($rvalues[$row["id"]][0]) ? $rvalues[$row["id"]][0] : '');
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<select name="param'.$row["id"].'">
						<option value="">-</option>';
						foreach($option as $k => $v)
						{
							echo '<option value="'.$k.'"'.($value == $k ? ' selected' : '').'>'.$v.'</option>';
						}
						echo '</select>
					</td>
				</tr>';
			}
			elseif($row["type"] == 'multiple')
			{
				$value = (! empty($rvalues[$row["id"]]) ? $rvalues[$row["id"]] : array());
				echo '
				<tr>
					<td align="right">
						'.$row["name"].'
					</td>
					<td>
						<select name="param'.$row["id"].'[]" multiple="multiple">';
						foreach($option as $k => $v)
						{
							echo '<option value="'.$k.'"'.(in_array($k, $value) ? ' selected' : '').'>'.$v.'</option>';
						}
						echo '</select>
					</td>
				</tr>';
			}
		}
		return TRUE;
	}

	/**
	 * Отправляет письмо пользователю
	 * @return boolean true
	 */
	protected function save_sendmail($email)
	{
		if(! empty($_POST["text"]) && $email)
		{
			$message = $this->get_message();
			$subject = str_replace(
				array('%title', '%url'),
				array(TITLE, BASE_URL),
				$this->diafan->configmodules('subject', 'feedback', _LANG, $_POST["site_id"])
			);

			$message = str_replace(
				array(
					'%title',
					'%url',
					'%message',
					'%answer'
				),
				array(
					TITLE,
					BASE_URL,
					$message,
					$_POST["text"]
				),
				$this->diafan->configmodules('message', 'feedback', _LANG, $_POST["site_id"])
			);

			include_once(ABSOLUTE_PATH.'includes/mail.php');
			send_mail(
				$email,
				$subject,
				$message,
				($this->diafan->configmodules("emailconf", 'feedback', _LANG, $_POST["site_id"]) && $this->diafan->configmodules("email", 'feedback', _LANG, $_POST["site_id"])
				? $this->diafan->configmodules("email", 'feedback', _LANG, $_POST["site_id"])
				: '')
			);
			$this->diafan->err = 5;
		}

		return TRUE;
	}

	/**
	 * Формирует текст письма пользователю
	 * @return string
	 */
	private function get_message()
	{
		if(! $rows_param = $this->diafan->_cache->get("form_param_".$this->oldrow["site_id"], "feedback/param"))
		{
			$rows_param = array();
			$result = DB::query("SELECT id, name, type from {param} WHERE site_id IN (0, %d)"
			                    ." AND trash='0' AND module_name='feedback' ORDER BY sort ASC", $_POST["site_id"]);

			while($row = DB::fetch_array($result))
			{
				if($row["type"] == 'select' || $row["type"] == 'multiple')
				{
					$result_select = DB::query("SELECT [name], value FROM {param_select} WHERE param_id=%d ORDER BY value ASC", $row["id"]);
					while ($row_select = DB::fetch_array($result_select))
					{
						$row["select_array"][$row_select["value"]] = $row_select["name"];
					}
				}
				$rows_param[] = $row;
			}
		}
		$message = array();

		foreach($rows_param as $row)
		{
			if(empty($_POST["param".$row["id"]]) && $row["type"] != "checkbox")
				continue;
			
			if($row["type"] == "text" || $row["type"] == "textarea" || $row["type"] == "email")
			{
				$message[] = $row["name"].': '.htmlspecialchars(htmlspecialchars($_POST["param".$row["id"]]));
			}
			elseif($row["type"] == "numtext")
			{
				$message[] = $row["name"].': '.$this->diafan->get_param($_POST, "param".$row["id"], '', 2);
			}
			elseif($row["type"] == "date")
			{
				if($_POST["param".$row["id"]])
				{
					$message[] = $row["name"].': '.$_POST["param".$row["id"]];
				}
			}
			elseif($row["type"] == "checkbox")
			{
				$value = ! empty($_POST["param".$row["id"]]) ? 1 : 0;
				$value_sel = DB::query_result("SELECT [name] FROM {param_select} WHERE value=%d AND param_id=%d", $value, $row["id"]);
				if(! $value_sel && $value == 1)
				{
					$message[] = $row["name"];
				}
				elseif($value_sel)
				{
					$message[] = $row["name"].': '.$value_sel;
				}
			}
			elseif($row["type"] == "select")
			{
				if(! empty($rows["select_array"][$_POST["param".$row["id"]]]))
				{
					$_POST["param".$row["id"]] = $this->diafan->get_param($_POST, "param".$row["id"], '', 1);
					$message[] = $row["name"].': '.$rows["select_array"][$_POST["param".$row["id"]]];
				}
			}
		}
		return implode('<br>', $message);
	}

	/**
	 * Сохранение поля "Файлы"
	 * @return boolean true
	 */
	protected function save_files_module()
	{
		if(! $this->diafan->configmodules("files", "feedback", "", $this->oldrow["site_id"]))
		{
			return FALSE;
		}
		$result = DB::query("SELECT id FROM {attachment} WHERE module_name='%s' AND element_id='%d'", $this->table, $this->diafan->save);
		while ($row = DB::fetch_array($result))
		{
			if(! empty($_POST["filedel"]) && in_array($row["id"], $_POST["filedel"]))
			{
				DB::query("delete from {attachment} where id='%d'", $row["id"]);
				unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/files/'.$row["id"]);
			}
		}

		return TRUE;
	}

	/**
	 * Сохранение поля "Дополнительные параметры"
	 * 
	 * @return boolean true
	 */
	protected function save_param_module()
	{
		$ids = array();
		$result = DB::query("SELECT p.id, p.name, p.type FROM {param} as p "
		                    ." WHERE p.trash='0' AND p.module_name='feedback' AND p.site_id IN (0,%d)"
		                    ." ORDER BY p.sort ASC", $this->oldrow["site_id"]
		                   );

		while($row = DB::fetch_array($result))
		{
			if($row["type"] == "multiple")
			{
				DB::query("DELETE FROM {param_element} WHERE param_id=%d AND element_id=%d AND module_name='feedback'", $row["id"], $this->diafan->save);
				if(! empty($_POST['param'.$row["id"]]) && is_array($_POST['param'.$row["id"]]))
				{
					foreach($_POST['param'.$row["id"]] as $v)
					{
						DB::query(
							"INSERT INTO {param_element} (value, param_id, element_id, module_name) VALUES ('%s', %d, %d, 'feedback')",
							$v,
							$row["id"],
							$this->diafan->save
						);
					}
				}
				
			}
			elseif(! empty($_POST['param'.$row["id"]]))
			{
				$id = 0;
				if(! $this->diafan->savenew)
				{
					$id = DB::query_result("SELECT id FROM {param_element} WHERE param_id=%d AND element_id=%d AND module_name='feedback'",
					                       $row["id"], $this->diafan->save);
				}
				if($row["type"] == "date")
				{
					$_POST['param'.$row["id"]] = $this->diafan->unixdate($_POST['param'.$row["id"]]);
				}
				if($id)
				{
					DB::query(
						"UPDATE {param_element} SET ".(in_array($row["type"], array("text", "editor", "textarea")) ? '[value]' : 'value')
						."='%s' WHERE id=%d",
						$_POST['param'.$row["id"]],
						$id
					);
				}
				else
				{
					DB::query(
						"INSERT INTO {param_element} (".(in_array($row["type"], array("text", "editor", "textarea")) ? '[value]' : 'value')
						.", param_id, element_id, module_name) VALUES ('%s', %d, %d, 'feedback')",
						$_POST['param'.$row["id"]],
						$row["id"],
						$this->diafan->save
					);
				}

				if($row["type"] == "email" && ! empty($_POST['param'.$row["id"].'send']))
				{
					$this->save_sendmail($_POST['param'.$row["id"]]);
				}
		  
			}
			$ids[] = $row["id"];
		}
		DB::query("DELETE FROM {param_element} WHERE param_id NOT IN (".implode(", ", $ids).") AND element_id=%d AND module_name='feedback'",
		          $this->diafan->save);
		return TRUE;
	}
}