<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Feedback
 *
 * Контроллер модуля "Обратная связь"
 */
class Feedback extends Frame
{
	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct(&$diafan)
	{
		$this->diafan = &$diafan;
		
		include_once(ABSOLUTE_PATH.'modules/feedback/feedback.ajax.php');
		$ajax = new Feedback_ajax($diafan);
		if($ajax->ajax_request())
		{
			exit;
		}
		
		$model = new Feedback_model($diafan);
		
		$this->result = $model->form();
		
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	public function show_module()
	{
		if(! empty($this->result["text"]))
		{
			echo $this->result["text"];
			return;
		}
		Feedback_view::form($this->result);
		return TRUE;
	}

	/**
	 * Шаблонная функция: форма добавления сообщения
	 *
	 * @param object $th основной объект
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return boolean
	 */
	public function show_form($th, $attributes)
	{
		$attributes = $this->get_attributes($attributes, 'site_id', 'template');

		$site_id = intval($attributes["site_id"]);

		include_once(ABSOLUTE_PATH.'modules/feedback/feedback.model.php');
		$model = new Feedback_model($th->diafan);
		$result = $model->form($site_id, TRUE);
		if($result)
		{
			include_once(ABSOLUTE_PATH.'modules/feedback/feedback.view.php');
			$func = 'form';
			if($attributes["template"])
			{
				$func .= '_'.preg_replace('/[^a-z_]+/','', $attributes["template"]);
				
			}
			Feedback_view::$func($result);
		}
		return TRUE;
	}
}