<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Feedback_view
 *
 * Шаблон модуля "Обратная связь"
 */
class Feedback_view
{
	/**
	 * Шаблон формы добавления сообщения
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function form($result)
	{
		echo '
		<form method="POST" enctype="multipart/form-data" action="'.BASE_PATH_HREF.$result["action"].'" class="ajax feedback-form">
		<input type="hidden" name="ajax_feedback" value="1">
		<input type="hidden" name="ajax" value="0">';

		if(! empty($result["rows"]))
		{
			foreach($result["rows"] as $row)
			{
				echo '
				<div class="param'.$row["id"].'">';
				if ($row["type"] == 'text' || $row["type"] == "email")
				{
					echo '
					<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>
					<input type="text" name="p'.$row["id"].'" size="40" value="" class="inptext">';
				}
				elseif ($row["type"] == 'textarea')
				{
					echo '
					<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>
					<textarea name="p'.$row["id"].'" class="inptext" rows="10" cols="30"></textarea>';
				}
				elseif ($row["type"] == 'date')
				{
					echo '
					<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>
						<input type="text" name="p'.$row["id"].'d" size="1" value="dd"
						onClick="this.value=\'\'" class="inpnum">
						
						<input type="text" name="p'.$row["id"].'m" size="1" value="mm"
						onClick="this.value=\'\'" class="inpnum">
						
						<input type="text" name="p'.$row["id"].'y" size="2" value="yyyy"
						onClick="this.value=\'\'" class="inpnum">'
						;
				}
				elseif($row["type"] == 'numtext')
				{
					echo '
					<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>
					<input type="text" name="p'.$row["id"].'" size="5" value="" class="inpnum">';
				}
				elseif($row["type"] == 'checkbox')
				{
					echo '
					<div class="infofield"><input type="checkbox" name="p'.$row["id"].'" value="1" class="inpcheckbox">
					'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').'</div>
					';
				}
				elseif($row["type"] == 'select')
				{
					echo '
					<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>
					<select name="p'.$row["id"].'" class="inpselect">
						<option value="">-</option>';
					foreach ($row["select_array"] as $key => $value)
					{
						echo '
						<option value="'.$key.'">'.$value.'</option>';
					}
					echo '
					</select>';
				}
				elseif ($row["type"] == 'multiple')
				{
					echo '
					<div class="infofield">'.$row["name"].($row["required"] ? '<font color="red">*</font>' : '').':</div>
					<select name="p'.$row["id"].'[]" multiple="multiple" class="inpselect">';
					foreach ($row["select_array"] as $key => $value)
					{
						echo '
						<option value="'.$key.'"'.(in_array($key, $row["value"]) ? " selected" : '').'>'.$value.'</option>';
					}
					echo '
					</select>';
				}
				echo '
				</div>
				<div class="errors error-p'.$row["id"].'"'.($result["error-p".$row["id"]] ? '>'.$result["error-p".$row["id"]] : ' style="display:none">').'</div>';
			}
		}

		//Прикрепляемые файлы
		if($result["files"])
		{
			echo '
			<div class="infofield">'._LANG_ATTACHMENT.':</div>
			<input type="file" name="attachment[]" class="inptext" max="'.$result["files"].'">
			<div class="errors error-attachments"'.($result["error-attachments"] ? '>'.$result["error-attachments"] : ' style="display:none">').'</div>';
		}

		//Защитный код
		echo $result["captcha"]

		//Кнопка Отправить
		.'<input type="submit" value="'._LANG_SEND.'" class="button" name="button">
		<div class="errors error"'.($result["error"] ? '>'.$result["error"] : ' style="display:none">').'</div>

		</form>';

		return TRUE;
	}
}