<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Files_view
 *
 * Шаблон модуля "Файловый архив"
 */
class Files_view
{
	/**
	 * Шаблон списка файлов
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function list_($result)
	{
		//название и описание категории
		echo '
		<div class="files-list">';

		echo (! empty($result["text"]) ? '
			<div class="files-cat-text">'.$result["text"].'</div>' : '');

		if(! empty($result["img"]))
		{
			echo '<div class="files-cat-img">';
			if(! empty($result["img"]["link"]))
			{
				echo '<a href="'.BASE_PATH_HREF.$result["img"]["link"].'">'.$result["img"]["tag"].'</a>';
			}
			elseif(! empty($result["img"]))
			{
				foreach($result["img"] as $img)
				{
					echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
				}
			}
			echo '</div>';
		}

		//ссылки на подкатегории
		if(! empty($result["children"]))
		{
			foreach($result["children"] as $child)
			{
				echo '
				<div class="files-cat-links"><a href="'.BASE_PATH_HREF.$child["link"].'">'.$child["name"].'</a></div>
				'.($child["anons"] ? '<div class="files-cat-text">'.$child["anons"].'</div>' : '');
				if(! empty($child["img"]))
				{
					echo '<div class="files-cat-img">';
					if(! empty($child["img"]["link"]))
					{
						echo '<a href="'.BASE_PATH_HREF.$child["img"]["link"].'">'.$child["img"]["tag"].'</a>';
					}
					elseif(! empty($child["img"]))
					{
						foreach($child["img"] as $img)
						{
							echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
						}
					}
					echo '</div>';
				}
			}
		}

		//фотографии
		if(! empty($result["rows"]))
		{
			foreach($result["rows"] as $row)
			{
				echo '
				<div class="files">';
					if(! empty($row["img"]))
					{
						echo '
						<div class="files-img">';
						if(! empty($row["img"]["link"]))
						{
							echo '<a href="'.BASE_PATH_HREF.$row["img"]["link"].'">'.$row["img"]["tag"].'</a>';
						}
						elseif(! empty($row["img"]))
						{
							foreach($row["img"] as $img)
							{
								echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
							}
						}
						echo '</div>';
					}
					echo '
					<div class="files-name"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a></div>
					'.(! empty($row["anons"]) ? '<div class="files-text">'.$row["anons"].'</div>' : '').'
					'.(! empty($row["show-rating"]) ? $row["show-rating"] : '').'
					'.(! empty($row["tags"]) ? $row["tags"] : '').'
				</div>';
			}
			echo '<div class="clear"></div>';
		}

		echo Paginator_view::get($result["paginator"])

		.(! empty($result["previous"]) ? '
		<div class="previous-link"><a href="'.BASE_PATH_HREF.$result["previous"]["link"].'">&larr; '.$result["previous"]["text"].'</a></div>' : '')

		.(! empty($result["next"]) ? '
		<div class="next-link"><a href="'.BASE_PATH_HREF.$result["next"]["link"].'">'.$result["next"]["text"].' &rarr;</a></div>' : '')

		.'<div class="clear"></div>'

		.(! empty($result["comments"]) ? $result["comments"] : '')
		.'
		</div>';

		return TRUE;
	}

	/**
	 * Шаблон первой страницы фотогалереи
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean
	 */
	public function first_page($result)
	{
		if(empty($result["categories"]))
			return FALSE;

		foreach($result["categories"] as $cat_id => $cat)
		{
			//название и описание категории
			echo '
			<div class="files-list">
				<h2>'.$cat["name"].'</h2>'
				
				.(! empty($cat["anons"]) ? '
				<div class="files-cat-text">'.$cat["anons"].'</div>' : '');

				if(! empty($cat["img"]))
				{
					echo '<div class="files-cat-img">';
					if(! empty($cat["img"]["link"]))
					{
						echo '<a href="'.BASE_PATH_HREF.$cat["img"]["link"].'">'.$cat["img"]["tag"].'</a>';
					}
					elseif(! empty($cat["img"]))
					{
						foreach($cat["img"] as $img)
						{
							echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
						}
					}
					echo '</div>';
				}

			//ссылки на подкатегории
			if(! empty($cat["children"]))
			{
				foreach($cat["children"] as $child)
				{
					echo '
					<div class="files-cat-links"><a href="'.BASE_PATH_HREF.$child["link"].'">'.$child["name"].'</a></div>
					'.(! empty($child["anons"]) ? '<div class="files-cat-text">'.$child["anons"].'</div>' : '');
					if(! empty($child["img"]))
					{
						echo '<div class="files-cat-img">';
						if(! empty($child["img"]["link"]))
						{
							echo '<a href="'.BASE_PATH_HREF.$child["img"]["link"].'">'.$child["img"]["tag"].'</a>';
						}
						elseif(! empty($child["img"]))
						{
							foreach($child["img"] as $img)
							{
								echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
							}
						}
						echo '</div>';
					}
				}
			}
			
			//файлы в категории
			if($cat["rows"])
			{
				foreach($cat["rows"] as $row)
				{
					echo '
					<div class="files">';
						if(! empty($row["img"]))
						{
							echo '
							<div class="files-img">';
							if(! empty($row["img"]["link"]))
							{
								echo '<a href="'.BASE_PATH_HREF.$row["img"]["link"].'">'.$row["img"]["tag"].'</a>';
							}
							elseif(! empty($row["img"]))
							{
								foreach($row["img"] as $img)
								{
									echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
								}
							}
							echo '</div>';
						}
						echo '
						<div class="files-name"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a></div>
						'.(! empty($row["anons"]) ? '<div class="files-text">'.$row["anons"].'</div>' : '').'
						'.(! empty($row["show-rating"]) ? $row["show-rating"] : '').'
						'.(! empty($row["tags"]) ? $row["tags"] : '').'
					</div>';
				}
			}
			//ссылка на все файлы в категории
			echo ($cat["allfiles"] ? '
			      <div class="show-all"><a href="'.BASE_PATH_HREF.$cat["allfiles"]["link"].'">'.$cat["allfiles"]["text"].'</a></div>' : '')
			.'
			</div>';
		}

		return TRUE;
	}

	/**
	 * Шаблон страницы с файлом
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function id($row)
	{	
		echo '<div class="files-id">'
			//рейтинг фотографии
			.(! empty($row["show-rating"]) ? $row["show-rating"] : '')

			//размер файла
			.(! empty($row["size"]) ? '
			<div class="files-size">('.$row["size"].')</div>' : '')

			.(! empty($row["link"]) ? '<div class="files-download"><a href="'.$row["link"].'">'._LANG_DOWNLOAD.'</a></div>' : '')
			
			//форма оценки фотографии
			.(! empty($row["add-rating"]) ? $row["add-rating"] :'')

			//анонс
			.($row["anons"] ? '<div class="files-anons">'.$row["anons"].'</div>' : '')

			//описание
			.'<div class="files-text">'.$row["text"].'</div>'
			
			//теги
			.(! empty($row["tags"]) ? $row["tags"] : '');

			if(! empty($row["img"]))
			{
				echo '
				<div class="files-all-img">';
				if(! empty($row["img"]["link"]))
				{
					echo '<a href="'.BASE_PATH.$row["img"]["link"].'">'.$row["img"]["tag"].'</a>';
				}
				elseif(! empty($row["img"]))
				{
					foreach($row["img"] as $img)
					{
						echo ' <a href="'.BASE_PATH.$img["link"].'">'.$img["tag"].'</a>';
					}
				}
				echo '</div>';
			}

			echo
			(! empty($row["previous"]) ? '
		        <div class="previous-link"><a href="'.BASE_PATH_HREF.$row["previous"]["link"].'">&larr; '.$row["previous"]["text"].'</a></div>' : '')

			.(! empty($row["next"]) ? '
		        <div class="next-link"><a href="'.BASE_PATH_HREF.$row["next"]["link"].'">'.$row["next"]["text"].' &rarr;</a></div>' : '')

			.'<div class="clear"></div>'

		.'</div>'
		.(! empty($row["comments"]) ? $row["comments"] : '');

		return TRUE;
	}

	/**
	 * Шаблонная функция: блок файлов
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean
	 */
	public function show_block($result)
	{
		if(empty($result["rows"]))
		{
			return FALSE;
		}
		echo '<div class="files-block">'
		.(! empty($result["name"]) ? '<h2>'.$result["name"].'</h2>' : '');
		
		//фотографии
		foreach($result["rows"] as $row)
		{
			echo '
			<div class="files">';
			if(! empty($row["img"]))
			{
				echo '
				<div class="files-img">';
				if(! empty($row["img"]["link"]))
				{
					echo '<a href="'.BASE_PATH_HREF.$row["img"]["link"].'">'.$row["img"]["tag"].'</a>';
				}
				elseif(! empty($row["img"]))
				{
					foreach($row["img"] as $img)
					{
						echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
					}
				}
				echo '</div>';
			}
			echo '
				<div class="files-name"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row['name'].'</a></div>
				<div class="files-anons">'.$row['anons'].'</div>
			</div>';
		}

		//ссылка на все файлы
		echo (! empty($result["allfiles"]) ? '
		      <div class="show-all"><a href="'.BASE_PATH_HREF.$result["allfiles"]["link"].'">'.$result["allfiles"]["text"].'</a></div>' : '').'
		</div>';

		return TRUE;
	}
}