<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(dirname(__FILE__)))).'/includes/404.php');
}

/**
 * Attachments_ajax
 *
 * Обработка Ajax-запроса
 */
class Attachments_ajax extends Model
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var array внутренние сообщения
	 */
	private $result;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{		
		$this->diafan = $diafan;
	}

	/**
	 * Обрабатывает полученные данные из формы
	 * 
	 * @return boolean
	 */
	public function ajax_request()
	{
		if(empty($_POST["ajax_attachment"]) || ! $this->diafan->_user->id)
		{
			return FALSE;
		}

		if(! empty($_POST["action"]) && $_POST["action"] == "delete-attachment")
		{
			return $this->delete();
		}
	}

	/**
	 * Удаляет файл
	 * 
	 * @return boolean
	 */
	private function delete()
	{
		if(empty($_POST["del_id"]))
		{
			return FALSE;
		}

		$row = DB::fetch_array(DB::query("SELECT id, name, element_id, module_name FROM {attachment} WHERE id='%d'", $_POST["del_id"]));

		if(! $this->diafan->_user->moderator && $this->diafan->_user->id != DB::query_result("SELECT author FROM {".$row["module_name"]."} WHERE id=%d", $row["element_id"]))
		{
			$this->result["errors"][0] = 'ERROR';
			return $this->send_errors();
		}

		if(stristr($row["name"], '.jpg'))
		{
			unlink(ABSOLUTE_PATH.USERFILES.'/'.$row["module_name"].'/imgs/'.$row["id"].'_'.$row["name"]);
			unlink(ABSOLUTE_PATH.USERFILES.'/'.$row["module_name"].'/imgs/small/'.$row["id"].'_'.$row["name"]);
		}
		else
		{
			unlink(ABSOLUTE_PATH.USERFILES.'/'.$row["module_name"].'/files/'.$row["id"]);
		}

		DB::query("DELETE FROM {attachment} WHERE id='%d'", $row["id"]);

		$this->result["form_hide"] = 1;
		$this->result["target"]    = "#attachment".$row["id"];

		return $this->send_errors();
	}

	/**
	 * Отправляет ответ
	 *
	 * @return boolean
	 */
	private function send_errors()
	{
		if(! empty($this->result["errors"]) || ! empty($this->result["form_hide"]))
		{
			if(! empty($_POST['ajax']))
			{
				include_once(ABSOLUTE_PATH.'plugins/json.php');
				echo to_json($this->result);
			}
			else
			{
				$query = '';
				if(! empty($this->result["errors"]))
				{
					foreach($this->result["errors"] as $field => $mes)
					{
						if(empty($_POST["update"]))
						{
							$query .= '&mess'.($field ? '-'.$field : '').'='.$mes;
						}
					}
				}
				$this->diafan->goto_diafan($this->diafan->path_module_variable().($query ? '?error=attachment'.$query : ''));
			}
			return TRUE;
		}
		return FALSE;
	}
}