<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(dirname(__FILE__)))).'/includes/404.php');
}

/**
 * Attachments_inc
 *
 * Работа с файлами
 */
class Attachments_inc
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{		
		$this->diafan = $diafan;

		include_once(ABSOLUTE_PATH.'modules/forum/attachments/attachments.ajax.php');
		$ajax = new Attachments_ajax($diafan);
		if($ajax->ajax_request())
		{
			exit;
		}
	}

	/**
	 * Возвращает файлы, прикрепленные к элементу
	 * 
	 * @param integer $element_id номер элемента
	 * @param string $module_name название модуля
	 * @param boolean $access доступ на удаление
	 * @return string|integer ошибка
	 */
	public function get($element_id = 0, $module_name = '', $access = FALSE)
	{
		if(! $module_name)
		{
			$module_name = $this->diafan->module;
		}
		if(! $element_id)
		{
			$element_id = $this->diafan->show;
		}

		$att = array();
		$result = DB::query("SELECT id, name, module_name, size FROM {attachment} WHERE element_id='%d' AND module_name='%h' ORDER BY id ASC",
				    $element_id, $module_name);

		while($row = DB::fetch_array($result))
		{
			if($this->diafan->configmodules("image", "forum") && stristr($row["name"], '.jpg'))
			{
				$link = '<a href="'.BASE_PATH.USERFILES.'/'.$module_name.'/imgs/'.$row["id"].'_'.$row["name"].'"';
				if(! $this->diafan->configmodules("use_animation", "forum"))
				{
					list($w, $h) = getImageSize(ABSOLUTE_PATH.USERFILES.'/'.$module_name.'/imgs/'.$row["id"].'_'.$row["name"]);
					$link .= ' href="javascript:void(0)" onclick="javascript: window.open(\''.BASE_PATH.USERFILES.'/'.$module_name.'/imgs/'.$row["id"].'_'.$row["name"]."',
					'', 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=".($w+40).",height=".($h+40)."');return false;".'"';
				}
				else
				{
					$link .= ' rel="prettyPhoto[gallery'.$element_id.$module_name.']"';
				}
				$link .= '>';

				$att[] = '<span id="attachment'.$row["id"].'">'
				.$link
				.$row["name"].'</a> ('.$this->diafan->convert($row["size"]).') '
				.$link
				.'<img src="'.BASE_PATH.USERFILES.'/'.$module_name.'/imgs/small/'.$row["id"].'_'.$row["name"].'"></a>'
				.($access ? ' <a href="javascript:void(0)" class="delete_attachment" del_id="'.$row["id"].'" title="'._ADMIN_CONFIRM_DELETE.'">x</a>' : '')
				.'</span>';
			}
			else
			{
				$att[] = '<span id="attachment'.$row["id"].'"><a href="'.BASE_PATH.'file/'.$row["id"]."/".$row["name"].'/">'
				.$row["name"].'</a> ('.$this->diafan->convert($row["size"]).')'
				.($access ? ' <a href="javascript:void(0)" class="delete_attachment" del_id="'.$row["id"].'" title="'._ADMIN_CONFIRM_DELETE.'">x</a>' : '')
				.'</span>';
			}
		}
		return $att;
	}

	/**
	 * Удаляет выбранный файл
	 * 
	 * @param integer $element_id номер элемента
	 * @param string $module_name название модуля
	 * @return boolean true
	 */
	public function delete($element_id, $module_name)
	{
		$result = DB::query("SELECT id, name FROM {attachment} WHERE element_id='%d' AND module_name='%h'", $element_id, $module_name);
		while($row = DB::fetch_array($result))
		{
			if($this->diafan->configmodules("image", "forum") && strstr($row["name"], '.jpg'))
			{
				unlink(ABSOLUTE_PATH.USERFILES.'/'.$module_name.'/imgs/'.$row["id"].'_'.$row["name"]);
				unlink(ABSOLUTE_PATH.USERFILES.'/'.$module_name.'/imgs/small/'.$row["id"].'_'.$row["name"]);
			}
			else
			{
				unlink(ABSOLUTE_PATH.USERFILES.'/'.$module_name.'/files/'.$row["id"]);
			}
		}
		DB::query("DELETE FROM {attachment} WHERE element_id='%d' AND module_name='%h'", $element_id, $module_name);
		return TRUE; 
	}

	/**
	 * Сохраняет добавленные файлы
	 * 
	 * @param integer $element_id номер элемента
	 * @param string $module_name название модуля
	 * @return string|integer ошибка
	 */
	public function save($element_id, $module_name)
	{
		$edit = 0;
		$err  = '';
		if(! empty($_FILES['attachment']))
		{
			foreach ($_FILES['attachment']['tmp_name'] as $n => $dummy)
			{
				if($this->diafan->configmodules("max-files", "forum") && $n > $this->diafan->configmodules("max-files", "forum"))
					break;
				if($_FILES['attachment']['tmp_name'][$n])
				{
					$edit = 2;
				}
				if($n == 0)
				{
					$n = 'null';
				}
				$err .= $this->file_upload($_FILES['attachment'], $module_name, $element_id, $n);
			}
		}
		if($err)
		{
			return $err;
		}
		return $edit;
	}

	/**
	 * Загружает файлы
	 * 
	 * @param array $file загруженный файл
	 * @param string $module_name название модуля
	 * @param integer $element_id номер элемента
	 * @param string|integer $n порядковый номер загружаемого файла
	 * @return string|boolean false
	 */
	private function file_upload($file, $module_name, $element_id, $n = 'one')
	{
		if($n !== 'one')
		{
			if($n === 'null')
			{
				$n = 0;
			}
			$name     = $file['name'][$n];
			$tmp_name = $file['tmp_name'][$n];
			$type     = $file['type'][$n];
			$size     = $file['size'][$n];
		}
		else
		{
			$name     = $file['name'];
			$tmp_name = $file['tmp_name'];
			$type     = $file['type'];
			$size     = $file['size'];
		}
		
		if ($name == '')
			return FALSE;

		$extension = strtolower(substr(strrchr($name, '.'), 1));
		$name      = $this->diafan->translit($name);
		if(strlen($name) > 50)
		{
			$name = substr($name, -50);
		}
		if (! in_array($extension, explode(',', str_replace(' ', '', strtolower($this->diafan->configmodules("attachment-extensions", "forum"))))))
		{
			return '<br>'.sprintf(_LANG_ATTACHMENT_EXTENSIONS, $name).$this->diafan->configmodules("attachment-extensions", "forum");
		}

		if (! is_uploaded_file($tmp_name) || ! file_exists($tmp_name))
		{
			return '<br>'.sprintf(_LANG_ATTACHMENT_NO_SUCCESS, $name);
		}

		DB::query("INSERT INTO {attachment} (name, module_name, element_id, extension, size) VALUES ('%s', '%s', '%d', '%s', '%d')",
			  $name,
			  $module_name,
			  $element_id,
			  $type,
			  $size
		);
		$id = DB::next_id("attachment");

		if($this->diafan->configmodules("image", "forum") && $extension == 'jpg')
		{
			include_once(ABSOLUTE_PATH.'includes/image.php');
			if(! Image::resize($tmp_name, $this->diafan->configmodules("big_width", "forum"), $this->diafan->configmodules("big_height", "forum"), $this->diafan->configmodules("big_quality", "forum")))
			{
				return 'ERROR';
			}
			if(! copy($tmp_name, ABSOLUTE_PATH.USERFILES."/".$module_name."/imgs/".$id."_".$name))
			{
				return 'ERROR';
			}

			if(! Image::resize($tmp_name, $this->diafan->configmodules("medium_width", "forum"), $this->diafan->configmodules("medium_height", "forum"), $this->diafan->configmodules("medium_quality", "forum")))
			{
				return 'ERROR';
			}

			if(! move_uploaded_file($tmp_name, ABSOLUTE_PATH.USERFILES."/".$module_name."/imgs/small/".$id."_".$name))
			{
				return 'ERROR';
			}
			return FALSE;
		}
		if(! move_uploaded_file($tmp_name, ABSOLUTE_PATH.USERFILES.'/'.$module_name.'/files/'.$id))
		{
			return 'ERROR';
		}
		return FALSE;
	}
}