<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Forum_admin_element
 *
 * Редактирование сообщений
 */
class Forum_admin_element extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'forum';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'forum';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		$this->diafan->nastr = 30;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'act'		=> 'checkbox',
			'del'		=> 'checkbox',
			'author'	=> 'function',
			'created'	=> 'datetime',
			'parent_id'	=> 'select',
			'user_update'	=> 'function',
			'cat_id'	=> 'select',
			'text'		=> 'textarea',
			'files'		=> 'function'
		);

		$this->config_module = array(
			'del'		=> 1,	//удалить
			'act'		=> 1,	//показать/скрыть
			'element'	=> 1,	//используются группы
			'trash'		=> 1,	//использовать корзину
			'datetime'	=> 1
		);

		$this->select["cat_id"] = array(
			"forum_category",
			"id",
			"name",
			$this->diafan->cat
		);

		$this->select["parent_id"] = array(
			"forum",
			"id",
			"text",
			$this->diafan->enterid ? $this->diafan->enterid : '',
			"-",
			$this->diafan->edit ? "id<>".$this->diafan->edit." AND cat_id=".$this->diafan->cat : '',
			"parent_id"
		);
	}

	/**
	 * Выводит список сообщений
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->name = "text";
		echo '<table border="0" cellpadding="1" cellspacing="3" class="list">';
		$this->list_row($this->diafan->cat);	
		echo '</table>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Прикрепленные файлы"
	 * @return boolean true
	 */
	protected function edit_files_module()
	{
		echo '
		<tr>
			<td align="right">'.$this->variable_names().'</td>
			<td>';
		$result = DB::query("SELECT id,name FROM {attachment} WHERE module_name='".$this->table."' AND element_id='%d'", $this->diafan->edit);
		while ($row = DB::fetch_array($result))
		{
			echo '<input type="checkbox" name="filedel[]" value="'.$row["id"].'" />';
			if($this->diafan->configmodules("image") && stristr($row["name"], '.jpg'))
			{
				
				echo '<a href="http://'.BASE_URL.'/'.USERFILES.'/'.$this->table.'/imgs/'.$row["id"].'_'.$row["name"].'">'.$row["name"].'
				<img src="http://'.BASE_URL.'/'.USERFILES.'/'.$this->table.'/imgs/small/'.$row["id"].'_'.$row["name"].'"></a><br>';
			}
			else
			{
				echo '<a href="http://'.BASE_URL.'/file/'.$row["id"]."/".$row["name"].'">'.$row["name"].'</a><br>
				';
			}
		}
		echo '<input type="file" name="attachment" size="40" class="fr">'.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Обновление"
	 * @return boolean true
	 */
	protected function edit_user_update_module()
	{
		if(! $this->value)
			return;
		echo '
		<tr>
			<td align="right">'.$this->variable_names().'</td>
			<td>'
			.DB::query_result("SELECT fio FROM {users_site} WHERE id=%d", $this->value).', '.date("d.m.Y H:i", $this->values["date_update"])
			.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Автор"
	 * @return boolean true
	 */
	protected function edit_author_module()
	{
		echo '
		<tr>
			<td align="right">'.$this->variable_names().'</td>
			<td>'
			.(! $this->value ? _LANG_GUEST : DB::query_result("SELECT fio FROM {users_site} WHERE id=%d", $this->value))
			.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Сохранение поля "Прикрепленные файлы"
	 * @return boolean true
	 */
	protected function save_files_module()
	{				
		$altname = $this->diafan->translit($_POST["name"]);

		$result = DB::query("SELECT id FROM {attachment} WHERE module_name='".$this->table."' AND element_id='%d'", $this->diafan->save);
		while ($row = DB::fetch_array($result))
		{
			if(! empty($_POST["filedel"]) && in_array($row["id"], $_POST["filedel"]))
			DB::query("DELETE FROM {attachment} WHERE id='%d'", $row["id"]);
			@unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/files/'.$row["id"]);
			@unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/files/imgs/'.$row["id"].'_'.$row["name"]);
			@unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/files/imgs/small/'.$row["id"].'_'.$row["name"]);
		}

		if(isset($_FILES["attachment"]) && is_array($_FILES["attachment"]) && $_FILES["attachment"]['name'] != '')
		{
			include_once (ABSOLUTE_PATH."includes/files.inc.php");
			
			$_FILES['attachment']['name'] = $altname.'.'.strtolower(substr(strrchr($_FILES['attachment']['name'], '.'), 1));	
			$f = new Files($this->diafan);
			$err = $f->file_upload($_FILES['attachment'],$this->table,$this->diafan->save);
			
			if(! empty($err))
			{
				echo '<script language="javascript" type="text/javascript">alert(\''.strip_tags($err).'\');history.go(-1);</script>';
				exit;
			}
		}

		return TRUE;
	}

	/**
	 * Сохранение поля "Обновление"
	 * @return boolean true
	 */
	protected function save_user_update_module()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Автор"
	 * @return boolean true
	 */
	protected function save_author_module()
	{
		return TRUE;
	}

	/**
	 * Удаляет категорию
	 * @return boolean
	 */
	public function del_module()
	{	
		if($this->diafan->admin_roles('del'))
		{
			$this->diafan->goto_diafan(URL);
			return FALSE;
		}
		$dels = $this->diafan->get_children($this->diafan->trash, "forum");
		DB::query("DELETE FROM {forum_show} WHERE table_name='forum' AND element_id IN (".implode(",", $dels).")");

		parent::del_module();

		return TRUE;
	}
}