<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN') || ! defined("IS_INSTALL"))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Forum_install
 *
 * Установка модуля "Форум"
 */

$title = "Форум";

$sql = array(
	"CREATE TABLE {forum} (
		`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
		`author` int(11) unsigned NOT NULL,
		`parent_id` int(11) unsigned NOT NULL,
		`created` int(12) unsigned NOT NULL,
		`date_update` int(12) unsigned NOT NULL,
		`user_update` int(11) unsigned NOT NULL,
		`cat_id` int(11) unsigned NOT NULL,
		`text` text NOT NULL,
		`del` ENUM('0', '1') NOT NULL DEFAULT '0',
		`act` ENUM('0', '1') NOT NULL DEFAULT '0',
		`trash` ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY (`id`),
		KEY `parent_id` (`parent_id`),
		KEY `element_id` (`cat_id`),
		KEY `author` (`author`)
	)",
	
	"ALTER DATABASE {forum} DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;",
	
	"CREATE TABLE {forum_category} (
		`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
		`author` int(11) unsigned NOT NULL,
		`parent_id` int(11) unsigned NOT NULL,
		`created` int(12) unsigned NOT NULL,
		`name` varchar(250) NOT NULL,
		`date_update` int(12) unsigned NOT NULL,
		`user_update` int(11) unsigned NOT NULL,
		`message_update` int(11) unsigned NOT NULL,
		`del` ENUM('0', '1') NOT NULL DEFAULT '0',
		`act` ENUM('0', '1') NOT NULL DEFAULT '0',
		`trash` ENUM('0', '1') NOT NULL DEFAULT '0',
		`prior` ENUM('0', '1') NOT NULL DEFAULT '0',
		`close` ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY (`id`),
		KEY `author` (`author`)
	)",
	
	"ALTER DATABASE {forum_category} DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;",
	
	"CREATE TABLE {forum_show} (
		`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
		`element_id` int(11) unsigned NOT NULL,
		`user_id` int(11) unsigned NOT NULL,
		`table_name` enum('forum','forum_category') NOT NULL,
		PRIMARY KEY (`id`),
		KEY `element_id` (`element_id`,`table_name`),
		KEY `user_id` (`user_id`)
	)",
	
	"ALTER DATABASE {forum_show} DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;",

	"INSERT INTO {site} (id,
		".multilang("nameLANG,")."
		".multilang("titleLANG,")."
		".multilang("actLANG,")."
		sort, timeedit, addmodule) VALUES (
		13,
		".multilang("'".$title."',", "'Forum',", "'',")."
		".multilang("'".$title."',", "'Forum',", "'',")."
		".multilang("'1',")."
		'13',
		'".time()."',
		'forum'
	);",

	"INSERT INTO {rewrite} (id, rewrite, module_name, element_id, site_id, cat_id, trash) VALUES (13, 'forum', 'site', 0, 13, 0, '0')",
	
	"INSERT INTO {adminsite} (id, parent_id, name, rewrite, text, act, numrow, sort) VALUES (
		40,
		15,
		'Форум',
		'forum',
		'',
		'1',
		759442,
		'13'
	);",
	
	"INSERT INTO {config} VALUES (id, module_name, config, cat_id) VALUES (
		33,
		'forum',

		'access_add="
		."\n"
		."format_date=5"
		."\n"
		."nastr=30"
		."\n"
		."premoderation_theme=0"
		."\n"
		."premoderation_message=0"
		."\n"
		."files=1"
		."\n"
		."max-count-files=5"
		."\n"
		."attachment-extensions=doc, gif, jpg, mpg, pdf, png, txt, zip"
		."\n"
		."image=1"
		."\n"
		."big_width=1000"
		."\n"
		."big_height=1000"
		."\n"
		."big_quality=90"
		."\n"
		."medium_width=50"
		."\n"
		."medium_height=50"
		."\n"
		."medium_quality=90"
		."\n"
		."use_animation=1'
		,0
	);"
);

$example = array(
	"UPDATE {site} SET actm='1' WHERE id=13"
);

/**
 * Выполняет действия для основной установки модуля
 * 
 * @return void
 */
function module_basic_forum()
{
	if(! is_dir(ABSOLUTE_PATH.USERFILES.'/forum'))
	{
		mkdir(ABSOLUTE_PATH.USERFILES.'/forum', 0777);
	}

	if(! is_dir(ABSOLUTE_PATH.USERFILES.'/forum/files'))
	{
		mkdir(ABSOLUTE_PATH.USERFILES.'/forum/files', 0777);
	}

	if(! is_dir(ABSOLUTE_PATH.USERFILES.'/forum/imgs'))
	{
		mkdir(ABSOLUTE_PATH.USERFILES.'/forum/imgs', 0777);
	}

	if(! is_dir(ABSOLUTE_PATH.USERFILES.'/forum/imgs/small'))
	{
		mkdir(ABSOLUTE_PATH.USERFILES.'/forum/imgs/small', 0777);
	}

	$text = 'Options -Indexes

<files *>
deny from all
</files>';

	$fp = fopen(ABSOLUTE_PATH.USERFILES.'/forum/files/.htaccess', "w");
	fwrite($fp, $text);
	fclose($fp);

	$url = parse_url(DB_URL);
	$result = DB::query("SHOW TABLES FROM ".substr($url['path'], 1));
	while ($row = mysql_fetch_row($result))
	{
		if($row[0] == DB_PREFIX."attachment") return;
	}

	DB::query("CREATE TABLE {attachment} (
	id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
	name VARCHAR(50) NOT NULL DEFAULT '',
	module_name VARCHAR(10) NOT NULL DEFAULT '',
	element_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
	extension VARCHAR(255) NOT NULL DEFAULT '',
	size INT(11) UNSIGNED NOT NULL DEFAULT '0',
	trash ENUM('0', '1') NOT NULL DEFAULT '0',
	PRIMARY KEY  (id),
	KEY element_id (element_id),
	KEY module_name (module_name(2))
	)");

	DB::query("ALTER DATABASE {attachment} DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;");
}

/**
 * Деинсталлирует модуль
 * 
 * @return void
 */
function module_basic_uninstall_forum()
{
	$module = 'forum';
	DB::query("DROP TABLE {".$module."};");
	DB::query("DROP TABLE {".$module."_category};");
	DB::query("DROP TABLE {".$module."_show};");
	DB::query("DELETE FROM {rewrite} WHERE module_name='site' AND site_id IN (SELECT id FROM {site} WHERE addmodule='".$module."');");
	DB::query("DELETE FROM {site} WHERE addmodule='".$module."';");
	DB::query("DELETE FROM {adminsite} WHERE rewrite='".$module."';");
	DB::query("DELETE FROM {config} WHERE module_name='".$module."';");
	DB::query("DELETE FROM {attachment} WHERE module_name='".$module."';");
	@DB::query("DELETE FROM {tags} WHERE module_name='".$module."';");

	if($dirr = @opendir(ABSOLUTE_PATH.USERFILES.'/'.$module.'/files'))
	{
		while(($file = readdir($dirr)) !== false)
		{
                    @unlink(ABSOLUTE_PATH.USERFILES.'/'.$module.'/files/'.$file);
		}
		closedir($dirr);
	}
	rmdir(ABSOLUTE_PATH.USERFILES.'/'.$module.'/files');

	if($dirr = @opendir(ABSOLUTE_PATH.USERFILES.'/'.$module.'/imgs/small'))
	{
		while(($file = readdir($dirr)) !== false)
		{
			@unlink(ABSOLUTE_PATH.USERFILES.'/'.$module.'/imgs/small/'.$file);
		}
		closedir($dirr);
	}
	rmdir(ABSOLUTE_PATH.USERFILES.'/'.$module.'/imgs/small');

	if($dirr = @opendir(ABSOLUTE_PATH.USERFILES.'/'.$module.'/imgs'))
	{
		while(($file = readdir($dirr)) !== false)
		{
			@unlink(ABSOLUTE_PATH.USERFILES.'/'.$module.'/imgs/'.$file);
		}
		closedir($dirr);
	}
	rmdir(ABSOLUTE_PATH.USERFILES.'/'.$module.'/imgs');

	if($dirr = @opendir(ABSOLUTE_PATH.USERFILES.'/'.$module))
	{
		while(($file = readdir($dirr)) !== false)
		{
			@unlink(ABSOLUTE_PATH.USERFILES.'/'.$module.'/'.$file);
		}
		closedir($dirr);
	}
	rmdir(ABSOLUTE_PATH.USERFILES.'/'.$module);
}