<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Forum
 *
 * Контроллер модуля "Форум"
 */
class Forum
{
	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct(&$diafan)
	{
		$this->diafan = &$diafan;

		$this->rewrite_variable_names = array('add', 'show', 'cat', 'edit', 'del', 'page', 'block', 'unblock');

		define('URL', BASE_PATH_HREF.($this->diafan->rewrite ? $this->diafan->rewrite.'/' : ''));
		define('URL_LIST', BASE_PATH_HREF.($this->diafan->rewrite ? $this->diafan->rewrite.'/' : '').($this->diafan->page > 1 ? 'page'.$this->diafan->page.'/' : ''));
		
		include_once(ABSOLUTE_PATH.'modules/forum/forum.ajax.php');
		$ajax = new Forum_ajax($diafan);
		if($ajax->ajax_request())
		{
			exit;
		}

		$model = new Forum_model($diafan);

		if($this->diafan->add)
		{
			$this->result = $model->add();	
		}
		elseif($this->diafan->show)
		{
			$this->result = $model->id();	
		}
		elseif($this->diafan->edit)
		{
			$this->result = $model->edit();	
		}
		elseif(! empty($_GET["block_id"]) || ! empty($_GET["unblock_id"]))
		{
			return $model->block_id();	
		}
		elseif(! empty($_GET["prior_id"]))
		{
			return $model->prior_id();	
		}
		elseif(! empty($_GET["close_id"]))
		{
			return $model->close_id();	
		}
		elseif(! empty($_GET["searchword"]))
		{
			$this->result = $model->list_search();	
		}
		elseif($this->diafan->cat)
		{
			$this->result = $model->list_category();	
		}
		else
		{
			$this->result = $model->first_page();	
		}
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	public function show_module()
	{
		if($this->diafan->add || $this->diafan->edit)
		{
			Forum_view::edit($this->result);
		}
		elseif($this->diafan->show)
		{
			Forum_view::id($this->result);
		}
		elseif(! empty($_GET["searchword"]))
		{
			Forum_view::list_search($this->result);		
		}
		elseif($this->diafan->cat)
		{
			Forum_view::list_category($this->result);	
		}
		else
		{
			Forum_view::first_page($this->result);	
		}
	}
}