<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Forum_view
 *
 * Шаблон модуля "Форум"
 */
class Forum_view
{
	/**
	 * Шаблон первой страницы форума
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function first_page($result)
	{
		echo '
		<script type="text/javascript" src="'.BASE_PATH.'modules/forum/forum-func.js"></script>';

		echo '<table class="forum-list">
			<tr><th>'._LANG_CATEGORIES.'</th><th>'._LANG_COUNT_THEMES.'</th><th>'._LANG_LAST_MESSAGE.'</th></tr>';
		// категории тем. первый уровень
		foreach($result["cats"] as $cat)
		{
			echo '<tr><td class="forum-name" colspan="3">'.$cat["name"].'</td></tr>';
			// категории тем. второй уровень
			foreach($cat["rows"] as $row)
			{
				echo '
				<tr class="forum-category">
					<td';
					// в теме есть новые сообщения
					if($row["theme_news"])
					{
						echo '  class="forum-news"';
					}
					echo '>
						<a href="'.BASE_PATH_HREF.$row["link"].'" class="forum-name">'.$row["name"].'</a>
					</td>
					<td>'
						// количество тем в категории
						.$row["count_caregory"].'
					</td>
					<td>';
					// последняя обсуждаемая тема в категории
					if($row["last_theme"])
					{
						// название последней темы
						echo '<a href="'.BASE_PATH_HREF.$row["last_theme"]["link"].'">'.$row["last_theme"]["name"].'</a>';
						if($row["last_theme"]["message_update"])
						{
							// дата последней темы
							echo '<br><span class="forum-date">'.$row["last_theme"]["message_update"].'</span>';
						}
					}
					echo '
					</td>
				</tr>';
			}
		}
		echo '
		</table>';

		// форма поиска по темам и сообщениям
		self::form_search();

		return TRUE;
	}

	/**
	 * Шаблон списка категорий форума
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function list_category($result)
	{
		echo '
		<script type="text/javascript" src="'.BASE_PATH.'modules/forum/forum-func.js"></script>';

		echo ($result["access_add"] ? '<div class="forum-add"><a href="'.BASE_PATH_HREF.$result["link_add"].'">'._ADMIN_FORUM_ADD.'</a></div>' : '').'

		<table class="forum-list">
			<tr><th>'._LANG_THEMES.'</th><th>'._LANG_ANSWERS.'</th><th>'._LANG_AUTHOR.'</th><th colspan="2">'._LANG_LAST_ANSWER.'</th></tr>';
		foreach($result["rows"] as $row)
		{
			echo '<tr class="forum-category" id="forum-category-'.$row["id"].'">'.self::list_id_category($row).'</tr>';
		}
		echo '
		</table>
		'.Paginator_view::get($result["paginator"]);

		// форма поиска по темам и сообщениям
		self::form_search();

		return TRUE;
	}

	/**
	 * Шаблон вывода темы в категории
	 * 
	 * @param array $row данные о теме
	 * @return string
	 */
	public function list_id_category($row)
	{
		$text = '<td class="forum-category-name';
		// в теме есть новые сообщения
		if($row["messages_new"] || $row["theme_news"])
		{
			$text .= ' forum-news';
		}
		$text .= '">';
		// тема удалена
		if($row["del"])
		{
			$text .= '<span class="forum-blocked">'.sprintf(_LANG_THEME_DELETED, $row["user_update"], '<span class="forum-name">'.$row["name"].'</span>').'</span>';
		}
		// тема заблокирована
		elseif(! $row["act"])
		{
			$text .= '<span class="forum-blocked">'._LANG_BLOCKED.': <span class="forum-name">'.$row["name"].'</span></span>';
		}
		// тема активна
		else
		{
			$text .= '<a href="'.BASE_PATH_HREF.$row["link"].'" class="forum-name">'.$row["name"].'</a>';
		}
		$text .= '
		</td>
		<td class="forum-count-message">'
			// ответов новых/всего
			.($row["messages_new"] ? '<span class="forum-active">'.$row["messages_new"].'</span>/' : '').$row["messages"].'
		</td>
		
		<td class="forum-category-author">';
			// автор темы
			if($row["author"])
			{
				$text .= '<span class="forum-author">'.$row["author"].'</span><br>';
			}
			// дата создания, редакции темы
			$text .= '<span class="forum-date">'.$row["created"].'</span>
		</td>
		<td class="forum-last-user">';
			// автор и дата последнего сообщения в теме
			if($row["last_user"])
			{
				$text .= '<span class="forum-author">'.$row["last_user"]["author"].'</span><br>
				<span class="forum-date">'.$row["last_user"]["created"].'</span>';
			}
			$text .= '
		</td>
		<td>';
		if($row["access_edit_delete"] || $row["access_block"])
		{
			$text .= '
			<div class="forum-actions">
			<form method="POST" action="" class="ajax">
			<input type="hidden" name="action" value="">
			<input type="hidden" name="ajax" value="">
			<input type="hidden" name="ajax_forum" value="1">
			<input type="hidden" name="id" value="'.$row["id"].'">
				<span>';
				if($row["access_edit_delete"])
				{
					// удалить тему
					$text .= '<a href="javascript:void(0)" title="'._ADMIN_CONFIRM_DELETE.'" action="delete-category">'
					.'<img src="'.BASE_PATH.'adm/img/b4.gif" width="15" height="15"'
					.' title="'._LANG_DELETE.'" alt="'._LANG_DELETE.'">'
					.'</a>'

					// редактировать тему
					.'<a href="'.BASE_PATH_HREF.$row["link_edit"].'">'
					.'<img src="'.BASE_PATH.'modules/forum/img/edit.gif" width="12" height="14"'
					.' title="'._LANG_EDIT.'" alt="'._LANG_EDIT.'">'
					.'</a>';
				}
				if($row["access_block"])
				{
					if($row["act"])
					{
						// блокировать тему
						$text .= '<a href="javascript:void(0)" action="block-category">'
						.'<img src="'.BASE_PATH.'adm/img/b2.gif" width="12" height="18"'
						.' title="'._LANG_FORUM_BLOCK.'" alt="'._LANG_FORUM_BLOCK.'">'
						.'</a>';
					}
					else
					{
						// разблокировать тему
						$text .= '<a href="javascript:void(0)" action="unblock-category">'
						.'<img src="'.BASE_PATH.'adm/img/b3.gif" width="12" height="18"'
						.' title="'._LANG_FORUM_UNBLOCK.'" alt="'._LANG_FORUM_UNBLOCK.'">'
						.'</a>';
					}
					if($row["close"])
					{
						// открыть тему
						$text .= '<a href="javascript:void(0)" action="open-category">'
						.'<img src="'.BASE_PATH.'modules/forum/img/lock.png" width="16" height="16"'
						.' title="'._LANG_FORUM_OPEN.'" alt="'._LANG_FORUM_OPEN.'">'
						.'</a>';
					}
					else
					{
						// закрыть тему
						$text .= '<a href="javascript:void(0)" action="close-category">'
						.'<img src="'.BASE_PATH.'modules/forum/img/lock_off.png" width="16" height="16"'
						.' title="'._ADMIN_FORUMCATEGORY_CLOSE.'" alt="'._ADMIN_FORUMCATEGORY_CLOSE.'">'
						.'</a>';
					}

					if($row["prior"])
					{
						// открепить тему
						$text .= '<a href="javascript:void(0)" action="unprior-category">'
						.'<img src="'.BASE_PATH.'adm/img/b6.gif" width="14" height="16"'
						.' title="'._LANG_UNPRIOR.'" alt="'._LANG_UNPRIOR.'">'
						.'</a>';
					}
					else
					{
						// закрепить тему
						$text .= '<a href="javascript:void(0)" action="prior-category">'
						.'<img src="'.BASE_PATH.'adm/img/b5.gif" width="14" height="16"'
						.' title="'._ADMIN_FORUMCATEGORY_PRIOR.'" alt="'._ADMIN_FORUMCATEGORY_PRIOR.'">'
						.'</a>';
					}
				}
				$text .= '</span>
				</form>
			</div>';
		}
		$text .= '</td>';
		return $text;
	}

	/**
	 * Шаблон вывода результатов поиска сообщений
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function list_search($result)
	{
		echo '<script type="text/javascript" src="'.BASE_PATH.'modules/forum/forum-func.js"></script>';

		echo '
		<div class="search-result">
			'._LANG_TOTAL_FOUND.": <b>".$result["value"].": ".$result["count"]."</b>
			<br>
			".sprintf(_LANG_COUNT_SEARCH, $result["count-page"], $result["count"]).'
		</div>';

		if($result["rows"])
		{
			foreach($result["rows"] as $row)
			{
				if($row["type"] == "message")
				{
					echo '
					<div class="forum-message">
						<a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["theme"].'</a>
						<br>
						<span class="forum-author">'.$row["author"].'</span>, <span class="forum-date">'.$row['created'].'</span>
						<br>
						'.$row['text'].'
					</div>';
				}
				else
				{
					echo '
					<div class="forum-category">
						<a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["theme"].'</a>
						<br>
						<span class="forum-author">'.$row["author"].'</span>, <span class="forum-date">'.$row['created'].'</span>
					</div>';
				}
			}
		}
		echo Paginator_view::get($result["paginator"]);

		// форма поиска по темам и сообщениям
		self::form_search($result["value"]);

		return TRUE;
	}

	/**
	 * Шаблон редактировани/добавления категории
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function edit($result)
	{
		echo ($result["premoderation"] ? '<p>'._LANG_THEME_ADDED_MODERATOR.'</p>' : '').'

		<form action="" method="POST" class="ajax forum-form">
		<input type="hidden" name="ajax" value="0">
		<input type="hidden" name="ajax_forum" value="1">
		<input type="hidden" name="action" value="'.$result["action"].'">
		<input type="hidden" name="id" value="'.$result["id"].'">
		<input type="hidden" name="parent_id" value="'.$result["parent_id"].'">

		<div class="infofield">'._LANG_NAME.':</div>
		<input type="text" name="name" size="40" value="'.$result["name"].'" class="inptext">
		<div class="errors error-name"'.($result["error-name"] ? '>'.$result["error-name"] : ' style="display:none">').'</div>
		
		'.($result["captcha"] ? $result["captcha"] : '').'

		<input type="submit" value="'.(! $result["name"] ? _LANG_CREATE : _LANG_SAVE).'" class="button">
		<div class="errors error"'.($result["error"] ? '>'.$result["error"] : ' style="display:none">').'</div>

		</form>';

		return TRUE;
	}

	/**
	 * Шаблон страницы категории
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function id($result)
	{
		echo '<script type="text/javascript" src="'.BASE_PATH.'modules/forum/forum-func.js"></script>'

		.$result["messages"];

		return TRUE;
	}

	/**
	 * Шаблон формы поиска по темам и сообщениям
	 * 
	 * @param string $value введенные поисковый запрос
	 * @return boolean true
	 */
	private function form_search($value = '')
	{
		echo '
		<div class="forum-search">
			<form action="'.URL.'" method="GET">
				<input type="text" name="searchword" value="'.$value.'" size="20" class="inptext">
				<input type="submit" value="'._LANG_SEARCH.'" class="button">
			</form>
		</div>';

		return TRUE;
	}
}