<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(dirname(__FILE__)))).'/includes/404.php');
}

/**
 * Forum_message_view
 *
 * Шаблон сообщений модуля "Форум"
 */
class Forum_message_view
{
	/**
	 * Шаблон списка и формы добавления сообщений модуля
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return string
	 */
	public function show_module($result)
	{
		$text  = $result["close"] ? '<div class="forum-active">'._LANG_FORUM_THEME_CLOSE.'</div>' : '';
		$text .= '<script type="text/javascript" src="'.BASE_PATH.'modules/forum/bbeditor/ed.js"></script>';
		$text .= '<div class="message0-result">';
		if($result["rows"])
		{
			$text .= self::show_list($result);
		}
		$text .= '</div>';
		$result["current_level"] = 0;
		$text .= self::show_form_module($result);
		return $text;
	}

	/**
	 * Шаблон списка сообщений
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @param boolean $edit сообщение редактировано
	 * @return string
	 */
	public function show_list($result, $edit = FALSE)
	{
		$text = '';
		foreach($result["rows"] as $row)
		{
			if(! $edit)
			{
				$text .= '
				<div id="show_message'.$row["id"].'" class="forum-message'.($row["show"] ? ' forum-news':'').'">';
			}
			$text .= '
			<form method="POST" action="'.$result["action"].'" class="ajax">
				<a name="'.$row["id"].'"></a>
				<input type="hidden" name="action" value="">
				<input type="hidden" name="ajax" value="">
				<input type="hidden" name="ajax_forum_message" value="1">
				<input type="hidden" name="id" value="'.$row["id"].'">';
			if($row["del"])
			{
				$text .= '<span class="forum-blocked">'
				.($row["access_edit_delete"]
				  ? sprintf(_LANG_MESSAGE_DELETED_MODERATOR, $row["user_update"], '<span class="forum-name">'.$row["text"].'</span>')
				  : _LANG_MESSAGE_DELETED)
				.'</span>
				</form>';
			}
			else
			{
				$text .=
				'<div class="forum-actions">
				<span>
				<a href="#'.$row["id"].'"><img src="'.BASE_PATH.'modules/forum/img/link.gif" title="'._LANG_LINK.'" alt="'._LANG_LINK.'"></a> ';
				if($row["access_edit_delete"])
				{
					$text .=
					// удалить сообщение
					'<a href="javascript:void(0)" action="delete-message" title="'._ADMIN_CONFIRM_DELETE.'">'
					.'<img src="'.BASE_PATH.'adm/img/b4.gif" width="15" height="15"'
					.' title="'._LANG_DELETE.'" alt="'._LANG_DELETE.'">'
					.'</a>'

					// редактировать сообщение
					.' <a href="javascript:void(0)" action="edit-message">'
					.'<img src="'.BASE_PATH.'modules/forum/img/edit.gif" title="'._LANG_EDIT.'" alt="'._LANG_EDIT.'"></a>';
				}
				if($row["access_block"])
				{
					$text .= ' <a href="javascript:void(0)" action="block-message">'
					.'<img src="'.BASE_PATH.'adm/img/b'.($row["act"] ? 3 : 2).'.gif"
					title="'.(! $row["act"] ? _LANG_FORUM_UNBLOCK : _LANG_FORUM_BLOCK).'"
					alt="'.(! $row["act"] ? _LANG_FORUM_UNBLOCK : _LANG_FORUM_BLOCK).'"></a>';
				}
				$text .= '</span></div>';

				$result["current_level"] = $row["id"];

				if(! $row["act"])
				{
					$text .= '<span class="forum-blocked">'._LANG_BLOCKED
					         .($row["access_edit_delete"] ? ': <span class="forum-name">'.$row["text"].'</span>' : '').'</span>
					</form>';
				}
				else
				{
					$text .= '<span class="forum-author">'.$row["author"].'</span>, <span class="forum-date">'.$row['created'].'</span>
					<div class="forum-message">'.$row['text'].'</div>
					<div class="errors error" style="display:none"></div>
					'.implode('<br>', $row["attachments"]).'
					</form>';
					if(empty($result["level"]) || $result["level"] < 6)
					{
						$text .= self::show_form_module($result, $row["id"]);
					}
				}
			}
			if(! $edit)
			{
				$text .= '
				</div>';
			}

			if($row["children"])
			{
				$result_children          = $result;
				$result_children["rows"]  = $row["children"];
				$result_children["level"] = empty($result["level"]) ? 1 : $result["level"] + 1;
				$text .= '<div class="messages-level message'.$row["id"].'-result">'.self::show_list($result_children).'</div>';
			}
			else
			{
				$text .= '<div class="messages-level message'.$row["id"].'-result" style="display:none;"></div>';
			}
		}
		return $text;
	}

	/**
	 * Шаблон формы добавления сообщения
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @param integer $parent_id номер сообщения-родителя
	 * @return string|boolean false
	 */
	public function show_form_module($result)
	{
		if(! $result["access_add"])
			return FALSE;

		$text = '
		<a href="javascript:void(0)" class="forum-dashed-link show_block" rel="message'.$result["current_level"].'-result">'
		.($result["current_level"] ? _LANG_RESPOND : _LANG_ADD_MESSAGE).'</a>

		<form method="POST" action="'.$result["action"].'" class="forum-form ajax" id="message'.$result["current_level"].'-result" style="display:none">
			'.($result["premoderation"] ? '<p>'._LANG_MESSAGE_ADDED_MODERATOR.'</p>' : '').'
			<input type="hidden" name="ajax" value="0">
			<input type="hidden" name="ajax_forum_message" value="1">
			<input type="hidden" name="action" value="upload-message">
			<input type="hidden" name="parent_id" value="'.$result["current_level"].'">'

			.self::bbcode($result["current_level"]);

		//Прикрепляемые файлы
		if($result["files"])
		{
			$text .= '
			<div class="infofield">'._LANG_ATTACHMENT.':</div>
			<input type="file" name="attachment[]" class="inptext" max="'.$result["files"].'">
			<div class="errors error-attachments"'.(! empty($result["error-attachments"]) ? '>'.$result["error-attachments"] : ' style="display:none">').'</div>';
			$text .= '<div class="attachment-extensions">('._LANG_FORUM_ATTACHMENT_EXTENSIONS.': '.$result["attachment-extensions"].')</div>
			';
		}

		//Защитный код
		$text .= $result["captcha"]

		//Кнопка Отправить
		.'
			<input type="submit" value="'._LANG_SEND.'" class="button" name="button">
			<div class="errors error"'.(! empty($result["error"]) ? '>'.$result["error"] : ' style="display:none">').'</div>
		</form>';

		return $text;
	}

	/**
	 * Шаблон формы редактирования сообщения
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return string
	 */
	public function show_edit_module($result)
	{
		if(! $result["access_add"])
			return;

		$text = '
		<form method="POST" action="'.$result["action"].'" class="forum-form ajax">
			'.($result["premoderation"] ? '<p>'._LANG_MESSAGE_ADDED_MODERATOR.'</p>' : '').'
			<input type="hidden" name="ajax_forum_message" value="1">
			<input type="hidden" name="action" value="save-message">
			<input type="hidden" name="ajax" value="">
			<input type="hidden" name="save_id" value="'.$result["id"].'">'

			.self::bbcode($result["id"], $result["text"]);

		//Прикрепляемые файлы
		if($result["files"])
		{
			$text .= '
			<div class="infofield">'._LANG_ATTACHMENT.':</div>
			<input type="file" name="attachment[]" class="inptext" max="'.$result["files"].'">
			<div class="errors error-attachments"'.(! empty($result["error-attachments"]) ? '>'.$result["error-attachments"] : ' style="display:none">').'</div>';
			$text .= '<span class="attachment-extensions">('._LANG_FORUM_ATTACHMENT_EXTENSIONS.': '.$result["attachment-extensions"].')</span>
			'.($result["attachments"] ? '<br>' : '')
			.implode('<br>', $result["attachments"]);
		}
		$text .= '
			<br><br>

			<div class="errors error"'.(! empty($result["error"]) ? '>'.$result["error"] : ' style="display:none">').'</div>
			<input type="submit" value="'._LANG_SEND.'" class="button">
			</form>
		</div>';
		return $text;
	}

	/**
	 * Шаблон поля, для ввода сообщения
	 *
	 * @param integer $id номер элемента
	 * @param strign $value сообщение для редактирования
	 * @return string
	 */
	private function bbcode($id, $value = '')
	{
		$obj = 'textarea_message_'.$id;

		return '
		<div class="message-toolbar">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/bold.gif" name="btnBold" title="Bold" onClick="doAddTags(\'[b]\', \'[/b]\', \''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/italic.gif" name="btnItalic" title="Italic" onClick="doAddTags(\'[i]\', \'[/i]\', \''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/underline.gif" name="btnUnderline" title="Underline" onClick="doAddTags(\'[u]\',\'[/u]\',\''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/link.gif" name="btnLink" title="Insert URL Link" onClick="doURL(\''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/picture.gif" name="btnPicture" title="Insert Image" onClick="doImage(\''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/ordered.gif" name="btnList" title="Ordered List" onClick="doList(\'[LIST=1]\',\'[/LIST]\',\''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/unordered.gif" name="btnList" title="Unordered List" onClick="doList(\'[LIST]\',\'[/LIST]\',\''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/quote.gif" name="btnQuote" title="Quote" onClick="doAddTags(\'[quote]\',\'[/quote]\',\''.$obj.'\')">
			<img class="bbutton" src="'.BASE_PATH.'modules/forum/bbeditor/images/code.gif" name="btnCode" title="Code" onClick="doAddTags(\'[code]\',\'[/code]\',\''.$obj.'\')">
		</div>
		<div class="message-toolbar">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/smile.gif" onClick="doSmile(\'smile\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/wink.gif" onClick="doSmile(\'wink\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/acute.gif" onClick="doSmile(\'acute\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/bad.gif" onClick="doSmile(\'bad\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/biggrin.gif" onClick="doSmile(\'biggrin\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/blum.gif" onClick="doSmile(\'blum\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/blush.gif" onClick="doSmile(\'blush\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/bomb.gif" onClick="doSmile(\'bomb\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/boredom.gif" onClick="doSmile(\'boredom\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/bye.gif" onClick="doSmile(\'bye\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/clapping.gif" onClick="doSmile(\'clapping\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/cool.gif" onClick="doSmile(\'cool\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/cray.gif" onClick="doSmile(\'cray\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/dance.gif" onClick="doSmile(\'dance\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/diablo.gif" onClick="doSmile(\'diablo\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/drinks.gif" onClick="doSmile(\'drinks\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/empathy.gif" onClick="doSmile(\'empathy\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/flag_of_truce.gif" onClick="doSmile(\'flag_of_truce\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/good.gif" onClick="doSmile(\'good\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/help.gif" onClick="doSmile(\'help\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/hi.gif" onClick="doSmile(\'hi\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/i_am_so_happy.gif" onClick="doSmile(\'i_am_so_happy\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/lol.gif" onClick="doSmile(\'lol\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/nea.gif" onClick="doSmile(\'nea\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/negative.gif" onClick="doSmile(\'negative\',\''.$obj.'\')">
			<img class="smile" src="'.BASE_PATH.'modules/forum/bbeditor/smiles/new_russian.gif" onClick="doSmile(\'new_russian\',\''.$obj.'\')">
		</div>
		<textarea name="message" id="'.$obj.'" class="inptext">'.$value.'</textarea>';
	}
}