<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Install_admin
 *
 * Установка/удаление модулей
 */
class Install_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'install';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * Выводит контент модуля
	 * @return boolean true
	 */
	public function show_module()
	{
		$rows = $this->get_rows();
		$module_rows = array('news', 'clauses', 'feedback', 'faq', 'shop', 'files', 'comments', 'rating',
				     'tags', 'photo', 'votes', 'subscribtion', 'usersite', 'forum');

		foreach($rows as $row)
		{
			if(! in_array($row, $module_rows))
			{
				$module_rows[] = $row;
			}
		}
		foreach($module_rows as $k => $val)
		{
			if(!in_array($val, $rows))
			{
				unset($module_rows[$k]);
			}
		}

		if($this->diafan->page == 2)
		{
			echo '<font color="red">'._ADMIN_MODULES_INSTALLED.'</font>';
		}
		echo '<p>'._ADMIN_INSTALL_ACCESSIBLE_INSTALL.':</p>
		<form action="'.path_module($this->diafan).'save1/" method="POST">';
		foreach($module_rows as $row)
		{
			$name  = $row;
			$const = strtoupper('_LANG_'.$row);

			if(defined($const))
			{
				$name = constant($const);
			}
			echo '<p><input type="checkbox" name="'.$row.'" '.(DB::where("adminsite", "rewrite='".$row."'", "id") ? 'checked' : '').'> <b>'.$name.'</b></p>';
			$k = 1;
		}
		echo '<input type="submit" value="'._ADMIN_TO_INSTALL.'" class="button" onmouseover="this.style.cursor=\'hand\';">';
		echo '
		</form>';

		return TRUE;
	}

	/**
	 * Установка/удаление модулей
	 * @return boolean true
	 */
	public function save_module()
	{
		$rows = $this->get_rows();
		if(! $rows)
		{
			$this->diafan = $this->goto_diafan(path_module($this->diafan, 1).'page2/');
		}

		global $count_lang;
		$count_lang = count($this->diafan->language_all);
		
		define('IS_INSTALL', 1);
		foreach($rows as $row)
		{
			$ins = DB::where("adminsite", "rewrite='".$row."'", "id");

			if(empty($_POST[$row]) && ! $ins || ! empty($_POST[$row]) && $ins)
				continue;

			include_once(ABSOLUTE_PATH."modules/".$row.'/'.$row.".install.php");

			if(empty($_POST[$row]) && $ins)
			{
				$func = 'module_basic_uninstall_'.$row;
				if(function_exists($func))
				{
					$func();
				}
				$this->diafan->_cache->delete('', $row);
				continue;
			}

			foreach($sql as $s)
			{
				DB::query($s);
			}
			$func = 'module_basic_'.$row;
			if(function_exists($func))
			{
				$func();
			}
		}

		$this->diafan->goto_diafan(path_module($this->diafan, 1).'page2/');

		return TRUE;
	}

	/**
	 * Получает список всех модулей которые можно установить
	 *
	 * @return array
	 */
	private function get_rows()
	{
		$rows = array();
		if(! $dirr = @opendir(ABSOLUTE_PATH.'modules'))
		{
			return $rows;
		}
		while(($row = readdir($dirr)) !== false)
		{	  
			if(file_exists(ABSOLUTE_PATH.'modules/'.$row.'/'.$row.'.install.php'))
			{
				$rows[] = $row;
			}
		}
		return $rows;
	}
}

/**
 * Адаптирует SQL запрос под текущее количество языковых версий сата
 *
 * @return string
 */
function multilang($str)
{
	global $count_lang;
	$result = '';

	$arg = func_get_args();

	for($i = 1; $i <= $count_lang; $i++)
	{
		if(isset($arg[$i-1]))
		{
			$str = $arg[$i-1];
		}

		if($i == 1)
		{
			$k = '';
		}
		else
		{
			$k = $i;
		}
		$result .= str_replace('LANG', $k, $str).' ';
	}
	return $result;
}