<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Language_admin_list
 *
 * Редактирование списка языковых версий сайта
 */
class Language_admin_list extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'languagelist';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'language';

	/**
	 * @var array список полей в таблицах базы данных, подлежащих переводу
	 */
	protected $array_language = array();

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'		=>'text',
			'shortname'	=>'text'
		);		
		
		$this->config_module = array(
			'del'	=> 1	//удалить
		);
		
		$this->array_language=array(
			'info' => array(
				'text'
			),
			'images' => array(
				'alt',
				'title'
			),
			'param' => array(
				'name'
			),
			'param_element' => array(
				'value'
			),
			'param_select' => array(
				'name'
			),
			'site' => array(
				'name',
				'title',
				'text',
				'keywords',
				'descr',
				'title_meta',
				'act'
			),
			'news' => array(
				'name',
				'act',
				'keywords',
				'descr',
				'title_meta',
				'anons',
				'text'
			),
			'news_category' => array(
				'name',
				'act',
				'keywords',
				'descr',
				'title_meta',
				'anons',
				'text'
			),
			'clauses' => array(
				'name',
				'act',
				'keywords',
				'descr',
				'title_meta',
				'anons',
				'text'
			),
			'clauses_category' => array(
				'name',
				'act',
				'keywords',
				'descr',
				'title_meta',
				'anons',
				'text'
			),
			'faq' => array(
				'name',
				'act',
				'keywords',
				'descr',
				'title_meta',
				'anons',
				'text'
			),
			'faq_category' => array(
				'name',
				'act',
				'keywords',
				'descr',
				'title_meta',
				'anons',
				'text'
			),
			'photo' => array(
				'name',
				'act',
				'keywords',
				'descr',
				'title_meta',
				'anons',
				'text'
			),
			'photo_category' => array(
				'name',
				'act',
				'keywords',
				'descr',
				'title_meta',
				'anons',
				'text'
			),
			'files' => array(
				'name',
				'act',
				'keywords',
				'descr',
				'title_meta',
				'anons',
				'text'
			),
			'files_category' => array(
				'name',
				'act',
				'keywords',
				'descr',
				'title_meta',
				'anons',
				'text'
			),
			'shop' => array(
				'name',
				'act',
				'keywords',
				'descr',
				'title_meta',
				'anons',
				'text'
			),
			'shop_category' => array(
				'name',
				'act',
				'keywords',
				'descr',
				'title_meta',
				'anons',
				'text'
			),
			'votes' => array(
				'name'
			),
			'votes_category' => array(
				'name',
				'act'
			),
			'subscribtion' => array(
				'name',
				'text'
			),
			'subscribtion_category' => array(
				'name',
				'text'
			),
			'tags_name' => array(
				'name'
			)
		);
	}

	/**
	 * Выводит контент модуля
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_LANGUAGE_ADD);
		echo '<table border="0" cellpadding="1" cellspacing="3" class="list">';
		$this->list_row();	
		echo '</table>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Сокращенное название языка на латинице"
	 * 
	 * @return boolean true
	 */
	protected function edit_shortname_module()
	{
		echo '
		<tr'.$this->get_other().'>
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td>
				<input type="text" name="'. $this->key.'" size="40" value="'
				.($this->diafan->edit == 1
				 ?  LANGUAGE_BASE.'" disabled'
				 : (! $this->diafan->addnew ? str_replace('"', '&quot;', $this->value):'').'"'
				).'>
				'.$this->show_help_row().'
			</td>
		</tr>
		<tr>
			<td></td>
			<td align="left">
				<a href="'.BASE_PATH_HREF.'language/site'.$this->diafan->edit.'/">'._ADMIN_LANGUAGE_EDIT_FILE.'</a>
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Сохранение поля "Сокращенное название языка на латинице"
	 * 
	 * @return boolean
	 */
	protected function save_shortname_module()
	{
		if($this->diafan->save == 1)
		{
			$this->query[] = "shortname='%s'";		
			$this->value[] = '';
			return FALSE;
		}
		$shortname = (! empty($_POST["shortname"]) ? $_POST["shortname"] : $_POST["name"]);
		$shortname = substr($this->diafan->translit($shortname), 0, 3);
		
		$this->query[] = "shortname='%s'";		
		$this->value[] = $shortname;
		return TRUE;
	}

	/**
	 * Добавление языкового интерфейса (вместо основной функции)
	 * 
	 * @return boolean
	 */
	public function new_module()
	{
		DB::query("INSERT INTO {".$this->table."} () VALUES ()");
		$this->diafan->save = DB::next_id($this->table);
		
		if(! $this->diafan->save)
		{
			echo '<script language="javascript" type="text/javascript">alert(\''
			.sprintf(_ADMIN_ERROR_INSERT_INTO, DB_PREFIX.$this->table)
			.'\');history.go(-1);</script>';
			return;
		}

		foreach ($this->array_language as $tab => $filds)
		{
			$creattable = DB::fetch_array(DB::query("SHOW CREATE TABLE {".$tab."}"));

			if($creattable)
			{
				foreach ($filds as $f)
				{
					if(preg_match("/".$f."` ([^\n]+),\n/", $creattable['Create Table'], $ob))
					{
						DB::query("ALTER TABLE {".$tab."} ADD `".$f.$this->diafan->save."`".$ob[1]." AFTER `".$f."`");
					}
				}
			}
		}

		DB::query("UPDATE {site} set act".$this->diafan->save."='1' WHERE id=1");

		$this->save_module();
		return TRUE;
	}

	/**
	 * Удаление языкового интерфейса (вместо основной функции)
	 * 
	 * @return boolean
	 */
	public function del_module()
	{
		if($this->diafan->admin_roles('del'))
		{
			$this->diafan->goto_diafan(URL);
			return FALSE;
		}
		
		if($this->diafan->del == 1 || !$this->diafan->del)
		{
			$this->diafan->goto_diafan(URL.'error11/');
			return FALSE;
		}
		
		foreach ($this->array_language as $tab => $filds)
		{
			$creattable = DB::fetch_array(DB::query("SHOW CREATE TABLE {".$tab."}"));
			
			if($creattable)
			{
				foreach ($filds as $f)
				{
					if(preg_match('/'.$f.'` ([^,]+),/', $creattable['Create Table'], $ob))
					{
						DB::query("ALTER TABLE {".$tab."} DROP `".$f.$this->diafan->del."`");
					}
				}
			}
		}

		DB::query("DELETE FROM {".$this->table."} WHERE id=%d", $this->diafan->del);

		if(_LANG == $this->diafan->del)
		{
			$this->diafan->goto_diafan(BASE_PATH.'language/');		
		}
		else
		{
			$this->diafan->goto_diafan(URL);
		}	    
		return TRUE;
	}
}