<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Map_model
 *
 * Модель модуля "Карта сайта"
 */
class Map_model extends Model
{
	/**
	 * @var array сгенерированные в моделе данные, передаваемые в шаблон
	 */
	protected $result;

	/**
	 * @var object основной объект системы
	 */
	protected $diafan;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * Генерирует данные для карты сайта
	 * 
	 * @return array
	 */
	public function show_list()
	{
		$this->map_parent_id();
		return $this->result;
	}

	/**
	* Формирует URL страниц сайта
	* 
	* @param integer $parent_id номер страницы-родителя
	* @param integer $margin отступ слева
	* @return boolean true
	*/
	private function map_parent_id($parent_id = 0, $margin = 0)
	{
		
		if($parent_id != 0)
		{
			$margin += 10;
		}
		$result = DB::query("SELECT id, [name], othurl, addmodule FROM {site} WHERE [act]='1' AND parent_id='%d' AND trash='0'"
				    ." ORDER BY sort ASC, id ASC", $parent_id);
		while ($row = DB::fetch_array($result))
		{ 
			$link = (! empty($row['othurl'])
				? $row["othurl"].' target="_blank'
				: ($row["id"] != 1
				  ? (! empty($this->diafan->rewrites[$row["id"]]['rewrite'])
				     ? $this->diafan->rewrites[$row["id"]]['rewrite'].'/' : '')
				  : ''
				  )
				);

			$this->result[] = array("margin" => $margin, "link" => $link, "name" => $row["name"]);

			if($row["addmodule"] == "files" || $row["addmodule"] == "shop" || $row["addmodule"] == "photo"
			   || $row["addmodule"] == "clauses" || $row["addmodule"] == "news" || $row["addmodule"] == "faq")
			{
				if($this->diafan->configmodules("cat", $row["addmodule"], _LANG, $row["id"]))
				{
					$this->map_module_category(0, $row["id"], $margin, $row["addmodule"]);
				}
				else
				{
					//$this->map_module_element(0, $margin, $row["addmodule"]);	
				}
			}
			$this->map_parent_id($row["id"], $margin);
		}
		return TRUE;
	}

	/**
	* Формирует URL страниц категорий модуля
	* 
	* @param integer $id номер родителя
	* @param integer $site_id номер страницы
	* @param integer $margin отступ слева
	* @param string $module название модуля
	* @return boolean true
	*/
	private function map_module_category($id, $site_id, $margin, $module)
	{
		$margin += 20;
		$result = DB::query("SELECT id, [name], site_id FROM {".$module."_category} WHERE [act]='1' AND parent_id='%d' AND site_id=%d"
				    ." AND trash='0' ORDER BY sort ASC, id ASC", $id, $site_id);
		if($result)
		{
			while ($row = DB::fetch_array($result))
			{
				$link = '';
				if(! empty($this->diafan->rewrites[$module]["cat".$row["id"]]))
				{
					$link = $this->diafan->rewrites[$module]["cat".$row["id"]]["rewrite"].'/';
				}
				elseif(! empty($this->diafan->rewrites[$row["site_id"]]["rewrite"]))
				{
					$link = $this->diafan->rewrites[$row["site_id"]]["rewrite"].'/cat'.$row["id"].'/';
				}
				$this->result[] = array(
					"margin" => $margin,
					"link"   => $link,
					"name"   => $row["name"]
				);
				//$this->map_module_element($row["id"], $margin, $module);
				$this->map_module_category($row["id"], $site_id, $margin, $module);
			}
		}
		return TRUE;
	}

	/**
	* Формирует URL страниц элементов модуля
	* 
	* @param integer $id номер категории
	* @param integer $margin отступ слева
	* @param string $module название модуля
	* @return boolean true
	private function map_module_element($id, $margin, $module)
	{
		$margin += 20;
		$result = DB::query("SELECT id, [name], site_id, cat_id FROM {".$module."} WHERE [act]='1' AND trash='0'"
				    .($id ? " AND cat_id='%d'" : "")." ORDER BY sort ASC, id ASC", $id);
		if($result)
		{
			while ($row = DB::fetch_array($result))
			{
				$link = '';
				if(! empty($this->diafan->rewrites[$module]["element".$row["id"]]))
				{
					$link = $this->diafan->rewrites[$module]["element".$row["id"]]["rewrite"].'/';
				}
				elseif(! empty($this->diafan->rewrites[$module]["cat".$row["cat_id"]]))
				{
					$link = $this->diafan->rewrites[$module]["cat".$row["cat_id"]]["rewrite"].'/show'.$row["id"].'/';
				}
				elseif(! empty($this->diafan->rewrites[$row["site_id"]]["rewrite"]))
				{
					$link = $this->diafan->rewrites[$row["site_id"]]["rewrite"].'/';
				}
				$this->result[] = array(
					"margin" => $margin,
					"link"   => $link,
					"name"   => $row["name"]
				);
			}
		}
		return TRUE;
	}
	*/
}