<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * News
 *
 * Контроллер модуля "Новости"
 */
class News extends Frame
{
	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct(&$diafan)
	{
		$this->diafan = &$diafan;

		$this->rewrite_variable_names = array('page', 'show', 'cat', 'year', 'month');
		if($this->diafan->configmodules("comments") || $this->diafan->configmodules("comments_cat") && ! $this->diafan->show && $this->diafan->cat)
		{
			$this->rewrite_variable_names[] = 'comments';
		}
		$this->diafan->rewrite_variable_names = $this->rewrite_variable_names;
		
		$model = new News_model($diafan);
		
		if($this->diafan->show)
		{
			$this->result = $model->id();
		}
		elseif(! $this->diafan->configmodules("cat") || $this->diafan->year || $this->diafan->month)
		{
			$this->result = $model->list_();
		}
		elseif(! $this->diafan->cat)
		{
			$this->result = $model->first_page();
		}
		else
		{
			$this->result = $model->list_category();
		}
		$this->get_global_variables();
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	public function show_module()
	{
		if($this->diafan->show)
		{
			News_view::id($this->result);
		}
		elseif($this->diafan->configmodules("cat") && ! $this->diafan->cat && !$this->diafan->year && !$this->diafan->month)
		{
			News_view::first_page($this->result);
		}
		else
		{
			if(! empty($this->result["level"]) && is_callable(array('News_view', 'list_level_'.$this->result["level"])))
			{
				$func = 'list_level_'.$this->result["level"];
				News_view::$func($this->result);
			}
			else
			{
				News_view::list_($this->result);
			}
		}
		return TRUE;
	}

	/**
	 * Шаблонная функция: блок новостей
	 * 
	 * @param object $th основной объект
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return boolean
	 */
	public function show_block($th, $attributes)
	{
		$attributes = $this->get_attributes($attributes, 'count', 'cat_id', 'photo', 'site_id', 'template');
		
		$count   = $attributes["count"] ? intval($attributes["count"]) : 3;
		$cat_id  = intval($attributes["cat_id"]);
		$site_id = intval($attributes["site_id"]);
		$photo   = intval($attributes["photo"]);

		if(($th->diafan->cid == $site_id || ! $site_id && $th->diafan->module == "news") && ! $th->diafan->show && $th->diafan->page < 2)
			return FALSE;

		include_once(ABSOLUTE_PATH.'modules/news/news.model.php');
		$model = new News_model($th->diafan);
		$result = $model->show_block($count, $cat_id, $photo, $site_id);
		
		include_once(ABSOLUTE_PATH.'modules/news/news.view.php');
		$func = 'show_block';
		if($attributes["template"])
		{
			$func .= '_'.preg_replace('/[^a-z_]+/','', $attributes["template"]);
			
		}
		News_view::$func($result);
		return TRUE;
	}

	/**
	 * Шаблонная функция: календарь архива новостей
	 * 
	 * @return boolean
	 */
	public function show_calendar(&$th, $attributes)
	{
		if($th->diafan->module != "news")
			return FALSE;

		$attributes = $this->get_attributes($attributes, 'month_hidden', 'template');
		
		$month_hidden = $attributes["month_hidden"];

		include_once(ABSOLUTE_PATH.'modules/news/news.model.php');
		$model  = new News_model($th->diafan);
		$result = $model->show_calendar($month_hidden);

		$func = 'show_calendar';
		if($attributes["template"])
		{
			$func .= '_'.preg_replace('/[^a-z_]+/','', $attributes["template"]);
			
		}
		News_view::$func($result);
		return TRUE;	
	}
}