<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * RSS лента новостей
 */

/**
 * Подготавливает текст для отображения в XML-файле
 *
 * @param string $text исходный текст
 * @return string
 */
function prepare($text)
{
	$repl = array('&nbsp', '"','&','>','<',"'");
	$replm = array(' ', '&quot;', '&amp;', '&gt;', '&lt;', '&apos;');
	
	$text = str_replace($repl, $replm, strip_tags($text));
	return $text;
}

if(! DB::query_result("SELECT COUNT(id) FROM {adminsite} WHERE rewrite='news' AND act='1'"))
{
	include(ABSOLUTE_PATH."includes/404.php");
}
$limit = 15;

if(! $rewrites = $this->_cache->get("ids", "rewrite"))
{
	$result = DB::query("SELECT rewrite, element_id, module_name, site_id, cat_id FROM {rewrite} WHERE trash='0'");
	while($row = DB::fetch_array($result))
	{
		if($row["module_name"] == 'site')
		{
			$rewrites[$row["site_id"]] = $row;
		}
		else
		{
			if($row["cat_id"])
			{
				$rewrites[$row["module_name"]]["cat".$row["cat_id"]] = $row;
			}
			else
			{
				$rewrites[$row["module_name"]]["element".$row["element_id"]] = $row;
			}
		}
	}
	$this->_cache->save($rewrites, "ids", "rewrite");
}

$result = DB::query("SELECT id, created, [name], [anons], cat_id, site_id FROM {news} WHERE [act]='1' AND trash='0'"
		    ." AND created<'%d' ORDER BY prior DESC, created DESC, id DESC LIMIT ".$limit, time());

$last  = '';
$item  = '';
$pages = array();

while($row = DB::fetch_array($result))
{
	if(! $this->configmodules("cat", "news", _LANG, $row["site_id"]))
	{
		$row["cat_id"] = 0;
	}
	$link = BASE_PATH_HREF;
	if(! empty($rewrites["news"]["element".$row["id"]]))
	{
		$link .= $rewrites["news"]["element".$row["id"]]["rewrite"].'/';
	}
	elseif(! empty($rewrites["news"]["cat".$row["cat_id"]]))
	{
		$link .= $rewrites["news"]["cat".$row["cat_id"]]["rewrite"].'/show'.$row["id"].'/';
	}
	elseif(! empty($rewrites[$row["site_id"]]["rewrite"]))
	{
		$link .= $rewrites[$row["site_id"]]["rewrite"].($row["cat_id"] ? '/cat'.$row["cat_id"] : '').'/show'.$row["id"].'/';
	}
	else
	{
		$link .= ($row["cat_id"] ? 'cat'.$row["cat_id"].'/' : '').'show'.$row["id"].'/';
	}
	if(empty($last))
	{
		$last = date("D, d F Y H:i:s T", $row['created']);
	}
	$item .= "
	<item>
		<title>".prepare($row['name'])."</title>
		<link>".$link."</link>
		<description>".prepare($row['anons'])."</description>
		<pubDate>".date("D, d F Y H:i:s T", $row['created'])."</pubDate>"
		.($this->configmodules("comments", "news", _LANG, $row["site_id"]) ? "
		<comments>".$link."</comments>" : "")."
	</item>";
}

$xml = '<?xml version="1.0"?>
<rss version="2.0">
	<channel>
		<title>'._LANG_NEWS.'</title>
		<link>'.BASE_PATH_HREF.'</link>
		<description>'._LANG_LAST_NEWS.' '.BASE_URL.'.</description>
		<language>ru-ru</language>
		<lastBuildDate>'.$last.'</lastBuildDate>
		<generator>diafan.CMS version 4.3</generator>
		'.$item.'
	</channel>
</rss>';

header('Content-type: application/xml'); 
header('Connection: close');
//header('Content-Length: '. utf::strlen($xml));
header('Content-Type: text/html; charset=utf-8');
header('Date: '.date('r'));
echo $xml;
exit;