<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * News_view
 *
 * Шаблон модуля "Новости"
 */
class News_view
{
	/**
	 * Шаблон списка новостей
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function list_($result)
	{
		//название и описание раздела
		echo '
		<div class="news-list">';

		echo (! empty($result["text"]) ? '
			<div class="news-cat-text">'.$result["text"].'</div>' : '');

		if(! empty($result["img"]))
		{
			echo '<div class="news-cat-img">';
			if(! empty($result["img"]["link"]))
			{
				echo '<a href="'.BASE_PATH_HREF.$result["img"]["link"].'">'.$result["img"]["tag"].'</a>';
			}
			elseif(! empty($result["img"]))
			{
				foreach($result["img"] as $img)
				{
					echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
				}
			}
			echo '</div>';
		}

		//ссылки на подразделы
		if(! empty($result["children"]))
		{
			foreach($result["children"] as $child)
			{
				echo '
				<div class="news-cat-links"><a href="'.BASE_PATH_HREF.$child["link"].'">'.$child["name"].'</a></div>
				'.($child["anons"] ? '<div class="news-cat-text">'.$child["anons"].'</div>' : '');
				if(! empty($child["img"]))
				{
					echo '<div class="news-cat-img">';
					if(! empty($child["img"]["link"]))
					{
						echo '<a href="'.BASE_PATH_HREF.$child["img"]["link"].'">'.$child["img"]["tag"].'</a>';
					}
					elseif(! empty($child["img"]))
					{
						foreach($child["img"] as $img)
						{
							echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
						}
					}
					echo '</div>';
				}
			}
		}

		//новости
		if(! empty($result["rows"]))
		{
			foreach($result["rows"] as $row)
			{
				echo '
				<div class="news">';
					if(! empty($row["img"]))
					{
						echo '
						<div class="news-img">';
						if(! empty($row["img"]["link"]))
						{
							echo '<a href="'.BASE_PATH_HREF.$row["img"]["link"].'">'.$row["img"]["tag"].'</a>';
						}
						elseif(! empty($row["img"]))
						{
							foreach($row["img"] as $img)
							{
								echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
							}
						}
						echo '</div>';
					}
					echo (! empty($row['date']) ? '
					<div class="news-date">'.$row["date"]."</div>" : '').'
					<div class="news-name"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a></div>
					'.(! empty($row["anons"]) ? '<div class="news-text">'.$row["anons"].'</div>' : '').'
					'.(! empty($row["show-rating"]) ? $row["show-rating"] : '').'
					'.(! empty($row["tags"]) ? $row["tags"] : '').'
				</div>';
			}
			echo '<div class="clear"></div>';
		}

		echo Paginator_view::get($result["paginator"])

		.(! empty($result["previous"]) ? '
		<div class="previous-link"><a href="'.BASE_PATH_HREF.$result["previous"]["link"].'">&larr; '.$result["previous"]["text"].'</a></div>' : '')

		.(! empty($result["next"]) ? '
		<div class="next-link"><a href="'.BASE_PATH_HREF.$result["next"]["link"].'">'.$result["next"]["text"].' &rarr;</a></div>' : '')

		.'<div class="clear"></div>'

		.(! empty($result["comments"]) ? $result["comments"] : '')
		.'
		</div>';

		return TRUE;
	}

	/**
	 * Шаблон первой страницы модуля "Новости"
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean
	 */
	public function first_page($result)
	{
		if(empty($result["categories"]))
			return FALSE;

		foreach($result["categories"] as $cat_id => $cat)
		{
			//название и описание категории
			echo '
			<div class="news-list">
				<h2>'.$cat["name"].'</h2>'
				
				.(! empty($cat["anons"]) ? '
				<div class="news-cat-text">'.$cat["anons"].'</div>' : '');

				if(! empty($cat["img"]))
				{
					echo '<div class="news-cat-img">';
					if(! empty($cat["img"]["link"]))
					{
						echo '<a href="'.BASE_PATH_HREF.$cat["img"]["link"].'">'.$cat["img"]["tag"].'</a>';
					}
					elseif(! empty($cat["img"]))
					{
						foreach($cat["img"] as $img)
						{
							echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
						}
					}
					echo '</div>';
				}

			//ссылки на подкатегории
			if(! empty($cat["children"]))
			{
				foreach($cat["children"] as $child)
				{
					echo '
					<div class="news-cat-links"><a href="'.BASE_PATH_HREF.$child["link"].'">'.$child["name"].'</a></div>
					'.(! empty($child["anons"]) ? '<div class="news-cat-text">'.$child["anons"].'</div>' : '');
					if(! empty($child["img"]))
					{
						echo '<div class="news-cat-img">';
						if(! empty($child["img"]["link"]))
						{
							echo '<a href="'.BASE_PATH_HREF.$child["img"]["link"].'">'.$child["img"]["tag"].'</a>';
						}
						elseif(! empty($child["img"]))
						{
							foreach($child["img"] as $img)
							{
								echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
							}
						}
						echo '</div>';
					}
				}
			}
			
			//новости в категории
			if($cat["rows"])
			{
				foreach($cat["rows"] as $row)
				{
					echo '
					<div class="news">';
						if(! empty($row["img"]))
						{
							echo '
							<div class="news-img">';
							if(! empty($row["img"]["link"]))
							{
								echo '<a href="'.BASE_PATH_HREF.$row["img"]["link"].'">'.$row["img"]["tag"].'</a>';
							}
							elseif(! empty($row["img"]))
							{
								foreach($row["img"] as $img)
								{
									echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
								}
							}
							echo '</div>';
						}
						echo (! empty($row['date']) ? '
						<div class="news-date">'.$row["date"]."</div>" : '').'
						<div class="news-name"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a></div>
						'.(! empty($row["anons"]) ? '<div class="news-text">'.$row["anons"].'</div>' : '').'
						'.(! empty($row["show-rating"]) ? $row["show-rating"] : '').'
						'.(! empty($row["tags"]) ? $row["tags"] : '').'
					</div>';
				}
			}
			//ссылка на все новости в категории
			echo ($cat["allnews"] ? '
			      <div class="show-all"><a href="'.BASE_PATH_HREF.$cat["allnews"]["link"].'">'.$cat["allnews"]["text"].'</a></div>' : '')
			.'
			</div>';
		}

		return TRUE;
	}

	/**
	 * Шаблон страницы с новостью
	 * 
	 * @param array $row данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function id($row)
	{
		echo '
		<div class="news-id">'
			.(! empty($row["show-rating"]) ? $row["show-rating"] : '')
			
			.(! empty($row["date"]) ? '
			  <div class="news-date">'.$row["date"]."</div>\n" : '')

			.($row['anons'] ? '<div class="news-anons">'.$row['anons'].'</div>' :'').'
			<div class="news-text">'.$row['text'].'</div>'

			.(! empty($row["tags"]) ? $row["tags"] : '');

			if(! empty($row["img"]))
			{
				echo '
				<div class="news-all-img">';
				if(! empty($row["img"]["link"]))
				{
					echo '<a href="'.BASE_PATH.$row["img"]["link"].'">'.$row["img"]["tag"].'</a>';
				}
				elseif(! empty($row["img"]))
				{
					foreach($row["img"] as $img)
					{
						echo ' <a href="'.BASE_PATH.$img["link"].'">'.$img["tag"].'</a>';
					}
				}
				echo '</div>';
			}

			echo
			(! empty($row["add-rating"]) ? $row["add-rating"] :'')

			.(! empty($row["previous"]) ? '
		        <div class="previous-link"><a href="'.BASE_PATH_HREF.$row["previous"]["link"].'">&larr; '.$row["previous"]["text"].'</a></div>' : '')

			.(! empty($row["next"]) ? '
		        <div class="next-link"><a href="'.BASE_PATH_HREF.$row["next"]["link"].'">'.$row["next"]["text"].' &rarr;</a></div>' : '')

			.(! empty($row["allnews"]) ? '
		        <div class="show-all"><a href="'.BASE_PATH_HREF.$row["allnews"]["link"].'">'.$row["allnews"]["text"].'</a></div>' : '')
		.'
		</div>';
		echo (! empty($row["comments"]) ? $row["comments"] : '');

		return TRUE;
	}

	/**
	 * Шаблонная функция: блок новостей
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function show_block($result)
	{
		if(empty($result["rows"]))
		{
			return FALSE;
		}
		echo '
		<div class="news-block">'
		.(! empty($result["name"]) ? '<h2>'.$result["name"].'</h2>' : '');
		foreach($result["rows"] as $row)
		{
			echo '
			<div class="news">';
			if(! empty($row["img"]))
			{
				echo '
				<div class="news-img">';
				if(! empty($row["img"]["link"]))
				{
					echo '<a href="'.BASE_PATH_HREF.$row["img"]["link"].'">'.$row["img"]["tag"].'</a>';
				}
				elseif(! empty($row["img"]))
				{
					foreach($row["img"] as $img)
					{
						echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
					}
				}
				echo '</div>';
			}
			echo (! empty($row["date"]) ? '
				<div class="news-date">'.$row["date"].'</div>' : '').'
				<div class="news-name"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row['name'].'</a></div>
				<div class="news-anons">'.$row['anons'].'</div>
			</div>';
		}

		//ссылка на все новости
		echo (! empty($result["allnews"]) ? '
		      <div class="show-all"><a href="'.BASE_PATH_HREF.$result["allnews"]["link"].'">'.$result["allnews"]["text"].'</a></div>' : '').'
		</div>';

		return TRUE;
	}

	/**
	 * Шаблонная функция: календарь архива новостей 
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function show_calendar($result)
	{
		echo '
		<div class="news-calendar">
			<h2>'._LANG_ARCHIVE.'</h2>';
		
		foreach($result["rows"] as $key => $values)
		{
			echo '
			<div class="news-year"><a href="'.BASE_PATH_HREF.$values["year"]["link"].'">'.$values["year"]["name"].'</a></div>';
			if($result["year"] == $key && ! empty($values["months"]))
			{
				foreach($values["months"] as $keym => $month)
				{
					echo '
			<div class="news-month">'.($month["link"] ? '<a href="'.BASE_PATH_HREF.$month["link"].'">'.$month["name"].'</a>' : $month["name"]).'</div>';
				}
			}
		}
		echo '
			<div class="show-all"><a href="'.BASE_PATH_HREF.$result["link"].'">'._LANG_ALL_NEWS.'</a></div>
		</div>';

		return TRUE;
	}
}