<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Order_ajax
 *
 * Обработка запроса при оформлении заказа
 */
class Order_ajax
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * @var array внутренние сообщения
	 */
	private $result;

	/**
	 * Обрабатывает полученные данные из формы
	 * 
	 * @return boolean
	 */
	function ajax_request()
	{
		if($this->diafan->configmodules('security_user', 'shop') && ! $this->diafan->_user->id)
		{
			return FALSE;
		}

		if(! empty($_POST["ajax_payment"]) && $this->diafan->configmodules("pay_systems", "shop"))
		{
			if($this->payment())
				return TRUE;
		}

		if(empty($_POST["ajax_address"]))
			return FALSE;

		if($this->check_empty_fields())
			return TRUE;

		$address = _LANG_TOWN.': '.$this->diafan->get_param($_POST, "city", '', 1)
		.'<br>'._LANG_STREET.': '.$this->diafan->get_param($_POST, "street", '', 1)
		.'<br>'._LANG_HOUSE_NUMBER.': '.$this->diafan->get_param($_POST, "home", '', 1)
		.'<br>'._LANG_BLOCK.': '.$this->diafan->get_param($_POST, "corps", '', 1)
		.'<br>'._LANG_FLAT.': '.$this->diafan->get_param($_POST, "flat", '', 1)
		.'<br>'._LANG_CONTACTS.': '.$this->diafan->get_param($_POST, "phone", '', 1);

		$address_sql = (! $this->diafan->_user->id
			        ? $this->diafan->get_param($_POST, "fio", '', 1)
			          .', '.$this->diafan->get_param($_POST, "mail", '', 1).'<br><br>'._LANG_ADDRESS.':<br><br>'
			        : '')
		               .$address;

		DB::query("INSERT INTO {shop_order} (user_id, address, more, created, status, language, summ) VALUES ('%d', '%s', '%h', '%d', '0', '%d', '%f')",
			  $this->diafan->_user->id,
			  $address_sql,
			  $_POST["more"],
			  time(),
			  _LANG,
			  $_SESSION["basket-summ"]
			  );

		$order_id = DB::next_id("shop_order");
		$summ = 0;

		foreach($_SESSION["basket"] as $shop_id => $array)
		{
			foreach($array as $param => $c)
			{
				$price = 0;
				$select_depend = 0;

				DB::query("INSERT INTO {shop_goods} (order_id, good, count_goods) VALUES ('%d', '%d', '%d')", $order_id, $shop_id, $c["count"]);
				$shop_good_id = DB::next_id("shop_goods");

				foreach($c["param"] as $id => $value)
				{
					if($id == 'depend')
					{
						$depend = DB::fetch_array(DB::query("SELECT param_id, price FROM {shop_price} WHERE shop_id=%d AND param_value=%d", $shop_id, $value));
						if(! $depend)
						{
							continue;
						}
						$select_depend =  $value;
						$price = $depend["price"];
					}
					else
					{
						DB::query("INSERT INTO {param_element} (element_id, module_name, value, param_id) "
				                  ."VALUES ('%d', 'shopgoods', '%d', '%d')", $shop_good_id, $value, $id);
					}
				}
				if(! $price)
				{
					$price = DB::query_result("SELECT price FROM {shop_price} WHERE shop_id=%d", $shop_id);
				}

				DB::query("UPDATE {shop_goods} SET price=%f, depend_price=%d WHERE id=%d", $price, $select_depend, $shop_good_id);
				$summ += $price * $c["count"];
			}
		}
		DB::query("UPDATE {shop_order} SET summ='%f' WHERE id='%d'", $summ, $order_id);
		$this->send_mails($order_id, $address);

		$_SESSION["order"][] = $order_id;

		unset($_SESSION["basket"]);

		if(! $this->diafan->configmodules("pay_systems", "shop"))
		{
			unset($_SESSION["order-pay"]);
			unset($_SESSION["basket-summ"]);
			unset($_SESSION["basket-count"]);
			$this->result["form"] = $this->diafan->configmodules('mes', 'shop');
			$this->result["basket"] = 0;
			$this->result["basketcount"] = 0;
		}
		else
		{
			$_SESSION["order-pay"] = TRUE;
			$this->result["redirect"] = BASE_PATH_HREF.$this->diafan->path_module_variable("step")."step3/";
		}
		return $this->send_errors();
	}

	/**
	 * Проверяет заполнение обязательных полей
	 * 
	 * @return boolean
	 */
	private function check_empty_fields()
	{
		
		if(! $_POST["phone"])
		{
			$this->result["errors"]["phone"] = _LANG_ENTER_FIELD_PHONE;
		}
		if($this->diafan->_user->id && empty($this->result["errors"]))
		{
			$query = 'city='  .str_replace("\n", '', $this->diafan->get_param($_POST, "city", '', 1))."\n"
			        .'street='.str_replace("\n", '', $this->diafan->get_param($_POST, "street", '', 1))."\n"
			        .'home='  .str_replace("\n", '', $this->diafan->get_param($_POST, "home", '', 1))."\n"
			        .'corps=' .str_replace("\n", '', $this->diafan->get_param($_POST, "corps", '', 1))."\n"
			        .'flat='  .str_replace("\n", '', $this->diafan->get_param($_POST, "flat", '', 1))."\n"
			        .'phone=' .str_replace("\n", '', $this->diafan->get_param($_POST, "phone", '', 1));
				DB::query("UPDATE {users_site} SET address='%s' WHERE id = '%d'",$query, $this->diafan->_user->id);
		}
		else
		{
			if(empty($_POST["fio"]))
			{
				$this->result["errors"]["fio"] = _LANG_ENTER_NAME_SURNAME;
			}
			if(empty($_POST["mail"]))
			{
				$this->result["errors"]["mail"] = _LANG_ENTER_FIELD_MAIL;
			}
			else
			{
				require_once(ABSOLUTE_PATH.'includes/validate.php');
				$mes = Validate::mail($_POST["mail"]);
				if($mes)
				{
					$this->result["errors"]["mail"] = $mes;
				}
			}
		}
		return $this->send_errors();
	}

	/**
	 * Отправляет письма администратору сайта и пользователю, сделавшему заказ
	 * 
	 * @return boolean
	 */
	private function send_mails($order_id, $address)
	{
		require_once (ABSOLUTE_PATH.'includes/mail.php');

		$model = new Basket_model($this->diafan);
		$result_basket = $model->form();
		$basket = Order_view::table_basket($result_basket);

		//send mail admin
		$subject = str_replace(array('%title', '%url'),
				       array(TITLE, BASE_URL),
				       $this->diafan->configmodules('subject-admin', 'shop')
				       );

		$user_email = $this->diafan->_user->mail ? $this->diafan->_user->mail : $this->diafan->get_param($_POST, "mail", '', 1);
		$message = str_replace(
				    array('%title',
					  '%url',
					  '%id',
					  '%fio',
					  '%email',
					  '%address',
					  '%order',
					  '%more'
					  ),
				    array(
					  TITLE,
					  BASE_URL,
					  $order_id,
					  ($this->diafan->_user->id ? $this->diafan->_user->fio : $this->diafan->get_param($_POST, "fio", '', 1)),
					  $user_email,
					  $address,
					  $basket,
					  $this->diafan->get_param($_POST, "more", '', 1)
					  ),
				    $this->diafan->configmodules('message-admin', 'shop'));

		send_mail(($this->diafan->configmodules("emailconfadmin", 'shop') ? $this->diafan->configmodules("email-admin", 'shop') : EMAIL_CONFIG),
			  $subject,
			  $message,
			  ($this->diafan->configmodules("emailconf", 'shop') ? $this->diafan->configmodules("email", 'shop') : '')
			  );

		//send mail user
		if(! $user_email)
		{
			return FALSE;
		}
		
		$subject = str_replace(
				array('%title', '%url'),
				array(TITLE, BASE_URL),
				$this->diafan->configmodules('subject', 'shop')
				);

		$message = str_replace(
				array('%title', '%url', '%id', '%fio', '%order'),
				array(
				      TITLE,
				      BASE_URL,
				      $order_id,
				      ($this->diafan->_user->id ? $this->diafan->_user->fio : $this->diafan->get_param($_POST, "fio", '', 1)),
				      $basket
				),
				$this->diafan->configmodules('message', 'shop')
			);

		send_mail(
			  $user_email,
			  $subject,
			  $message,
			  ($this->diafan->configmodules("emailconf", 'shop') ? $this->diafan->configmodules("email", 'shop') : '')
			  );
		return TRUE;
	}

	/**
	 * Результат выбора платежной системы
	 * 
	 * @return boolean
	 */
	function payment()
	{
		if(empty($_SESSION["order"]) || ! is_array($_SESSION["order"]))
			return FALSE;

		$order_id = $_SESSION["order"][count($_SESSION["order"]) - 1];

		DB::query("UPDATE {shop_order} SET payment='%d' WHERE id='%d'", $_POST["payment"], $order_id);

		if($_POST["payment"] == 4 && $this->diafan->configmodules("courier", "shop"))
		{
			$this->result["form"] = DB::where("info", "tag_name='shop_courier'", "text"._LANG);
		}
		else
		{
			$this->result["redirect"] = BASE_PATH_HREF.$this->diafan->rewrite.'/step4/show'.$order_id.'/';
		}

		unset($_SESSION["order-pay"]);
		unset($_SESSION["basket"]);
		unset($_SESSION["basket-summ"]);
		unset($_SESSION["basket-count"]);

		return $this->send_errors();
	}

	/**
	 * Отправляет несколько ошибок
	 *
	 * @return boolean
	 */
	private function send_errors()
	{
		if(! empty($this->result["errors"]) || ! empty($this->result["form"]) || ! empty($this->result["redirect"]))
		{
			if(! empty($_POST['ajax']))
			{
				include_once(ABSOLUTE_PATH.'plugins/json.php');
				echo to_json($this->result);
			}
			else
			{
				$query = '';
				if(! empty($this->result["errors"]))
				{
					foreach($this->result["errors"] as $field => $mes)
					{
						if(empty($_POST["update"]))
						{
							$query .= '&mess'.($field ? '-'.$field : '').'='.$mes;
						}
					}
				}
				$this->diafan->goto_diafan($this->diafan->path_module_variable().($query ? '?error=order'.$query : ''));
			}
			return TRUE;
		}
		return FALSE;
	}
}