<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Order
 *
 * Контроллер модуля "Оформление заказа"
 */
class Order extends Frame
{
	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct(&$diafan)
	{
		$this->diafan = &$diafan;
		
		$this->rewrite_variable_names = array('step', 'show');
		$this->diafan->rewrite_variable_names = $this->rewrite_variable_names;
		
		include_once(ABSOLUTE_PATH.'modules/basket/basket.model.php');

		include_once(ABSOLUTE_PATH.'modules/order/order.ajax.php');
		$ajax = new Order_ajax($diafan);
		if($ajax->ajax_request())
		{
			exit;
		}

		$model = new Order_model($diafan);
		if(! $this->diafan->_user->id && empty($this->diafan->step))
		{
			$this->result = $model->show_step_1();
		}
		elseif($this->diafan->step == 2 || $this->diafan->_user->id && empty($this->diafan->step))
		{
			$this->result = $model->show_step_2();
		}
		elseif($this->diafan->step == 3 && $this->diafan->configmodules("pay_systems", "shop"))
		{
			$this->result = $model->show_step_3();
		}
		elseif($this->diafan->step == 4 && $this->diafan->show && $this->diafan->configmodules("pay_systems", "shop"))
		{
			$this->result = $model->show_step_4();
		}

		//подтверждение или опровержение платежа
		elseif(($this->diafan->step == 5 || $this->diafan->step == 6) && $this->diafan->configmodules("pay_systems", "shop"))
		{
			$this->result = $model->show_step_5();
		}
		else
		{
			$this->diafan->goto_diafan($this->diafan->path_module_variable("step"));
		}
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean
	 */
	public function show_module()
	{
		if(! $this->diafan->_user->id && empty($this->diafan->step) && $this->result["to-step-2"])
		{
			include_once(ABSOLUTE_PATH.'modules/registration/registration.view.php');
			Order_view::show_step_1($this->result);
		}
		elseif($this->diafan->step == 2 || $this->diafan->_user->id && empty($this->diafan->step) || empty($this->diafan->step))
		{
			Order_view::show_step_2($this->result);
		}
		elseif($this->diafan->step == 3 && $this->diafan->configmodules("pay_systems", "shop"))
		{
			Order_view::show_step_3($this->result);
		}
		elseif($this->diafan->step == 4 && $this->diafan->configmodules("pay_systems", "shop"))
		{
			switch($this->result["type"])
			{
				case "webmoney":
					Order_view::webmoney($this->result);
					break;
				case "roboxchange":
					Order_view::roboxchange($this->result);
					break;
				case "non_cash":
					Order_view::non_cash($this->result);
					break;
			}
		}

		//подтверждение/опровержение платежа
		elseif(($this->diafan->step == 5 || $this->diafan->step == 6) && $this->diafan->configmodules("pay_systems", "shop"))
		{
			Order_view::show_step_5($this->result);
		}
	}
}