<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Order_view
 *
 * Шаблон модуля "Оформление заказа"
 */
class Order_view
{
	/**
	 * Шаблон первого шага в оформлении заказа
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function show_step_1($result)
	{
		echo '
		<h2>'._LANG_STEP.' 1</h2>
		
		'.self::table_basket($result).'

		'._LANG_ORDER_NOT_REGISTRATION.' <a href="'.$result["to-step-2"].'">'._LANG_NEXT.'</a>
		<br><br>
		'._LANG_ORDER_AUTHORIZATION.'
		<br>
		'.Registration_view::show_login($result["show_login"], TRUE).'
		<br>
		'._LANG_ORDER_REGISTRATION;
		
		Registration_view::form($result["registration"]);

		return TRUE;
	}
	/**
	 * Шаблон второго шага в оформлении заказа
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function show_step_2($result)
	{
		echo '
		<h2>'._LANG_STEP.' 2</h2>
		'.self::table_basket($result)
		.$result["text"]
		.'
		<br><br>
		<form method="POST" action="" class="order-form ajax">
		<input type="hidden" name="ajax_address" value="1">
		<input type="hidden" name="ajax" value="">
		'.(! $result["user"] ? '
		<div class="infofield">'._LANG_NAME_SURNAME.'<font color="red">*</font>:</div>
		<input type = "text" maxLength="70" name="fio" size="40" class="inptext" value="">
		<div class="errors error-fio"'.($result["error-fio"] ? '>'.$result["error-fio"] : ' style="display:none">').'</div>

		<div class="infofield">'._LANG_EMAIL.'<font color="red">*</font>:</div>
		<input type = "text" maxLength="70" name="mail" size="40" class="inptext" value="">
		<div class="errors error-mail"'.($result["error-mail"] ? '>'.$result["error-mail"] : ' style="display:none">').'</div>'

		: '').'

		<div class="infofield">'._LANG_CONTACTS.'<font color="red">*</font>:</div>
		<input type = "text" maxLength="70" name="phone" size="40" class="inptext" value="'.$result["phone"].'">
		<div class="errors error-phone"'.($result["error-phone"] ? '>'.$result["error-phone"] : ' style="display:none">').'</div>

		<div class="infoform">'._LANG_ADDRESS.'</div>

		<div class="infofield">'._LANG_TOWN.':</div>
		<input type = "text" maxLength="70" name="city" size="40" class="inptext" value="'.$result["city"].'">

		<div class="infofield">'._LANG_STREET .':</div>
		<input type = "text" maxLength="70" name="street" size="40" class="inptext" value="'.$result["street"].'">

		<div class="infofield">'._LANG_HOUSE_NUMBER.':</div>
		<input type = "text" maxLength="70" name="home" size="40" class="inptext" value="'.$result["home"].'">

		<div class="infofield">'._LANG_BLOCK.':</div>
		<input type = "text" maxLength="70" name="corps" size="40" class="inptext" value="'.$result["corps"].'">

		<div class="infofield">'._LANG_FLAT.':</div>
		<input type = "text" maxLength="70" name="flat" size="40" class="inptext" value="'.$result["flat"].'">

		<div class="infofield">'._LANG_MORE.':</div>
		<textarea name="more" class="inptext"></textarea>

		<br>
		<input type="submit" value="'._LANG_TO_ISSUE.'" class="button">
		</form>';

		return TRUE;
	}

	/**
	 * Шаблон третьего шага в оформлении заказа
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function show_step_3($result)
	{
		echo '
		<h2>'._LANG_STEP.' 3</h2>
		<div class="order-result">
		<form method="POST" action="" class="order-form ajax">
		<input type="hidden" name="ajax_payment" value="1">
		<input type="hidden" name="ajax" value="">
		<p>'._LANG_SELECT_PAYMENT.':</p>
		'.($result["webmoney"] ? '<p><input name="payment" value="1" type="radio" checked> WebMoney</p>' : '').'
		'.($result["robox"]    ? '<p><input name="payment" value="2" type="radio"> RoboxChange</p>' : '').'
		'.($result["non_cash"] ? '<p><input name="payment" value="3" type="radio"> '._LANG_NON_CACHE.'</p>' : '').'
		'.($result["courier"]  ? '<p><input name="payment" value="4" type="radio"> '._LANG_COURIER.'</p>' : '').'
		<input type="submit" value="'._LANG_PAY.'" class="button">
		</form>
		</div>';

		return TRUE;
	}

	/**
	 * Шаблон чтевертого шага
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function show_step_4($result)
	{
		echo $result;

		return TRUE;
	}

	/**
	 * Шаблон подтверждения/опровержения платежа
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function show_step_5($result)
	{
		echo $result;

		return TRUE;
	}

	/**
	 * Шаблон таблицы заказанных товаров
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function table_basket($result)
	{
		$text = '
		<table class="basket">
			<tr>
				<th class="basket-th-first">'._LANG_NAME_GOOD.'</th>
				<th>'._LANG_COUNT.'</th>
				<th>'._LANG_PRICE.', '.$result["currency"].'</th>
				<th class="basket-th-last">'._LANG_SUM.', '.$result["currency"].'</th>
			</tr>';

		if(! empty($result["rows"]))
		{
			foreach($result["rows"] as $row)
			{
				$text .= '
				<tr>
					<td class="basket-name"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a></td>
					<td class="basket-count">'.$row["count"].'</td>
					<td class="basket-price">'.$row["price"].'</td>
					<td class="basket-summ">'.$row["summ"].'</td>
				</tr>';
			}
		}

		$text .= '
			<tr class="basket-last-tr">
				<td class="basket-total">'._LANG_GOODS_TOTAL.'</td>
				<td class="basket-count">'.$result["count"].'</td>
				<td>&nbsp;</td>
				<td class="basket-summ" id="basket-td-last">'.$result["summ"].'</td>
			</tr>
		</table>';

		return $text;
	}

	/**
	 * Шаблон четвертого шага в оформлении заказа: платеж через систему WebMoney
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function webmoney($result)
	{
		echo 
		$result["text"]
		.'<form id=pay name=pay method="POST" action="https://merchant.webmoney.ru/lmi/payment.asp">'."\n"
		.'<b>'.sprintf(_LANG_PAYMENT_WM_TITLE, $result["summ"]).'</b> &nbsp;'
		.'<input type="hidden" name="LMI_PAYMENT_AMOUNT" value="'.$result['summ'].'">'."\n"
		.'<input type="hidden" name="LMI_PAYMENT_DESC" value="'.$result['desc'].'">'."\n"
		.'<input type="hidden" name="LMI_PAYMENT_NO" value="'.$result["order_id"].'">'."\n"
		.'<input type="hidden" name="LMI_PAYEE_PURSE" value="'.$result["wm_target"].'">'."\n"
		.(isset($result["LMI_SIM_MODE"]) ? '<input type="hidden" name="LMI_SIM_MODE" value="'.$result["LMI_SIM_MODE"].'">'."\n" : '')
		.'<input type="hidden" name="RND" value="'.$result["rnd"].'">'."\n"
		.'<p><input type="submit" value="'._LANG_PAY.'"></p>'."\n"
		.'</form>'."\n";

		return TRUE;
	}

	/**
	 * Шаблон четвертого шага в оформлении заказа: безналичный платеж
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function non_cash($result)
	{
		echo 
		$result["text"]
		.'
		<p><a href="'.BASE_PATH.'payment/ul/'.$result["order_id"].'/">'._LANG_NON_CACH_ACCOUNT_UL.'</a></p>
		<p><a href="'.BASE_PATH.'payment/fl/'.$result["order_id"].'/">'._LANG_NON_CACH_ACCOUNT_FL.'</a></p>';

		return TRUE;
	}

	/**
	 * Шаблон четвертого шага в оформлении заказа: платеж через систему Roboxchange
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function roboxchange($result)
	{
		echo 
		$result["text"]
		."<html><script language=JavaScript "
		."src='http://www.roboxchange.com/mrh_summpreview.asp?"
		."mrh=".$result["login"]."&out_summ=".$result["summ"]."&inv_id=".$result["order_id"]."&inv_desc=".$result["desc"]
		."&crc=".$result["crc"]."'></script></html>";

		return TRUE;
	}
}