<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Photo_admin_element
 *
 * Редактирование фотографий
 */
class Photo_admin_element extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'photo';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'photo';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'       => 'text',
			'act'        => 'checkbox',
			'photoone'   => 'function',
			'tags'       => 'function',
			'comments'   => 'function',
			'rate'       => 'function',
			'hr1'        => 'hr',
			'number'     => 'function',
			'timeedit'   => 'text',
			'title_meta' => 'text',
			'keywords'   => 'text',
			'descr'      => 'textarea',
			'rewrite'    => 'function',
			'cat_id'     => 'function',
			'site_id'    => 'function',
			'sort'       => 'function',
			'hr2'        => 'hr',
			'anons'      => 'editor',
			'text'       => 'editor'
		);
		
		//поля, которые прячутся в Дополнительно
		$this->variable_other = array(
			'hr1'        => 1,
			'number'     => 1,
			'title_meta' => 1,
			'timeedit'   => 1,
			'keywords'   => 1,
			'descr'      => 1,
			'rewrite'    => 1,
			'cat_id'     => 1,
			'site_id'    => 1,
			'sort'       => 1
		);
		
		//переводимые поля
		$this->language_names = array(
			'name',
			'title_meta',
			'act',
			'keywords',
			'descr',
			'text',
			'anons'
		);
		
		$this->config_module = array(
			'del'           => 1,	//удалить
			'act'           => 1,	//показать/скрыть
			'order'         => 1,	//сортируется
			'element_site'  => $this->diafan->configmodules("cat") ? 0 : 1,	//модуль может быть прикреплен к нескольким страницам
			'element'       => $this->diafan->configmodules("cat") ? 1 : 0,	//используются группы
			'photo'         => 1,	//показать фотографию в списке
			'search_name'   => 1,	//искать по названию
			'trash'         => 1	//использовать корзину
		);
		
		if(! extension_loaded('gd') && ! extension_loaded('gd2'))
		{
			$this->diafan->error = 7;
		}

		//высота поля для Визуального редактора
		$this->editor_height = array(
			'anons' => 200,
			'text'  => 400
		);
		if(! $this->diafan->edit && ! $this->diafan->addnew)
		{
			$this->config_module['multiupload'] = 1;
		}
	}

	/**
	 * Выводит список фотографий
	 * @return boolean true
	 */
	public function show_module()
	{
		echo '
		<div class="add">
			<a href="'.URL.'addnew1/">'._ADMIN_PHOTO_ADD.'</a>
			/ <a href="'.URL.'savenew1/" class="upload_files">'._ADMIN_PHOTO_ADD_SOME.'</a>
		</div>

		<div id="uploadAreaMulti">
			<div id="file-uploader">
				<noscript>
					<p>Please enable JavaScript to use file uploader.</p>
					<!-- or put a simple form for upload here -->
				</noscript>
			</div>
		</div>';

		echo '<table class="list">';
		$this->list_row($this->diafan->cat);
		echo '</table>';

		return TRUE;
	}

	/**
	 * Добавляет элемент в базу данных
	 * 
	 * @return boolean
	 */
	public function new_module()
	{
		// если сохраняли Ajaxом, отдаем положительный результат
		if(! empty($_GET["save_post"]))
		{
			header('Content-Type: text/html; charset=utf-8');
			$_POST["save_post"] = true;
			$_POST["cat_id"]    = $this->diafan->cat;
			$_POST["site_id"]   = 0;
			$_POST["rewrite"]   = '';
			$_POST["name"]      = '';
		}
		parent::new_module();
	}

	/**
	 * Производит перенаправление на страницу редактирования, на список и пр.
	 * 
	 * @return boolean true
	 */
	protected function redirect()
	{
		// если сохраняли Ajaxом, отдаем положительный результат
		if(! empty($_GET["save_post"]))
		{
			$result["success"] = TRUE;

			$photo_row = DB::fetch_array(DB::query("SELECT id, name FROM {images} WHERE element_id=%d AND module_name='%s' AND trash='0'"
												   ." ORDER BY sort ASC LIMIT 1", $this->diafan->save, $this->table));

			$result["result"] = '
			<tr altcolor="#eeeeee" class="tr">
				<td>
					<a href="'.BASE_PATH_HREF.$this->diafan->rewrite.($this->diafan->cat ? '/cat'.$this->diafan->cat : '').'/edit'.$this->diafan->save.'/"'
					.' title="Редактировать ('.$this->diafan->save.')">'
					.'<img src="http://'.BASE_URL.'/'.USERFILES.'/'.$this->diafan->rewrite.'/small/'.$photo_row["name"]."_".$photo_row["id"].'.jpg" border="0"></a>
				</td>
				<td class="tdedit" style="padding-left: 5px; width: 70%;">
					<font> <a href="'.BASE_PATH_HREF.$this->diafan->rewrite.($this->diafan->cat ? '/cat'.$this->diafan->cat : '').'/edit'.$this->diafan->save.'/" title="Редактировать ('.$this->diafan->save.')" class="noplus">'.$this->diafan->save.'</a></font>
				</td>
				<td>
					<div class="actions">
						<span>
							<nobr>
							'.(! $this->diafan->admin_roles('act') ? '
								<a href="'.URL.'unblock'.$this->diafan->save.'/" title="'._ADMIN_UNBLOCK.'"><img src="'.BASE_PATH.'img/b3.gif"></a>
							' : '').'
							'.(! $this->diafan->admin_roles('del') ? '
								<a href="'.URL.'trash'.$this->diafan->save.'/" title="'._LANG_DELETE.'"'
								.' onclick="if(! confirm(\''._ADMIN_CONFIRM_TRASH.'\')){ return false; }">'
								.'<img src="'.BASE_PATH.'img/b4.gif"></a>
							'.(! $this->diafan->admin_roles('order') ? '
							' : '').'
								<a href="'.URL.'up'.$this->diafan->save.'/" title="'._ADMIN_UP.'"><img src="'.BASE_PATH.'img/b5.gif"></a>
							' : '').'
							</nobr>
						</span>
					</div>
				</td>
				<td class="checkbox">
					<input name="ids[]" value="'.$this->diafan->save.'" type="checkbox">
				</td>
			</tr>';
			include_once(ABSOLUTE_PATH.'plugins/json.php');
			echo to_json($result);
			exit;
		}
		parent::redirect();
	}


	/**
	 * Редактирование поля "Фотография"
	 * @return boolean true
	 */
	protected function edit_photoone_module()
	{
		$photo_row = DB::fetch_array(DB::query("SELECT id, name FROM {images} WHERE element_id=%d AND module_name='%s' AND trash='0' ORDER BY sort DESC LIMIT 1", $this->diafan->edit, $this->table));

		if($photo_row && file_exists(ABSOLUTE_PATH.USERFILES."/".$this->table."/small/".$photo_row["name"]."_".$photo_row["id"].".jpg"))
		{
			list($w, $h) = getImageSize(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/'.$photo_row["name"]."_".$photo_row["id"].".jpg");
			$w += 40;
			$h += 40;
			echo "
			<tr>
				<td align=\"right\">
				</td>
				<td>
					<a href=\"#\" onclick=\"javascript: window.open('http://".BASE_URL."/".USERFILES."/".$this->table.'/'.$photo_row["name"]."_".$photo_row["id"].".jpg', ''
					, 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=".$w.",height=".$h."');
					return false;\">"
					.'<img src="http://'.BASE_URL."/".USERFILES."/".$this->table.'/small/'.$photo_row["name"]."_".$photo_row["id"].'.jpg" border="0"></a>
				</td>
			</tr>';
		}
		echo '
		<tr>
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<input type="file" name="photo" size="40">
				'.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Сохранение поля "Фотография"
	 * @return boolean true
	 */
	protected function save_photoone_module()
	{
		if(isset($_GET['qqfile']))
		{
			$_FILES["photo"]['name'] = $_GET['qqfile'];
			$_FILES["photo"]['tmp_name'] = $this->qq_temp_name();
		}
		elseif(isset($_FILES['qqfile']))
		{
			$_FILES["photo"] = $_FILES['qqfile'];
		}

		if(isset($_FILES["photo"]) && is_array($_FILES["photo"]) && $_FILES["photo"]['name'] != '')
		{
			$err = $this->upload_photoone();
			if($err)
			{
				unlink($_FILES["photo"]['tmp_name']);
				if(! empty($_SERVER["HTTP_X_REQUESTED_WITH"]) && $_SERVER["HTTP_X_REQUESTED_WITH"] == 'XMLHttpRequest')
				{
					echo '{error: "'.$err.' '.$_FILES["photo"]['tmp_name'].'"}';
					exit;
				}
				else
				{
					echo '<script language="javascript" type="text/javascript">alert(\''.$err.'\');history.go(-1);</script>';
				}
			}
		}
		unlink($_FILES["photo"]['tmp_name']);

		return TRUE;
	}

	private function qq_temp_name()
	{
        $input = fopen("php://input", "r");
		$tmpfname = tempnam(ABSOLUTE_PATH.USERFILES.'/photo', "diafan");

		$temp = fopen($tmpfname, "w");

        $realSize = stream_copy_to_stream($input, $temp);
        fclose($input);
		fclose($temp);

        if(! isset($_SERVER["CONTENT_LENGTH"]) || $realSize != (int)$_SERVER["CONTENT_LENGTH"])
		{            
            return false;
        }
		
		return $tmpfname;
    }

	/**
	 * Загружает фотографию
	 * @return string|boolean false
	 */
	private function upload_photoone()
	{
		include_once(ABSOLUTE_PATH."includes/image.php");

		$result = DB::query("SELECT id,name FROM {images} WHERE module_name='%s' AND element_id='%d'", $this->table, $this->diafan->save);
		while($row = DB::fetch_array($result))
		{
			unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/'.$row["name"].'_'.$row["id"].'.jpg');
			unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/medium/'.$row["name"].'_'.$row["id"].'.jpg');
			unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/small/'.$row["name"].'_'.$row["id"].'.jpg');
		}
		DB::query("DELETE FROM {images} WHERE module_name='%s' AND element_id='%d'", $this->table, $this->diafan->save);

		if(! isset($_FILES["photo"]) || ! is_array($_FILES["photo"]) || $_FILES["photo"]['name'] == '')
		{
			return _ADMIN_NO_FILE_FOR_UPLOAD;
		}

		$altname = $this->diafan->translit($_POST["name"]);

		$altname = substr($altname, 0, 15);

		if(empty($altname))
		{
			$altname = rand(100,  99999999);
		}

		if(! $this->diafan->configmodules("big_width") || ! $this->diafan->configmodules("big_height"))
			return _ADMIN_NO_CONFIG_BIG_SIZE;

		if(! $this->diafan->configmodules("medium_width") || ! $this->diafan->configmodules("medium_height"))
			return _ADMIN_NO_CONFIG_MEDIUM_SIZE;

		list($width, $height) = getImageSize($_FILES["photo"]['tmp_name']);
		if($width > $this->diafan->configmodules("big_width")|| $height > $this->diafan->configmodules("big_height"))
		{
			if(! Image::resize($_FILES["photo"]['tmp_name'],
				$this->diafan->configmodules("big_width"),
				$this->diafan->configmodules("big_height"),
				$this->diafan->configmodules("big_quality")
			))
				return _ADMIN_INCORRECT_FORMAT_FILE;
		}

		$size = filesize($_FILES["photo"]['tmp_name']);

		DB::query("INSERT INTO {images} (name,module_name,element_id,size) VALUES ('%s','%s','%d','%d')",
			  $altname,
			  $this->table,
			  $this->diafan->save,
			  $size
		);

		$id = DB::next_id("images");

		if (! copy($_FILES["photo"]['tmp_name'], ABSOLUTE_PATH.USERFILES."/".$this->table."/".$altname.'_'.$id.".jpg"))
			return _NO_UPLOAD_FILE;

		list($width, $height) = getImageSize( $_FILES["photo"]['tmp_name']);

		if ($width > $this->diafan->configmodules("medium_width") || $height > $this->diafan->configmodules("medium_height"))
		{
			if(! Image::resize($_FILES["photo"]['tmp_name'],
					$this->diafan->configmodules("medium_width"),
					$this->diafan->configmodules("medium_height"),
					$this->diafan->configmodules("medium_quality")
			))
				return _ADMIN_INCORRECT_FORMAT_FILE;
		}

		if (! copy($_FILES["photo"]['tmp_name'], ABSOLUTE_PATH.USERFILES."/".$this->table."/medium/".$altname.'_'.$id.".jpg"))
			return _ADMIN_NO_UPLOAD_FILE;

		list($width, $height) = getImageSize( $_FILES["photo"]['tmp_name']);

		if ($width > 50|| $height > 50)
		{		
			if(! Image::resize($_FILES["photo"]['tmp_name'], 50, 50, 70))
				return _ADMIN_INCORRECT_FORMAT_FILE;
		}
		if (! copy($_FILES["photo"]['tmp_name'], ABSOLUTE_PATH.USERFILES."/".$this->table."/small/".$altname.'_'.$id.".jpg"))
			return _ADMIN_NO_UPLOAD_FILE;

		chmod(ABSOLUTE_PATH.USERFILES."/".$this->table."/".$altname.'_'.$id.".jpg", 0755);
		chmod(ABSOLUTE_PATH.USERFILES."/".$this->table."/medium/".$altname.'_'.$id.".jpg", 0755);
		chmod(ABSOLUTE_PATH.USERFILES."/".$this->table."/small/".$altname.'_'.$id.".jpg", 0755);

		DB::query("UPDATE {images} SET sort=id WHERE sort=0");

		return FALSE;
	}
}