<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Photo_view
 *
 * Шаблон модуля "Фотогалерея"
 */
class Photo_view
{ 
	/**
	 * Шаблон списка фотографий
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function list_($result)
	{
		//название и описание категории
		echo '
		<div class="photo-list">';

		echo (! empty($result["text"]) ? '
			<div class="photo-cat-text">'.$result["text"].'</div>' : '');

		//ссылки на подкатегории
		if(! empty($result["children"]))
		{
			foreach($result["children"] as $child)
			{
				echo '
				<div class="photo-cat-links"><a href="'.BASE_PATH_HREF.$child["link"].'">'.$child["name"].'</a></div>
				'.($child["anons"] ? '<div class="photo-cat-text">'.$child["anons"].'</div>' : '');
			}
		}

		//фотографии
		if(! empty($result["rows"]))
		{
			foreach($result["rows"] as $row)
			{
				echo '
				<div class="photo">
					<div class="photo-img"><a href="'.BASE_PATH_HREF.$row["img"]["link"].'">'.$row["img"]["tag"].'</a></div>
					<div class="photo-name"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a></div>
					<div class="photo-size">('.$row["img"]["size"].')</div>
					'.(! empty($row["anons"]) ? '<div class="photo-text">'.$row["anons"].'</div>' : '').'
					'.(! empty($row["show-rating"]) ? $row["show-rating"] : '').'
					'.(! empty($row["tags"]) ? $row["tags"] : '').'
				</div>';
			}
			echo '<div class="clear"></div>';
		}

		echo Paginator_view::get($result["paginator"])

		.(! empty($result["previous"]) ? '
		<div class="previous-link"><a href="'.BASE_PATH_HREF.$result["previous"]["link"].'">&larr; '.$result["previous"]["text"].'</a></div>' : '')

		.(! empty($result["next"]) ? '
		<div class="next-link"><a href="'.BASE_PATH_HREF.$result["next"]["link"].'">'.$result["next"]["text"].' &rarr;</a></div>' : '')

		.'<div class="clear"></div>'

		.(! empty($result["comments"]) ? $result["comments"] : '')
		.'
		</div>';

		return TRUE;
	}

	/**
	 * Шаблон первой страницы фотогалереи
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function first_page($result)
	{
		if(empty($result["categories"]))
			return;
		foreach($result["categories"] as $cat_id => $cat)
		{
			//название и описание категории
			echo '
			<div class="photo-list">
				<h2>'.$cat["name"].'</h2>'
				
				.(! empty($cat["anons"]) ? '
				<div class="photo-cat-text">'.$cat["anons"].'</div>' : '');
			
			//ссылки на подкатегории
			if(! empty($cat["children"]))
			{
				foreach($cat["children"] as $child)
				{
					echo '
					<div class="photo-cat-links"><a href="'.BASE_PATH_HREF.$child["link"].'">'.$child["name"].'</a></div>
					'.(! empty($child["anons"]) ? '<div class="photo-cat-text">'.$child["anons"].'</div>' : '');
				}
			}
			
			//фотографии в категории
			if($cat["rows"])
			{
				foreach($cat["rows"] as $row)
				{
					echo '
					<div class="photo">
						<div class="photo-img"><a href="'.BASE_PATH_HREF.$row["img"]["link"].'">'.$row["img"]["tag"].'</a></div>
						<div class="photo-name"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a></div>
						<div class="photo-size">('.$row["img"]["size"].')</div>
						'.(! empty($row["anons"]) ? '<div class="photo-text">'.$row["anons"].'</div>' : '').'
						'.(! empty($row["show-rating"]) ? $row["show-rating"] : '').'
						'.(! empty($row["tags"]) ? $row["tags"] : '').'
					</div>';
				}
			}
			//ссылка на все фотографии в категории
			echo ($cat["allphoto"]?'
			      <div class="show-all"><a href="'.BASE_PATH_HREF.$cat["allphoto"]["link"].'">'.$cat["allphoto"]["text"].'</a></div>' : '')
			.'
			</div>';
		}

		return TRUE;
	}

	/**
	 * Шаблон страницы с фотографией
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	public function id($row)
	{	
		echo '<div class="photo-id">'
			//рейтинг фотографии
			.(! empty($row["show-rating"]) ? $row["show-rating"] : '')
			
			//форма оценки фотографии
			.(! empty($row["add-rating"]) ? $row["add-rating"] :'')
			
			//фотография и ссылка на просмотр большой версии
			.'<div class="photo-img">'.$row["img"]["tag"].'</div>'

			//анонс
			.($row["anons"] ? '<div class="photo-anons">'.$row["anons"].'</div>' : '')

			//описание
			.'<div class="photo-text">'.$row["text"].'</div>'
			
			//теги
			.(! empty($row["tags"]) ? $row["tags"] : '')

			.(! empty($row["previous"]) ? '
		        <div class="previous-link"><a href="'.BASE_PATH_HREF.$row["previous"]["link"].'">&larr; '.$row["previous"]["text"].'</a></div>' : '')

			.(! empty($row["next"]) ? '
		        <div class="next-link"><a href="'.BASE_PATH_HREF.$row["next"]["link"].'">'.$row["next"]["text"].' &rarr;</a></div>' : '')

			.'<div class="clear"></div>'

		.'</div>'
		.(! empty($row["comments"]) ? $row["comments"] : '');

		return TRUE;
	}

	/**
	 * Шаблонная функция: блок фотографий
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean
	 */
	public function show_block($result)
	{
		if(empty($result["rows"]))
		{
			return FALSE;
		}
		echo '<div class="photo-block">'
		.(! empty($result["name"]) ? '<h2>'.$result["name"].'</h2>' : '');
		
		//фотографии
		foreach($result["rows"] as $row)
		{
			echo '
			<div class="photo">
				<div class="photo-img"><a href="'.BASE_PATH_HREF.$row["img"]["link"].'">'.$row["img"]["tag"].'</a></div>'
				.($row["name"]?'
				<div class="photo-name">'.$row["name"].'</div>' : '').'
				<div class="photo-size">('.$row["img"]["size"].')</div>
			</div>';
		}

		//ссылка на все фотографии
		echo (! empty($result["allphoto"]) ? '
		      <div class="show-all"><a href="'.BASE_PATH_HREF.$result["allphoto"]["link"].'">'.$result["allphoto"]["text"].'</a></div>' : '').'
		</div>';

		return TRUE;
	}
}