<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Registration_ajax
 *
 * Обработка запроса при регистрации или изменении данных о пользователе
 */
class Registration_ajax
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var array внутренние сообщения
	 */
	private $result;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * Обрабатывает полученные данные из формы
	 * 
	 * @return boolean
	 */
	public function ajax_request()
	{
		if(! empty($_POST["addnew"]) && !$this->diafan->_user->id)
		{
			$this->check_captcha();
			$this->validate();

			if($this->send_errors())
				return TRUE;

			DB::query("INSERT INTO {users_site} (name, password, mail, created, language, fio, act)"
				  ." VALUES ('%h', '%h', '%h', '%d', '%d', '%h', '%d')",
				  $_POST["name"], code_password($_POST["password"]), $_POST["mail"],
				  time(), _LANG, $_POST["fio"],
				  $this->diafan->configmodules("act", "usersite") ? 0 : 1
				  );
			$save_id = DB::next_id("users_site");

			$this->send_mails($save_id);

			if(! $this->diafan->configmodules("act", "usersite"))
			{
				$this->diafan->_user->id = $save_id;
				if($_POST["url"])
				{
					$this->result["redirect"] = $_POST["url"];
					return $this->send_errors();
				}
			}

			$this->result["errors"][0] = $this->diafan->configmodules('mes', "usersite");
			$this->result["success"] = TRUE;

			return $this->send_errors();
		}
	
		if(! empty($_POST["edit"]) && $this->diafan->_user->id)
		{
			if($this->validate_edit())
				return TRUE;
			
			if(! empty($_POST["language"]) && ! DB::query_result("SELECT id FROM {language} WHERE id=%d", $_POST["language"]))
			{
				$this->result["errors"][0] = 'ERROR';
				return $this->send_errors();
			}

			DB::query("UPDATE {users_site} SET name='%h', mail='%h', language='%d', fio='%h' WHERE id=%d",
			          $_POST["name"],
			          $_POST["mail"],
			          $_POST["language"],
			          $_POST["fio"],
			          $this->diafan->_user->id
			         );

			if($_POST["password"])
			{
				DB::query("UPDATE {users_site} SET password='%h' WHERE id=%d", code_password($_POST["password"]), $this->diafan->_user->id);
			}
			$this->result["errors"][0] = _LANG_CHANGES_SAVED;

			return $this->send_errors();
		}
	}

	/**
	 * Проверяет правильность каптчи
	 * 
	 * @return boolean
	 */
	private function check_captcha()
	{
		$this->result["code"] = '';
		if($this->diafan->configmodules('security_code', "usersite"))
		{
			require_once(ABSOLUTE_PATH.'includes/captcha/captcha.inc.php');	
			$mes = Captcha_inc::is_right($this->diafan->module);
			$this->result["code"] = Captcha_inc::get($this->diafan->module, '', TRUE);				
			if($mes)
			{
				$this->result["errors"]["code"] = $mes;
				return TRUE;
			}
		}
		return FALSE;
	}

	/**
	 * Проверяет валидность введенных при регистрации данных
	 * 
	 * @return boolean true
	 */
	private function validate()
	{
		require_once(ABSOLUTE_PATH.'includes/validate.php');
		$mes = Validate::login($_POST["name"]);
		if($mes)
		{
			$this->result["errors"]["name"] = $mes;
		}
		$mes = Validate::mail($_POST["mail"]);
		if($mes)
		{
			$this->result["errors"]["mail"] = $mes;
		}
		else
		{
			$mes = Validate::mail_user($_POST["mail"]);
			if($mes)
			{
				$this->result["errors"]["mail"] = $mes;
			}
		}
		$mes = Validate::password($_POST["password"]);
		if($mes)
		{
			$this->result["errors"]["password"] = $mes;
		}
		elseif($_POST["password"] != $_POST["password2"])
		{
			$this->result["errors"]["password"] = _LANG_PASSWORDS_ARENT_SIMULAR;
		}

		if(! $_POST["fio"])
		{
			$this->result["errors"]["fio"] = _LANG_ENTER_NAME_SURNAME;
		}

		return TRUE;
	}

	/**
	 * Проверяет валидность введенных при редактировании данных
	 * 
	 * @return boolean
	 */
	private function validate_edit()
	{
		
		require_once(ABSOLUTE_PATH.'includes/validate.php');
		if($_POST["name"] != $this->diafan->_user->name)
		{
			$mes = Validate::login($_POST["name"]);
			if($mes)
			{
				$this->result["errors"]["name"] = $mes;
			}
		}
		$mes = Validate::mail($_POST["mail"]);
		if($mes)
		{
			$this->result["errors"]["mail"] = $mes;
		}
		if($_POST["mail"] != $this->diafan->_user->mail)
		{
			$mes = Validate::mail_user($_POST["mail"]);
			if($mes)
			{
				$this->result["errors"]["mail"] = $mes;
			}
		}
		if($_POST["password"])
		{
			$mes = Validate::password($_POST["password"]);
			if($mes)
			{
				$this->result["errors"]["password"] = $mes;
			}
			elseif($_POST["password"] != $_POST["password2"])
			{
				$this->result["errors"]["password"] = _LANG_PASSWORDS_ARENT_SIMULAR;
			}
		}

		if(empty($_POST["fio"]))
		{
			$this->result["errors"]["fio"] = _LANG_ENTER_NAME_SURNAME;
		}

		return $this->send_errors();
	}

	/**
	 * Отправляет письмо новому пользователю и администратору сайта
	 * 
	 * @return boolean true
	 */
	private function send_mails($save)
	{
		include_once(ABSOLUTE_PATH.'includes/mail.php');
		if($this->diafan->configmodules("sendmailadmin", "usersite"))
		{
			$subject = str_replace(
					array('%title', '%url'),
					array(TIT, BASE_URL),
					$this->diafan->configmodules('subject-admin', "usersite")
				);
			$message = str_replace(
					array('%login', '%title', '%url', '%fio', '%email'),
					array(
						$this->diafan->get_param($_POST, "name", '', 1),
						TIT,
						BASE_URL,
						$this->diafan->get_param($_POST, "fio", '', 1),
						$this->diafan->get_param($_POST, "mail", '', 1)
					),
					$this->diafan->configmodules('message-admin', "usersite")
				);
			send_mail(
				  $this->diafan->configmodules("emailconfadmin", "usersite") ? $this->diafan->configmodules("email-admin", "usersite") : EMAIL_CONFIG,
				  $subject,
				  $message,
				  $this->diafan->configmodules("emailconf", "usersite") ? $this->diafan->configmodules("email", "usersite") : ''
				  );
		}

		//send mail user
		$subject = str_replace(
				array('%title', '%url'),
				array(TITLE, BASE_URL),
				$this->diafan->configmodules('subject', "usersite")
			);

		$actlink = '';
		if($this->diafan->configmodules("act", "usersite") == 1)
		{
			$link = md5(rand(111, 99999));
			DB::query("INSERT INTO {actlink} (link,user_id,created) VALUES ('%s','%d','%d')", $link, $save, time() + 86400);
			$actlink = '<a href="'.BASE_PATH_HREF.$this->diafan->rewrite.'/?act='.$link.'">'.BASE_PATH_HREF.$this->diafan->rewrite.'/?act='.$link.'</a>';
		}

		$message = str_replace(
				array('%login', '%title', '%url', '%fio', '%password', '%actlink'),
				array(
					$this->diafan->get_param($_POST, "name", '', 1),
					TITLE,
					BASE_URL,
					$this->diafan->get_param($_POST, "fio", '', 1),
					$this->diafan->get_param($_POST, "password", '', 1),
					$actlink
				),
				$this->diafan->configmodules('message', "usersite")
			);

		send_mail(
			   $_POST["mail"],
			   $subject,
			   $message,
			   ($this->diafan->configmodules("emailconf", "usersite") ? $this->diafan->configmodules("email", "usersite") : '')
			  );
		return TRUE;
	}

	/**
	 * Отправляет несколько ошибок
	 *
	 * @return boolean
	 */
	private function send_errors()
	{
		if(! empty($this->result["errors"]) || ! empty($this->result["redirect"]))
		{
			if(! empty($_POST['ajax']))
			{
				include_once(ABSOLUTE_PATH.'plugins/json.php');
				echo to_json($this->result);
			}
			else
			{
				$query = '';
				if(! empty($this->result["errors"]))
				{
					foreach($this->result["errors"] as $field => $mes)
					{
						if(empty($_POST["update"]))
						{
							$query .= '&mess'.($field ? '-'.$field : '').'='.$mes;
						}
					}
				}
				$this->diafan->goto_diafan($this->diafan->path_module_variable().($query ? '?error=registration'.$query : ''));
			}
			return TRUE;
		}
		return FALSE;
	}
}