<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Registration_model
 *
 * Модель модуля "Регистрация"
 */
class Registration_model extends Model
{
	/**
	 * @var array сгенерированные в моделе данные, передаваемые в шаблон
	 */
	protected $result;

	/**
	 * @var object основной объект системы
	 */
	protected $diafan;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * Генерирует данные для формы регистрации
	 * 
	 * @return array
	 */
	public function form()
	{
		if(! empty($_GET["act"]))
		{
			if($actlink = DB::fetch_array(DB::query("SELECT user_id, created FROM {actlink} WHERE link='%h'", $_GET["act"])))
			{
				if($actlink["created"] < time())
				{
					$this->result["actlink"] = _LANG_ACTLINK_OLD;
				}
				else
				{
					DB::query("UPDATE {users_site} SET act='1' WHERE id=%d", $actlink["user_id"]);
					DB::query("DELETE FROM {actlink} WHERE link='%h' AND user_id='%d'", $_GET["act"], $actlink["user_id"]);
					$this->result["actlink"] = _LANG_USER_ACT.Registration_view::show_login(array('user' => 0, 'error' => '', 'action' => BASE_PATH_HREF), 1);
				}
			}
			else
			{
				$this->result["actlink"] = _LANG_ACTLINK_INCORRECT;			
			}
		}

		$this->result["captcha"] = '';
		if($this->diafan->configmodules('security_code', "usersite") && ! $this->diafan->_user->id)
		{
			require_once (ABSOLUTE_PATH.'includes/captcha/captcha.inc.php');
			$this->result["captcha"] = Captcha_inc::get("registration", $this->get_error("registration", "code"));
		}
		$this->result["fio"]  = '';
		$this->result["mail"] = '';
		$this->result["name"] = '';

		if($this->diafan->_user->id)
		{
			$this->result["fio"] = $this->diafan->_user->fio;
			$this->result["mail"] = $this->diafan->_user->mail;
			$this->result["name"] = $this->diafan->_user->name;
			if(count($this->diafan->language_all) > 1)
			{
				foreach ($this->diafan->language_all as $key => $language)
				{
					$this->result["language"][] = array("value"    => $language[0],
									    "selected" => ($language[0] == $this->diafan->_user->language ? ' selected' : ''),
									    "name"     => $language[2]
									    );
				}
			}
		}
		$this->result["action"]         = BASE_PATH_HREF.$this->diafan->path_module_variable();
		$this->result["error"]          = $this->get_error("registration");
		$this->result["error-name"]     = $this->get_error("registration", 'name');
		$this->result["error-fio"]      = $this->get_error("registration", 'fio');
		$this->result["error-password"] = $this->get_error("registration", 'password');
		$this->result["error-mail"]     = $this->get_error("registration", 'mail');
		$this->result["user"]           = $this->diafan->_user->id;
		$this->result["url"] 		= '';
		
		if(! empty($_SERVER["HTTP_REFERER"]) && !  $this->diafan->configmodules("act", "usersite"))
		{
			$ref = parse_url($_SERVER["HTTP_REFERER"]);
	
			if($ref["host"] == $_SERVER["HTTP_HOST"])
			{
				$this->result["url"] = $_SERVER["HTTP_REFERER"];
			}
		}
		
		return $this->result;
	}

	/**
	 * Генерирует данные для формы авторизации
	 * 
	 * @return array|boolean false
	 */
	function show_login()
	{
	  	if($this->diafan->module == "registration" && ! $this->diafan->_user->id || $this->diafan->module == "shop/order")
			return FALSE;

		$result["registration"] = BASE_PATH_HREF.$this->get_rewrite_from_module("registration").'/';
		$result["user"] = $this->diafan->_user->id;
		if (! $result["user"])
		{
			switch($this->diafan->_user->errauth)
			{
				case 'wrong_login_or_pass':
					$result["error"] = _LANG_WRONG_LOGIN_OR_PASS;
				break;

				case 'blocked_30_min':
					$result["error"] = _LANG_BLOCKED_30_MIN;
				break;

				case 'blocked':
					$result["error"] = _LANG_LOGIN_BLOCKED;
				break;

				default:
					$result["error"] = '';
				
			}
			$result["reminding"] = BASE_PATH_HREF.$this->get_rewrite_from_module("reminding").'/';
			$result["action"] = $this->diafan->module == "registration" ? BASE_PATH_HREF : '';
		}
		else
		{
			$result["fio"] = $this->diafan->_user->fio;
		}
		return $result;
	}  	
}