<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Registration_view
 *
 * Шаблон модуля "Регистрация"
 */
class Registration_view
{
	/**
	 * Шаблон формы регистрации
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @return boolean true
	 */
	function form($result)
	{
		echo '
		<form action="'.$result["action"].'" method="POST" class="registration-form ajax">
			<input type="hidden" name="ajax" value="">
			<input type="hidden" name="url" value="'.$result["url"].'">
			<input type="hidden" name="'.(! empty($result["user"]) ? 'edit':'addnew').'" value="1">

			<div class="infofield">'._LANG_NAME_SURNAME.(empty($result["user"]) ? '<font color="red">*</font>' : '').'</div>
			<input type = "text" maxLength="70" name="fio" size="40" class="inptext" value="'.$result["fio"].'">
			<div class="errors error-fio"'.($result["error-fio"] ? '>'.$result["error-fio"] : ' style="display:none">').'</div>

			<div class="infofield">'._LANG_EMAIL.(empty($result["user"]) ? '<font color="red">*</font>' : '').':</div>
			<input type = "text" maxLength="70" name="mail" size="40" class="inptext" value="'.$result["mail"].'">
			<div class="errors error-mail"'.($result["error-mail"] ? '>'.$result["error-mail"] : ' style="display:none">').'</div>

			<div class="infofield">'._LANG_LOGIN.(empty($result["user"]) ? '<font color="red">*</font>' : '').':</div>
			<input type = "text" maxLength="70" name="name" size="40" class="inptext" value="'.$result["name"].'">
			<div class="errors error-name"'.($result["error-name"] ? '>'.$result["error-name"] : ' style="display:none">').'</div>

			<div class="infofield">'._LANG_PASSWORD.(empty($result["user"]) ? '<font color="red">*</font>' : '').':</div>
			<input type = "password" maxLength="70" name="password" size="40" class="inptext">
			<div class="errors error-password"'.($result["error-password"] ? '>'.$result["error-password"] : ' style="display:none">').'</div>

			<div class="infofield">'._LANG_RETURN_PASSWORD.(empty($result["user"]) ? '<font color="red">*</font>' : '').':</div>
			<input type = "password" maxLength="70" name="password2" size="40" class="inptext">
			';
	  
			if(! empty($result["language"]))
			{
				echo '<div class="infofield">'._LANG_LANGUAGE.':</div>
				<select name="language">';
				foreach($result["language"] as $row)
				{
					echo '
					<option value="'.$row["value"].'"'.$row["selected"].'>'.$row["name"].'</option>';
				}
				
				echo '</select>';
			}
			echo $result["captcha"].'
			<br>
			<input type="submit" value="'.(! $result["user"] ? _LANG_REGISTRATION : _LANG_SAVE).'" class="button">
			<div class="errors error"'.($result["error"] ? '>'.$result["error"] : ' style="display:none">').'</div>
		</form>';

		return TRUE;
	}

	/**
	 * Шаблон формы авторизации
	 * 
	 * @param array $result данные, сгенерированные в моделе
	 * @param boolean $registration скрывать ссылки "Зарегистрироватся", "Забыли пароль?"
	 * @return string
	 */
	function show_login($result, $registration = FALSE)
	{
		if (! $result["user"])
		{
			$text = '
			<div class="login">
				'.$result["error"].'
				<form method="post" action="'.$result["action"].'">
					<input type="hidden" name="action" value="auth">
					<div class="infofield">'._LANG_LOGIN.'</div>
					<input type="text" name="name" value="" class="inptext">
					<br>
					<div class="infofield">'._LANG_PASSWORD.'</div>
					<input type="password" name="pass" value="" class="inptext">
					<div class="intbutton"><input type="submit" value="'._LANG_OK.'" class="button"></div>'
					
				.(! $registration
				 ? '
					<div class="login-reminding"><a href="'.$result["reminding"].'">'._LANG_FOGOT_PASSWORD.'</a></div>
					<div class="login-registration"><a href="'.$result["registration"].'">'._LANG_REGISTRATION.'</a></div>'
				 : '').'
				
				</form>
			</div>
			';
		}
		else
		{
			$text = '<div class="login">'._LANG_HELLO.', '.$result["fio"].'!
			<br>
			<a href="'.BASE_PATH_HREF.'logout/">'._LANG_LOGOUT.'</a>
			<br>
			<a href="'.$result["registration"].'">'._LANG_EDIT_YOUR_INFORMATION.'</a></div>';
		}
		return $text;
	}
}