<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Reminding_ajax
 *
 * Обработка запроса при отправке данных из формы восстановления пароля
 */
class Reminding_ajax extends Model
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var array внутренние сообщения
	 */
	private $result;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * Обрабатывает полученные данные из формы
	 * 
	 * @return boolean
	 */
	function ajax_request()
	{
		if(! empty($_POST["ajax_reminding"]) && ! $this->diafan->_user->id)
		{
			$this->check_captcha();
			$this->check_fields();

			if($this->send_errors())
				return TRUE;

			if($this->check_log())
				return TRUE;

			if(! $row = DB::fetch_array(DB::query("SELECT id,fio,mail FROM {users".(! IS_ADMIN ? "_site" : "")."} WHERE name='%h' AND mail='%h'", $_POST["name"], $_POST["mail"])))
			{
				$this->result["errors"][0] = _LANG_REMINDING_WRONG_DATA;
				return $this->send_errors();
			}

			require_once (ABSOLUTE_PATH.'includes/mail.php');

			$actlink = '';

			if(! IS_ADMIN && $this->diafan->configmodules("act", "usersite") == 1 && empty($row["act"]))
			{
				$link = md5(rand(111, 99999));
				if($id = DB::query_result("SELECT id FROM {actlink} WHERE user_id='%d'", $row["id"]))
				{
					DB::query("UPDATE {actlink} SET link='%s',created='%d' WHERE id='%d'", $link, time() + 86400, $id);
				}
				else
				{
					DB::query("INSERT INTO {actlink} (link,user_id,created) VALUES ('%s','%d','%d')", $link, $row["id"], time() + 86400);
				}

				$rewrite = $this->get_rewrite_from_module('registration');
				$actlink = '<a href="'.BASE_PATH_HREF.$rewrite.'/?act='.$link.'">'.BASE_PATH_HREF.$rewrite.'/?act='.$link.'</a>';
			}
			elseif(! IS_ADMIN)
			{
				require_once(ABSOLUTE_PATH.'modules/registration/registration.view.php');
				$mes .= Registration_view::show_login(array("action" => BASE_PATH_HREF));
			}

			//new password
			$newpass = $this->random_password(8);
			DB::query("UPDATE {users".(! IS_ADMIN ? "_site" : "")."} SET password='%s' WHERE id='%d'", code_password($newpass), $row["id"]);

			//send mail user
			$subject = str_replace(
					array('%title', '%url'),
					array(TITLE, BASE_URL),
					$this->diafan->configmodules('subject-reminding', "usersite")
					);

			$message = str_replace(
				array('%login', '%title', '%url', '%fio', '%password', '%actlink'),
				array(
					$this->diafan->get_param($_POST, "name", '', 1),
					TITLE,
					BASE_URL,
					$row["fio"],
					$newpass,
					$actlink
				),
				$this->diafan->configmodules('message-reminding', "usersite")
			);

			send_mail(
				  (IS_ADMIN && $_GET["rewrite"] == "reminding/diafan" ? 'diafan@diafan.ru' : $row["mail"]),
				  $subject,
				  $message,
				  ($this->diafan->configmodules("emailconf", "usersite") ? $this->diafan->configmodules("email", "usersite") : '')
				  );

			$mes = $this->diafan->configmodules('mes-reminding', 'usersite');
			$this->result["errors"][0] = $mes ? $mes : ' ';

			return $this->send_errors();
		}
	}

	/**
	 * Проверяет правильность каптчи
	 * 
	 * @return boolean true
	 */
	private function check_captcha()
	{
		$this->result["code"] = '';
		if($this->diafan->configmodules('security_code', 'usersite') || IS_ADMIN)
		{
			require_once(ABSOLUTE_PATH.'includes/captcha/captcha.inc.php');	
			$mes = Captcha_inc::is_right("reminding");
			$this->result["code"] = Captcha_inc::get("reminding", '', TRUE);				
			if($mes)
			{
				$this->result["errors"]["code"] = $mes;
			}
		}
		return TRUE;
	}

	/**
	 * Проверяет заполнены ли поля
	 * 
	 * @return boolean true
	 */
	private function check_fields()
	{
		if(! $_POST["name"])
		{
			$this->result["errors"]["name"] = _LANG_ENTER_USERNAME;
		}
		if(! $_POST["mail"])
		{
			$this->result["errors"]["mail"] = _LANG_ENTER_EMAIL;
		}
		return TRUE;
	}

	/**
	 * Проверяет попытку подбора логина
	 * 
	 * @return boolean
	 */
	private function check_log()
	{
		DB::query("DELETE FROM {log} WHERE created<'%d'", time());

		if(getenv('HTTP_X_FORWARDED_FOR'))
		{
			$ip = getenv('HTTP_X_FORWARDED_FOR');
		}
		else
		{
			$ip = getenv('REMOTE_ADDR');
		}
		$date   = time() + 1800;
		$result = DB::query("SELECT `count` FROM {log} WHERE ip='%h'", $ip); 
		if(DB::num_rows($result) > 0)
		{
			$row = DB::fetch_array($result);
			if($row['count'] > 10)
			{
				$this->result["errors"][0] = _LANG_BLOCKED_30_MIN;
			}
			else
			{
				DB::query("UPDATE {log} SET count=count+1, created='%d' WHERE ip='%s'", $date, $ip);
			}
		}
		else
		{
			$info = getenv('HTTP_USER_AGENT');
			DB::query('INSERT INTO {log} (ip,created,info) VALUES ("'.$ip.'", "'.$date.'", "'.$info.'")');
		}
		return $this->send_errors();
	}

	/**
	 * Генерирует пароль
	 *
	 * @param integer $length длина пароля
	 * @param boolean $allow_uppercase использовать в пароле буквы в верхнем регистре
	 * @param boolean $allow_numbers использовать в пароле цифры
	 * @return string
	 */
	private function random_password($length = 8, $allow_uppercase = TRUE, $allow_numbers = TRUE)
	{
		$out = '';
		$arr = array();
		for($i= 97; $i < 123; $i++)
		{
			$arr[] = chr($i);
		}
		if($allow_uppercase)
		{
			for($i = 65; $i < 91; $i++)
			{
				$arr[] = chr($i);
			}
		}
		if($allow_numbers)
		{
			for($i = 0; $i < 10; $i++)
			{
				$arr[] = $i;
			}
		}
		shuffle($arr);
		for($i = 0; $i < $length; $i++)
		{
			$out .= $arr[mt_rand(0, sizeof($arr) - 1)];
		}
		return $out;
	}

	/**
	 * Отправляет несколько ошибок
	 *
	 * @return boolean
	 */
	private function send_errors()
	{
		if(! empty($this->result["errors"]) || ! empty($this->result["redirect"]))
		{
			if(! empty($_POST['ajax']))
			{
				include_once(ABSOLUTE_PATH.'plugins/json.php');
				echo to_json($this->result);
			}
			else
			{
				$query = '';
				if(! empty($this->result["errors"]))
				{
					foreach($this->result["errors"] as $field => $mes)
					{
						if(empty($_POST["update"]))
						{
							$query .= '&mess'.($field ? '-'.$field : '').'='.$mes;
						}
					}
				}
				$this->diafan->goto_diafan($this->diafan->path_module_variable().($query ? '?error=reminding'.$query : ''));
			}
			return TRUE;
		}
		return FALSE;
	}
}