<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Reminding_model
 *
 * Модель модуля "Восстановление пароля"
 */
class Reminding_model extends Model
{
	/**
	 * @var array сгенерированные в моделе данные, передаваемые в шаблон
	 */
	protected $result;

	/**
	 * @var object основной объект системы
	 */
	protected $diafan;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * Генерирует данные для формы восстановления пароля
	 * 
	 * @return array
	 */
	public function form()
	{
		if($this->diafan->_user->id)
		{
			$this->result["error"] = _LANG_YOU_ARE_REGISTRED;
			return $this->result;
		}
		
		if($this->diafan->configmodules('security_code', "usersite"))
		{
			require_once (ABSOLUTE_PATH.'includes/captcha/captcha.inc.php');
			$this->result["captcha"] = Captcha_inc::get("reminding", $this->get_error("reminding", "code"));
		}
		$this->result["action"]         = BASE_PATH_HREF.$this->diafan->path_module_variable();
		$this->result["error"]          = $this->get_error("reminding");
		$this->result["error-name"]     = $this->get_error("reminding", 'name');
		$this->result["error-mail"]     = $this->get_error("reminding", 'mail');
		return $this->result;
	}
}