<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Search_model
 *
 * Модель модуля "Поиск по сайту"
 */
class Search_model extends Model
{
	/**
	 * @var object основной объект системы
	 */
	protected $diafan;

	/**
	 * @var array сгенерированные в моделе данные, передаваемые в шаблон
	 */
	private $result;

	/**
	 * @var integer количество элементов, показанных на странице
	 */
	private $nastr = 10;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * Генерирует список найденных страниц
	 * 
	 * @return array
	 */
	public function show_module()
	{
		$search = '';
		if(isset($_GET["searchword"]))
		{
			if(is_array($_GET["searchword"]))
			{
				$_GET["searchword"] = '';
			}
			$search = trim(htmlspecialchars(stripslashes($_GET["searchword"])));
		}
		$this->result = array();
 
		if(! empty($search))
		{
			$time = mktime(23, 59, 0, date("m"), date("d"), date("Y"));
			
			//Страницы сайта
			$sql_count = "SELECT COUNT(*) FROM {site}"
				     ." WHERE [act]='1' AND trash='0' AND [text]<>''"
				     .(! $this->diafan->_user->id ? " AND access='0'" : "")
				     ." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%')"
				
			;
			$k = 2;

			$sql = "SELECT id, [name], othurl, [text], '' AS cat_id, 0 AS site_id, 'site' AS module FROM {site}"
			       ." WHERE [act]='1' AND trash='0' AND  [text]<>'' "
			       .(! $this->diafan->_user->id ? " AND access='0'" : "")
			       ." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%')"
			;
			
			//Товары в интернет-магазине
			$shop = DB::where("adminsite", "rewrite='shop'", "id");
			if($shop)
			{
				if($this->diafan->configmodules("cat", "shop"))
				{
					$sql_count .= " UNION SELECT COUNT(*) FROM {shop_category}"
						      ." WHERE [act]='1' AND trash='0'"
						      ." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";
	
					$sql .= " UNION SELECT id, [name],'' AS othurl,[text], 0 AS cat_id, site_id,"
					        ." 'shop_category' AS module FROM {shop_category}"
						." WHERE [act]='1' AND trash='0'"
						." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";
					$k = $k + 3;
				}

				$sql_count .= " UNION SELECT COUNT(*) FROM {shop}"
					      ." WHERE [act]='1' AND trash='0' AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";

				$sql .= " UNION SELECT id, [name], '' AS othurl, [text], cat_id, site_id, 'shop' AS module FROM {shop}"
					." WHERE [act]='1' AND trash='0'"
					." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";
				$k = $k + 3;
			}
			//Файлы
			$files = DB::where("adminsite","rewrite='files'", "id");
			if($files)
			{
				if($this->diafan->configmodules("cat", "files"))
				{
					$sql_count .= " UNION SELECT COUNT(*) FROM {files_category}"
						      ." WHERE [act]='1' AND trash='0'"
						      ." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";
	
					$sql .= " UNION SELECT id, [name], '' AS othurl, [text], 0 AS cat_id, site_id,"
					        ." 'files_category' AS module FROM {files_category}"
						." WHERE [act]='1' AND trash='0'"
						." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";
					$k = $k + 3;
				}

				$sql_count .= " UNION SELECT COUNT(*) FROM {files}"
					      ." WHERE [act]='1' AND trash='0'"
					      ." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";

				$sql .= " UNION SELECT id, [name], '' AS othurl, [text], cat_id, site_id, 'files' AS module FROM {files}"
					." WHERE [act]='1' AND trash='0'"
					." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";
				$k = $k + 3;
			}
			
			//Вопрос-Ответ
			$faq = DB::where("adminsite", "rewrite='faq'", "id");
			if($faq)
			{
				if($this->diafan->configmodules("cat", "faq"))
				{
					$sql_count .= " UNION SELECT COUNT(*) FROM {faq_category}"
						      ." WHERE [act]='1' AND trash='0'"
						      ." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";
	
					$sql .= " UNION SELECT id, [name], '' AS othurl, [text], 0 AS cat_id, site_id,"
					        ." 'faq_category' AS module FROM {faq_category}"
						." WHERE [act]='1' AND trash='0'"
						." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";
					$k = $k + 3;
				}
				$sql_count .= " UNION SELECT COUNT(*) FROM {faq}"
					      ." WHERE [act]='1' AND trash='0'"
					      ." AND created<'".$time."'"
					      ." AND ([name] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%' OR [text] LIKE '%%%h%%')";

				$sql .= " UNION SELECT id, [name], '' AS othurl, [text], cat_id, site_id, 'faq' AS module FROM {faq}"
					." WHERE [act]='1' AND trash='0'"
					." AND created<'".$time."'"
					." AND ([name] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%' OR [text] LIKE '%%%h%%')";
				$k = $k + 3;
			}

			//Новости
			$news = DB::where("adminsite", "rewrite='news'", "id");
			if($news)
			{
				if($this->diafan->configmodules("cat", "news"))
				{
					$sql_count .= " UNION SELECT COUNT(*) FROM {news_category}"
						      ." WHERE [act]='1' AND trash='0'"
						      ." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";
	
					$sql .= " UNION SELECT id, [name], '' AS othurl, [text], 0 AS cat_id, site_id,"
					        ." 'news_category' AS module FROM {news_category}"
						." WHERE [act]='1' AND trash='0'"
						." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";
					$k = $k + 3;
				}
				$sql_count .= " UNION SELECT COUNT(*) FROM {news}"
					      ." WHERE [act]='1' AND trash='0'"
					      ." AND created<'".$time."'"
					      ." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";

				$sql .= " UNION SELECT id, [name], '' AS othurl, [text], cat_id, site_id, 'news' AS module FROM {news}"
					." WHERE [act]='1' AND trash='0'"
					." AND created<'".$time."'"
					." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";
				$k = $k + 3;
			}

			//Статьи
			$clauses = DB::where("adminsite", "rewrite='clauses'", "id");
			if($clauses)
			{
				if($this->diafan->configmodules("cat", "clauses"))
				{
					$sql_count .= " UNION SELECT COUNT(*) FROM {clauses_category}"
						      ." WHERE [act]='1' AND trash='0'"
						      ." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";
	
					$sql .= " UNION SELECT id, [name], '' AS othurl, [text], 0 AS cat_id, site_id,"
					        ." 'clauses_category' AS module FROM {clauses_category}"
						." WHERE [act]='1' AND trash='0'"
						." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";
					$k = $k + 3;
				}
				$sql_count .= " UNION SELECT COUNT(*) FROM {clauses}"
					      ." WHERE [act]='1' AND trash='0' AND created<'".$time."'"
					      ." AND ([name] LIKE '%%%h%%' OR [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";

				$sql .= " UNION SELECT id, [name], '' AS othurl, [text], cat_id, site_id, 'clauses' AS module FROM {clauses}"
					." WHERE [act]='1' AND trash='0' AND created<'".$time."'"
					." AND ([name] LIKE '%%%h%%' OR  [text] LIKE '%%%h%%' OR [anons] LIKE '%%%h%%')";
				$k = $k + 3;
			}

			for($i = 0; $i < $k; $i++)
			{
				$values[] = $search;
			}

			$nen = 0;
			$result = DB::query($sql_count, $values);
			while ($row = DB::fetch_array($result))
			{
				$nen += $row[0];
			}

			////navigation//
			include_once(ABSOLUTE_PATH.'includes/paginator/paginator.inc.php');
			$paginator = new Paginator_inc();
			if($this->nastr)
			{
				$paginator->nastr = $this->nastr;
			}
			$paginator->page    = $this->diafan->page;
			$paginator->navlink = $this->diafan->path_module_variable("page");
			$paginator->get_nav = '?searchword='.$search;
			$paginator->nen     = $nen;
			$links = $paginator->get();
			////navigation///
			$k = (! $this->diafan->page ? 1 : ($this->diafan->page - 1) * $paginator->nastr + 1);

			$this->result["paginator"] = $links;

			$result = DB::query_range($sql, $values, $paginator->polog, $paginator->nastr);
			while ($row = DB::fetch_array($result))
			{
				$row["i"] = $k++;
				$row["cat"]  = array();
				$row["site"] = array();
				$row["link"] = '';

				if($row["module"] == "site")
				{
					if(! empty($this->diafan->rewrites[$row["id"]]))
					{
						$row["link"] = $this->diafan->rewrites[$row["id"]]["rewrite"]
						        ? $this->diafan->rewrites[$row["id"]]["rewrite"].'/' : '';
					}
				}
				elseif(strstr($row["module"], '_category'))
				{
					if(! $this->diafan->configmodules("cat", str_replace('_category', '', $row["module"]), _LANG, $row["site_id"]))
					{
						continue;
					}
					if(empty($site_arr_link[$row["site_id"]]))
					{
						$site_arr_link[$row["site_id"]] = DB::query_result("SELECT [name] FROM {site} WHERE id=%d AND act='1' AND trash='0'", $row["site_id"]);
					}

					$link = '';
					if(! empty($this->diafan->rewrites[$row["site_id"]]))
					{
						$link = $this->diafan->rewrites[$row["site_id"]]["rewrite"]
						        ? $this->diafan->rewrites[$row["site_id"]]["rewrite"].'/' : '';
					}

					$row["site"] = array(
						     'link' => $link,
						     'name' => $site_arr_link[$row["site_id"]]
						     );
					if(! empty($this->diafan->rewrites[$row["module"]]["cat".$row["id"]]))
					{
						$row["link"] = $this->diafan->rewrites[$row["module"]]["cat".$row["id"]]["rewrite"].'/';
					}
					elseif(! empty($this->diafan->rewrites[$row["site_id"]]))
					{
						$row["link"] = ($this->diafan->rewrites[$row["site_id"]]["rewrite"]
						         ? $this->diafan->rewrites[$row["site_id"]]["rewrite"].'/' : '')
							.'cat'.$row["id"].'/';
					}
				}
				else
				{
					if(! $this->diafan->configmodules("cat", $row["module"], _LANG, $row["site_id"]))
					{
						$row["cat_id"] = 0;
					}
					if($row["cat_id"])
					{
						if(! isset($cats[$row["module"]][$row["cat_id"]]))
						{
							$cats[$row["module"]][$row["cat_id"]] = DB::query_result("SELECT [name] FROM {".$row["module"]."_category} WHERE id=%d AND act='1' AND trash='0'", $row["cat_id"]);
						}
						if($cats[$row["module"]][$row["cat_id"]])
						{
							$link = '';
							if(! empty($this->diafan->rewrites[$row["module"]]["cat".$row["cat_id"]]))
							{
								$link = $this->diafan->rewrites[$row["module"]]["cat".$row["cat_id"]]["rewrite"].'/';
							}
							elseif(! empty($this->diafan->rewrites[$row["site_id"]]))
							{
								$link = ($this->diafan->rewrites[$row["site_id"]]["rewrite"]
								         ? $this->diafan->rewrites[$row["site_id"]]["rewrite"].'/' : '')
								        .'cat'.$row["cat_id"].'/';
							}
							$row["cat"] = array(
								     'link' => $link,
								     'name' => $cats[$row["module"]][$row["cat_id"]]
								     );
						}
					}
					if(! isset($cats[$row["module"]][$row["cat_id"]]))
					{
						$cats[$row["module"]][$row["cat_id"]] = DB::query_result("SELECT [name] FROM {".$row["module"]."_category} WHERE id=%d AND act='1' AND trash='0'", $row["cat_id"]);
					}
					if(empty($site_arr_link[$row["site_id"]]))
					{
						$site_arr_link[$row["site_id"]] = DB::query_result("SELECT [name] FROM {site} WHERE id=%d AND act='1' AND trash='0'", $row["site_id"]);
					}

					$link = '';
					if(! empty($this->diafan->rewrites[$row["site_id"]]))
					{
						$link = $this->diafan->rewrites[$row["site_id"]]["rewrite"]
						        ? $this->diafan->rewrites[$row["site_id"]]["rewrite"].'/' : '';
					}
					
					$row["site"] = array(
						     'link' => $link,
						     'name' => $site_arr_link[$row["site_id"]]
						     );
					if(! empty($this->diafan->rewrites[$row["module"]]["element".$row["id"]]))
					{
						$row["link"] = $this->diafan->rewrites[$row["module"]]["element".$row["id"]]["rewrite"].'/';
					}
					elseif($row["cat_id"] && ! empty($this->diafan->rewrites[$row["module"]]["cat".$row["cat_id"]]))
					{
						$row["link"] = $this->diafan->rewrites[$row["module"]]["cat".$row["cat_id"]]["rewrite"].'/show'.$row["id"].'/';
					}
					elseif(! empty($this->diafan->rewrites[$row["site_id"]]))
					{
						$row["link"] = ($this->diafan->rewrites[$row["site_id"]]["rewrite"]
						         ? $this->diafan->rewrites[$row["site_id"]]["rewrite"].'/' : '')
						        .($row["cat_id"] ? 'cat'.$row["cat_id"].'/' : '')
							.'show'.$row["id"].'/';
					}
				}
				$row["snippet"] = $this->str_search($row["text"], $search);
				$row["name"] = $this->diafan->short_text($row["name"], 20);

				$this->result["rows"][] = $row;
			}

			$this->result["count"] = $paginator->nen;
			$this->result["count-page"] = $paginator->nen > $paginator->nastr ? $paginator->nastr : $paginator->nen;
		}
		$this->result["value"] = $search;
		$this->result["button"] = '';
		$this->result["action"] = BASE_PATH_HREF.($this->diafan->rewrite ? $this->diafan->rewrite.'/' : '');

		return $this->result;
	}

	/**
	 * Генерирует контент для шаблонной функции: форма поиска по сайту
	 * 
	 * @return array
	 */
	function show_search($button)
	{			
		$result["value"] = '';
		if(isset($_GET["searchword"]))
		{
			if(is_array($_GET["searchword"]))
			{
				$_GET["searchword"] = '';
			}
			$result["value"] = trim(htmlspecialchars(stripslashes($_GET["searchword"])));
		}
		$rewrite = $this->get_rewrite_from_module("search");
		$result["action"] = BASE_PATH_HREF.($rewrite ? $rewrite.'/' : '');
		$result["button"] = $button;
		return $result;
	}

	/**
	 * Ищет слово в тексте и выделяет его жирным
	 * 
	 * @return array
	 */
	private function str_search($text, $search)
	{
		$search = utf::strtolower($search);
		//strtolower,stristr,strpos,substr
		$pos  = utf::strpos(strip_tags(utf::strtolower($text)), $search);
		$str  = str_replace(utf::stristr(strip_tags($text), $search), "", strip_tags($text));
		$str1 = strrchr($str, ".");
		if($str1)
		{
			$str = utf::substr($str1, 1);
		}
		$str .= "<b>".utf::substr(utf::stristr(strip_tags($text), $search), 0, utf::strlen($search))."</b>";
		$pos  = utf::strpos(utf::stristr(strip_tags(utf::strtolower($text)), $search), "." );
		$str .= utf::substr(utf::stristr(strip_tags($text), $search ), utf::strlen($search), $pos - 1);
		return $str;
	}
}