<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Shop_admin_config
 *
 * Конфигурация магазина
 */
class Shop_admin_config extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'shop_config';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		$this->variable_table = array(
			'base' => array(
				'format_price'		=> 'function',
				'format_price_1'	=> 'none',
				'format_price_2'	=> 'none',
				'format_price_3'	=> 'none',
				'search_price'		=> 'checkbox',
				'search_text'		=> 'checkbox',
				'search_name'		=> 'checkbox',
				'cat'			=> 'checkbox',
				'count_list'		=> 'numtext',
				'allshop'		=> 'text',
				'childrens_elements'	=> 'checkbox',
				'comments_cat'		=> 'function',

				'hr2'			=> 'hr',

				'nastr'			=> 'numtext',
				'comments'		=> 'checkbox',
				'tags'			=> 'function',
				'rating'		=> 'checkbox',
				'upload_max_filesize'	=> 'function',
				'currency'		=> 'text',
				
				'security_user'		=> 'checkbox'
			),
			'images' => array(
				'image'			=> 'function',
				'big_width'		=> 'function',
				'big_height'		=> 'none',
				'big_quality'		=> 'none',
				'medium_width'		=> 'function',
				'medium_height'		=> 'none',
				'medium_quality'	=> 'none',
				'list_img'		=> 'select',

				'image_cat'		=> 'function',
				'big_width_cat'		=> 'function',
				'big_height_cat'	=> 'none',
				'big_quality_cat'	=> 'none',
				'medium_width_cat'	=> 'function',
				'medium_height_cat'	=> 'none',
				'medium_quality_cat'	=> 'none',
				'list_img_cat'		=> 'select',

				'use_animation'		=> 'checkbox'
			),
			'yandex_shop' => array(
				'yandex'		=> 'checkbox',
				'nameshop'		=> 'text',
				'currencyyandex'	=> 'function',
				'currencyratesel'	=> 'none',
				'currencyrate'		=> 'none',
				'show_yandex_category'  => 'select',
				'show_yandex_element'   => 'select',
				'bid'			=> 'numtext',
				'cbid'			=> 'numtext'
			),
			'methods_payment' => array(
				'pay_systems'		=> 'checkbox',
				'desc_order'		=> 'text',
			        'tab_1'			=> 'hr',
				'courier'		=> 'checkbox',
				'courier_text'		=> 'editor',
			        'tab_2'			=> 'hr',
				'webmoney'		=> 'checkbox',
				'wm_target'		=> 'text',
				'wm_secret'		=> 'text',
				'wm_text'		=> 'editor',
			        'tab_3'			=> 'hr',
				'robox'			=> 'checkbox',
				'robox_login'		=> 'text',
				'robox_pass_1'		=> 'text',
				'robox_pass_2'		=> 'text',
				'robox_text'		=> 'editor',
			        'tab_4'			=> 'hr',
				'non_cash'		=> 'checkbox',
				'non_cash_name'		=> 'text',
				'non_cash_kpp'		=> 'text',
				'non_cash_inn'		=> 'text',
				'non_cash_tax-department'=> 'text',
				'non_cash_okato'	=> 'text',
				'non_cash_ogrn'		=> 'text',
				'non_cash_rs'		=> 'text',
				'non_cash_bank'		=> 'text',
				'non_cash_bik'		=> 'text',
				'non_cash_ks'		=> 'text',
				'non_cash_kbk'		=> 'text',
				'non_cash_address'	=> 'text',
				'non_cash_director'	=> 'text',
				'non_cash_glbuh'	=> 'text',
				'non_cash_text'		=> 'editor',
			        'tab_5'			=> 'hr',
				'payment_success_text'	=> 'editor',
				'payment_fail_text'	=> 'editor'
			),
			'send_mails' => array(
				'mes'			=> 'text',
				'order_step_2_text'	=> 'editor',

				'hr6'			=> 'hr',

				'subject'		=> 'text',
				'message'		=> 'textarea',
				'emailconf'		=> 'function',
				'email'			=> 'none',

				'hr7'			=> 'hr',

				'subject-admin'		=> 'text',
				'message-admin'		=> 'textarea',
				'emailconfadmin'	=> 'function',
				'email-admin'		=> 'none'
			)
		);

		$this->language_names = array(
			'allshop',
			'currency',
			'mes',
			'subject',
			'message'
		);

		$this->config_module = array(
			 'tab_card'	=> 1	//делить редактирование на вкладки
		);

		$this->select_arr["currencyyandex"] = array(
			'RUR' => 'RUR',
			'USD' => 'USD',
			'EUR' => 'EUR',
			'UAH' => 'UAH'
		);

		$this->select_arr["show_yandex_category"] = array(
			'0' => _ADMIN_SHOP_YANDEX_0,
			'1' => _ADMIN_SHOP_YANDEX_1
		);

		$this->select_arr["show_yandex_element"] = array(
			'0' => _ADMIN_SHOP_YANDEX_0,
			'1' => _ADMIN_SHOP_YANDEX_1
		);

		$this->select_arr["currencyratesel"] = array(
			'1' => _ADMIN_SHOP_CONFIG_CURRENCYRATESEL_1,
			'2' => _ADMIN_SHOP_CONFIG_CURRENCYRATESEL_2,
			'3' => _ADMIN_SHOP_CONFIG_CURRENCYRATESEL_3
		);

		$this->select_arr["list_img"] = array(
			0 => _ADMIN_CONFIG_LIST_IMG_0,
			1 => _ADMIN_CONFIG_LIST_IMG_1,
			2 => _ADMIN_CONFIG_LIST_IMG_2
		);

		$this->select_arr["list_img_cat"] = array(
			0 => _ADMIN_CONFIG_LIST_IMG_0,
			1 => _ADMIN_CONFIG_LIST_IMG_1,
			2 => _ADMIN_CONFIG_LIST_IMG_2
		);

		$this->show_tr_click_checkbox = array(
			'cat'		=> array(
						'count_list',
						'allshop',
						'comments_cat',
						'image_cat'
					),
			'yandex'	=> array(
						'nameshop',
						'currencyyandex',
						'bid',
						'cbid',
						'show_yandex_category',
						'show_yandex_element'
					),
			'image'	=> array(
						'big',
						'medium',
						'list_img'
					),
			'image_cat'	=> array(
						'big_cat',
						'medium_cat',
						'list_img_cat'
					),
			'pay_systems'	=> array(
						'webmoney',
						'robox',
						'non_cash',
						'desc_order',
						'courier',
						'hr1',
						'hr2',
						'hr3',
						'hr4',
						'tab_1',
						'tab_2',
						'tab_3',
						'tab_4',
						'tab_5',
						'payment_success_text',
						'payment_fail_text'
					),
			'webmoney'	=> array(
						'wm_target',
						'wm_secret',
						'wm_text'
					),
			'robox'	=> array(
						'robox_login',
						'robox_pass_1',
						'robox_pass_2',
						'robox_text'
					),
			'non_cash'	=> array(
						'non_cash_text',
						'non_cash_name',
						'non_cash_kpp',
						'non_cash_inn',
						'non_cash_tax-department',
						'non_cash_okato',
						'non_cash_ogrn',
						'non_cash_rs',
						'non_cash_bank',
						'non_cash_bik',
						'non_cash_ks',
						'non_cash_kbk',
						'non_cash_address',
						'non_cash_director',
						'non_cash_glbuh'
					),
			'courier'	=> array(
						'courier_text'
					)
		);
		
	}

	/**
	 * Редактирование поля "Формат цены"
	 * 
	 * @return boolean true
	 */
	function edit_format_price_module_config()
	{
		echo '
		<tr'.$this->get_other().'>
			<td class="first-td">'.$this->variable_names().'</td>
			<td>
				'
			.sprintf(
				_ADMIN_SHOP_CONFIG_FORMAT_PRICE_NUM,
				'<input type="text" name="format_price_1" size="2" value="'.$this->values["format_price_1"].'" class="inpnum">'
				.'<br>',
				
				'<input type="text" name="format_price_2" size="2" value="'.$this->values["format_price_2"].'">'
				.'<br>',
				
				'<input type="text" name="format_price_3" size="2" value="'.$this->values["format_price_3"].'">'
			)
			.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Валюта для Яндекс.Маркета"
	 * 
	 * @return boolean true
	 */
	protected function edit_currencyyandex_module_config()
	{
		echo '
		<tr'.$this->get_other().' valign="top">
			<td class="first-td">'.$this->variable_names().'</td>
			<td>
				<select name="'.$this->key.'">
					'.$this->select_option($this->key, '', '', '', $this->value).'
				</select>
				<div class="currencyratesel">
					<br>
					<select name="currencyratesel">
						'.$this->select_option('currencyratesel', '', '', '', $this->values['currencyratesel']).'
					</select>
					<div class="currencyrate">
						<br>
						<input type="text" name="currencyrate" size="20" value="'.$this->values["currencyrate"].'">
						'.$this->variable_names("currencyrate").'
					</div>
				</div>';
		?>
		<script language="javascript" type="text/javascript">
		$(document).ready(function() {
			$("select[name=currencyyandex]").change(function(){
				show_currency($(this));
			});
			$("select[name=currencyratesel]").change(function(){
				show_currencysel($(this));
			});
			
			show_currency($("select[name=currencyyandex]"));
			show_currencysel();
			function show_currency(th)
			{
				if(th.val() == 'RUR')
				{
					$(".currencyratesel").hide();
				}
				else
				{
					$(".currencyratesel").show();
				}
			}
			function show_currencysel(th)
			{
				if(th.val() == '2')
				{
					$(".currencyrate").hide();
				}
				else
				{
					$(".currencyrate").show();
				}
			}
		});
		</script>
		<?php
		echo $this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Выводит вкладку "Наличными курьеру"
	 * 
	 * @return boolean true
	 */
	protected function edit_tab_1_module_config()
	{
		echo '</table>
		<script language="javascript" type="text/javascript">
			var tabs_mini = new Array("courier", "wm", "robox", "non_cash");
			var current_tab_mini = "";
		</script>
		<table class="table-edit">
			<tr'.$this->get_other().'>
				<td>
					<a href="javascript:void(0)" class="show_tab_mini href" rel="courier">'._ADMIN_SHOP_CONFIG_COURIER.'</a>
				</td>
			</tr>
		</table>
		<div  class="tab_mini courier">
		<table class="table-edit">
			<tr>
				<td class="first-td"></td>
				<td></td>
			</tr>';

		return TRUE;
	}

	/**
	 * Выводит вкладку "Webmoney"
	 * 
	 * @return boolean true
	 */
	protected function edit_tab_2_module_config()
	{
		echo '</table>
		</div>
		<table class="table-edit">
			<tr'.$this->get_other().'>
				<td align="left">
					<a href="javascript:void(0)" class="show_tab_mini href" rel="wm">'._ADMIN_SHOP_CONFIG_WEBMONEY.'</a>
				</td>
			</tr>
		</table>
		<div class="tab_mini wm">
		<table class="table-edit">
			<tr>
				<td class="first-td"></td>
				<td></td>
			</tr>';

		return TRUE;
	}

	/**
	 * Выводит вкладку "Roboxchange"
	 * 
	 * @return boolean true
	 */
	protected function edit_tab_3_module_config()
	{
		echo '</table>
		</div>
		<table class="table-edit">
			<tr'.$this->get_other().'>
				<td align="left">
					<a href="javascript:void(0)" class="show_tab_mini href" rel="robox">'._ADMIN_SHOP_CONFIG_ROBOX.'</a>
				</td>
			</tr>
		</table>
		<div class="tab_mini robox">
		<table class="table-edit">
			<tr>
				<td class="first-td"></td>
				<td></td>
			</tr>';

		return TRUE;
	}

	/**
	 * Выводит вкладку "Банковские платежи"
	 * 
	 * @return boolean true
	 */
	protected function edit_tab_4_module_config()
	{
		echo '</table>
		</div>
		<table class="table-edit">
			<tr'.$this->get_other().'>
				<td align="left">
					<a href="javascript:void(0)" class="show_tab_mini href" rel="non_cash">'._ADMIN_SHOP_CONFIG_NON_CASH.'</a>
				</td>
			</tr>
		</table>
		<div class="tab_mini non_cash">
		<table class="table-edit">
			<tr>
				<td class="first-td"></td>
				<td></td>
			</tr>';

		return TRUE;
	}

	/**
	 * Закрывает вкладку "Банковские платежи"
	 * 
	 * @return boolean true
	 */
	protected function edit_tab_5_module_config()
	{
		echo '</table>
		</div>
		<table class="table-edit">
			<tr>
				<td class="first-td"></td>
				<td></td>
			</tr>';

		return TRUE;
	}

	/**
	 * Сохранение поля "Roboxchange: логин"
	 * 
	 * @return boolean true
	 */
	protected function save_robox_login_module_config()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Roboxchange: пароль 1"
	 * 
	 * @return boolean true
	 */
	protected function save_robox_pass_1_module_config()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Roboxchange: пароль 2"
	 * 
	 * @return boolean true
	 */
	protected function save_robox_pass_2_module_config()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Webmoney: кошелек"
	 * 
	 * @return boolean true
	 */
	protected function save_wm_target_module_config()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Webmoney: секретный ключ"
	 * 
	 * @return boolean true
	 */
	protected function save_wm_secret_module_config()
	{
	$text = '<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined(\'DIAFAN\'))
{
	include(dirname(__FILE__).\'/includes/404.php\');
}
define("REVATIVE_PATH","'.REVATIVE_PATH.'");';
		foreach($this->diafan->language_all as $l => $langarr)
		{
			if(defined("TIT".$langarr[0]))
			{
				$text.='
define("TIT'.$langarr[0].'", "'.constant("TIT".$langarr[0]).'");';
			}
		}
	$text.='

define("DB_URL", "'.DB_URL.'");
define("DB_PREFIX", "'.DB_PREFIX.'");
define("DB_CHARSET", "'.DB_CHARSET.'");

define("EMAIL_CONFIG", "'.EMAIL_CONFIG.'");
define("HTMLEDITOR", '.(HTMLEDITOR ? 'TRUE' : 'FALSE').');
define("USERFILES", "'.USERFILES.'");
define("LANGUAGE_BASE", "'.LANGUAGE_BASE.'");
define("VERSION_CMS", "'.VERSION_CMS.'");
define("DATE_UPDATE", "'.DATE_UPDATE.'");
define("DIAFAN_CODE", "'.DIAFAN_CODE.'");
define("ADMIN_FOLDER", "'.ADMIN_FOLDER.'");
define("MOD_DEVELOPER", '.(MOD_DEVELOPER ? 'TRUE' : 'FALSE').');
define("MOD_DEVELOPER_CACHE", '.(MOD_DEVELOPER_CACHE ? 'TRUE' : 'FALSE').');
define("MOD_DEVELOPER_PROFILING", '.(MOD_DEVELOPER_PROFILING ? 'TRUE' : 'FALSE').');

define("FTP_HOST", "'.FTP_HOST.'");
define("FTP_DIR", "'.FTP_DIR.'");
define("FTP_LOGIN", "'.FTP_LOGIN.'");
define("FTP_PASSWORD", "'.FTP_PASSWORD.'");

define("SMTP_MAIL", '.(defined('SMTP_MAIL') && SMTP_MAIL ? 'TRUE' : 'FALSE').');
define("SMTP_HOST", "'.(defined('SMTP_HOST') ? SMTP_HOST : '').'");
define("SMTP_LOGIN", "'.(defined('SMTP_LOGIN') ? SMTP_LOGIN : '').'");
define("SMTP_PASSWORD", "'.(defined('SMTP_PASSWORD') ? SMTP_PASSWORD : '').'");
define("SMTP_PORT", "'.(defined('SMTP_PORT') ? SMTP_PORT : '').'");
'
.(! empty($_POST["robox"]) || ! empty($_POST["robox_login"]) ? '
define("ROBOX_LOGIN", "'.$this->diafan->get_param($_POST, "robox_login", '', 1 ).'");' : '')
.(! empty($_POST["robox"]) || ! empty($_POST["robox_pass_1"]) ? '
define("ROBOX_PASS_1", "'.$this->diafan->get_param($_POST, "robox_pass_1", '', 1 ).'");' : '')
.(! empty($_POST["robox"]) || ! empty($_POST["robox_pass_2"]) ? '
define("ROBOX_PASS_2", "'.$this->diafan->get_param($_POST, "robox_pass_2", '', 1 ).'");
':'')
	
.(! empty($_POST["webmoney"]) || ! empty($_POST["wm_secret"]) ? '
define("WM_SECRET", "'.$this->diafan->get_param($_POST, "wm_secret", '', 1 ).'");' : '')
.(! empty($_POST["webmoney"]) || ! empty($_POST["wm_target"]) ? '
define("WM_TARGET", "'.$this->diafan->get_param($_POST, "wm_target", '', 1 ).'");' : '');
		$fp = fopen(ABSOLUTE_PATH."bdcfg.php", "w");
		fwrite($fp, $text);
		fclose($fp);
		return TRUE;
	}

	/**
	 * Сохранение поля "Наличными курьеру: описание"
	 * 
	 * @return boolean true
	 */
	protected function save_courier_text_module_config()
	{
		$this->save_text_info("courier");

		return TRUE;
	}

	/**
	 * Сохранение поля "Банковские платежи: описание"
	 * 
	 * @return boolean true
	 */
	protected function save_non_cash_text_module_config()
	{
		$this->save_text_info("non_cash");

		return TRUE;
	}

	/**
	 * Сохранение поля "Roboxchange: описание"
	 * 
	 * @return boolean true
	 */
	protected function save_robox_text_module_config()
	{
		$this->save_text_info("robox");

		return TRUE;
	}

	/**
	 * Сохранение поля "Webmoney: описание"
	 * 
	 * @return boolean true
	 */
	protected function save_wm_text_module_config()
	{
		$this->save_text_info("wm");

		return TRUE;
	}

	/**
	 * Сохранение поля "Оформление платежа. Шаг 2"
	 * 
	 * @return boolean true
	 */
	protected function save_order_step_2_text_module_config()
	{
		$this->save_text_info("order_step_2");

		return TRUE;
	}

	/**
	 * Сохранение поля "Платеж успешно принят"
	 * 
	 * @return boolean true
	 */
	protected function save_payment_success_text_module_config()
	{
		$this->save_text_info("payment_success");

		return TRUE;
	}

	/**
	 * Сохранение поля "Платеж не принят"
	 * 
	 * @return boolean true
	 */
	protected function save_payment_fail_text_module_config()
	{
		$this->save_text_info("payment_fail");

		return TRUE;
	}

	/**
	 * Сохраняет конфигурируемые значения в базу данных
	 * 
	 * @return boolean
	 */
	private function save_text_info($key)
	{
		if(empty($_POST[$key."_text"]))
			return FALSE;

		if(! $id = DB::where("info", "tag_name='shop_".$key."'", "id"))
		{
			DB::query("INSERT INTO {info} (tag_name, [text]) VALUES ('%s', '%s')", 'shop_'.$key, $_POST[$key."_text"]);

			return TRUE;
		}

		DB::query("UPDATE {info} SET [text]='%s' WHERE id='%d'",$_POST[$key."_text"], $id);

		return TRUE;
	}

	/**
	 * Поготавливает значения для формы
	 * 
	 * @return array
	 */
	protected function get_values()
	{
		$values = array(
			"wm_text"              => DB::where("info", "tag_name='shop_wm'",              "text"._LANG),
			"robox_text"           => DB::where("info", "tag_name='shop_robox'",           "text"._LANG),
			"courier_text"         => DB::where("info", "tag_name='shop_courier'",         "text"._LANG),
			"non_cash_text"        => DB::where("info", "tag_name='shop_non_cash'",        "text"._LANG),
			"order_step_2_text"    => DB::where("info", "tag_name='shop_order_step_2'",    "text"._LANG),
			"payment_success_text" => DB::where("info", "tag_name='shop_payment_success'", "text"._LANG),
			"payment_fail_text"    => DB::where("info", "tag_name='shop_payment_fail'",    "text"._LANG)
		);
		return $values;
	}
}