<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Shop_admin_element
 *
 * Редактирование администраторов сайта
 */
class Shop_admin_element extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'shopelement';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'shop';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'		=> 'text',
			'act'		=> 'checkbox',
			'price'		=> 'floattext',
			'photo'		=> 'function',
			'hr1'           => 'hr',
			'param'		=> 'function',
			'hr2'           => 'hr',
			'tags'		=> 'function',
			'comments'	=> 'function',
			'rate'		=> 'function',
			'hr3'           => 'hr',
			'number'	=> 'function',
			'timeedit'	=> 'text',
			'title_meta'	=> 'text',
			'keywords'	=> 'text',
			'descr'		=> 'textarea',
			'rewrite'	=> 'function',
			'hr4'		=> 'hr',
			'cat_id'	=> 'function',
			'site_id'	=> 'function',
			'hr5'		=> 'hr',
			'sort'		=> 'function',
			'hr6'		=> 'hr',
			'show_yandex'	=> 'checkbox',
			'yandex'	=> 'function',
			'hr7'           => 'hr',
			'anons'         => 'editor',
			'text'		=> 'editor'
		);
		
		//поля, которые прячутся в Дополнительно
		$this->variable_other = array(
			'hr3'           => 1,
			'hr4'           => 1,
			'hr5'           => 1,
			'hr6'           => 1,
			'number'        => 1,
			'title_meta'	=> 1,
			'timeedit'	=> 1,
			'keywords'	=> 1,
			'descr'		=> 1,
			'rewrite'	=> 1,
			'cat_id'	=> 1,
			'site_id'	=> 1,
			'sort'		=> 1,
			'yandex'	=> 1,
			'show_yandex'	=> 1
		);
		
		//переводимые поля
		$this->language_names = array(
			'name',
			'title_meta',
			'act',
			'keywords',
			'descr',
			'text',
			'anons'	
		);
		
		$this->config_module = array(
			'del'	       => 1,	//удалить
			'act'	       => 1,	//показать/скрыть
			'order'        => 1,	//сортируется
			'element_site' => $this->diafan->configmodules("cat") ? 0 : 1,	//модуль может быть прикреплен к нескольким страницам
			'element'      => $this->diafan->configmodules("cat") ? 1 : 0,	//используются группы
			'trash'        => 1,	//использовать корзину
			'search_name'  => 1,	//искать по названию
			'photo'	       => 1	//показать фотографию в списке
		);

		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'id',
			'text'
		);

		if(! $this->diafan->configmodules('show_yandex_element', 'shop'))
		{
			unset($this->variable_table["show_yandex"]);
		}
		else
		{
			$this->show_tr_click_checkbox = array('show_yandex' => array('yandex'));
		}

		if(! extension_loaded('gd') && ! extension_loaded('gd2'))
		{
			$this->diafan->error = 7;
		}

		//высота поля для Визуального редактора
		$this->editor_height = array(
			'anons'   => 200,
			'text'    => 400
		);
	}

	/**
	 * Выводит список товаров
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_SHOP_ADD_GOODS);
		echo '<table class="list">';
		$this->list_row($this->diafan->cat);	
		echo '</table>';

		return TRUE;
	}

	/**
	 * Выводит цену в списке товаров
	 * @return string
	 */
	protected function other_row_id($row)
	{
		$min_price = 0;
		$max_price = 0;
		$result = DB::query("SELECT price FROM {shop_price} WHERE shop_id=%d ORDER BY price ASC", $row["id"]);
		while ($row = DB::fetch_array($result))
		{
			if(! $min_price)
			{
				$min_price = $row["price"];
			}
			$max_price = $row["price"];
		}
		return '</td><td>'.($min_price
				    ? ($min_price*1).($max_price != $min_price ? ' - '.($max_price*1) : '')
				      .' '.$this->diafan->configmodules("currency", "shop")
				    : '');
	}

	/**
	 * Редактирование поля "Цена"
	 * @return boolean true
	 */
	protected function edit_price_module()
	{
		if(! $this->diafan->addnew)
		{
			$result = DB::query("SELECT price, param_id, param_value FROM {shop_price} WHERE shop_id=%d ORDER BY param_value ASC", $this->diafan->edit);
			while ($row = DB::fetch_array($result))
			{
				if(! $row["param_id"])
				{
					$this->values["price"] = $row["price"];
				}
				else
				{
					$this->values["depend"][$row["param_id"]][$row["param_value"]] = $row["price"];
				}
			}
		}

		echo '
		<tr'.$this->get_other().(! empty($this->values["depend"]) ? ' class="hide"' : '').'>
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td>
				<input type="text" name="'.$this->key.'" size="20" value="'.(! empty($this->values["price"]) ? $this->values["price"] * 1 : '')
				.'" class="inpnum">
				'.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
		
	}

	/**
	 * Редактирование поля "Яндекс.Маркет"
	 * @return boolean true
	 */
	protected function edit_yandex_module()
	{
		if(! $this->diafan->configmodules("yandex"))
		{
			return;
		}

		$u = array();

		if(! $this->diafan->addnew)
		{		
			if($this->value)
			{
				$conf_arr = explode("\n", $this->value);
				foreach($conf_arr as $c_a)
				{
					list($k, $v) = explode("=", $c_a, 2);
					$u[$k] = $v;
				}
			}
		}

		echo '
		<tr'.$this->get_other().' valign="top">
			<td align="right">'
				.$this->variable_names().$this->show_help_row().'
			</td>
			<td>'
		._ADMIN_SHOPELEMENT_YANDEX_CAT.':<br>
		<input type="text" maxLength="70" name="typePrefix" size="40" class="inptext" value="'.(! empty($u["typePrefix"]) ? $u["typePrefix"] : '').'"><br>'
		
		.'<br>'._ADMIN_SHOPELEMENT_YANDEX_VENDOR.':<br>
		<input type = "text" maxLength="70" name="vendor" size="40" class="inptext" value="'.(! empty($u["vendor"]) ? $u["vendor"] : '').'"><br>'
		
		._ADMIN_SHOPELEMENT_YANDEX_MODEL.':<br>
		<input type = "text" maxLength="70" name="model" size="40" class="inptext" value="'.(! empty($u["model"]) ? $u["model"] : '').'"><br>'
		
		._ADMIN_SHOPELEMENT_YANDEX_VENDORCODE.':<br>
		<input type = "text" maxLength="70" name="vendorCode" size="40" class="inptext" value="'.(! empty($u["vendorCode"]) ? $u["vendorCode"] : '').'"><br>'
		
		._ADMIN_SHOPELEMENT_YANDEX_SALES_NOTES.':<br>
		<input type = "text" maxLength="50" name="sales_notes" size="40" class="inptext" value="'.(! empty($u["sales_notes"]) ? $u["sales_notes"] : '').'"><br>'
		
		._ADMIN_SHOPELEMENT_YANDEX_MANUFACTURER_WARRANTY.': 
		<input type = "checkbox" name="manufacturer_warranty" value="1"'.(! empty($u["manufacturer_warranty"]) ? ' checked' : '').'><br><br>'
		
		._ADMIN_SHOPELEMENT_YANDEX_COUNTRY_OF_ORIGINAL.':<br>
		<input type = "text" maxLength="70" name="country_of_origin" size="40" class="inptext" value="'.(! empty($u["country_of_origin"]) ? $u["country_of_origin"] : '').'">
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Дополнительные параметры"
	 * 
	 * @return boolean true
	 */
	protected function edit_param_module()
	{
		echo '
		<tr>
			<td></td>
			<td>
				<a href="'.BASE_PATH_HREF.'shop/param/addnew1/" target="_blank">'._ADMIN_SHOP_ADD_PARAM.'</a>
				'.$this->show_help_row().'
			</td>
		</tr>';
		$values = array();
		$rvalues = array();
		
		if($this->diafan->addnew)
		{
			$result = DB::query("SELECT p.id, p.name, p.type FROM {param} as p "
					    ." INNER JOIN {category} as cp ON cp.module_name='shopparam' AND cp.cat_id IN (%d, 0) AND cp.element_id=p.id"
					    ." WHERE p.trash='0' AND p.module_name='shop'"
					    ." GROUP BY p.id"
					    ." ORDER BY p.sort ASC", $this->diafan->cat
					    );
		}
		else
		{
			$result = DB::query("SELECT p.id, p.name, p.type FROM {param} as p "
					    .($this->diafan->configmodules("cat") ? " INNER JOIN {category} as c ON c.module_name='shop' AND c.element_id=%d" : "")
					    ." INNER JOIN {category} as cp ON cp.module_name='shopparam' AND ("
						.($this->diafan->configmodules("cat") ? "cp.cat_id=c.cat_id OR" : "")
						." cp.cat_id=0) AND cp.element_id=p.id"
					    ." WHERE p.trash='0' AND p.module_name='shop'"
					    ." GROUP BY p.id"
					    ." ORDER BY p.sort ASC", $this->diafan->edit
					    );
			$result_el = DB::query("SELECT value as rv, [value], param_id FROM {param_element} WHERE element_id=%d AND module_name='shop'", $this->diafan->edit);
			while ($row_el = DB::fetch_array($result_el))
			{
				$values[$row_el["param_id"]][] = $row_el["value"];
				$rvalues[$row_el["param_id"]][] = $row_el["rv"];
			}
		}

		while($row = DB::fetch_array($result))
		{
			$option = array();
			if(in_array($row["type"], array('select', 'multiple')))
			{
				$result_select = DB::query("SELECT [name], value FROM {param_select} WHERE param_id=%d ORDER BY value ASC", $row["id"]);
				while ($row_select = DB::fetch_array($result_select))
				{
					$option[$row_select["value"]] = $row_select["name"];
				}
			}
			if($row["type"] == 'text')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="40" value="'.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '').'">
					</td>
				</tr>';
			}
			elseif($row["type"] == 'date')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="40" value="'.(! empty($rvalues[$row["id"]]) ? str_replace('"', '&quot;', date("d.m.Y", $rvalues[$row["id"]][0])) : '').'">
					</td>
				</tr>';
			}
			elseif($row["type"] == 'numtext')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="text" name="param'.$row["id"].'" size="20" value="'.(! empty($rvalues[$row["id"]]) ? str_replace('"', '&quot;', $rvalues[$row["id"]][0]) : '').'" class="inpnum">
					</td>
				</tr>';
			}
			elseif($row["type"] == 'textarea')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<textarea name="param'.$row["id"].'" cols="60" rows="5">'.(! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '').'</textarea>
					</td>
				</tr>';
			}
			elseif($row["type"] == 'checkbox')
			{
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<input type="checkbox" name="param'.$row["id"].'" value="1"'.(! $this->diafan->addnew && ! empty($rvalues[$row["id"]][0]) ? " checked":'').'>
					</td>
				</tr>';
			}
			elseif($row["type"] == 'select')
			{
				$value = (! empty($rvalues[$row["id"]][0]) ? $rvalues[$row["id"]][0] : '');
				echo '
				<tr>
					<td align="right">'.$row["name"].'</td>
					<td>
						<select name="param'.$row["id"].'">
						<option value="">-</option>';
						foreach($option as $k => $v)
						{
							echo '<option value="'.$k.'"'.($value == $k ? ' selected' : '').'>'.$v.'</option>';
						}
						echo '</select>
					</td>
				</tr>';
			}
			elseif($row["type"] == 'multiple')
			{
				$value = (! empty($rvalues[$row["id"]]) ? $rvalues[$row["id"]] : array());
				echo '
				<tr>
					<td align="right">
						'.$row["name"].'
						<a href="javascript:void(0)" onClick="show_div(\'help_depend_price'.$row["id"].'\');"><img src="'.BASE_PATH.'img/quest.gif"></a>
						<br>
						<div id="help_depend_price'.$row["id"].'" class="help-row">'._ADMIN_SHOPELEMENT_DEPEND_PRICE_HELP.'</div>
						<div class="check_price'.(! empty($this->values["depend"]) && empty($this->values["depend"][$row["id"]]) ? ' hide' : '').'">
							<input type="checkbox" name="check_price_'.$row["id"].'" value="1"
							'.(! empty($this->values["depend"][$row["id"]]) ? ' checked' : '').' rel="'.$row["id"].'">
							'._ADMIN_SHOP_DEPEND_PRICE.'
						</div>
					</td>
					<td>
						<div class="select_param'.(! empty($this->values["depend"][$row["id"]]) ? ' hide' : '').'" id="select_param_'.$row["id"].'">
						<select name="param'.$row["id"].'[]" multiple="multiple">';
						foreach($option as $k => $v)
						{
							echo '<option value="'.$k.'"'.(in_array($k, $value) ? ' selected' : '').'>'.$v.'</option>';
						}
						echo '</select>
					</div>
					<div class="price_param'.(empty($this->values["depend"][$row["id"]]) ? ' hide' : '').'" id="price_param_'.$row["id"].'">
					<table class="table-in">
					<tr>
						<th>'._ADMIN_VALUE.'</th>
						<th>'._LANG_PRICE.'</th>
					</tr>';
					foreach($option as $k => $v)
					{
						echo '<tr>
						<td>
							'.$v.'
						</td>
						<td>
							<input name="param_price_'.$row["id"].'_'.$k.'" value="'
							.(! empty($this->values["depend"][$row["id"]][$k]) ? $this->values["depend"][$row["id"]][$k] : '').'">
						</td>
						</tr>';
					}
					echo '</table>
					</div>
					</td>
				</tr>';
			}
			elseif($row["type"] == 'editor')
			{
				echo '
				<tr'.$this->get_other().'>
					<td colspan="2">'.$row["name"]
						.'<textarea name="param'.$row["id"].'" style="width:100%;height:200px"'.(HTMLEDITOR ? ' class="htmleditor"' : '').'>'
						.(! $this->diafan->addnew && ! empty($values[$row["id"]]) ? $values[$row["id"]][0] : '')
						.'</textarea>
					</td>
				</tr>';
			}
		}
		return TRUE;
	}

	/**
	 * Сохранение поля "Цена"
	 * @return boolean true
	 */
	protected function save_price_module()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Яндекс.Маркет"
	 * @return boolean true
	 */
	protected function save_yandex_module()
	{
		if(! $this->diafan->configmodules("yandex"))
		{
			return FALSE;
		}
		
		$this->query[] = "yandex='%s'";
		$this->value[] =
			'typePrefix='.str_replace("\n", '', $this->diafan->get_param($_POST, "typePrefix", '', 1))."\n"
			.'vendor='.str_replace("\n", '', $this->diafan->get_param($_POST, "vendor", '', 1))."\n"
			.'model='.str_replace("\n", '', $this->diafan->get_param($_POST, "model", '', 1))."\n"
			.'vendorCode='.str_replace("\n", '', $this->diafan->get_param($_POST, "vendorCode", '', 1))."\n"
			.'sales_notes='.str_replace("\n", '', $this->diafan->get_param($_POST, "sales_notes", '', 1))."\n"
			.'manufacturer_warranty='.str_replace("\n", '', $this->diafan->get_param($_POST, "manufacturer_warranty", '', 1))."\n"
			.'country_of_origin='.str_replace("\n", '', $this->diafan->get_param($_POST, "country_of_origin", '', 1));

		return TRUE;
	}

	/**
	 * Сохранение поля "Дополнительные параметры"
	 * 
	 * @return boolean true
	 */
	protected function save_param_module()
	{
		$price = FALSE;
		$ids = array();
		
		if($this->diafan->savenew)
		{
			$result = DB::query("SELECT p.id, p.name, p.type FROM {param} as p "
					    ." INNER JOIN {category} as cp ON cp.module_name='shopparam' AND cp.cat_id IN (%d, 0) AND cp.element_id=p.id"
					    ." WHERE p.trash='0' AND p.module_name='shop'"
					    ." GROUP BY p.id"
					    ." ORDER BY p.sort ASC", $this->diafan->cat
					    );
		}
		else
		{
			DB::query("DELETE FROM {shop_price} WHERE shop_id=%d", $this->diafan->save);
			$result = DB::query("SELECT p.id, p.name, p.type FROM {param} as p "
					    .($this->diafan->configmodules("cat") ? " INNER JOIN {category} as c ON c.module_name='shop' AND c.element_id=%d" : "")
					    ." INNER JOIN {category} as cp ON cp.module_name='shopparam' AND ("
						.($this->diafan->configmodules("cat") ? "cp.cat_id=c.cat_id OR" : "")
						." cp.cat_id=0) AND cp.element_id=p.id"
					    ." WHERE p.trash='0' AND p.module_name='shop'"
					    ." ORDER BY p.sort ASC", $this->diafan->save
					    );
		}

		while($row = DB::fetch_array($result))
		{
			if($row["type"] == "multiple")
			{
				DB::query("DELETE FROM {param_element} WHERE param_id=%d AND element_id=%d AND module_name='shop'", $row["id"], $this->diafan->save);
				if(! empty($_POST['check_price_'.$row["id"]]))
				{
					$result_select = DB::query("SELECT value FROM {param_select} WHERE param_id=%d", $row["id"]);
					while ($row_select = DB::fetch_array($result_select))
					{
						$option[] = $row_select["value"];
					}
					foreach($option as $v)
					{
						if(! empty($_POST['param_price_'.$row["id"].'_'.$v]))
						{
							DB::query(
								"INSERT INTO {param_element} (value, param_id, element_id, module_name) VALUES ('%s', %d, %d, 'shop')",
								$v,
								$row["id"],
								$this->diafan->save
							);
							DB::query(
								"INSERT INTO {shop_price} (price, param_id, shop_id, param_value) VALUES ('%f', %d, %d, '%d')",
								$_POST['param_price_'.$row["id"].'_'.$v],
								$row["id"],
								$this->diafan->save,
								$v
							);
						}
					}
					$price = TRUE;
				}
				elseif(! empty($_POST['param'.$row["id"]]) && is_array($_POST['param'.$row["id"]]))
				{
					foreach($_POST['param'.$row["id"]] as $v)
					{
						DB::query(
							"INSERT INTO {param_element} (value, param_id, element_id, module_name) VALUES ('%s', %d, %d, 'shop')",
							$v,
							$row["id"],
							$this->diafan->save
						);
					}
				}
				
			}
			elseif(! empty($_POST['param'.$row["id"]]))
			{
				$id = 0;
				if(! $this->diafan->savenew)
				{
					$id = DB::query_result("SELECT id FROM {param_element} WHERE param_id=%d AND element_id=%d AND module_name='shop'",
							       $row["id"], $this->diafan->save);
				}
				if($row["type"] == "date")
				{
					$_POST['param'.$row["id"]] = $this->diafan->unixdate($_POST['param'.$row["id"]]);
				}
				if($id)
				{
					DB::query(
						"UPDATE {param_element} SET ".(in_array($row["type"], array("text", "editor", "textarea")) ?'[value]' : 'value')
						."='%s' WHERE id=%d",
						$_POST['param'.$row["id"]],
						$id
					);
				}
				else
				{
					DB::query(
						"INSERT INTO {param_element} (".(in_array($row["type"], array("text", "editor", "textarea")) ?
										 '[value]' : 'value')
						.", param_id, element_id, module_name) VALUES ('%s', %d, %d, 'shop')",
						$_POST['param'.$row["id"]],
						$row["id"],
						$this->diafan->save
					);
				}
			}
			else
			{
				DB::query("DELETE FROM {param_element} WHERE param_id=%d AND element_id=%d AND module_name='shop'", $row["id"], $this->diafan->save);
			}
			$ids[] = $row["id"];
		}
		DB::query("DELETE FROM {param_element} WHERE param_id NOT IN (".implode(", ", $ids).") AND element_id=%d AND module_name='shop'", $this->diafan->save);
		if(! $price && ! empty($_POST["price"]))
		{
			DB::query(
				"INSERT INTO {shop_price} (price, shop_id) VALUES ('%f', %d)",
				$_POST['price'],
				$this->diafan->save
			);
		}
		return TRUE;
	}
}