<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Shop_admin_order
 *
 * Редактирование заказов товаров
 */
class Shop_admin_order extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'shoporder';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'shop_order';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		//поля в базе данных для редактирования
		$this->variable_table = array(
			'number'	=> 'function',
			'user_id'	=> 'function',
			'address'	=> 'textarea',
			'more'		=> 'textarea',
			'created'	=> 'datetime',
			'status'	=> 'select',
			'payment'	=> 'select',
			'language'	=> 'select',
			'goods'		=> 'function'
		);
		
		$this->config_module = array(
			'del'		=> 1,	//удалить
			'datetime'	=> 1,	//показывать дату и время в списке
			'trash'		=> 1	//использовать корзину
		);
		
		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'status',
			'summ',
			'user_id',
			'address'
		);
		
		$this->select["language"] = array(
			"language",
			"id",
			"name"
		);
		
		$this->select_arr["status"] = array(
			0	 => _ADMIN_SHOPORDER_STATUS_0,
			1	 => _ADMIN_SHOPORDER_STATUS_1,
			2	 => _ADMIN_SHOPORDER_STATUS_2,
			3	 => _ADMIN_SHOPORDER_STATUS_3,
			4	 => _ADMIN_SHOPORDER_STATUS_4,
			5	 => _ADMIN_SHOPORDER_STATUS_5
		);
		if($this->diafan->configmodules("pay_systems", "shop"))
		{
			$this->select_arr["payment"][0] = '';
			if($this->diafan->configmodules("webmoney", "shop"))
			{
				$this->select_arr["payment"][1] = 'Webmoney';
			}
			if($this->diafan->configmodules("robox", "shop"))
			{
				$this->select_arr["payment"][2] = 'Roboxchange';
			}
			if($this->diafan->configmodules("non_cash", "shop"))
			{
				$this->select_arr["payment"][3] = _LANG_NON_CACHE;
			}
			if($this->diafan->configmodules("courier", "shop"))
			{
				$this->select_arr["payment"][4] = _LANG_COURIER;
			}
		}
		else
		{
			unset($this->variable_table["payment"]);
		}
		
		$this->select_arr["color"] = array(
			0	=> "red",
			1	=> "blue",
			2	=> "green",
			3	=> "gray",
			4	=> "orange",
			5	=> "gray"
		);
	}

	/**
	 * Выводит список заказов
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->name = "concat('"._ADMIN_SHOPORDER_NUMBER." ', id)";

		echo '<table border="0" cellpadding="1" cellspacing="3" class="list">
		<col width="12%">
		<col width="9%">
		<col width="15%">
		<col width="9%">
		<col width="10%">
		<col width="39%">
		<col width="4%">
		';
		$this->list_row();	
		echo '</table>';
		if(! $this->count)
		{
			echo _ADMIN_SHOPORDER_NONE;
		}

		return TRUE;
	}

	/**
	 * Редактирование поля "Номер"
	 * @return boolean true
	 */
	protected function edit_number_module()
	{
		echo '<tr'.$this->get_other().'>
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td style="color:#999999;font-weight:bold">
				'.$this->diafan->edit.' '.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Выводит имя заказчика в списке заказов
	 * @return string
	 */
	protected function other_row_user_id($row)
	{
		return '</td><td>'
		.($row["user_id"]
		 ? '<a href="'.BASE_PATH_HREF.'usersite/edit'.$row["user_id"].'/">'.DB::title("users_site", $row["user_id"], "fio").'</a>'
		 : _ADMIN_SHOPORDER_NOT_REGISTRATION);
	}

	/**
	 * Выводит сумму заказа в списке заказов
	 * @return string
	 */
	protected function other_row_summ($row)
	{
		return '</td><td>'
		.($row["summ"]
		 ? $this->diafan->format_price($row["summ"]).' '.$this->diafan->configmodules("currency", "shop")
		 : '');
	}

	/**
	 * Выводит адрес в списке заказов
	 * @return string
	 */
	protected function other_row_address($row)
	{
		return '</td><td class="Comments">
			<div>
				<span></span>
				<table><tbody><tr><td>'
				.str_replace(
					array(_LANG_ADDRESS.':', _LANG_TOWN.':', _LANG_STREET.':', _LANG_HOUSE_NUMBER.':', _LANG_BLOCK.':', _LANG_FLAT.':', _LANG_CONTACTS.':', '<br>'),
					array('', '', '', '', '', '', '', ' '),
					$row["address"])
				.'</td></tr></tbody></table>
			</div>';
	}

	/**
	 * Выводит статус заказа в списке заказов
	 * @return string
	 */
	protected function other_row_status($row)
	{
		if(! $row["status"])
		{
			$row["status"] = 0;
		}
		return '</td><td>'.(! empty($this->select_arr["status"][$row["status"]])
				    ? '<span style="color:'.$this->select_arr["color"][$row["status"]].';font-weight: bold;">'
				      .$this->select_arr["status"][$row["status"]].'</span>'
				    : '');
	}

	/**
	 * Редактирование поля "Пользователь"
	 * @return boolean true
	 */
	protected function edit_user_id_module()
	{
		if($this->value)
		{
			echo '
			<tr>
				<td align="right">'.$this->variable_names().'</td>
				<td>
					<a href="'.BASE_PATH_HREF.'usersite/edit'.$this->value.'/">'.DB::title("users_site", $this->value, "fio").'</a>'
					.$this->show_help_row().'
				</td>
			</tr>';
		}
	}

	/**
	 * Редактирование поля "Адрес получателя"
	 * @return boolean true
	 */
	protected function edit_address_module()
	{
		echo '
		<tr>
			<td align="right" valign="top">'.($this->values["user_id"] ? $this->variable_names() : _ADMIN_SHOPORDER_CUSTOMER).'</td>
			<td>'.$this->value.$this->show_help_row().'</td>
		</tr>';
	}

	/**
	 * Редактирование поля "Товары"
	 * @return boolean true
	 */
	protected function edit_goods_module()
	{
		$summ = 0; $count = 0;
		echo '
		<tr>
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<table class="border" cellspacing="0">
					<tr id="first-tr">
						<td id="first">'._LANG_NAME_GOOD.'</td>
						<td>'._LANG_COUNT.'</td>
						<td>'._LANG_PRICE.'</td>
						<td>'._LANG_SUM.'</td>
					</tr>';
		$result = DB::query("SELECT * FROM {shop_goods} where order_id=%d", $this->values["id"]); 
		while($row = DB::fetch_array($result))
		{
			$depend = '';
			if($row["depend_price"])
			{
				$param_name  = DB::query_result("SELECT [name] FROM {param} WHERE id IN (SELECT param_id FROM {shop_price} WHERE shop_id=%d AND param_value=%d)", $row["good"], $row["depend_price"]);
				$param_value = DB::query_result("SELECT s.[name] FROM {param_select} as s WHERE s.value=%d AND s.param_id IN (SELECT param_id FROM {shop_price} WHERE shop_id=%d AND param_value=s.value)", $row["depend_price"], $row["good"]);
				$depend = ', '.$param_name.': '.$param_value;
			}
			$result_p = DB::query("SELECT * FROM {param_element} WHERE element_id=%d AND module_name='shopgoods'", $row["id"]); 
			while($row_p = DB::fetch_array($result_p))
			{
				$param_name  = DB::query_result("SELECT [name] FROM {param} WHERE id=%d", $row_p["param_id"]);
				$param_value = DB::query_result("SELECT s.[name] FROM {param_select} as s WHERE s.value=%d AND s.param_id=%d", $row_p["value"], $row_p["param_id"]);
				$depend .= ', '.$param_name.': '.$param_value;
			}
			
			echo '
					<tr>
						<td id="first">'.DB::title("shop", $row["good"], "name").$depend.'</td>
						<td align="center">'.$row["count_goods"].'</td>
						<td align="right">'.$this->diafan->format_price($row["price"]).'</td>
						<td align="right">'.$this->diafan->format_price($row["price"] * $row["count_goods"]).'</td>
					</tr>';
					
			$summ += $row["price"] * $row["count_goods"];
			$count += $row["count_goods"];
		}
		
		echo '
					<tr>
						<td id="first">'._LANG_GOODS_TOTAL.'</td>
						<td align="center">'.$count.'</td>
						<td>&nbsp;</td>
						<td align="right">'.$this->diafan->format_price($summ).'</td>
					</tr>
				</table>
				'.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Сохранение поля "Пользователь"
	 * @return boolean true
	 */
	protected function save_user_id_module()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Адрес"
	 * @return boolean true
	 */
	protected function save_address_module()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Товары"
	 * @return boolean true
	 */
	protected function save_goods_module()
	{
		return TRUE;
	}
}