<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Shop_admin_param
 *
 * Редактирование дополнительных характеристик товаров
 */
class Shop_admin_param extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'shopparam';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'param'; 

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'     => 'text',
			'type'     => 'select',
			'search'   => 'checkbox',
			'list'     => 'checkbox',
			'block'    => 'checkbox',
			'cat_id'   => 'function',
			'required' => 'checkbox',
			'param'    => 'function',
			'sort'     => 'function'
		);

		//поля, которые прячутся в Дополнительно
		$this->variable_other = array(
			'sort' => 1
		);

		//переводимые поля
		$this->language_names = array(
			'name'
		);

		$this->config_module = array(
			'del'   => 1,	//удалить
			'order' => 1,	//сортируется
			'trash' => 1	//использовать корзину
		);

		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'type',
			'id'
		);

		$this->select_arr["type"] = array(
			"text"     => _ADMIN_PARAM_TEXT_FIELD,
			"numtext"  => _ADMIN_PARAM_NUMTEXT_FIELD,
			"date"     => _ADMIN_PARAM_DATE_FIELD,
			"textarea" => _ADMIN_PARAM_TEXTAREA_FIELD,
			"checkbox" => _ADMIN_PARAM_CHECKBOX_FIELD,
			"select"   => _ADMIN_PARAM_SELECT_FIELD,
			"multiple" => _ADMIN_PARAM_MULTIPLE_FIELD,
			"editor"   => _ADMIN_PARAM_EDITOR_FIELD
		);
		$this->where = " AND module_name='shop'";
	}

	/**
	 * Выводит список дополнительных характеристик товара
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_SHOP_ADD_PARAM);

		echo '<p>'._ADMIN_CAT_ID.': <select rel="'.path_module($this->diafan, 0, 0, 0, 1, 1).'" class="redirect" name="cat">'
		.'<option value="">'._LANG_ALL.'</option>'
		.'<option value="9999"'.($this->diafan->cat == 9999 ? ' selected' : '').'>'._LANG_COMMON.'</option>';
		$result = DB::query("SELECT id, name FROM {shop_category} WHERE trash='0' ORDER BY sort ASC");
		while ($row = DB::fetch_array($result))
		{
			$cats[0][] = $row;
		}
		echo $this->get_options($cats, $cats[0], array($this->diafan->cat))
		.'</select></p>';

		if($this->diafan->cat)
		{
			$this->diafan->cat = $this->diafan->cat == 9999 ? 0 : $this->diafan->cat;
			$this->where .= " AND id IN (SELECT element_id FROM {category} WHERE module_name='shopparam' AND cat_id='".$this->diafan->cat."')";
		}

		echo '<table class="list">';
		$this->list_row();
		echo '</table>';

		return TRUE;
	}

	/**
	 * Выводит категории в списке характеристик
	 * @return boolean true
	 */
	protected function other_row_type($row)
	{
		$cats = array();
		$result = DB::query("SELECT s.[name] FROM {category} as c INNER JOIN {shop_category} as s ON s.id=c.cat_id"
		                    ." WHERE module_name='shopparam' AND element_id='%d'", $row["id"]);
		while($row_cat = DB::fetch_array($result))
		{
			$cats[] = $row_cat["name"];
		}
		if(! $cats)
		{
			$cats[] = _LANG_COMMON;
		}
		return '</td><td>'.implode(', ', $cats);
	}

	/**
	 * Выводит тип характеристики в списке характеристик
	 * @return boolean true
	 */
	protected function other_row_id($row)
	{
		return '</td><td>'.$this->select_arr["type"][$row["type"]];
	}

	/**
	 * Редактирование поля "Параметры"
	 * @return boolean true
	 */
	protected function edit_param_module()
	{

		$value = array();
		if(! $this->diafan->addnew && in_array($this->values["type"], array('select', 'multiple', 'checkbox')))
		{
			$result_select = DB::query("SELECT [name], value FROM {param_select} WHERE param_id=%d ORDER BY value ASC", $this->diafan->edit);
			while ($row_select = DB::fetch_array($result_select))
			{
				$value[$row_select["value"]] = $row_select["name"];
			}
		}

		echo '
		<script language="javascript" type="text/javascript">
			$(document).ready(function(){
				show_param($("#type select"));
				$("#type select").change(function(){
					show_param($(this));
				});
			});
			function show_param(obj)
			{
				if(obj.val() == "multiple")
				{
					$("#required").show();
				}
				else
				{
					$("#required").hide();
				}
				if(obj.val() == "select" || obj.val() == "multiple")
				{
					$("#param").show();
				}
				else
				{
					$("#param").hide();
				}
				if(obj.val() == "checkbox")
				{
					$("#param_check").show();
				}
				else
				{
					$("#param_check").hide();
				}
			}
		</script>
		<tr id="param">
			<td colspan="2"><b>'.$this->variable_names().'</b><br>
			<table>';

		$fileds = false;
		foreach($value as $k => $v)
		{
			echo '
			<tr class="rowparam">
				<td>
					<input type="text" name="paramv[]" size="40" value="'.str_replace('"', '&quot;', $v).'">
				</td>
			</tr>';
			$fileds = true;
		}
		if(! $fileds)
		{
			echo '
			<tr class="rowparam">
				<td>
					<input type="text" name="paramv[]" size="40" value="">
				</td>
			</tr>';
		}
		echo '</table>
				<a href="javascript:void(0)" class="plus" title="'._LANG_ADD.'">+</a>
			</td>
		</tr>
		<tr id="param_check">
			<td colspan="2">
				<b>'.$this->variable_names().'</b><br>
				<table>
					<tr>
						<td>
							'._LANG_YES.' <input type="text" name="paramk_check1" size="20" value="'
							.(! empty($value[1]) ? str_replace('"', '&quot;', $value[1]) : '')
							.'">
						</td>
						<td>
							'._LANG_NO.' <input type="text" name="paramk_check0" size="20" value="'
							.(! empty($value[0]) ? str_replace('"', '&quot;', $value[0]) : '').'">
						</td>
					</tr>
				</table>
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Категория"
	 * 
	 * @return boolean
	 */
	protected function edit_cat_id_module()
	{
		if(! $this->diafan->configmodules("cat", "shop"))
		{
			return FALSE;
		}

		echo '
		<tr'.$this->get_other().' valign="top">
			<td align="right">'.$this->variable_names().'</td>
			<td>';

		$marker = "&nbsp;&nbsp;";
		$result = DB::query("SELECT id, name, parent_id FROM {shop_category} WHERE trash='0' ORDER BY id ASC");
		while ($row = DB::fetch_array($result))
		{
			$cats[$row["parent_id"]][] = $row;
		}

		$values = array();
		$result = DB::query("SELECT cat_id FROM {category} WHERE module_name='shopparam' AND element_id='%d'", $this->diafan->edit);
		while ($row = DB::fetch_array($result))
		{
			$values[] = $row["cat_id"];
		}
		echo '
				<select name="cat_ids[]" multiple="multiple">'
				.$this->get_options($cats, $cats[0], $values).'
				</select>'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Сохранение поля "Параметры"
	 * @return boolean true
	 */
	protected function save_param_module()
	{
		if(($_POST["type"] == "select" || $_POST["type"] == "multiple") && ! empty($_POST["paramv"]))
		{
			foreach($_POST["paramv"] as $key => $value)
			{
				if(! $value)
				{
					DB::query("DELETE FROM {param_select} WHERE param_id=%d AND value=%d", $this->diafan->save, $key + 1);
					continue;
				}
				$result = DB::query("SELECT id FROM {param_select} WHERE param_id=%d AND value=%d", $this->diafan->save, $key + 1);
				if($row = DB::fetch_array($result))
				{
					DB::query("UPDATE {param_select} SET [name]='%h' WHERE id=%d", $value, $row["id"]);
				}
				else
				{
					DB::query("INSERT INTO {param_select} (param_id, value, [name]) VALUES (%d, %d, '%h')",
						  $this->diafan->save, $key + 1, $value);
				}
				$max = $key + 1;
			}
			DB::query("DELETE FROM {param_select} WHERE param_id=%d AND (value>%d OR value=0)", $this->diafan->save, $max);
		}
		elseif($_POST["type"] = "checkbox")
		{
			if($this->oldrow["type"] == "checkbox" && ($_POST["paramk_check1"] || $_POST["paramk_check0"]))
			{
				$result = DB::query("SELECT id, value FROM {param_select} WHERE param_id=%d", $this->diafan->save);
				while ($row = DB::fetch_array($result))
				{
					if($row["value"] == 1)
					{
						DB::query("UPDATE {param_select} SET [name]='%h' WHERE id=%d", $_POST["paramk_check1"], $row["id"]);
						$check1 = TRUE;
					}
					elseif($row["value"] == 0)
					{
						DB::query("UPDATE {param_select} SET [name]='%h' WHERE id=%d", $_POST["paramk_check0"], $row["id"]);
						$check0 = TRUE;
					}
				}
				DB::query("DELETE FROM {param_select} WHERE param_id=%d AND value NOT IN (0,1)", $this->diafan->save);

			}
			else
			{
				DB::query("DELETE FROM {param_select} WHERE param_id=%d", $this->diafan->save);
			}
			if(empty($check0) && $_POST["paramk_check0"])
			{
				DB::query("INSERT INTO {param_select} (param_id, value, [name]) VALUES (%d, 0, '%h')", $this->diafan->save, $_POST["paramk_check0"]);
			}
			if(empty($check1) && $_POST["paramk_check1"])
			{
				DB::query("INSERT INTO {param_select} (param_id, value, [name]) VALUES (%d, 1, '%h')", $this->diafan->save, $_POST["paramk_check1"]);
			}
		}
		else
		{
			DB::query("DELETE FROM {param_select} WHERE param_id=%d", $this->diafan->save);
		}
		return TRUE;
	}

	/**
	 * Сохранение поля "Доступен к выбору при заказе"
	 * 
	 * @return boolean true
	 */
	protected function save_required_module()
	{
		$this->query[] = "required='%d'";
		$this->value[] = $_POST["type"] == 'multiple' && $_POST["required"] ? 1 : 0;
		return TRUE;
	}

	/**
	 * Сохранение поля "Категория"
	 * 
	 * @return boolean
	 */
	protected function save_cat_id_module()
	{
		DB::query("DELETE FROM {category} WHERE element_id=%d AND module_name='shopparam'", $this->diafan->save);

		if(! empty($_POST["cat_ids"]) && is_array($_POST["cat_ids"]))
		{
			foreach($_POST["cat_ids"] as $cat_id)
			{
				DB::query("INSERT INTO {category} (element_id, cat_id, module_name) VALUES('%d', '%d', 'shopparam')", $this->diafan->save, $cat_id);
				$select_cat_id = TRUE;
			}
		}
		if(empty($select_cat_id))
		{
			DB::query("INSERT INTO {category} (element_id, cat_id, module_name) VALUES('%d', '0', 'shopparam')", $this->diafan->save);
		}
		return TRUE;
	}
}