<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Shop_ajax
 *
 * Обработка запроса при добавлении товара в корзину
 */
class Shop_ajax extends Model
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * Обрабатывает полученные данные из формы
	 * 
	 * @return boolean
	 */
	public function ajax_request()
	{
		if(! empty($_POST['addshop']) && (! $this->diafan->configmodules('security_user') || $this->diafan->_user->id))
		{
			$_POST['addshop'] = intval($_POST['addshop']);
			if(! DB::query_result("SELECT id FROM {shop} WHERE id=%d AND trash='0' AND [act]='1'", $_POST['addshop']))
			{
				$this->result["errors"][0][] = 'ERROR';
				return $this->send_errors();
			}

			$count = ! empty($_POST["count"]) ? intval($_POST["count"]) : 0;
			$count = $count > 0 ? $count : 1;
			$params = array();

			//зависимая цена. параметр, влияющий на цену не определен
			if(empty($_POST["depend"]) && ! DB::query_result("SELECT id FROM {shop_price} WHERE shop_id=%d AND param_id=0", $_POST['addshop']))
			{
				$this->result["errors"][0][] = _LANG_PLEASE_SELECT.' '
				                               .DB::query_result("SELECT [name] FROM {param} WHERE module_name='shop' AND type='multiple' AND id IN"
						                                         ." (SELECT param_id FROM {shop_price} WHERE shop_id=%d) LIMIT 1", $_POST['addshop']);
			}
			elseif(isset($_POST["depend"]))
			{
				if(! DB::query_result("SELECT id FROM {shop_price} WHERE shop_id=%d AND param_value=%d", $_POST['addshop'], $_POST["depend"]))
				{
					$this->result["errors"][0][] = 'ERROR';
				}
				$params["depend"] = intval($_POST["depend"]);
			}

			$result = DB::query("SELECT p.[name], p.id FROM {param} as p WHERE p.`type`='multiple' AND p.required='1'"
								." AND (SELECT COUNT(*) FROM {param_element} WHERE element_id=%d AND module_name='shop' AND param_id=p.id) > 1", $_POST['addshop']);
			while ($row_param = DB::fetch_array($result))
			{
				if(isset($_POST["param".$row_param["id"]]))
				{
					if(empty($_POST["param".$row_param["id"]]))
					{
						$this->result["errors"][0][] = _LANG_PLEASE_SELECT.' '.$row_param["name"];
					}
					else
					{
						$params[$row_param["id"]] = intval($_POST["param".$row_param["id"]]);
					}
				}
			}

			if($this->send_errors())
			{
				return TRUE;
			}
			asort($params);
			$param = '|';
			foreach($params as $key => $value)
			{
				$param .= $key.'='.$value.'|';
			}

			if(isset($_SESSION["basket"][$_POST['addshop']][$param]))
			{
				$_SESSION["basket"][$_POST['addshop']][$param]["count"] +=$count;
			}
			else
			{
				$_SESSION["basket"][$_POST['addshop']][$param]["count"] = $count;
				$_SESSION["basket"][$_POST['addshop']][$param]["param"] = $params;
			}

			$summ  = 0;
			$count = 0;
			foreach($_SESSION["basket"] as $shop_id => $array)
			{
				foreach($array as $param => $c)
				{
					if(isset($c["param"]["depend"]))
					{
						$summ += DB::query_result("SELECT price FROM {shop_price} WHERE shop_id=%d AND param_value=%d", $shop_id, $c["param"]["depend"]) * $c["count"];
					}
					else
					{
						$summ  += DB::query_result("SELECT price FROM {shop_price} WHERE shop_id=%d", $shop_id) * $c["count"];
					}
					$count += $c["count"];
				}
			}
			$_SESSION["basket-summ"]     = $summ;
			$_SESSION["basket-count"]    = $count;

			$this->result["errors"][0][] = sprintf(_LANG_GOODS_ADDED, '<a href="'.BASE_PATH_HREF.$this->get_rewrite_from_module("basket").'/">', '</a>');
			$this->result["basketcount"] = $count;
			$this->result["basket"]      = $this->diafan->format_price($summ);

			return $this->send_errors();
		}
		return FALSE;
	}

	/**
	 * Отправляет несколько ошибок
	 *
	 * @return boolean
	 */
	private function send_errors()
	{
		if(! empty($this->result["errors"][0]))
		{
			$message = implode(', ', $this->result["errors"][0]);
			unset($this->result["errors"][0]);
			$this->result["errors"][0] = $message;

			if(! empty($_POST['ajax']))
			{
				include_once(ABSOLUTE_PATH.'plugins/json.php');
				echo to_json($this->result);
			}
			else
			{
				$this->diafan->goto_diafan($this->diafan->path_module_variable().'?error=shop'.$_POST['addshop']
							   .'&mess='.$message);
			}
			return TRUE;
		}
		return FALSE;
	}
}