<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Shop_install
 *
 * Установка модуля "Магазин"
 */

$title = "Каталог товаров";

$sql = array(
	"CREATE TABLE {shop} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		".multilang("nameLANG TEXT NOT NULL,")."
		".multilang("actLANG ENUM('0', '1') NOT NULL DEFAULT '0',")."
		cat_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		site_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		".multilang("keywordsLANG VARCHAR(250) NOT NULL DEFAULT '',")."
		".multilang("descrLANG text NOT NULL,")."
		".multilang("title_metaLANG VARCHAR(250) NOT NULL DEFAULT '',")."
		".multilang("anonsLANG text NOT NULL,")."
		".multilang("textLANG text NOT NULL,")."
		yandex TEXT NOT NULL,
		show_yandex ENUM( '0', '1' ) NOT NULL,
		sort INT(11) UNSIGNED NOT NULL DEFAULT '0',
		timeedit INT(12) UNSIGNED NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY site_id (site_id)
	)",

	"ALTER DATABASE {shop} DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;",

	"CREATE TABLE {shop_category} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		".multilang("nameLANG TEXT NOT NULL,")."
		".multilang("actLANG ENUM('0', '1') NOT NULL DEFAULT '0',")."
		parent_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		site_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		".multilang("keywordsLANG VARCHAR(250) NOT NULL DEFAULT '',")."
		".multilang("descrLANG text NOT NULL,")."
		".multilang("title_metaLANG VARCHAR(250) NOT NULL DEFAULT '',")."
		".multilang("anonsLANG text NOT NULL,")."
		".multilang("textLANG text NOT NULL,")."
		show_yandex ENUM( '0', '1' ) NOT NULL,
		sort INT(11) UNSIGNED NOT NULL DEFAULT '0',
		timeedit INT(12) UNSIGNED NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY parent_id (parent_id),
		KEY site_id (site_id)
	)",

	"ALTER DATABASE {shop_category} DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;",

	"CREATE TABLE {shop_order} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		user_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		address TEXT NOT NULL,
		more TEXT NOT NULL,
		created INT(12) UNSIGNED NOT NULL DEFAULT '0',
		status ENUM('0', '1', '2', '3', '4', '5') NOT NULL DEFAULT '0',
		language TINYINT(2) UNSIGNED NOT NULL DEFAULT '0',
		summ FLOAT NOT NULL,
		payment CHAR(1) NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id)
	)",

	"ALTER DATABASE {shop_order} DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;",

	"CREATE TABLE {shop_price} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		shop_id INT( 11 ) UNSIGNED NOT NULL ,
		price FLOAT UNSIGNED NOT NULL ,
		param_id INT( 11 ) UNSIGNED NOT NULL ,
		param_value TINYINT( 2 ) UNSIGNED NOT NULL,
		PRIMARY KEY  (id),
		KEY parent_id (shop_id)
	)",

	"ALTER DATABASE {shop_price} DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;",

	"CREATE TABLE {info} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		tag_name VARCHAR( 50 ) NOT NULL ,
		".multilang("textLANG TEXT NOT NULL ,")."
		PRIMARY KEY ( id ),
		KEY tag_name (tag_name(4))
	);",

	"ALTER DATABASE {info} DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;",

	"CREATE TABLE {payment} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		order_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		state ENUM('I','R','S','G','F') NOT NULL DEFAULT 'I',
		timestamp datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
		RND varchar(8) NOT NULL DEFAULT '',
		LMI_SYS_INVS_NO INT(11) UNSIGNED NOT NULL DEFAULT '0',
		LMI_SYS_TRANS_NO INT(11) UNSIGNED NOT NULL DEFAULT '0',
		LMI_SYS_TRANS_DATE VARCHAR(17) DEFAULT NULL,
		LMI_PAYER_PURSE VARCHAR(13) DEFAULT NULL,
		LMI_PAYER_WM VARCHAR(12) DEFAULT NULL,
		PRIMARY KEY  (`id`)
	)",

	"ALTER DATABASE {payment} DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;",

	"CREATE TABLE {shop_goods} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		order_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		good INT(11) UNSIGNED NOT NULL DEFAULT '0',
		count_goods INT(5) UNSIGNED NOT NULL DEFAULT '0',
		price float NOT NULL DEFAULT '0',
		depend_price TINYINT(3) UNSIGNED NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id)
	)",

	"ALTER DATABASE {shop_goods} DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;",

	"INSERT INTO {site} (id,
		".multilang("nameLANG,")."
		".multilang("titleLANG,")."
		".multilang("actLANG,")."
		sort, timeedit, addmodule) VALUES (
		3,
		".multilang("'".$title."',", "'The catalogue of the goods',", "'',")."
		".multilang("'".$title."',", "'The catalogue of the goods',", "'',")."
		".multilang("'1',")."
		'3',
		'".time()."',
		'shop'
	);",
	
	"INSERT INTO {rewrite} (id, rewrite, module_name, element_id, site_id, cat_id, trash) VALUES (3, 'shop', 'site', 0, 3, 0, '0')",

	"INSERT INTO {site} (id, parent_id,
		".multilang("nameLANG,")."
		".multilang("titleLANG,")."
		".multilang("actLANG,")."
		sort, timeedit, addmodule) VALUES (
		10,
		3,
		".multilang("'Корзина',", "'Basket',", "'',")."
		".multilang("'Корзина',", "'Basket',", "'',")."
		".multilang("'1',")."
		'10',
		'".time()."',
		'basket'
	);",

	"INSERT INTO {rewrite} (id, rewrite, module_name, element_id, site_id, cat_id, trash) VALUES (10, 'shop/basket', 'site', 0, 10, 0, '0')",

	"INSERT INTO {site} (id, parent_id,
		".multilang("nameLANG,")."
		".multilang("titleLANG,")."
		".multilang("actLANG,")."
		sort, timeedit, addmodule) VALUES (
		15,
		3,
		".multilang("'Оформление заказа',", "'Order registration',", "'',")."
		".multilang("'Оформление заказа',", "'Order registration',", "'',")."
		".multilang("'1',")."
		'15',
		'".time()."',
		'order'
	);",

	"INSERT INTO {rewrite} (id, rewrite, module_name, element_id, site_id, cat_id, trash) VALUES (15, 'shop/order', 'site', 0, 15, 0, '0')",

	"INSERT INTO {adminsite} (id, parent_id, name, rewrite, text, act, numrow, sort) VALUES (
		32,
		1,
		'Магазин',
		'shop',
		'<p>Товары добавляются в создаваемые группы. Каждый товар имеет базовые характеристики: &quot;название, описание, цена&quot;. Для добавления характеристик к группам товаров используется модуль <a href=\"base_path/shop/param/\">&quot;Характеристики&quot;</a>.<br />\r\nЗаказы с сайта собираются в модуле <a href=\"base_path/shop/order/\">&quot;Заказы&quot;</a>, а также дублируются на e-mail, указанный в  <a href=\"base_path/shop/config1/\">настройках модуля &quot;Магазин&quot;</a>.</p>\r\n<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>',
		'1',
		670346,
		'6'
	);",

	"INSERT INTO {config} (id, module_name, config, cat_id) VALUES (
		6,
		'shop',
		'big_width=600"
		."\n"
		."big_height=600"
		."\n"
		."big_quality=90"
		."\n"
		."medium_width=150"
		."\n"
		."medium_height=150"
		."\n"
		."medium_quality=80"
		."\n"
		."search_price=1"
		."\n"
		."search_text=1"
		."\n"
		."search_name=1"
		."\n"
		."cat=1"
		."\n"
		."count_list=3"
		."\n"
		."image=1"
		."\n"
		."pid_array=1"
		."\n"
		."comments_cat=".(! empty($_POST["comments"]) ? '1' : '0')
		."\n"
		."nastr=10"
		."\n"
		."use_animation=1"
		."\n"
		."comments=".(! empty($_POST["comments"]) ? '1' : '0')
		."\n"
		."tags=".(! empty($_POST["tags"]) ? '1' : '0')
		."\n"
		."rating=".(! empty($_POST["rating"]) ? '1' : '0')
		."\n"
		."upload_max_filesize="
		."\n"
		."currency=руб."
		."\n"
		."currency5=rub."
		."\n"
		."security_user=0"
		."\n"
		."yandex=0"
		."\n"
		."nameshop=Рыбы"
		."\n"
		."currencyyandex=RUR"
		."\n"
		."currencyratesel=1"
		."\n"
		."currencyrate="
		."\n"
		."bid=15"
		."\n"
		."cbid=0"
		.multilang(
			"\n"
			."mes=Спасибо за Ваш заказ! В ближайшее время мы с Вами свяжемся для подтверждения заказа."
			."\n"
			."subject=Вы оформили заказ на сайте %%title (%%url)."
			."\n"
			."message=Здравствуйте, %%fio!<br>Вы оформили заказ на сайте %%title (%%url):<br><br>Номер заказа: %%id<br>%%order<br><br>"
			."Спасибо за Ваш заказ! В ближайшее время мы с Вами свяжемся для подтверждения заказа"
			."\n"
			."subject-admin=%%title (%%url). Новый заказ"
			."\n"
			."message-admin=Здравствуйте, администратор сайта %%title (%%url)!<br>На сайте появился новый заказ номер %%id: %%order"
			."<br><br>Пользователь: %%fio, %%email.<br><br>Адрес:<br><br>%%address<br><br>Дополнительно: %%more"
			."\n"
			."allshop=Посмотреть все товары в категории",

			"\n"
			."allshop2=Show all goods in category"
			."\n"
			."mes2=Thank you for your order! We will connect with you in near time to confirm order."."\n"
			."subject2=You placed an order on web site %%title (%%url)."
			."\n"
			."message2=Hello, %%fio!<br>You placed an order on web site %%title (%%url):<br><br>Number of order: %%id<br>%%order<br><br>"
			."Thank you for your order! We will connect with you in near time to confirm order."
		)."',
		0
	);"
);
	
$example = array(
	"UPDATE {site} SET
		".multilang(
			"text='<p>Чтобы положить товар в корзину, перейдите в каталог товаров.</p>'",
			", text2='<p>To put the goods in a basket, pass in the catalogue of the goods.</p>'",
			""
		)
	."WHERE id=10",

	"INSERT INTO {shop} VALUES (
		1,
		".multilang("'Коршун',", "'Vulture',", "'',")."
		".multilang("'1',")."
		1,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Дневная хишная птица, очень полезная в домашнем хозяйстве.</p>\r\n<p>Отличается:</p>\r\n<ul>\r\n    <li>широкая грудь</li>\r\n    <li>крепкие крылья</li>\r\n    <li>острое зрение</li>\r\n    <li>лапы короткие</li>\r\n</ul>\r\n<p>Питается мясом, любит змей, мелких грызунов.</p>',",
			"'<p>Day rapacious a bird very useful in housekeeping.</p><p>Differs:</p><ul><li>a broad chest</li><li>strong wings</li><li>an acute eyesight</li><li>paws short</li></ul><p>Eats meat, the dragon, small rodents loves.</p>',",
			"'',"
		)."
		'',
		'0',
		1,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 1, 1);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (1, 3500)",

	"INSERT INTO {shop} VALUES (
		2,
		".multilang("'Рыбка-Карасик',", "'Fish-karasik',", "'',")."
		".multilang("'1',")."
		3,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Караси &mdash; рыбка семейства карповых.<br />\r\nСпинной плавник длинный, глоточные зубы однорядные.</p>\r\n<p>Тело высокое с толстой спиной, умеренно сжатое с боков.<br />\r\nЧешуя крупная и гладкая на ощупь.</p>',",
			"'<p>Crucians &mdash; a small fish of family Cyprinoid.<br />Back fin long, a pharyngeal teeth single-row.<br /><br />Body high with the thick back, moderately compressed from sides.<br />Scales large and smooth to the touch.</p>',",
			"'',"
		)."
		'',
		'0',
		2,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 2, 3);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (2, 100)",

	"INSERT INTO {shop} VALUES (
		3,
		".multilang("'Пеликан',", "'Pelican',", "'',")."
		".multilang("'1',")."
		1,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Пеликан &mdash; птица обитатель морских мелководий, неглубоких пресных и солёных озёр, устьев крупных рек. Ходит неуклюже, но хорошо летает и плавает, может подолгу парить. С воды поднимается после разбега.</p>',",
			"'<p>Pelican &mdash; a bird the inhabitant of sea shoal, superficial fresh and salty lakes, устьев the large rivers. Goes clumsily, but well flies and floats, can soar long. From water rises after running start.</p>',",
			"'',"
		)."
		'',
		'0',
		3,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 3, 1);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (3, 4700)",

	"INSERT INTO {shop} VALUES (
		4,
		".multilang("'Гусь',", "'Goose',", "'',")."
		".multilang("'1',")."
		1,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>У гуся есть клюв, имеющий при основании большую высоту, чем ширину, и оканчивающийся ноготком с острым краем. По краям клюва идут мелкие зубчики.</p>\r\n<p>Гусь отличаются шеей средней длины, довольно высокими ногами, прикрепленными ближе к середине тела, и твердым бугром, или шпорой, на сгибе крыла. Перья и пух сильно развиты.</p>',",
			"'<p>At a goose is a beak having at the basis the big height, than width, and terminating in a nail with a keen edge. Along the edges of a beak go small roughness.</p><p>Goose differ a neck of average length, high enough feet attached more close to the middle of a body, and a firm hillock, or a spur, on a wing bend. Feathers and down are strongly developed.</p>',",
			"'',"
		)."
		'',
		'0',
		4,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 4, 1);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (4, 1000)",

	"INSERT INTO {shop} VALUES (
		5,
		".multilang("'Цапля',", "'Heron ',", "'',")."
		".multilang("'1',")."
		1,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Цапля живет на мелководье,  на заболоченных либо медленно текущих водоёмах.</p>\r\n<p>Отличает:</p>\r\n<ul>\r\n    <li>длинноногость</li>\r\n    <li>длинный и узкий, приплюснутый с боков клюв</li>\r\n    <li>сквозные ноздри.</li>\r\n</ul>\r\n<p>Цапля неподвижно стоит в воде и всматривается в воду, выискивая добычу.</p>',",
			"'<p>The heron lives on shoal, on boggy or slowly current reservoirs.</p><p>Distinguishes</p><ul><li>Long and narrow, flat beak from sides</li><li>Through nostrils.</li><li>The heron motionlessly costs in water and peers at water, trying to discover extraction.</li></ul>',",
			"'',"
		)."
		'',
		'0',
		5,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 5, 1);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (5, 6800)",

	"INSERT INTO {shop} VALUES (
		6,
		".multilang("'Филин',", "'Eagle owl',", "'',")."
		".multilang("'1',")."
		1,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Для филина характерны глубокие и размеренные взмахи широких крыльев.</p>\r\n<p>Как правило, филин неторопливо летает над землей, высматривая добычу, чередуя машущий полет с непродолжительным планированием.</p>',"
			,
			"'<p>For an eagle owl deep and measured waves of wide wings are characteristic.</p><p>As a rule, the eagle owl slowly flies over the earth, looking out for extraction, alternating waving flight to short planning.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		6,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 6, 1);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (6, 3600)",

	"INSERT INTO {shop} VALUES (
		7,
		".multilang("'Сова',", "'Owl',", "'',")."
		".multilang("'1',")."
		1,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Сова - птица с большими ушными пучками перьев, очень большим отверстием уха, диаметр которого превышает диаметр глаза, полным лицевым диском и сравнительно узким лбом.</p>',"
			,
			"'<p>Owl - a bird with the big ear bunches of feathers, very big aperture of the ear which diameter exceeds diameter of the eye, a full obverse disk and rather narrow forehead.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		7,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 7, 1);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (7, 3500)",

	"INSERT INTO {shop} VALUES (
		8,
		".multilang("'Лебедь',", "'Swan',", "'',")."
		".multilang("'1',")."
		1,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Оперенье лебедя по своей окраске бывает либо чисто белое, либо серого или чёрного цвета.</p>\r\n<p>Самок и самцов внешне весьма трудно различать. Лебедей отличает более длинная шея, позволяющая в более глубоких водах обыскивать дно в поисках пищи, а также их величина, по которой они являются самыми крупными водными птицами. Размах их крыльев достигает двух метров, а вес может превышать 15 кг.</p>',"
			,
			"'<p>Feather of swan on the colouring is either purely white, or grey or black colour.<br /><br />Females and males outwardly are rather difficult for distinguishing. Swans longer neck allowing in deeper waters to search a bottom in search of food, and also their size on which they are the largest water birds distinguishes. Scope of their wings reaches two metres, and the weight can exceed 15 kg.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		8,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 8, 1);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (8, 8800)",

	"INSERT INTO {shop} VALUES (
		9,
		".multilang("'Утенок',", "'Duckling',", "'',")."
		".multilang("'1',")."
		1,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Утенок &mdash; это детеныш утки, птицы средних размеров с относительно короткой шеей и цевкой, покрытой спереди поперечными щитками. Окраска оперения разнообразна, у многих видов на крыле имеется особое зеркальце.</p>',"
			,
			"'<p>The duckling is a cub of a duck, a bird of the average sizes with rather short neck, covered in front cross-section guards. Plumage colouring is various, many kinds on a wing have a special pocket mirror.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		9,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 9, 1);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (9, 3500)",

	"INSERT INTO {shop} VALUES (
		10,
		".multilang("'Страус',", "'Ostrich',", "'',")."
		".multilang("'1',")."
		1,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Страус &mdash; бескилевая нелетающая птица.</p>\r\n<p>В переводе с греческого &quot;страус&quot; означает &laquo;воробей-верблюд&raquo;.</p>\r\n<p>Страус &mdash; единственная современная нам птица, у которой имеется мочевой пузырь.</p>',"
			,
			"'<p>Ostrich &mdash; бескилевая not flying bird.<br /><br />In a translation from Greek &quot;ostrich&quot; means &quot;sparrow-camel&quot;.<br /><br />Ostrich &mdash; unique modern to us a bird who has a bladder.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		10,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 10, 1);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (10, 6200)",

	"INSERT INTO {shop} VALUES (
		11,
		".multilang("'Голубь',", "'Pigeon',", "'',")."
		".multilang("'1',")."
		1,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>В природе голубь обычно живет не более трёх-пяти лет, но при разведении в домашних условиях часто доживают до 15-летнего возраста, а отдельные особи и до 35 лет.</p>\r\n<p>Народные названия птицы &mdash; сизак, сизарь.</p>',"
			,
			"'<p>The pigeon usually lives in the nature no more than three-five years, but at cultivation in house conditions to 15-year-old age, and separate individuals and till 35 years often live.<br /><br />National names of a bird &mdash; sizak, sizar.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		11,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 11, 1);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (11, 900)",

	"INSERT INTO {shop} VALUES (
		12,
		".multilang("'Гриф',", "'Vulture',", "'',")."
		".multilang("'1',")."
		1,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Общая длина до метра, вес 7-12 кг.</p>\r\n<p>Это оседлая птица гор и предгорий. Обитает в Южной Европе, Северной Африке, Передней, Средней и Центральной Азии.</p>\r\n<p>В небольшом числе грифа можно найти на юго-восточном Алтае.</p>\r\n<p>Кормится падалью.</p>',"
			,
			"'<p>Total length to metre, weight of 7-12 kg.<br /><br />She is a settled bird of mountains and foothills. Lives in Southern Europe, the North Africa, Forward, Average and the Central Asia.<br /><br />It is possible to find in a signature stamp small number on southeast Altai.<br /><br />It is fed with drop.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		12,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 12, 1);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (12, 11000)",

	"INSERT INTO {shop} VALUES (
		13,
		".multilang("'Орел',", "'Eagle',", "'',")."
		".multilang("'1',")."
		1,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Гнездится на земле, скалах или деревьях.</p>\r\n<p>Питается мелкими и средней величины позвоночными, которых высматривают, паря в воздухе, или подкарауливают, сидя на возвышенном месте, иногда падалью.</p>\r\n<p>Численность сокращается.</p>',"
			,
			"'<p>Nests on the earth, rocks or trees.</p><p>Eats small and average size vertebral which look out, soaring in air, or watch, sitting on a raised place, sometimes drop.</p><p>Number is reduced.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		13,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 13, 1);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (13, 15000)",

	"INSERT INTO {shop} VALUES (
		14,
		".multilang("'Кенгуру',", "'Kangaroo',", "'',")."
		".multilang("'1',")."
		4,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Особенности:</p>\r\n<ol>\r\n    <li>Наличие сумчатых костей.</li>\r\n    <li>Температура тела &mdash; 34&mdash;36&deg;C.</li>\r\n    <li>У кенгуру есть сумка для вынашивания детенышей, она открывается вперед к голове, наподобие кармана передника.</li>\r\n    <li>Особое строение нижней челюсти, нижние концы которой загнуты внутрь. Клыки у них отсутствуют или недоразвиты, а коренные зубы с притупленными бугорками.</li>\r\n    <li>Иммунная система новорождённого кенгурёнка не сформирована, поэтому молоко мамы-кенгуру обладает сильным антибактериальным действием.</li>\r\n    <li>Сумка у самцов кенгуру отсутствует, а есть только у самок.</li>\r\n    <li>Кенгуру передвигаются длинными прыжками.</li>\r\n</ol>',"
			,
			"'<p>Features:<br />&nbsp;&nbsp; 1. Presence of marsupials of bones.<br />&nbsp;&nbsp; 2. A body temperature &mdash; 34&mdash;36&deg;C.<br />&nbsp;&nbsp; 3. The kangaroo have a bag for carrying of a pregnancy cubs, it opens forward to a head, like an apron pocket.<br />&nbsp;&nbsp; 4. The special structure of the bottom jaw, which bottom ends are bent inside. Canines at them are absent or are underdeveloped, and molars with dulled mounts.<br />&nbsp;&nbsp; 5. The immune system of the newborn baby is not generated, therefore milk of mum-kangaroo possesses strong antibacterial action.<br />&nbsp;&nbsp; 6. The bag at males of a kangaroo is absent, and is only at females.<br />&nbsp;&nbsp; 7. Kangaroos move long jumps.<br />&nbsp;</p>',"
			,
			"'',"
		)."
		'',
		'0',
		14,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 14, 4);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (14, 5600)",

	"INSERT INTO {shop} VALUES (
		15,
		".multilang("'Олень',", "'Deer',", "'',")."
		".multilang("'1',")."
		4,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Характерны разветвлённые рога, которые имеются в наличии только у самцов.</p>\r\n<p>Исключениями являются только олень водяной, у которого вообще нет рогов, и олень северный, у которого рога носят оба пола.</p>\r\n<p>Рога сбрасываются каждый год и вырастают заново.</p>',"
			,
			"'<p>The branched out horns which are available only at males are characteristic.<br /><br />Exceptions are only a deer water which in general does not have horns, and a deer northern, at which horn carry both floors.<br /><br />Horns are dumped every year and grow anew.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		15,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 15, 4);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (15, 10000)",

	"INSERT INTO {shop} VALUES (
		16,
		".multilang("'Носорог',", "'Rhinoceros',", "'',")."
		".multilang("'1',")."
		4,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Главным отличительным признаком носорога является рог на носу.</p>\r\n<p>В зависимости от вида носорога может быть один рог или два. Передний рог растёт из носовой кости, задний (если имеется в наличии) из лобовой части черепа. Несмотря на твёрдость, рога состоят не из костной ткани, а из сосредоточенного кератина &mdash; белка, который присутствует и в волосах.</p>',"
			,
			"'<p>The main distinctive sign of a rhinoceros is the horn on a nose.<br /><br />Depending on a kind of a rhinoceros there can be one horn or two. The forward horn grows from a nasal bone, back (if is available) of a front part of a skull. Despite hardness, horns consist not of a bone fabric, and from concentrated keratin &mdash; the squirrel who is present and at hair.<br />&nbsp;</p>',"
			,
			"'',"
		)."
		'',
		'0',
		16,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 16, 4);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (16, 9000)",

	"INSERT INTO {shop} VALUES (
		17,
		".multilang("'Верблюд',", "'Camel',", "'',")."
		".multilang("'1',")."
		4,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Масса взрослого верблюда &mdash; 500&mdash;800 кг, репродуктивный возраст начинается с 2&mdash;3 лет.</p>\r\n<p>Верблюды могут жить до 20 лет.</p>\r\n<p>Эти млекопитающие хорошо приспособлены к жизни в суровой и безводной местности.</p>\r\n<p>Густой мех предназначен для защиты от дневного зноя и ночного холода.</p>',"
			,
			"'<p>The weight of an adult camel &mdash; 500&mdash;800 kg, reproductive age begins from 2&mdash;3 years.<br /><br />Camels can live till 20 years.<br /><br />These mammals are well adapted for a life in severe and waterless district.<br /><br />The dense fur is intended for protection against day heat and a night cold.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		17,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 17, 4);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (17, 25000)",

	"INSERT INTO {shop} VALUES (
		18,
		".multilang("'Медведь',", "'Bear',", "'',")."
		".multilang("'1',")."
		4,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Отличается коренастым телосложением. Медведь всеяден, хорошо лазает и плавает, быстро бегает, может стоять и проходить короткие расстояния на задних лапах.</p>\r\n<p>Имеет короткий хвост, длинную и густую шерсть, а также отличные обоняние и слух.</p>',"
			,
			"'<p>Differs a thickset constitution. The bear is omnivorous, it is good climb and floats, quickly runs, can stand and pass short distances on hinder legs.<br /><br />Has a short tail, a long and dense wool, and also excellent sense of smell and hearing.<br />&nbsp;</p>',"
			,
			"'',"
		)."
		'',
		'0',
		18,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 18, 4);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (18, 12500)",

	"INSERT INTO {shop} VALUES (
		19,
		".multilang("'Суслик',", "'Gopher',", "'',")."
		".multilang("'1',")."
		5,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<ul>\r\n    <li>Задние конечности немного длиннее передних.</li>\r\n    <li>Уши короткие, слабо опушённые.</li>\r\n    <li>Окраска спины очень разнообразная, от зелёной, до пурпурной.</li>\r\n    <li>Часто на спине имеется тёмная рябь, продольные тёмные полоски, светлые пестрины или мелкие пятнышки.</li>\r\n    <li>По бокам туловища могут проходить светлые полосы.</li>\r\n    <li>Брюхо обычно грязно-жёлтого или беловатого цвета.</li>\r\n    <li>К зиме мех у суслика становится мягким и густым; в летнее время он реже, короче и грубее.</li>\r\n</ul>',"
			,
			"'<ul>    <li>Back finitenesses are a bit longer than lobbies.</li>    <li>Ears short, poorly downy.</li>    <li>back Colouring very various, from green, to the purple.</li>    <li>it is frequent on a back there are dark ripples, longitudinal dark strips or small specks.</li>    <li>On each side trunks can pass light strips.</li>    <li>the Belly of usually lurid or whitish colour.</li>    <li>By the winter the fur at a gopher becomes soft and dense; in summertime it is more rare, shorter and more rough.</li></ul>',"
			,
			"'',"
		)."
		'',
		'0',
		19,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 19, 5);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (19, 1200)",

	"INSERT INTO {shop} VALUES (
		20,
		".multilang("'Белочка',", "'Bunny',", "'',")."
		".multilang("'1',")."
		5,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Имеет удлинённое тело с пушистым длинным хвостом, уши длинные, цвет темно-бурый с белым брюшком, иногда серый (особенно зимою). Водятся повсюду, кроме Австралии. Белка даёт ценный мех.</p>',"
			,
			"'<p>Has the extended body with a fluffy long tail, ears long, colour dark-brown with a white paunch, sometimes grey (especially in winter). Are found everywhere, except Australia. The squirrel gives valuable fur.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		20,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 20, 5);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (20, 2450)",

	"INSERT INTO {shop} VALUES (
		21,
		".multilang("'Обезьяна',", "'Monkey',", "'',")."
		".multilang("'1',")."
		5,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Характерны пятипалые очень подвижные верхние конечности (руки), противопоставление большого пальца остальным (для большинства), ногти. Тело покрыто волосами. Похожа на человека.</p>',"
			,
			"'<p>Five-fingered very mobile top finitenesses (hand), opposition of a thumb to the rest (for the majority), nails are characteristic. The body is covered by hair. It is similar to the person.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		21,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 21, 5);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (21, 7900)",

	"INSERT INTO {shop} VALUES (
		22,
		".multilang("'Волк',", "'Wolf',", "'',")."
		".multilang("'1',")."
		5,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>По общему виду волк напоминает крупную остроухую собаку. Ноги высокие, сильные; лапа крупнее и более вытянута, нежели собачья, длина следа порядка 15 см, ширина 7 см, средние два пальца вынесены вперёд, что позволяет отличать следы волка от собачьих. Голова широколобая, морда относительно широкая, сильно вытянута и по бокам обрамлена &laquo;бакенбардами&raquo;.</p>',"
			,
			"'<p>On a general view the wolf reminds large a dog. Feet high, strong; the paw is larger and is more extended, rather than dog, length of a trace of an order of 15 sm, width of 7 sm, average two fingers are taken out forward that allows to distinguish traces of a wolf from the dog. The head broad-fronted, a muzzle rather wide, is strongly extended and on each side is framed by &quot;whiskers&quot;.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		22,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 22, 5);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES 22, 11800)",

	"INSERT INTO {shop} VALUES (
		23,
		".multilang("'Заяц',", "'Hare',", "'',")."
		".multilang("'1',")."
		5,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Отличается развитыми задними конечностями, длинными ушами и наличием короткого хвоста.<br />\r\n&nbsp;</p>',"
			,
			"'<p>Differs the developed back finitenesses, long ears and presence of a short tail.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		23,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 23, 5);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (23, 3200)",

	"INSERT INTO {shop} VALUES (
		24,
		".multilang("'Кот',", "'Cat',", "'',")."
		".multilang("'1',")."
		5,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Кот является мелким теплокровным животным, покрытым негустой шерстью, окрашенной в различные оттенки серого. В среднем взрослый кот достигает длины в 50 см от кончика носа до кончика хвоста.</p>',"
			,
			"'<p>The cat is to the small warm-blooded animals covered with a rather thin wool, painted in various shades grey. On the average the adult cat reaches length 50 sm from a tip of a nose to a tail tip.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		24,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 24, 5);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (24, 1200)",

	"INSERT INTO {shop} VALUES (
		25,
		".multilang("'Дикобраз',", "'Porcupine',", "'',")."
		".multilang("'1',")."
		5,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Дикобразовые располагают самыми длинными иголками среди всех млекопитающих. В эволюционном отношении иголки являются видоизменёнными волосами. Некоторые из них достигают длину 40 см и диаметр 7 мм, являются острыми и могут вызвать воспаления, если ими уколоться.</p>',"
			,
			"'<p>Porcupines have the longest needles among all mammals. In the evolutionary relation of a needle are modified hair. Some of them reach length of 40 sm and diameter of 7 mm, are sharp and can cause inflammations if them to prick.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		25,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 25, 5);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (25, 1200)",

	"INSERT INTO {shop} VALUES (
		26,
		".multilang("'Ежик',", "'Hedgehog',", "'',")."
		".multilang("'1',")."
		5,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Форма черепа варьирует от удлинённого и узкого до короткого и широкого.</p>\r\n<p>Хорошо развиты скуловые дуги, широко расставленные в стороны.</p>\r\n<p>Мозговой отдел небольших размеров.</p>\r\n<p>Зубов 36&mdash;44. Первый верхний резец, а иногда и первый нижний резец увеличены в размерах и похожи на клыки.</p>',"
			,
			"'<p>The skull form varies from extended and narrow to short and wide.<br /><br />The malar arches widely placed in the parties are well developed.<br /><br />Brain department of the small sizes.<br /><br />Teeth 36&mdash;44. The first top cutter, and sometimes and the first bottom cutter are increased in sizes and are similar to canines.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		26,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 26, 5);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (26, 700)",

	"INSERT INTO {shop} VALUES (
		27,
		".multilang("'Скай терьер',", "'Skye terrier',", "'',")."
		".multilang("'1',")."
		5,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Длинный, приземистый, обильно одетый, в два раза косая длина туловища превышает высоту в холке. Движения на вид совершенно без усилий. Крепкие конечности, колодка и челюсти.</p>',"
			,
			"'<p>Long, stocky, plentifully dressed, twice the slanting length of a trunk exceeds height in холке. Movements it is by sight perfect without efforts. Strong finitenesses and jaws.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		27,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 27, 5);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (27, 3500)",

	"INSERT INTO {shop} VALUES (
		28,
		".multilang("'Такса',", "'Turnspit',", "'',")."
		".multilang("'1',")."
		5,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<ul>\r\n    <li>Крепкая, с массивным костяком собака, прочно стоящая на земле, с длинной вытянутой мордой, ушки длинные, мягкие, закругляются на концах.</li>\r\n    <li>Спина мускулистая, крепкая, грудь объёмная, глубокая, с характерным &laquo;килем&raquo; впереди.</li>\r\n    <li>Хвост, толстый и крепкий у основания, поставлен низко, обычно держится чуть ниже линии спины, при возбуждении торчит вверх, как антенна.</li>\r\n    <li>Конечности короткие, толстые, с рельефной мускулатурой (особенно передние).</li>\r\n    <li>Передние лапы шире и больше задних.</li>\r\n    <li>Передвигается свободно, размашисто.</li>\r\n</ul>',"
			,
			"'<ul><li>Strong, with massive skeleton a dog strongly standing on the earth, with the long extended muzzle, ears long, soft, are brief on the ends.</li><li>the Back brawny, strong, a breast volume, deep, with characteristic &laquo;kil&raquo; ahead.</li><li>the Tail, thick and strong at the basis, is put low, usually keeps hardly below a back line, at excitation sticks out upwards, as the aerial.</li><li>Finitenesses short, thick, with relief muscles (especially forward).</li><li>Forepaws more widely and there are more than back.</li><li>Moves freely, widely.</li></ul>',"
			,
			"'',"
		)."
		'',
		'0',
		28,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 28, 5);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (28, 4200)",

	"INSERT INTO {shop} VALUES (
		29,
		".multilang("'Мышь',", "'Mouse',", "'',")."
		".multilang("'1',")."
		5,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Мышь внесла огромный вклад в развитие науки &mdash; на этих животных ставятся биологические опыты, вырабатывают противоядия и вакцины, проверяют лекарства и другие вещества на токсичность и тератогенность.</p>',"
			,
			"'<p>The mouse has brought the huge contribution to science development &mdash; on these animals experiments in biology are put, develop antidotes and vaccines, check medicines and other substances on toxicity.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		29,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 29, 5);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (29, 200)",

	"INSERT INTO {shop} VALUES (
		30,
		".multilang("'Лягушка',", "'Frog',", "'',")."
		".multilang("'1',")."
		5,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Проводит жизнь во влажных местах, чередуя пребывание на суше и в воде.</p>',"
			,
			"'<p>Spends a life in damp places, alternating stay on a land and in water.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		30,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 30, 5);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (30, 310)",

	"INSERT INTO {shop} VALUES (
		31,
		".multilang("'Бобр',", "'Beaver',", "'',")."
		".multilang("'1',")."
		3,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Тело у бобра приземистое, с укороченными 5-палыми конечностями, задние значительно сильнее передних. Между пальцами имеются плавательные перепонки, сильно развитые на задних конечностях и слабо &mdash; на передних. Когти на лапах сильные, уплощённые.</p>',"
			,
			"'<p>The body at the beaver stocky, with truncated 5-palymi finitenesses, back is much stronger than lobbies. Between fingers there are the swimming membranes strongly developed on back finitenesses and is weak &mdash; on lobbies. Claws on paws strong.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		31,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 31, 3);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (31, 2200)",

	"INSERT INTO {shop} VALUES (
		32,
		".multilang("'Саламандра',", "'Salamander',", "'',")."
		".multilang("'1',")."
		3,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>В случае опасности они спокойно расстаются со своими хвостом или лапами. Нередки случаи полного восстановления внутренних органов и даже глаз.</p>',"
			,
			"'<p>In case of danger they easy leave the a tail or paws. Cases of a complete recovery of an internal and even eyes are frequent.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		32,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 32, 3);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (32, 4400)",

	"INSERT INTO {shop} VALUES (
		33,
		".multilang("'Черепаха',", "'Turtle',", "'',")."
		".multilang("'1',")."
		3,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Черепахи являются одними из любимых и популярных домашних животных. Они неприхотливы и выносливы, долго живут даже в условиях российских квартир и особенно любимы детьми, хотя из-за неправильного &quot;вольного&quot; содержания многие умирают в первые 5 лет, а оставшиеся зачастую остаются калеками с кривым панцирем и грибком. Встречаются случаи, когда черепахи передаются родственниками из поколения в поколение.</p>',"
			,
			"'<p>Turtles are one of favourite and popular pets. They are unpretentious and hardy, long live even in conditions of the Russian apartments and are especially favourite by children though because of the wrong &quot;free&quot; maintenance many die in the first 5 years, and remained frequently remain cripples with a curve armour and a fungus. There are cases when turtles are transferred by relatives from generation to generation.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		33,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 33, 3);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (33, 3200)",

	"INSERT INTO {shop} VALUES (
		34,
		".multilang("'Крокодил',", "'Crocodile',", "'',")."
		".multilang("'1',")."
		3,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Внешность крокодила демонстрирует адаптацию к обитанию в водной среде: голова плоская, с длинным рылом; туловище приплюснутое; хвост мощный, сжатый с боков; ноги довольно короткие. На передних конечностях &mdash; 5 пальцев, на задних &mdash; 4 (нет мизинца), соединённых перепонкой. Глаза с вертикально-щелевидным зрачком расположены на верхней части головы, так что животное может выглядывать из воды, выставляя наружу только ноздри и глаза; ноздри и ушные отверстия под водой закрываются подвижными клапанами.</p>',"
			,
			"'<p>Appearance of a crocodile shows adaptation to dwelling in the water environment: a head flat, with a long snout; a trunk flat; a tail powerful, compressed from sides; feet short enough. On forward finitenesses &mdash; 5 fingers, on back &mdash; 4 (there is no little finger), connected by a membrane. Eyes with vertically-shchelevidnym pupil are located on the top part of a head so the animal can look out of water, exposing outside only nostrils and eyes; nostrils and ear apertures under water are closed by mobile valves.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		34,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 34, 3);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (34, 17000)",

	"INSERT INTO {shop} VALUES (
		35,
		".multilang("'Кит',", "'Whale',", "'',")."
		".multilang("'1',")."
		3,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Тело веретенообразное, наподобие обтекаемого тела рыбы. Плавники, иногда также называемые ластами, имеют лопастеообразный вид. На конце хвоста расположен стоячий плавник в виде гребня, играющий роль стабилизатора и обспечивающий движение вперед благодаря вертикальным движениям.</p>',"
			,
			"'<p>Body&nbsp; like a streamline body of fish. The fins sometimes also named flappers. On the tail end the standing fin in the form of a crest, playing a role of the stabilizer and furnish advance thanks to vertical movements is located.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		35,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 35, 3);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (35, 10000)",

	"INSERT INTO {shop} VALUES (
		36,
		".multilang("'Слон',", "'Elephant',", "'',")."
		".multilang("'1',")."
		3,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Слон потребляет 230 килограммов сена и 270 литров воды каждый день.</p>',"
			,
			"'<p>The elephant consumes 230 kgs of hay and 270 litres of water every day.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		36,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 36, 3);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (36, 35000)",

	"INSERT INTO {shop} VALUES (
		37,
		".multilang("'Свинья',", "'Pig',", "'',")."
		".multilang("'1',")."
		3,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Характерны:</p>\r\n<ul>\r\n    <li>компактное телосложение</li>\r\n    <li>длинная морда, заканчивающаяся голым хрящевым подвижным &laquo;пятачком&raquo; &mdash; это приспособление для разрыхления земли в поисках корма</li>\r\n    <li>хорошо развитые клыки, острые, изогнуты вверх.</li>\r\n    <li>конечности четырёхпалые; боковые пальцы (второй и пятый) едва касаются земли</li>\r\n    <li>сросшиеся в копытообразное окончание пальцы</li>\r\n</ul>',"
			,
			"'<p>Are characteristic:</p><ul><li>a compact constitution</li><li>the long muzzle which is coming to an end naked cartilaginous mobile &laquo;five-kopeck coin&raquo; is an adaptation for loosening the earths in search of a forage</li><li>well developed canines, sharp, are bent upwards.</li><li>finitenesses tetradactyl; lateral fingers (the second and the fifth) hardly concern the earths</li><li>accrete in копытообразное the termination fingers</li></ul>',"
			,
			"'',"
		)."
		'',
		'0',
		37,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 37, 3);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (37, 7100)",

	"INSERT INTO {shop} VALUES (
		38,
		".multilang("'Лев',", "'Lion',", "'',")."
		".multilang("'1',")."
		4,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang(
			"'<p>Образ жизни льва нетипичен для больших кошек. Лев живет в большой семейной группе &mdash; прайде. Охотится и приглядывает за детенышами, в основном, самки, самцы же охраняют территорию.</p>\r\n<p>Взрослый лев способен съесть за один раз до 18 кг мяса, а по другим оценкам, даже 31 кг. При случае убивает представителей других кошачьих и гиен.</p>',"
			,
			"'<p>The way of life of a lion is atypical for the big cats. The lion lives in the big family group. Hunts and looks for cubs, basically, females, males protect territory.<br /><br />The adult lion is capable to eat for once to 18 kg of meat, and by other estimations, even 31 kg. As required kills representatives of others cat\'s and hyenas.</p>',"
			,
			"'',"
		)."
		'',
		'0',
		38,
		'".time()."',
		'0'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shop', 38, 4);",

	"INSERT INTO {shop_price} (shop_id, price) VALUES (38, 22000)",

	"INSERT INTO {shop_category} VALUES (
		1,
		".multilang("'Птицы',", "'Birds',", "'',")."
		".multilang("'1',")."
		0,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'<p>Птицы  &mdash; животные с перьями, теплокровные, яйцекладущие с позвоночником, чьи передние конечности имеют форму крыльев.<br />\r\nВ принципе, все птицы летают, но в настоящее время существует много видов нелетающих птиц. А также у птиц должен быть клюв.</p>',"
			,
			"'<p>Birds &mdash; animals with feathers, warm-blooded, яйцекладущие with a backbone, whose forward finitenesses have the form of wings.<br />
	    Basically, all birds fly, but now there are many kinds of not flying birds. And also birds should have a beak.</p>',"
			,
			"'',"
		)."
		'0',
		1,
		'".time()."',
		'0'
	);",

	"INSERT INTO {shop_category} VALUES (
		2,
		".multilang("'Звери',", "'Animals',", "'',")."
		".multilang("'1',")."
		0,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'<p>Звери &mdash;  млекопитающие животные, которые рожают детёнышей без откладывания яиц. Все звери имеют  уши, их детёныши могут кормиться от груди, и все они имеют щиколотку, что увеличивает силу их движений. Звери часто классифицируются по картине срастания зубов. Почти все современные млекопитающие &mdash; звери.</p>',"
			,
			"'<p>Animals &mdash; mammals who give birth to cubs without putting off of eggs. All animals have ears, their cubs can be fed from a breast, and all of them have an ankle that increases force of their movements. Animals are often classified on a picture of accretion of a teeth. Almost all modern mammals &mdash; animals.</p>',"
			,
			"'',"
		)."
		'0',
		2,
		'".time()."',
		'0'
	);",

	"INSERT INTO {shop_category} VALUES (
		3,
		".multilang("'Водоплавающие',", "'Natatorial',", "'',")."
		".multilang("'1',")."
		0,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'<p>Водоплавающие это живые существа,  ведущие водный образ жизни. К ним относятся все те, кто живут в воде, под водой и над водой.</p>',"
			,
			"'<p>Natatorial it is the live beings conducting a water way of life. All concern them those who live in water, under water and over water.</p>',"
			,
			"'',"
		)."
		'0',
		3,
		'".time()."',
		'0'
	);",

	"INSERT INTO {shop_category} VALUES (
		4,
		".multilang("'Крупные',", "'Big',", "'',")."
		".multilang("'1',")."
		2,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'<p>Большие животные звери, которые больше человека, собраны здесь. Это и домашний крупный рогатый скот и дикие большие звери.</p>',"
			,
			"'<p>The big animal animals which there is more than person, are collected here. It both a house horned cattle and wild big animals.</p>',"
			,
			"'',"
		)."
		'0',
		4,
		'".time()."',
		'0'
	);",

	"INSERT INTO {shop_category} VALUES (
		5,
		".multilang("'Мелкие',", "'Small',", "'',")."
		".multilang("'1',")."
		2,
		3,
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'',")."
		".multilang("'<p>Все пузатая мелочь, вроде зайцев и кошек у нас в этой категории, мелкие звери.</p>',"
			,
			"'<p>All a big-bellied trifle, like hares and cats at us in this category, small animals.</p>',"
			,
			"'',"
		)."
		'0',
		5,
		'".time()."',
		'0'
	);",

	"INSERT INTO {shop_goods} VALUES (1, '1', '33', '1', '3200', '0', '0');",

	"INSERT INTO {shop_goods} VALUES (2, '2', '1', '1', '3500', '0', '0');",

	"INSERT INTO {shop_goods} VALUES (3, '2', '3', '1', '4700', '0', '0');",

	"INSERT INTO {shop_goods} VALUES (4, '3', '15', '1', '10000', '0', '0');",

	"INSERT INTO {shop_goods} VALUES (5, '3', '16', '1', '9000', '0', '0');",

	"INSERT INTO {shop_goods} VALUES (6, '3', '14', '2', '5600', '0', '0');",

	"INSERT INTO {shop_goods} VALUES (7, '3', '21', '1', '7900', '0', '0');",

	"INSERT INTO {shop_goods} VALUES (8, '4', '33', '10', '3200', '0', '0');",

	"INSERT INTO {shop_goods} VALUES (9, '4', '3', '1', '4700', '0', '0');",

	"INSERT INTO {shop_goods} VALUES (10, '4', '4', '1', '1000', '0', '0');",

	"INSERT INTO {shop_order} VALUES (
		2,
		'0',
		'Пользователь: Серафим Подольский, serafim@podolskijy.ru<br><br>Адрес:<br><br>Город: Моногорск<br>Улица: Широкая<br>Корпус: 1<br>Квартира, офис: 54<br>Телефон: +7(999)888-22-55',
		'',
		'".(time()-234678)."',
		'2',
		'1',
		'',
		'',
		'0'
	);",

	"INSERT INTO {shop_order} VALUES (
		3,
		'0',
		'Пользователь: Витольд Покровский, diafan@mail.ru<br><br>Адрес:<br><br>Город: Можжевельнинск<br>Улица: Липовая<br>Корпус: <br>Квартира, офис: 11<br>Телефон: +7(999)888-77-22',
		'',
		'".(time()-86240)."',
		'1',
		'1',
		'',
		'',
		'0'
	);",

	"INSERT INTO {shop_order} VALUES (
		4,
		'2',
		'Город: Мохнатск<br>Улица: Крученая<br>Корпус: <br>Квартира, офис: 98<br>Телефон: +7(999)444-55-66',
		'',
		'".time()."',
		'0',
		'0',
		'',
		'',
		'0'
	);",

	"INSERT INTO {param} (id, ".multilang("nameLANG,")." module_name, type, sort, search) VALUES (
		1,
		".multilang("'Размах крыльев',", "'Wingspan',", "'',")." 
		'shop',
		'numtext',
		1,
		'1'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shopparam', 1, 1);",

	"INSERT INTO {param} (id, ".multilang("nameLANG,")." module_name, type, sort, search) VALUES (
		2,
		".multilang("'Летный потолок',", "'Flight ceiling',", "'',")."
		'shop',
		'text',
		2,
		'1'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shopparam', 2, 1);",

	"INSERT INTO {param} (id, ".multilang("nameLANG,")." module_name, type, sort, search) VALUES (
		3,
		".multilang("'Хищность',", "'Rapacity',", "'',")."
		'shop',
		'checkbox',
		3,
		'1'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shopparam', 3, 4);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shopparam', 3, 5);",

	"INSERT INTO {param_select} (param_id, value ".multilang(", nameLANG").") VALUES (3, 0 ".multilang(", 'Не опасен'", ", 'Dangerous'").");",

	"INSERT INTO {param_select} (param_id, value ".multilang(", nameLANG,").") VALUES (3, 1 ".multilang(", 'Опасен'", ", 'Not dangerous'").");",

	"INSERT INTO {param} (id, ".multilang("nameLANG,")." module_name, type, sort, search) VALUES (
		4,
		".multilang("'Содержание',", "'Keep',", "'',")."
		'shop',
		'select',
		4,
		'1'
	);",

	"INSERT INTO {param_select} (param_id, value ".multilang(", nameLANG").") VALUES (4, 1 ".multilang(", 'Домашнее'", ", 'House'").");",

	"INSERT INTO {param_select} (param_id, value ".multilang(", nameLANG").") VALUES (4, 2 ".multilang(", 'Во дворе'", ", 'In a court yard'").");",

	"INSERT INTO {param_select} (param_id, value ".multilang(", nameLANG").") VALUES (4, 3 ".multilang(", 'Дикое'", ", 'Wild'").");",

	"INSERT INTO {param} (id, ".multilang("nameLANG,")." module_name, type, sort, search) VALUES (
		5,
		".multilang("'Плавники',", "'Fin',", "'',")."
		'shop',
		'checkbox',
		5,
		'1'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shopparam', 5, 3);",

	"INSERT INTO {param_select} (param_id, value ".multilang(", nameLANG").") VALUES (5, 0 ".multilang(", 'Отсутствуют'", ", 'Be absent'").");",

	"INSERT INTO {param_select} (param_id, value ".multilang(", nameLANG").") VALUES (5, 1 ".multilang(", 'Есть'", ", 'Be'").");",

	"INSERT INTO {param} (id, ".multilang("nameLANG,")." module_name, type, sort, search) VALUES (
		6,
		".multilang("'Глубина заныривания',", "'Depth to dive',", "'',")."
		'shop',
		'numtext',
		6,
		'1'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shopparam', 6, 3);",

	"INSERT INTO {param} (id, ".multilang("nameLANG,")." module_name, type, sort, search) VALUES (
		7,
		".multilang("'Шерсть',", "'Wool',", "'',")."
		'shop',
		'checkbox',
		7,
		'1'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shopparam', 7, 4);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shopparam', 7, 5);",

	"INSERT INTO {param_select} (param_id, value ".multilang(", nameLANG").") VALUES (7, 0 ".multilang(", 'Нет'", ", 'No'").");",

	"INSERT INTO {param_select} (param_id, value ".multilang(", nameLANG").") VALUES (7, 1 ".multilang(", 'Да'", ", 'Yes'").");",

	"INSERT INTO {param} (id, ".multilang("nameLANG,")." module_name, type, sort, search) VALUES (
		8,
		".multilang("'Условия проживания',", "'Residing conditions',", "'',")."
		'shop',
		'text',
		8,
		'1'
	);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shopparam', 8, 4);",

	"INSERT INTO {category} (module_name, element_id, cat_id) VALUES ('shopparam', 8, 5);",

	"INSERT INTO {param_element} VALUES (219, ".multilang("'1',", "'',")." 3, 1, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (218, ".multilang("'1500',", "'',")." 2, 1, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (217, ".multilang("'3',", "'',")." 1, 1, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (8, ".multilang("'2',", "'',")." 4, 3, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (7, ".multilang("'1',", "'',")." 1, 3, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (226, ".multilang("'2',", "'',")." 4, 4, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (225, ".multilang("'1',", "'',")." 2, 4, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (224, ".multilang("'2',", "'',")." 1, 4, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (20, ".multilang("'3',", "'',")." 4, 5, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (19, ".multilang("'1000',", "'1000',", "'',")." 2, 5, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (18, ".multilang("'4',", "'',")." 1, 5, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (27, ".multilang("'1',", "'',")." 3, 6, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (26, ".multilang("'300',", "'300',", "'',")." 2, 6, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (25, ".multilang("'2',", "'',")." 1, 6, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (28, ".multilang("'3',", "'',")." 4, 6, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (229, ".multilang("'1',", "'',")." 3, 7, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (228, ".multilang("'250',", "'250',", "'',")." 2, 7, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (227, ".multilang("'1.5',", "'',")." 1, 7, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (41, ".multilang("'700',", "'700',", "'',")." 2, 8, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (40, ".multilang("'2.5',", "'',")." 1, 8, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (42, ".multilang("'3',", "'',")." 4, 8, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (45, ".multilang("'0.3',", "'',")." 1, 9, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (46, ".multilang("'1',", "'',")." 4, 9, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (51, ".multilang("'10',", "'10',", "'',")." 2, 10, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (50, ".multilang("'2.3',", "'',")." 1, 10, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (52, ".multilang("'2',", "'',")." 4, 10, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (57, ".multilang("'500',", "'500',", "'',")." 2, 11, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (56, ".multilang("'0.5',", "'',")." 1, 11, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (58, ".multilang("'2',", "'',")." 4, 11, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (65, ".multilang("'1',", "'',")." 3, 12, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (64, ".multilang("'1000',", "'1000',", "'',")." 2, 12, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (63, ".multilang("'3',", "'',")." 1, 12, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (66, ".multilang("'3',", "'',")." 4, 12, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (73, ".multilang("'1',", "'',")." 3, 13, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (72, ".multilang("'3000',", "'3000',", "'',")." 2, 13, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (71, ".multilang("'3',", "'',")." 1, 13, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (74, ".multilang("'3',", "'',")." 4, 13, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (78, ".multilang("'любит поесть',", "'',")." 8, 14, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (77, ".multilang("'2',", "'',")." 4, 14, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (84, ".multilang("'Иногда лижут соль',", "'Sometimes lick salt',", "'',")." 8, 15, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (83, ".multilang("'1',", "'',")." 7, 15, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (82, ".multilang("'2',", "'',")." 4, 15, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (90, ".multilang("'Сидит в воде',", "'Sits in water',", "'',")." 8, 16, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (89, ".multilang("'3',", "'',")." 4, 16, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (88, ".multilang("'1',", "'',")." 3, 16, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (233, ".multilang("'Его надо вьючить',", "'It is necessary load',", "'',")." 8, 17, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (232, ".multilang("'1',", "'',")." 7, 17, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (231, ".multilang("'2',", "'',")." 4, 17, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (237, ".multilang("'Нужна будка',", "'The box is necessary',", "'',")." 8, 18, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (236, ".multilang("'1',", "'',")." 7, 18, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (235, ".multilang("'2',", "'',")." 4, 18, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (234, ".multilang("'1',", "'',")." 3, 18, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (110, ".multilang("'В полях',", "'In dales',", "'',")." 8, 19, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (109, ".multilang("'1',", "'',")." 7, 19, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (108, ".multilang("'3',", "'',")." 4, 19, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (116, ".multilang("'На деревьях',", "'On trees',", "'',")." 8, 20, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (115, ".multilang("'1',", "'',")." 7, 20, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (114, ".multilang("'3',", "'',")." 4, 20, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (122, ".multilang("'Рядом с людьми',", "'Near to people',", "'',")." 8, 21, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (121, ".multilang("'1',", "'',")." 7, 21, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (120, ".multilang("'1',", "'',")." 4, 21, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (130, ".multilang("'В лесу',", "'In wood',", "'',")." 8, 22, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (129, ".multilang("'1',", "'',")." 7, 22, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (128, ".multilang("'3',", "'',")." 4, 22, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (127, ".multilang("'1',", "'',")." 3, 22, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (136, ".multilang("'В коробке',", "'In a box',", "'',")." 8, 23, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (135, ".multilang("'1',", "'',")." 7, 23, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (134, ".multilang("'1',", "'',")." 4, 23, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (144, ".multilang("'Нужны мыши',", "'Mice are necessary',", "'',")." 8, 24, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (143, ".multilang("'1',", "'',")." 7, 24, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (142, ".multilang("'1',", "'',")." 4, 24, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (141, ".multilang("'1',", "'',")." 3, 24, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (150, ".multilang("'Пустыня',", "'Desert',", "'',")." 8, 25, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (149, ".multilang("'3',", "'',")." 4, 25, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (148, ".multilang("'1',", "'',")." 3, 25, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (154, ".multilang("'Под кроватью',", "'Under a bed',", "'',")." 8, 26, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (153, ".multilang("'1',", "'',")." 4, 26, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (160, ".multilang("'На кровати',", "'On a bed',", "'',")." 8, 27, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (159, ".multilang("'1',", "'',")." 7, 27, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (158, ".multilang("'1',", "'',")." 4, 27, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (162, ".multilang("'2',", "'',")." 4, 28, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (163, ".multilang("'1',", "'',")." 7, 28, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (164, ".multilang("'В будке',", "'In a box',", "'',")." 8, 28, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (170, ".multilang("'Под плинтусом',", "'Under a plinth',", "'',")." 8, 29, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (169, ".multilang("'1',", "'',")." 7, 29, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (168, ".multilang("'1',", "'',")." 4, 29, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (174, ".multilang("'1',", "'',")." 6, 30, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (173, ".multilang("'3',", "'',")." 4, 30, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (178, ".multilang("'2',", "'',")." 6, 31, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (177, ".multilang("'3',", "'',")." 4, 31, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (180, ".multilang("'3',", "'',")." 4, 32, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (184, ".multilang("'10',", "'',")." 6, 33, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (183, ".multilang("'1',", "'',")." 4, 33, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (192, ".multilang("'20',", "'',")." 6, 34, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (191, ".multilang("'1',", "'',")." 5, 34, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (190, ".multilang("'2',", "'',")." 4, 34, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (189, ".multilang("'1',", "'',")." 3, 34, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (198, ".multilang("'1000',", "'',")." 6, 35, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (197, ".multilang("'1',", "'',")." 5, 35, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (196, ".multilang("'3',", "'',")." 4, 35, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (204, ".multilang("'Большой двор',", "'The big court yard',", "'',")." 8, 36, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (203, ".multilang("'1',", "'',")." 7, 36, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (202, ".multilang("'2',", "'',")." 4, 36, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (208, ".multilang("'У помойки',", "'At a dustbin',", "'',")." 8, 37, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (207, ".multilang("'2',", "'',")." 4, 37, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (216, ".multilang("'В саванне Африки',", "'In savanna of Africa',", "'',")." 8, 38, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (215, ".multilang("'1',", "'',")." 7, 38, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (214, ".multilang("'3',", "'',")." 4, 38, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (213, ".multilang("'1',", "'',")." 3, 38, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (220, ".multilang("'3',", "'',")." 4, 1, 'shop', '0');",

	"INSERT INTO {param_element} VALUES (230, ".multilang("'3',", "'',")." 4, 7,'shop','0',0);"
);

/**
 * Выполняет действия для основной установки модуля
 * 
 * @return void
 */
function module_basic_shop()
{
	$id = DB::query_result("SELECT id FROM {adminsite} WHERE rewrite='shop'");

	DB::query("INSERT INTO {adminsite} (parent_id, name, rewrite, text, act, numrow, sort) VALUES (".$id.", 'Характеристики', 'shop/param', '<p>Модуль управления дополнительными характеристиками для групп товаров <a href=\"base_path/shop/\">магазина</a>.</p>\r\n<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>', '1', 28, '1');");

	DB::query("INSERT INTO {adminsite} (parent_id, name, rewrite, text, act, numrow, sort) VALUES (".$id.", 'Заказы', 'shop/order', '<p>Заказы <a href=\"base_path/shop/\">магазина</a> собираются в этом модуле.</p>\r\n<p><a target=\"_blank\" href=\"http://cms.diafan.ru/dokument/\">Полная документация и помощь</a></p>', '1', 347, '2');");

	if(! is_dir(ABSOLUTE_PATH.USERFILES.'/shop'))
	{
		mkdir(ABSOLUTE_PATH.USERFILES.'/shop', 0777);
	}

	if(! is_dir(ABSOLUTE_PATH.USERFILES.'/shop/small'))
	{
		mkdir(ABSOLUTE_PATH.USERFILES.'/shop/small', 0777);
	}

	if(! is_dir(ABSOLUTE_PATH.USERFILES.'/shop/medium'))
	{
		mkdir(ABSOLUTE_PATH.USERFILES.'/shop/medium', 0777);
	}
	
	$url = parse_url(DB_URL);
	$result = DB::query("SHOW TABLES FROM ".substr($url['path'], 1));
	while ($row = mysql_fetch_row($result))
	{
		if($row[0] == DB_PREFIX."param") return;
	}

	DB::query("CREATE TABLE {param} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		".multilang("nameLANG VARCHAR(250) NOT NULL DEFAULT '',")."
		module_name VARCHAR(10) NOT NULL DEFAULT '',
		type ENUM('text', 'numtext', 'date', 'textarea', 'checkbox', 'select', 'email', 'editor', 'multiple') NOT NULL,
		site_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		sort INT(11) UNSIGNED NOT NULL DEFAULT '0',
		search ENUM('0', '1') NOT NULL DEFAULT '0',
		list ENUM('0', '1') NOT NULL DEFAULT '0',
		block ENUM('0', '1') NOT NULL DEFAULT '0',
		required ENUM('0', '1') NOT NULL DEFAULT '0',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY module_name (module_name(2))
	)");

	DB::query("ALTER DATABASE {param} DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;");

	DB::query("CREATE TABLE {param_element} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		".multilang("valueLANG text NOT NULL,")."
		param_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		element_id  INT(11) UNSIGNED NOT NULL DEFAULT '0',
		module_name VARCHAR(10) NOT NULL DEFAULT '',
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY element_id (element_id),
		KEY param_id (param_id),
		KEY value (value(5)),
		KEY module_name (module_name(2))
	)");

	DB::query("ALTER DATABASE {param_element} DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;");

	DB::query("CREATE TABLE {param_select} (
		id INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
		param_id INT(11) UNSIGNED NOT NULL DEFAULT '0',
		value TINYINT(2) UNSIGNED NOT NULL DEFAULT '0',
		".multilang("nameLANG VARCHAR(50) NOT NULL DEFAULT '',")."
		trash ENUM('0', '1') NOT NULL DEFAULT '0',
		PRIMARY KEY  (id),
		KEY param_id (param_id)
	)");

	DB::query("ALTER DATABASE {param_select} DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;");
}

/**
 * Выполняет действия для установки примеров заполнения модуля
 * 
 * @return void
 */
function module_example_shop()
{
	$array = array(
		1  => array(41 => 'korshun'),
		2  => array(42 => 'rybka-karasik'),
		3  => array(43 => 'pelikan'),
		4  => array(44 => 'gus'),
		5  => array(45 => 'caplya'),
		6  => array(46 => 'filin'),
		7  => array(47 => 'sova'),
		8  => array(48 => 'lebed'),
		9  => array(49 => 'utenok'),
		10 => array(50 => 'straus'),
		11 => array(51 => 'golub'),
		12 => array(52 => 'grif'),
		13 => array(53 => 'orel'),
		14 => array(54 => 'kenguru'),
		15 => array(55 => 'olen', 56 => 'olen'),
		16 => array(57 => 'nosorog'),
		17 => array(58 => 'verblyud', 59 => 'verblyud'),
		18 => array(60 => 'medved'),
		19 => array(61 => 'suslik'),
		20 => array(62 => 'belochka'),
		21 => array(63 => 'obezyana'),
		22 => array(64 => 'volk'),
		23 => array(65 => 'zayac'),
		24 => array(66 => 'kot'),
		25 => array(67 => 'dikobraz', 68 => 'dikobraz'),
		26 => array(69 => 'ezhik'),
		27 => array(70 => 'skaj-terer', 71 => 'skaj-terer'),
		28 => array(72 => 'taksa'),
		29 => array(73 => 'mysh'),
		30 => array(74 => 'lyagushka'),
		31 => array(75 => 'bobr'),
		32 => array(76 => 'salamandra'),
		33 => array(77 => 'cherepaxa', 78 => 'cherepaxa'),
		34 => array(79 => 'krokodil'),
		35 => array(80 => 'kit'),
		36 => array(81 => 'slon'),
		37 => array(82 => 'svinya'),
		38 => array(83 => 'lev')
	);

	$module = 'shop';
	foreach($array as $k => $a)
	{
		foreach($a as $id => $name)
		{
			DB::query("INSERT INTO {images} (id, name, module_name, element_id, sort) VALUES ('%d', '%s', '%s', '%d', '%d')",
				  $id, $name, $module, $k, $id);
			$name = $name.'_'.$id;

			if(! file_exists(ABSOLUTE_PATH.USERFILES.'/'.$module.'/'.$name.'.jpg'))
			{
				copy('http://cms.diafan.ru/files4.2/'.$module.'/'.$name.'.jpg', ABSOLUTE_PATH.USERFILES.'/'.$module.'/'.$name.'.jpg');
				copy('http://cms.diafan.ru/files4.2/'.$module.'/small/'.$name.'.jpg', ABSOLUTE_PATH.USERFILES.'/'.$module.'/small/'.$name.'.jpg');
				copy('http://cms.diafan.ru/files4.2/'.$module.'/medium/'.$name.'.jpg', ABSOLUTE_PATH.USERFILES.'/'.$module.'/medium/'.$name.'.jpg');
			}

			chmod(ABSOLUTE_PATH.USERFILES.'/'.$module.'/'.$name.'.jpg', 0777);
			chmod(ABSOLUTE_PATH.USERFILES.'/'.$module.'/small/'.$name.'.jpg', 0777);
			chmod(ABSOLUTE_PATH.USERFILES.'/'.$module.'/medium/'.$name.'.jpg', 0777);
		}
	}
}

/**
 * Деинсталлирует модуль
 * 
 * @return void
 */
function module_basic_uninstall_shop()
{
	$module = 'shop';
	DB::query("DROP TABLE {".$module."};");
	DB::query("DROP TABLE {".$module."_category};");
	DB::query("DROP TABLE {".$module."_price};");
	DB::query("DROP TABLE {".$module."_order};");
	DB::query("DROP TABLE {".$module."_goods};");
	DB::query("DROP TABLE {payment};");
	DB::query("DROP TABLE {info}");
	DB::query("DELETE FROM {rewrite} WHERE module_name='site' AND site_id IN (SELECT id FROM {site} WHERE addmodule='".$module."' or addmodule='order' or addmodule='basket');");
	DB::query("DELETE FROM {site} WHERE addmodule='".$module."' or addmodule='order' or addmodule='basket';");
	DB::query("DELETE FROM {rewrite} WHERE module_name='".$module."';");
	DB::query("DELETE FROM {category} WHERE module_name='".$module."';");
	DB::query("DELETE FROM {adminsite} WHERE rewrite='".$module."';");
	DB::query("DELETE FROM {adminsite} WHERE rewrite='".$module."/param';");
	DB::query("DELETE FROM {adminsite} WHERE rewrite='".$module."/order';");
	DB::query("DELETE FROM {config} WHERE module_name='".$module."';");
	DB::query("DELETE FROM {images} WHERE module_name='".$module."';");
	@DB::query("DELETE FROM {rating} WHERE module_name='".$module."';");
	DB::query("DELETE FROM {param_element} WHERE module_name='".$module."';");
	DB::query("DELETE FROM {param} WHERE module_name='".$module."';");
	@DB::query("DELETE FROM {comments} WHERE module_name='".$module."';");
	@DB::query("DELETE FROM {comments} WHERE module_name='".$module."_category';");
	@DB::query("DELETE FROM {tags} WHERE module_name='".$module."';");

	if($dirr = @opendir(ABSOLUTE_PATH.USERFILES.'/'.$module.'/small'))
	{
		while(($file = readdir($dirr)) !== false)
		{
			@unlink(ABSOLUTE_PATH.USERFILES.'/'.$module.'/small/'.$file);
		}
		closedir($dirr);
	}
	rmdir(ABSOLUTE_PATH.USERFILES.'/'.$module.'/small');

	if($dirr = @opendir(ABSOLUTE_PATH.USERFILES.'/'.$module.'/medium'))
	{
		while(($file = readdir($dirr)) !== false)
		{
			@unlink(ABSOLUTE_PATH.USERFILES.'/'.$module.'/medium/'.$file);
		}
		closedir($dirr);
	}
	rmdir(ABSOLUTE_PATH.USERFILES.'/'.$module.'/medium');

	if($dirr = @opendir(ABSOLUTE_PATH.USERFILES.'/'.$module))
	{
		while(($file = readdir($dirr)) !== false)
		{
			@unlink(ABSOLUTE_PATH.USERFILES.'/'.$module.'/'.$file);
		}
		closedir($dirr);
	}
	rmdir(ABSOLUTE_PATH.USERFILES.'/'.$module);
}