<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Site_admin
 *
 * Редактирование страниц сайта
 */
class Site_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'site';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'site'; 

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		$this->nastr = 100;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'          => 'text',
			'act'           => 'checkbox',
			'actm'          => 'checkbox',
			'photo'         => 'function',
			'tags'          => 'function',
			'comments'      => 'function',

			'hr1'           => 'hr',
			'number'        => 'function',
			'timeedit'      => 'text',
			'title_meta'    => 'text',
			'keywords'      => 'text',
			'descr'         => 'textarea',
			'rewrite'       => 'function',
			'title_no_show' => 'checkbox',

			'hr2'           => 'hr',
			'addmodule'     => 'select',
			'parent_id'     => 'select',
			'sort'          => 'function',

			'hr3'           => 'hr',
			'theme'         => 'text',
			'othurl'        => 'text',
			'access'        => 'checkbox',

			'hr4'           => 'hr',
			'text'          => 'editor'
		);

		//поля, которые прячутся в Дополнительно
		$this->variable_other = array(
			'title'         => 1,
			'title_meta'    => 1,
			'access'        => 1,
			'keywords'      => 1,
			'descr'         => 1,
			'title_no_show' => 1,
			'othurl'        => 1,
			'rewrite'       => 1,
			'timeedit'      => 1,
			'parent_id'     => 1,
			'theme'         => 1,
			'id'            => 1,
			'sort'          => 1,
			'photo'         => 1,
			'hr1'           => 1,
			'hr2'           => 1,
			'hr3'           => 1,
			'addmodule'     => 1,
			'number'        => 1
		);

		//переводимые поля
		$this->language_names = array(
			'name',
			'act',
			'title',
			'title_meta',
			'keywords',
			'descr',
			'text'
		);
		
		$this->config_module = array(
			'parent' => 1,	//содержит вложенности
			'order'  => 1,	//сортируется
			'act'    => 1,	//показать/скрыть
			'view'   => 1,	//просмотр на сайте
			'del'    => 1,	//удалить
			'menu'   => 1,	//показывать в меню (м)
			'nopage' => 1,	//не разбивать на страницы
			'trash'  => 1 	//использовать корзину
		);
		
		//нельзя редактировать поля Принадлежит, Псевдоссылка, Сторонняя ссылка, Активность для Главной страницы
		if($this->diafan->edit == 1 || $this->diafan->save == 1)
		{
			unset($this->variable_table["act"]);
			unset($this->variable_table["parent_id"]);
			unset($this->variable_table["rewrite"]);
			unset($this->variable_table["othurl"]);
			unset($this->variable_table["hr3"]);
		}
	}

	/**
	 * Выводит список страниц сайта
	 * @return boolean true
	 */
	public function show_module()
	{		
		echo '<table class="list">';
		
		//Главная страница
		if ($row = DB::fetch_array(DB::query("SELECT [name], actm FROM {".$this->table."} WHERE id=1")))
		{
			echo '
			<tr altcolor="#eeeeee" class="tr">
				<td class="tdedit0">
					<font>
						<a href="'.URL.'edit1/" title="'._LANG_EDIT.'">'
							.($row["name"] ? $row["name"] : 1)
						.'</a>
					</font>
					'.($row["actm"] ? ' ('._LANG_SHORT_MENU.')' : '').'
				</td>
				<td class="actions actions-home">
					<span>
						<a href="'.URL.'enterid0/addnew1/" title="'._ADMIN_SITE_ADD.'"><img src="'.BASE_PATH.'img/b1.gif"></a>
						- 
						<a href="'.URL.'enterid0/addnew1/">'._ADMIN_SITE_ADD.'</a>  
					</span>
				</td>
			</tr>';
		}

		//весь список
		$this->list_row();

		echo '</table>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Шаблон страницы"
	 * @return boolean true
	 */
	protected function edit_theme_module()
	{
		echo '<tr'.$this->get_other().'>
			<td class="first-td">
				'.$this->variable_names().'
			</td>
			<td>
				<select name="theme">
					<option value="">site.php</option>';

		if($dir = opendir(ABSOLUTE_PATH."themes"))
		{
			while (($file = readdir($dir)) !== false)
			{
				if(strstr($file, 'site') && $file != 'site.php')
				{
					echo '
					<option value="'.$file.'"'.($this->value == $file ? ' selected' : '').'>'.$file.'</option>';
				}
			}
		}
		closedir($dir);
		echo '
				</select>'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Редактирование поля "Прикрепленный модуль"
	 * @return boolean true
	 */
	protected function edit_addmodule_module()
	{
		echo '<tr'.$this->get_other().'>
			<td class="first-td">
				'.$this->variable_names().'
			</td>
			<td>
				<select name="'.$this->key.'">
					<option value="">'._LANG_NOT.'</option>';

		if ($dir = opendir(ABSOLUTE_PATH."modules"))
		{
			while (($file = readdir($dir)) !== false)
			{
				if(! $file != '.' && $file != '..' && file_exists(ABSOLUTE_PATH.'modules/'.$file.'/'.$file.'.php')
				    && (! file_exists(ABSOLUTE_PATH.'modules/'.$file.'/'.$file.'.install.php') || DB::where("adminsite", "rewrite='".$file."'", "id")))
				{
					$const = strtoupper('_LANG_'.$file);
				echo '
					<option value="'.$file.'"'.($this->value == $file ? ' selected':'').'>'
					.(defined($const) ? constant($const) : $file).'</option>';
				}
			}
		}
		closedir($dir);

		echo '
				</select>
				'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Сохранение поля "Псевдоссылка"
	 * @return boolean true
	 */
	protected function save_rewrite_module()
	{
		$this->diafan->_cache->delete("", "rewrite");
		DB::query("DELETE FROM {rewrite} WHERE module_name='%s' AND site_id=%d", $this->diafan->module, $this->diafan->save);
		if(! empty($_POST["rewrite"]))
		{
			//$rewrite = $this->diafan->translit($_POST["rewrite"]);
			$rewrite = $_POST["rewrite"];
			//если такая псевдоссылка принадлежит другому элементу, добавляем номер id 
			if(DB::query_result("SELECT id FROM {rewrite} WHERE rewrite='%s'", $rewrite))
			{
				$rewrite .= $this->diafan->save;
			}
			DB::query("INSERT INTO {rewrite} (module_name, site_id, rewrite) VALUES ('site', %d, '%h')", $this->diafan->save, $rewrite);

			return TRUE;
		}
		if(! empty($rewrite))
		{
			// в готовой псевдоссылке берется только последняя часть
			if(strstr($rewrite, '/'))
			{
				$rewrite_array = explode("/", $rewrite);
				$rewrite = $rewrite_array[count($rewrite_array) - 1];
			}
		}
		else
		{
			//если псевдоссылка не задана, она генерируется из имени страницы
			$rewrite = $this->diafan->translit($_POST["name"]);
			$rewrite = preg_replace('/[^A-Za-z0-9-_]+/', '', $rewrite);
			//берутся первые 50 символов
			$rewrite = strtolower(substr($rewrite, 0, 50));
		}
		
		//если сохраняемый элемент имеет родителя, то в начало псевдоссылки подставляется псевдоссылка родителя
		$rewrite = ($_POST["parent_id"]
		            ? DB::query_result("SELECT rewrite FROM {rewrite} WHERE module_name='%s' AND site_id=%d", $this->table, $_POST["parent_id"]).'/'
		            : '')
		           .$rewrite;
		
		//если такая псевдоссылка принадлежит другому элементу, добавляем номер id 
		if(DB::query_result("SELECT id FROM {rewrite} WHERE rewrite='%s'", $rewrite))
		{
			$rewrite .= $this->diafan->save;
		}

		//изменяем псевдоссылку у дочерних страниц
		$this->save_children_rewrite($this->diafan->save, $rewrite);

		DB::query("INSERT INTO {rewrite} (module_name, site_id, rewrite) VALUES ('site', %d, '%h')", $this->diafan->save, $rewrite);
		return TRUE;
	}

	/**
	 * Изменяет псевдоссылки вложенных страниц
	 * @return boolean true
	 */
	private function save_children_rewrite($parent_id, $rewrite)
	{
		$result = DB::query("SELECT r.rewrite, s.id FROM {site} AS s"
		                    ." INNER JOIN {} AS r ON r.site_id=a.id AND r.module_name='site'"
		                    ." WHERE s.parent_id=%d AND s.id<>%d", $parent_id, $parent_id);
		while($row = DB::fetch_array($result))
		{
			if(empty($row["rewrite"]))
			{
				$rewrite1 = $rewrite.'/'.$row["id"];
			}
			else
			{
				$rew = explode("/", $row["rewrite"]);
				if(empty($rew[count($rew) - 1]))
				{
					$rewrite1 = $rewrite.'/'.$row["id"];
				}
				else
				{
					$rewrite1 = $rewrite.'/'.$rew[count($rew) - 1];
				}
			}
			DB::query("UPDATE {rewrite} SET rewrite='%h' WHERE module_name='%s', site_id=%d", $rewrite1, $row["id"]);
			$this->save_children_rewrite($row["id"], $rewrite1);
		}
		return TRUE;
	}

	/**
	 * Сохранение поля "Родитель"
	 * @return boolean true
	 */
	protected function save_parent_id_module()
	{
		//сохраняет поле Принадлежит
		$parent_id = 0;
		if($this->diafan->save != 1 && ! empty($_POST["parent_id"]))
		{
			$parent_id = preg_replace('/[^0-9]+/', '', $_POST["parent_id"]);
			//проверяем не принадлежит ли родитель к дочерним элеменат, чтобы не было рекурсии
			if(in_array($parent_id, $this->diafan->get_children($this->diafan->save, $this->table)))
			{
				$parent_id = 0;
			}
		}
		$this->query[] = "parent_id='%d'";
		$this->value[] = $parent_id;
		return TRUE;
	}
}