<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Subscribtion_admin_element
 *
 * Рассылки
 */
class Subscribtion_admin_element extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'subscribtion';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'subscribtion';

	/**
	 * @var integer количество отправленных писем
	 */
	var $count = 0;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'    => 'text',
			'created' => 'date',
			'send'    => 'checkbox',
			'lang'    => 'checkbox',
			'hr1'     => 'hr',
			'cat_id'  => 'select',
			'hr2'     => 'hr',
			'text'    => 'editor'
		);

		//поля, которые прячутся в Дополнительно
		$this->variable_other = array(
			'cat_id' => 1,
			'hr1'    => 1
		);

		//переводимые поля
		$this->language_names = array(
			'name',
			'text'
		);

		$this->config_module = array(
			'del'     => 1,
			'date'    => 1,
			'element' => 1,
			'trash'   => 1	//использовать корзину
		);

		$this->select["cat_id"] = array(
			"subscribtion_category",
			"id",
			"name",
			$this->diafan->cat,
			"",
			" AND trash='0'",
			"parent_id"
		);

		if(! $this->diafan->configmodules("cat"))
		{
			unset($this->variable_table['cat_id']);
			unset($this->variable_other['cat_id']);
			unset($this->config_module['element']);
		}

		if(count($this->diafan->language_all) < 2)
		{
			unset($this->variable_table['lang']);
		}

		if($this->diafan->error >= 10)
		{
			$this->count = $this->diafan->error - 10;
			$this->diafan->error = 0;
		}
	}

	/**
	 * Выводит список рассылок
	 * @return boolean true
	 */
	public function show_module()
	{
		if($this->count)
		{
			echo '<font color="red" size="3">'._ADMIN_ERROR_10.' '.$this->count.'</font><br /><br />';
		}

		$this->addnew_init(_ADMIN_SUBSCRIBTION_ADD);

		echo '<table class="list">';
		$this->list_row($this->diafan->cat);
		echo '</table>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Отправить сообщение"
	 * @return boolean true
	 */
	protected function edit_send_module()
	{

		if(! empty($this->values["sends"]))
			return FALSE;

		if(! $this->diafan->configmodules("cat") || $this->diafan->cat)
		{
			echo '<br><font color="red">'._ADMIN_SUBSCRIBTION_COUNT_OF_SUBSCRIBERS.': '
			.DB::query_result("SELECT COUNT(id) FROM {users_site} WHERE act='1'"
				.($this->diafan->configmodules("cat") && $this->diafan->cat ? " AND subscribtion NOT LIKE '% ".$this->diafan->cat." %'" : '')
			)
			.(! empty($this->variable_table['lang'])
			  ? ' '._ADMIN_SUBSCRIBTION_CURRENT_LANGUAGE.': '
				.DB::query_result("SELECT COUNT(id) FROM {users_site} WHERE act='1'"
				                  .($this->diafan->configmodules("cat") && $this->diafan->cat ? " AND subscribtion NOT LIKE '% ".$this->diafan->cat." %'" : '')
				                  ." AND language='"._LANG."'")
			  : '')
			.'</font>';
			
		}

		echo '
		<tr'.$this->get_other().'>
			<td align="right">
				'.(! empty($this->values["send"]) ? _ADMIN_SUBSCRIBTION_SENDS : $this->variable_names()).'
			</td>
			<td>
				<input type="checkbox" name="'.$this->key.'" value="1"'.(! empty($this->values["sends"]) ? ' checked' : '').'>'
				.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Дата отправки"
	 * @return boolean true
	 */
	protected function edit_created_module()
	{
		if($this->diafan->addnew)
			return FALSE;

		echo '
		<tr'.$this->get_other().'>
			<td align="right">
				'.($this->values["send"] ? _ADMIN_SUBSCRIBTION_CREATEDS : $this->variable_names()).'
			</td>
			<td>
				'.date("D, d M Y H:i:s", ($this->value ? $this->value : time()))
				.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Категория"
	 * 
	 * @return boolean
	 */
	protected function edit_cat_id_module()
	{
		if(! $this->diafan->configmodules("cat"))
		{
			return FALSE;
		}
		if(! $this->value)
		{
			$this->value = $this->diafan->cat;
		}

		echo '
		<tr'.$this->get_other().' valign="top">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<select name="'.$this->key.'">';

		$marker = "&nbsp;&nbsp;";
		$result = DB::query("SELECT id, name, parent_id FROM {".$this->table."_category} WHERE trash='0' ORDER BY id ASC");
		while ($row = DB::fetch_array($result))
		{
			$cats[$row["parent_id"]][] = $row;
		}
		echo $this->get_options($cats, $cats[0], array($this->value)).'
				</select>
				'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}

	/**
	 * Сохранение поля "Дата отправки"
	 * @return boolean true
	 */
	protected function save_created_module()
	{
		$created = $this->oldrow["created"];

		if(! $created || ! empty($_POST["text"]) && ! empty($_POST["send"]))
		{
			$created = time();
		}

		$this->query[] = "created='%d'";
		$this->value[] = $created;

		return TRUE;
	}

	/**
	 * Сохранение поля "Язык рассылки"
	 * @return boolean true
	 */
	protected function save_lang_module()
	{
		return TRUE;
	}

	/**
	 * Сохранение поля "Отправить рассылку"
	 * @return boolean true
	 */
	protected function save_send_module()
	{
		if(empty($_POST["text"]) && ! empty($_POST["send"]))
		{
			$this->diafan->err = 10;
			return FALSE;
		}

		if(empty($_POST["send"]) || empty($_POST["text"]))
		{
			return FALSE;
		}

		$subject = str_replace(
			array(
				'%title',
				'%url',
				'%subject'
			),
			array(
				TITLE,
				BASE_URL,
				$this->diafan->get_param($_POST, "name", '', 1)
			),
			$this->diafan->configmodules('subject')
		);

		$message = str_replace(
						'/'.USERFILES,
						'http://'.BASE_URL.'/'.USERFILES,
						$_POST["text"]
		);

		$k = 0;
		$result = DB::query("SELECT mail FROM {users_site} WHERE act='1'"
		                    .($this->diafan->configmodules("cat") ? " AND subscribtion NOT LIKE '% ".$this->diafan->cat." %'" : '')
		                    .(! empty($this->variable_table['lang']) && empty($_POST["lang"]) ? " AND language='"._LANG."'" : '')
		);

		while ($row = DB::fetch_array($result))
		{
			include_once(ABSOLUTE_PATH."includes/mail.php");
			send_mail(
				$row["mail"],
				$subject,
				$message,
				($this->diafan->configmodules("emailconf") && $this->diafan->configmodules("email") ? $this->diafan->configmodules("email") : '')
			);
			
			$k++;
		}
		$this->diafan->err = 10 + $k;

		$this->query[] = "send='%d'";
		$this->value[] = 1;

		return TRUE;
	}

	/**
	 * Сохранение поля "Категория"
	 * @return boolean true
	 */
	protected function save_cat_id_module()
	{
		if(! $this->diafan->configmodules("cat"))
		{
			return FALSE;
		}
		$this->query[] = "cat_id='%d'";
		$this->value[] = $_POST["cat_id"];

		return TRUE;
	}
}