<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Tags_inc
 *
 * Работа с тэгами
 */
class Tags_inc
{
	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * @var array имена тэгов
	 */
	public $cache;

	/**
	 * @var integer номер страницы тэгов
	 */
	public $site_id;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		require_once (ABSOLUTE_PATH.'modules/tags/tags.view.php');
	}

	/**
	 * Выводит подключенные к элементу тэги
	 * 
	 * @return string|boolean false
	 */
	public function get($element_id = '', $module_name = '')
	{
		if(! $module_name)
		{
			$module_name = $this->diafan->module;
		}
		if(! $element_id)
		{
			$element_id = $this->diafan->show;
		}
		if(! $this->site_id)
		{
			$this->site_id = DB::query_result("SELECT id FROM {site} WHERE addmodule='tags' AND act='1'");
		}
		if(! $this->site_id)
		{
			return FALSE;
		}

		//выводит метки, если в конфигурации текущего модуля они подключены
		if(! $this->diafan->configmodules("tags", $module_name) || ! $element_id)
			return FALSE;
	
		$result = DB::query("SELECT tags_name_id FROM {tags} WHERE module_name='%h' AND element_id='%d' AND trash='0' ORDER BY id DESC",
				    $module_name, $element_id);
		$rows = array();
		
		while($row = DB::fetch_array($result))
		{
			if(empty($this->cache[$row["tags_name_id"]]))
			{
				$this->cache[$row["tags_name_id"]] = DB::query_result("SELECT [name] FROM {tags_name} WHERE id=%d", $row["tags_name_id"]);
			}
			$row["name"] = $this->cache[$row["tags_name_id"]];
			$row["link"] = (! empty($this->diafan->rewrites["tags"]["element".$row["tags_name_id"]]["rewrite"])
					? $this->diafan->rewrites["tags"]["element".$row["tags_name_id"]]["rewrite"].'/'
					: (! empty($this->diafan->rewrites[$this->site_id]["rewrite"])
					   ? $this->diafan->rewrites[$this->site_id]["rewrite"].'/' : '')
					   .'show'.$row["tags_name_id"].'/'
				       );
			$rows[] = $row;
		}
		return Tags_view::get($rows);
	}
}