<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Tags
 *
 * Контроллер модуля "Тэги"
 */
class Tags extends Frame
{
	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct(&$diafan)
	{
		$this->diafan = &$diafan;

		$model = new Tags_model($diafan);
		$this->rewrite_variable_names = array('page', 'show');

		if(! $this->diafan->show)
		{
			$this->result = $model->show_block();
		}
		else
		{
			$this->result = $model->list_module();
		}

		if(! empty($this->result["title"]))
		{
			$this->diafan->name = $this->result["title"];
		}
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	public function show_module()
	{
		if(! $this->diafan->show)
		{
			Tags_view::show_block($this->result, TRUE);
		}
		else
		{
			Tags_view::list_module($this->result);
		}
		return TRUE;
	}

	/**
	 * Шаблонная функция: выводит облако тэгов
	 * 
	 * @return boolean
	 */
	public function show_block($th, $attributes)
	{
		$this->diafan = $th->diafan;
		
		if($this->diafan->module == "tags" && ! $this->diafan->show)
			return FALSE;
		
		include_once(ABSOLUTE_PATH.'modules/tags/tags.model.php');
		$model = new Tags_model($this->diafan);
		$result = $model->show_block();
		
		include_once(ABSOLUTE_PATH.'modules/tags/tags.view.php');
		Tags_view::show_block($result);

		return TRUE;
	}
}