<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Tags_view
 *
 * Шаблон модуля "Тэги"
 */
class Tags_view
{
	/**
	 * Шаблон списка прикрепленных к элементу тэгов
	 * 
	 * @param array $rows список тэгов
	 * @return string
	 */
	public function get($rows)
	{
		$text = '';
		if(! empty($rows))
		{
			$k = 0;
			$text .= '
			<div class="tags"><span class="tags-header">'._LANG_TAGS.':</span> ';
			foreach($rows as $row)
			{
				$text .= ($k ? ', ' : '').'<a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a>
				';
				$k++;
			}
			$text .= '</div>';
		}
		return $text;
	}

	/**
	 * Шаблон списка элементов, к которым прикреплен тэг
	 *
	 * @param array $result сгенерированные в моделе данные
	 * @return boolean
	 */
	public function list_module($result)
	{
		if(empty($result["rows"]))
			return FALSE;
		
		foreach($result["rows"] as $row)
		{
			echo '
			<div class="tags-list">
				<div class="tag-name">'
				.($row["site"] ? '<a href="'.BASE_PATH_HREF.$row["site"]["link"].'">'.$row["site"]["name"].'</a> / ' : '')
				.($row["cat"]  ? '<a href="'.BASE_PATH_HREF.$row["cat"]["link"].'">'.$row["cat"]["name"].'</a> / '   : '')
				.'<a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a></div>
				<div class="tag-text">'.$row["snippet"].'</div>
				'.(! empty($row["tags"]) ? $row["tags"] : '').'
			</div>';
		}
		echo Paginator_view::get($result["paginator"]);

		return TRUE;
	}

	/**
	 * Шаблон облака тэгов
	 * 
	 * @param array $result сгенерированные в моделе данные
	 * @param boolean $title_no_show скрывать заголовок H2
	 * @return boolean
	 */
	public function show_block($result, $title_no_show = FALSE)
	{
		if(! $result["rows"])
			return FALSE;
		
		echo '<div class="tags-block">'
		.(! $title_no_show ? '<h2>'._LANG_TAGS.'</h2>' : '');
		
		foreach ($result["rows"] as $row)
		{
			if(! $row["selected"])
			{
				echo '
				<a href="'.BASE_PATH_HREF.$row["link"].'" style="font-size: '.$row["size"].'em;">'.$row["name"].'</a> ';
			}
			else
			{
				echo '
				<span style="font-size: '.$row["size"].'em;">'.$row["name"].'</span> ';
			}
		}
		echo '</div>';

		return TRUE;
	}
}