<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Usersite_admin
 *
 * Редактирование пользователей сайта сайта
 */
class Usersite_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'usersite';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'users_site';

	/**
	 * @var boolean установлен модуль "Форум"
	 */
	public $forum 	= FALSE;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		//$this->forum = TRUE;
		
		$this->nastr = 30;
		
		//поля в базе данных для редактирования
		$this->variable_table = array(
			'fio'		=> 'text',
			'name'		=> 'text',
			'password'	=> 'password',
			'mail'		=> 'text',
			'created'	=> 'date',
			'act'		=> 'checkbox',
			'moderator'	=> 'checkbox',
			'language'	=> 'select',
			'address'	=> 'function',
			'subscribtion'	=> 'function'
		);
		
		$this->config_module = array(
			'del'	=> 1,	//удалить
			'act'	=> 1,	//показать/скрыть
			'trash'	=> 1	//использовать корзину
		);
		
		$this->config_other_row = array(
			'name as n'
		);
		
		foreach ($this->diafan->language_all as $key => $language)
		{
			$this->select_arr["language"][$language[0]] = $language[2];
		}
	}

	/**
	 * Выводит список пользователей сайта
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->name = 'fio';

		$this->addnew_init(_ADMIN_USERS_ADD);
		echo '<table border="0" cellpadding="1" cellspacing="3" class="list">';
		$this->list_row();	
		echo '</table>';

		DB::query("DELETE FROM {actlink} WHERE created<%d", time());
		DB::query("DELETE FROM {actlink} WHERE user_id IN (SELECT id FROM {users_site} WHERE act='1')");

		return TRUE;
	}

	/**
	 * Выводит статус пользователя (на сайте)
	 * @return string
	 */
	protected function other_row_nameasn($row)
	{
		return '</td><td>'.$row["n"]
		.(DB::query_result("SELECT COUNT(session_id) AS count FROM {sessions_site} WHERE timestamp >= %d AND user_id='%d'", (time()-900), $row["id"])
		 ? ' <font style="color: #ffffff; background-color: red;">'._ADMIN_USERS_ON_SITE.'</font>'
		 : '');
	}

	/**
	 * Редактирование поля "Адрес"
	 * @return boolean true
	 */
	protected function edit_address_module()
	{
		
		$u = array();
		
		if($this->value)
		{
			$conf_arr = explode("\n", $this->value);
			foreach($conf_arr as $c_a)
			{
				list($kk, $v)=explode("=", $c_a, 2);
				$u[$kk] = $v;
			}
		}
		echo '
		<tr'.$this->get_other().' valign="top">
			<td align="right">
				'.$this->variable_names()
				.$this->show_help_row().'
			</td>
			<td>
				'._LANG_CONTACTS.':<br>
				<input type="text" maxLength="70" name="phone" size="40" class="inptext" value="'.(! empty($u["phone"]) ? $u["phone"] : '').'"><br><br>
				'._LANG_TOWN.':<br>
				<input type = "text" maxLength="70" name="city" size="40" class="inptext" value="'.(! empty($u["city"]) ? $u["city"] : '').'"><br>
				'._LANG_STREET.':<br>
				<input type = "text" maxLength="70" name="street" size="40" class="inptext" value="'.(! empty($u["street"]) ? $u["street"] : '').'"><br>
				'._LANG_HOUSE_NUMBER.':<br>
				<input type = "text" maxLength="70" name="home" size="40" class="inptext" value="'.(! empty($u["home"]) ? $u["home"] : '').'"><br>
				'._LANG_BLOCK.':<br>
				<input type = "text" maxLength="70" name="corps" size="40" class="inptext" value="'.(! empty($u["corps"]) ? $u["corps"] : '').'"><br>
				'._LANG_FLAT.':<br>
				 <input type = "text" maxLength="70" name="flat" size="40" class="inptext" value="'.(! empty($u["flat"]) ? $u["flat"] : '').'">
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Подписан на рассылки"
	 * @return boolean true
	 */
	protected function edit_subscribtion_module()
	{
		if(! $this->diafan->configmodules("cat", "subscribtion"))
			return FALSE;

		echo '
		<tr'.$this->get_other().' valign="top">
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td>';
		$this->parent_id_subscribtion_module_registration(0, '', array(), $this->value);
		echo $this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Формирует список рассылок
	 * @return array
	 */
	private function parent_id_subscribtion_module_registration($parent_id, $rew, $array, $subscribtion)
	{
		$result = DB::query("SELECT name,id FROM {subscribtion_category} WHERE parent_id='%d' AND trash='0'", $parent_id);
		while ($row = DB::fetch_array($result))
		{
			echo $rew.'<input type="checkbox" name="subscribtion[]" value="'.$row["id"].'"'
			.(! strstr($subscribtion, ' '.$row["id"].' ') ? ' checked' : '')
			.'> '.$row["name"].'<br>';
			if(in_array($row["id"], $array))
			{
				return $array;
			}
			$array[] = $row["id"];
			$array = $this->parent_id_subscribtion_module_registration($row["id"], '&nbsp;&nbsp;&nbsp;'.$rew, $array, $subscribtion);
		}
		return $array;
	}

	/**
	 * Сохранение поля "Логин"
	 * @return boolean true
	 */
	protected function save_name_module()
	{
		if(! $this->diafan->save || $_POST["name"] != $this->oldrow["name"])
		{
			require_once(ABSOLUTE_PATH.'includes/validate.php');
			$err = Validate::login($_POST["name"]);
			if($err)
			{
				echo '<script language="javascript" type="text/javascript">alert(\''.strip_tags($err).'\');history.go(-1);</script>';
				exit;
			}
		}

		$this->query[] = "name='%h'";
		$this->value[] = $this->diafan->translit($_POST["name"]);

		return TRUE;
	}

	/**
	 * Сохранение поля "Адрес"
	 * @return boolean true
	 */
	protected function save_address_module()
	{
		$query = 'city='.   str_replace("\n", '', $this->diafan->get_param($_POST, "city", '', 1))."\n"
			.'street='. str_replace("\n", '', $this->diafan->get_param($_POST, "street", '', 1))."\n"
			.'home='.   str_replace("\n", '', $this->diafan->get_param($_POST, "home", '', 1))."\n"
			.'corps='.  str_replace("\n", '', $this->diafan->get_param($_POST, "corps", '', 1))."\n"
			.'flat='.   str_replace("\n", '', $this->diafan->get_param($_POST, "flat", '', 1))."\n"
			.'phone='.  str_replace("\n", '', $this->diafan->get_param($_POST, "phone", '', 1));

		$this->query[] = "address='%s'";
		$this->value[] = $query;

		return TRUE;
	}

	/**
	 * Сохранение поля "Список рассылок"
	 * @return boolean
	 */
	protected function save_subscribtion_module()
	{
		if(! $this->diafan->configmodules("cat", "subscribtion"))
			return FALSE;

		$array = array();
		$result = DB::query("SELECT id FROM {subscribtion_category} WHERE trash='0'");
		while ($row = DB::fetch_array($result))
		{
			if(empty($_POST["subscribtion"]) || ! in_array($row["id"], $_POST["subscribtion"]))
			{
				$array[] = $row["id"];
			}
		}
		$cats = '0 '.implode("  ", $array).' 0';
		$this->query[] = "subscribtion='%s'";
		$this->value[] = $cats;

		return TRUE;
	}

	/**
	 * Добавляет пользователя (вместо основной фунции)
	 * @return boolean true
	 */
	public function new_module()
	{
		require_once(ABSOLUTE_PATH.'includes/validate.php');
		$err = Validate::login($_POST["name"]);
		if($err)
		{
			echo '<script language="javascript" type="text/javascript">alert(\''.strip_tags($err).'\');history.go(-1);</script>';
			return FALSE;
		}
		parent::new_module();

		return TRUE;
	}

	/**
	 * Удаляет пользователя (вместо основной функции)
	 * @return boolean
	 */
	public function del_module()
	{	
		if($this->diafan->admin_roles('del'))
		{
			$this->diafan->goto_diafan(URL);
			return FALSE;
		}	
		DB::query("DELETE FROM {actlink} WHERE user_id='%d'", $this->diafan->del);

		if($this->forum)
		{
			DB::query("DELETE FROM {forum_show} WHERE user_id='%d'", $this->diafan->del);
		}
		parent::del_module();

		return TRUE;
	}
}