<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Votes_admin_category
 *
 * Редактирование вопросов для голосования
 */
class Votes_admin_category extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'votesquest';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'votes_category';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'		=> 'text',
			'act'		=> 'checkbox',
			'site_id'	=> 'select'
		);

		//переводимые поля
		$this->language_names = array(
			'name',
			'act'
		);

		$this->config_module = array(
			'del'		=> 1,	//удалить
			'act'		=> 1,	//показать/скрыть
			'category'	=> 1,	//основная ссылка ведет к списку элементов, принадлежащих группе
			'trash'		=> 1	//использовать корзину
		);

		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'site_id'
		);
	}

	/**
	 * Выводит список вопросов
	 * @return boolean true
	 */
	public function show_module()
	{		
		$this->addnew_init(_ADMIN_VOTESQUEST_ADD);
		echo '<table border="0" cellpadding="1" cellspacing="3" class="list">';
		$this->list_row();	
		echo '</table>';

		return TRUE;
	}

	/**
	 * Выводит количество ответов на вопрос
	 * @return string
	 */
	protected function other_row_site_id($row)
	{
		$row["site_id"] = (! $row["site_id"] ? _ADMIN_VOTESQUEST_PREVAILING : DB::title("site", $row["site_id"], "name"));
		return '</td><td>'.$row["site_id"];
	}

	/**
	 * Редактирование поля "Расположение"
	 * 
	 * @return boolean
	 */
	protected function edit_site_id_module()
	{
		echo '
		<tr'.$this->get_other().' valign="top">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<select name="'.$this->key.'">
					<option value="">'._ADMIN_VOTESQUEST_PREVAILING.'</option>';

		$marker = "&nbsp;&nbsp;";
		$result = DB::query("SELECT id, name, parent_id FROM {site} WHERE trash='0' AND act='1' ORDER BY id ASC");
		while ($row = DB::fetch_array($result))
		{
			$cats[$row["parent_id"]][] = $row;
		}
		echo $this->get_options($cats, $cats[0], array($this->value)).'
				</select>
				'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}
}