<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Votes_admin_element
 *
 * Редактирование ответов для голосования
 */
class Votes_admin_element extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'votesanswer';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'votes';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		$this->table = 'votes';
		
		//поля в базе данных для редактирования
		$this->variable_table = array(
			'name'		=> 'text',
			'count_votes'	=> 'numtext',
			'cat_id'	=> 'function'
		);
		
		//переводимые поля
		$this->language_names = array(
			'name'
		);	

		$this->config_module = array(
			'del'		=> 1,	//удалить
			'trash'		=> 1,	//использовать корзину
			'element'	=> 1	//используются группы
		);

		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'count_votes'
		);
	}

	/**
	 * Выводит списко ответов
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_VOTESANSWER_ADD);
		echo '<table border="0" cellpadding="1" cellspacing="3" class="list">';
		$this->list_row($this->diafan->cat);	
		echo '</table>';

		return TRUE;
	}

	/**
	 * Редактирование поля "Вопрос"
	 * @return boolean true
	 */
	protected function edit_cat_id_module()
	{
		echo '<input type="hidden" name="cat_id" value="'.$this->diafan->cat.'">';

		return TRUE;
	}

	/**
	 * Сохранение поля "Вопрос"
	 * @return boolean true
	 */
	protected function save_cat_id_module()
	{
		$this->query[] = "cat_id='%d'";
		$this->value[] = $_POST["cat_id"];

		return TRUE;
	}
}