<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Votes_inc
 *
 * Подключение модуля "Голосование"
 */
class Votes_inc extends Model
{
	/**
	 * @var array сгенерированные в моделе данные, передаваемые в шаблон
	 */
	public $result;

	/**
	 * @var object основной объект системы
	 */
	public $diafan;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		require_once (ABSOLUTE_PATH.'modules/votes/votes.view.php');

		include_once(ABSOLUTE_PATH.'modules/votes/votes.ajax.php');
		$ajax = new Votes_ajax($diafan);
		if($ajax->ajax_request())
		{
			exit;
		}
	}

	/**
	 * Выводит подключенные к странице опросы
	 * 
	 * @param integer $id номер опроса
	 * @return void
	 */
	public function votes_show_votes($id = 0)
	{
		if($this->diafan->configmodules('security_user', 'votes') && ! $this->diafan->_user->id)
			return FALSE;
		
		if(! $id && ! $this->diafan->configmodules('order', 'votes'))
		{
			$max_count = DB::query_result("SELECT COUNT(id) FROM {votes_category} WHERE [act]='1' AND trash='0'"
						      ." AND (site_id='%d' OR site_id='0')", $this->diafan->cid);
			$rand = rand(0, $max_count - 1);
		}

		$result_question = DB::query("SELECT id, [name] FROM {votes_category} WHERE [act]='1' AND trash='0'"
					     ." AND (site_id='%d' OR site_id='0')"
					     .($id
					       ? " AND id=".$id
					       : ($this->diafan->configmodules('order','votes')
						  ? " ORDER BY id DESC"
						  : " LIMIT ".$rand.",1"
						  )
					       ),
					     $this->diafan->cid);
		$rows = array();
		while($row = DB::fetch_array($result_question))
		{
			$result = array();
			$result["question-id"] = $row["id"];
			if($this->check_log($row["id"]))
			{
				$k = 0;
				$result_answer = DB::query("SELECT id, [name] FROM {votes} WHERE trash='0' AND cat_id='%d' ORDER BY id DESC", $row["id"]);
				while($row_answers = DB::fetch_array($result_answer))
				{
					$row_answer = array();
					$row_answer["input"] = '<input type="radio" name="answer" value="'.$row_answers["id"].'"'.(! $k ? " checked" : '').'> ';
					$row_answer["name"] = $row_answers["name"];
					$result["answers"][] = $row_answer;
					$k++;
				}
				$result["captcha"] = '';
				if($this->diafan->configmodules('security','votes') == 2)
				{
					require_once(ABSOLUTE_PATH.'includes/captcha/captcha.inc.php');
					$result["captcha"] = Captcha_inc::get("votes".$row["id"], $this->get_error("votes".$row["id"], "code"));
				}
				$result["answers"] = Votes_view::show_form_answers($result);
			}
			else
			{
				$sum_votes = DB::query_result("SELECT SUM(count_votes) FROM {votes} WHERE trash='0' AND cat_id='%d'", $row["id"]);

				$result_answer = DB::query("SELECT [name], count_votes FROM {votes} WHERE trash='0' AND cat_id='%d' ORDER BY id DESC", $row["id"]);
				while($row_answer = DB::fetch_array($result_answer))
				{
					$ra["count"]   = $row_answer["count_votes"];
					$ra["persent"] = $sum_votes ? round($row_answer["count_votes"] / $sum_votes * 100) : 0;
					$ra["name"]    = $row_answer["name"];
					$result["answers"][] = $ra;
				}
	
				$result["summ"] = $sum_votes;
				$result["answers"] = Votes_view::show_answers($result);
			}
			$result["question"] = $row["name"];
			$result["error"] = $this->get_error("votes".$row["id"]);
			$rows[] = $result;
		}
		Votes_view::show_module($rows);

		return TRUE;
	}

	/**
	 * Проверяет доступ к голосованию
	 * 
	 * @return boolean
	 */
	private function check_log($id)
	{
		if($this->diafan->configmodules('security_user', 'votes') && ! $this->diafan->_user->id)
		{
			return FALSE;
		}
		if($this->diafan->configmodules('security','votes') == 3)
		{
			if(DB::query_result("SELECT COUNT(id) FROM {log_note} WHERE session_id='%s' AND element_id='%d' AND include_name='votes'",
			                    $this->diafan->configmodules('security_user', 'votes') ? $this->diafan->_user->id : session_id(), $id))
			{
				return FALSE;
			}
		}
		elseif($this->diafan->configmodules('security', 'votes') == 4)
		{
			if(! empty($_SESSION["votes"][$id]))
			{
				return FALSE;
			}
		}
		return TRUE;
	}
}