<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2011 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Votes_view
 *
 * Шаблон модуля "Голосование"
 */
class Votes_view
{
	/**
	 * Шаблон формы голосования
	 * 
	 * @param array $rows список опросов
	 * @return boolean true
	 */
	public function show_module($rows)
	{
		if(! empty($rows))
		{
			foreach($rows as $result)
			{
				echo '
				<div class="votes-guestion">'.$result["question"].'</div>
				<form method="post" action="" class="votes-form ajax" id="votes'.$result["question-id"].'">
				<div id="votes'.$result["question-id"].'-form">
				'.$result["answers"].'
				</div>
				<div class="errors error"'.($result["error"] ? '>'.$result["error"] : ' style="display:none">').'</div>
				</form>';
			}
			echo '<script type="text/javascript" src="'.BASE_PATH.'modules/votes/votes-func.js"></script>';
		}

		return TRUE;
	}

	/**
	 * Шаблон вопросов для голосования
	 * 
	 * @param array $rows список ответов
	 * @return string
	 */
	public function show_form_answers($result)
	{
		$text = '
			<input type="hidden" name="question" value="'.$result["question-id"].'">
			<input type="hidden" name="ajax" value="0">
			<input type="hidden" name="ajax_votes" value="1">
			<input type="hidden" name="result" value="">';
		if(! empty($result))
		{
			foreach($result["answers"] as $row)
			{
				$text .= '<div class="votes-form-answer">'.$row["input"]." ".$row["name"].'</div>';
			}
			$text .= $result["captcha"].'
				<input type="submit" class="button" value="'._LANG_VOTE.'">
				<input type="button" class="button votes_result" value="'._LANG_RESULT.'">';
		}
		return $text;
	}

	/**
	 * Шаблон результатов голосования
	 * 
	 * @param array $rows список ответов
	 * @return string
	 */
	public function show_answers($result)
	{
		$text = '
			<input type="hidden" name="question" value="'.$result["question-id"].'">
			<input type="hidden" name="ajax" value="0">
			<input type="hidden" name="ajax_votes" value="1">
			<input type="hidden" name="result" value="2">';
		if(! empty($result))
		{
			foreach($result["answers"] as $row)
			{
				$text .= '<div class="votes-answer">'.$row["name"].' - '.$row["persent"].'% ('.$row["count"].')</div>';
			}
			$text .= '<div class="votes-count">'._ADMIN_RATING_COUNT_VOTES.': '.$result["summ"].'</div>';
			$text .= (! empty($result["result"]) ? '
			<input type="submit" class="button" value="'._LANG_VOTE.'">' : '');
		}
		return $text;
	}
}